package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:cpm:对账报文明细信息表
*/
@Table("cpm")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cpm extends AbstractModule
{

        public Cpm(){
            super();
        }

        public Cpm(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "cpm";
        }

        //主键
        private String inr ;
        //关联MPI表主键
        private String mpiinr ;
        //报文标志号
        private String ownref ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //贷记标识
        private String dc ;
        //状态
        private String sta ;
        //发起直接参与者行号
        private String sndbic ;
        //交易码
        private BigDecimal cod  = new BigDecimal("0.00");
        //关联cpy表主键
        private String cpyinr ;
        //报文类型
        private String subtyp ;
        //对账日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date chkdat;
        //对账直接参与者行号
        private String chkbic ;
        //是否已发送报文
        private String flg ;
        //CIPS日间/夜间标识
        private String biztyp ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }
         public void setCod(Object o){
            if (o instanceof String) {
                this.cod = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.cod = (BigDecimal) o;
            }
        }

}