package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:cpsact:CIPS清算账户信息存储表
*/
@Table("cpsact")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cpsact extends AbstractModule
{

        public Cpsact(){
            super();
        }

        public Cpsact(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "cpsact";
        }

        //主键
        private String inr ;
        //直接参与者行号
        private String dirbic ;
        //账户状态
        private String acttyp ;
        //注资最低限额
        private BigDecimal injectminamt  = new BigDecimal("0.00");
        //当前余额
        private BigDecimal amt  = new BigDecimal("0.00");
        //注资状态
        private String injecttyp ;
        //余额警戒值
        private BigDecimal waramt  = new BigDecimal("0.00");
        //起始余额
        private BigDecimal begamt  = new BigDecimal("0.00");
        //借记排队总金额
        private BigDecimal deballamt  = new BigDecimal("0.00");
        //贷记排队总金额
        private BigDecimal crdallamt  = new BigDecimal("0.00");
        //注资最低限额
        private BigDecimal lowamt  = new BigDecimal("0.00");
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credattim;
        //暂存金额
        private BigDecimal tepamt  = new BigDecimal("0.00");
        //轧差金额
        private BigDecimal balamt  = new BigDecimal("0.00");
        //预注资金额
        private BigDecimal preamt  = new BigDecimal("0.00");



         public void setInjectminamt(Object o){
            if (o instanceof String) {
                this.injectminamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.injectminamt = (BigDecimal) o;
            }
        }
         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }
         public void setWaramt(Object o){
            if (o instanceof String) {
                this.waramt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.waramt = (BigDecimal) o;
            }
        }
         public void setBegamt(Object o){
            if (o instanceof String) {
                this.begamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.begamt = (BigDecimal) o;
            }
        }
         public void setDeballamt(Object o){
            if (o instanceof String) {
                this.deballamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.deballamt = (BigDecimal) o;
            }
        }
         public void setCrdallamt(Object o){
            if (o instanceof String) {
                this.crdallamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.crdallamt = (BigDecimal) o;
            }
        }
         public void setLowamt(Object o){
            if (o instanceof String) {
                this.lowamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.lowamt = (BigDecimal) o;
            }
        }
         public void setTepamt(Object o){
            if (o instanceof String) {
                this.tepamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.tepamt = (BigDecimal) o;
            }
        }
         public void setBalamt(Object o){
            if (o instanceof String) {
                this.balamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.balamt = (BigDecimal) o;
            }
        }
         public void setPreamt(Object o){
            if (o instanceof String) {
                this.preamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.preamt = (BigDecimal) o;
            }
        }

}