package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:dot:勾销记账报文信息表
*/
@Table("dot")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dot extends AbstractModule
{

        public Dot(){
            super();
        }

        public Dot(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "dot";
        }

        //序列号
        private String inr ;
        //勾销记录主键
        private String offinr ;
        //报文关联信息inr
        private String objinr ;
        //报文关联类型
        private String objtyp ;
        //所属账户行
        private String accpty ;
        //账号
        private String acc ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //收支
        private String dcflg ;
        //收发日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rsptim;
        //业务参考号
        private String ownref ;
        //相关参考号
        private String othref ;
        //业务标识
        private String busflg ;
        //详细信息
        private String inf ;
        //状态
        private String sta ;
        //对账信息类型
        private String typ ;
        //勾销标志
        private String offsta ;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //选择标志monly
        private String selflg ;
        //账户行BIC
        private String actbic ;
        //对账单参号
        private String staref ;
        //入账日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date entdat;
        //业务标识代码
        private String tratic ;
        //补充细节
        private String supdlt ;
        //金额代码
        private String fdc ;
        //收报行
        private String revbak ;
        //发报行
        private String sedbak ;
        //对账单号
        private String stanum ;
        //对账单页号
        private String seqnum ;
        //报文关联外键
        private String relinr ;
        //报文类型
        private String mty ;
        //交易对手
        private String oppbic ;
        //交易日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date tradat;
        //授权状态
        private String wflsta ;
        //发报流水号
        private String sndnum ;
        //多笔生成mon
        private String multimsg ;
        //选中memonly
        private String chk ;
        //勾销附言monly
        private String offinf ;
        //记账附言monly
        private String kpainf ;
        //记账类型mon
        private String kpatyp ;
        //机构mon
        private String area ;
        //opsta(mon)
        private String opsta ;
        //记帐状态
        private String recsta ;
        //最后处理时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date lstdat;
        //已操作
        private String isdone ;
        //dir
        private String dir ;
        //报文渠道类型
        private String msgtyp ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //G渠道标识
        private String sweflg ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}