package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:gndlst:
*/
@Table("gndlst")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gndlst extends AbstractModule
{

        public Gndlst(){
            super();
        }

        public Gndlst(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "gndlst";
        }

        //MPS表主键
        private String inr ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //20域编号
        private String ownref ;
        //21域编号
        private String othref ;
        //UETR
        private String uetr ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //行内系统
        private String srcchncod ;
        //第一家银行BIC
        private String firbic ;
        //第一家银行处理状态
        private String firrspsta ;
        //第一家银行状态处理码
        private String firrspcod ;
        //第一家银行处理时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date firdat;
        //第一家银行已扣费金额
        private BigDecimal firdeuamt  = new BigDecimal("0.00");
        //第一家银行已扣费币种
        private String firdeucur ;
        //当前处理银行BIC
        private String nowbic ;
        //当前银行业务处理状态
        private String nowrspsta ;
        //当前银行业务处理码
        private String nowrspcod ;
        //当前银行处理时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date nowdat;
        //当前银行已扣费金额
        private BigDecimal nowdeuamt  = new BigDecimal("0.00");
        //当前银行已扣费币种
        private String nowdeucur ;
        //已处理银行数目
        private long num ;
        //接收行内系统发报时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rcvdattim;
        //报文类型
        private String subtyp ;
        //发送时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date snddattim;
        //回执状态
        private String rspsta ;
        //处理状态
        private String sta ;
        //发报行BIC
        private String sndbic ;
        //收报行BIC
        private String rcvbic ;
        //处理码
        private String rspcod ;
        //当前反馈报文类型
        private String baksubtyp ;
        //当前渠道代码
        private String chncod ;
        //下一渠道代码
        private String nxtchncod ;
        //最终渠道代码
        private String tgtchncod ;
        //第一银行时区
        private String firutc ;
        //当前银行时区
        private String nowutc ;
        //G渠道标识
        private String sweflg ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }
         public void setFirdeuamt(Object o){
            if (o instanceof String) {
                this.firdeuamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.firdeuamt = (BigDecimal) o;
            }
        }
         public void setNowdeuamt(Object o){
            if (o instanceof String) {
                this.nowdeuamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.nowdeuamt = (BigDecimal) o;
            }
        }

}