package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:gpe:GPI报文处理信息表
*/
@Table("gpe")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Gpe extends AbstractModule
{

        public Gpe(){
            super();
        }

        public Gpe(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "gpe";
        }

        //主键索引
        private String inr ;
        //原始MPS表主键
        private String orimpsinr ;
        //MPS表主键
        private String mpsinr ;
        //原始LJD表主键
        private String oriljdinr ;
        //LJD表主键
        private String ljdinr ;
        //状态发起行BIC 
        private String orgbic ;
        //转发行BIC
        private String fwdbic ;
        //处理状态
        private String rspsta ;
        //状态处理码
        private String rspcod ;
        //状态发送时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date stasndtim;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //原始币种
        private String oricur ;
        //转换币种
        private String exgcur ;
        //汇率
        private BigDecimal exgrat  = new BigDecimal("0.00");
        //扣费币种
        private String deucur ;
        //扣费金额
        private BigDecimal deuamt  = new BigDecimal("0.00");
        //创建时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date credattim;
        //处理说明
        private String txt ;
        //更新时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date upddattim;
        //关联199报文mpsinr
        private String relinr ;
        //报文类型
        private String subtyp ;
        //收发方向
        private String dir ;
        //发报机构代码
        private String sndbic ;
        //收报机构代码
        private String rcvbic ;
        //操作员
        private String usrnam ;
        //uetr
        private String uetr ;
        //报文发送/接收时间(由收发报进行判断)
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date mpstim;
        //时区
        private String utc ;
        //结算方式
        private String setmth ;
        //清算系统
        private String clrsys ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }
         public void setExgrat(Object o){
            if (o instanceof String) {
                this.exgrat = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.exgrat = (BigDecimal) o;
            }
        }
         public void setDeuamt(Object o){
            if (o instanceof String) {
                this.deuamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.deuamt = (BigDecimal) o;
            }
        }

}