package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:png:cips排队业务登记簿
*/
@Table("png")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Png extends AbstractModule
{

        public Png(){
            super();
        }

        public Png(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "png";
        }

        //主键
        private String inr ;
        //业务币种
        private String cur ;
        //原业务报文类型
        private String msgtyp ;
        //业务金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //原业务参考号
        private String ownref ;
        //排队状态
        private String sta ;
        //排队业务报文标识号
        private String etyref ;
        //受理日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credat;
        //原报文PMS主键
        private String mpsinr ;
        //业务撤销登记簿标记
        private String canflg ;
        //排队申请登记标识
        private String queflg ;
        //排队申请发报时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date sndordtim;
        //队首/队尾
        private String prtry ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}