package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:qrd:case基本模型
*/
@Table("qrd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Qrd extends AbstractModule
{

        public Qrd(){
            super();
        }

        public Qrd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "qrd";
        }

        //惟一编号
        private String inr ;
        //case编号
        private String casnum ;
        //case状态
        private String cassta ;
        //关联报文编号(报文inr)
        private String relref ;
        //关联报文参号
        private String relrfn ;
        //汇票号码
        private String drfnum ;
        //接收行BIC
        private String revbakbic ;
        //创建时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date settim;
        //最近处理时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date neadeltim;
        //修改时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date amdtim;
        //上次经办人
        private String lstopr ;
        //备注
        private String des ;
        //发报行
        private String sedbak ;
        //收报行
        private String revbak ;
        //账户行
        private String actbak ;
        //20域编号(发)
        private String ownt20 ;
        //20域编号(收)
        private String otht20 ;
        //账户行BIC(53域)
        private String t53bic ;
        //账户行BIC(54域)
        private String t54bic ;
        //当前操作员
        private String curusr ;
        //上次操作员
        private String lstusr ;
        //原始汇款报文编号
        private String orirofinr ;
        //报文类型
        private String msgtyp ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //uetr
        private String uetr ;
        //G渠道标识
        private String sweflg ;
        //G渠道清分类型
        private String swetyp ;




}