package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:rel:主关联信息表
*/
@Table("rel")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Rel extends AbstractModule
{

        public Rel(){
            super();
        }

        public Rel(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "rel";
        }

        //序列号
        private String inr ;
        //账户行
        private String accpty ;
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date valdat;
        //业务参考号
        private String ownref ;
        //相关参考号
        private String othref ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //关联原因备注
        private String blk ;
        //操作类型
        private String bnknam ;
        //借贷标志
        private String dcflg ;
        //币种
        private String cur ;
        //账户行BIC
        private String actbic ;
        //关联状态
        private String sta ;
        //dotinr
        private String dotinr ;
        //发报流水号
        private String sndnum ;
        //人民币记录号
        private String rmbinr ;
        //主关联记录inr
        private String msgrelinr ;
        //主关联记录报文类型
        private String msgtyp ;
        //关联路径
        private String relpath ;
        //dotinrb
        private String dotinrb ;
        //备份dotinr
        private String bakdotinr ;
        //rmbinrb
        private String rmbinrb ;
        //bakdotinrb
        private String bakdotinrb ;
        //bakrmbinrb
        private String bakrmbinrb ;
        //bakrmbinr
        private String bakrmbinr ;
        //最近操作员
        private String oppusr ;
        //最近修改日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date amedate;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date credate;
        //根关联记录
        private String pntinr ;
        //选中memonly
        private String chk ;
        //收报行
        private String revbak ;
        //发报行
        private String sedbak ;
        //收发时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date rsptim;
        //mpi主键
        private String msginr ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}