package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:sed:G渠道报文信息表
*/
@Table("sed")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sed extends AbstractModule
{

        public Sed(){
            super();
        }

        public Sed(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "sed";
        }

        //
        private String inr ;
        //父报文主键
        private String pntinr ;
        //mps主键
        private String mpsinr ;
        //smh主键
        private String smhinr ;
        //收发方向
        private String dir ;
        //报送原报收发方向
        private String msgdir ;
        //报文类型
        private String msgtyp ;
        //报文类型(如:MT)
        private String submsgtyp ;
        //报文类型(如:103)
        private String subtyp ;
        //我方编号
        private String ownref ;
        //对方编码
        private String othref ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //发报机构代码
        private String sndbic ;
        //收报机构代码
        private String rcvbic ;
        //账户行
        private String actbic ;
        //账号
        private String act ;
        //会计日期
        private String accdat ;
        //通讯标识号
        private String sndnum ;
        //通讯参考号
        private String refnum ;
        //报文标识号
        private String msgref ;
        //消息接收时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date rcvdattim;
        //最近处理时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date lstdattim;
        //开始处理时间（需要延迟处理）
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date sttdattim;
        //发送时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date snddattim;
        //回执时间
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone="GMT+8")
        private Date rspdattim;
        //报文发送时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date swedattim;
        //响应代码
        private String rspcod ;
        //响应状态
        private String rspsta ;
        //通讯级状态
        private String sndsta ;
        //ACK状态
        private String acksta ;
        //消息处理状态
        private String sta ;
        //报送类型
        private String rpttyp ;
        //是否全链路
        private String fulchn ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}