package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:spt:(系统表)待办文件表
*/
@Table("spt")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Spt extends AbstractModule
{

        public Spt(){
            super();
        }

        public Spt(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "spt";
        }

        //唯一编号
        private String inr ;
        //业务状态
        private String sta ;
        //唯一编号
        private String smhinr ;
        //业务所属机构
        private String ptyinr ;
        //经办人（对于VIP用户）
        private String oprusrinr ;
        //业务经办机构
        private String oprogninr ;
        //对象类型
        private String objtyp ;
        //对象编号
        private String objinr ;
        //业务编号
        private String ownref ;
        //交易名称
        private String frm ;
        //创建日期时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date dattim;
        //业务来源
        private String scr ;
        //业务来源参数
        private String scrtxt ;
        //业务来源机构
        private String scrpty ;
        //主题
        private String nam ;
        //业务名称
        private String objnam ;
        //订单号
        private String ordinr ;
        //交易币种
        private String trncur ;
        //交易金额
        private BigDecimal trnamt  = new BigDecimal("0.00");
        //交易流水表索引
        private String trninr ;
        //业务所属机构
        private String bchinr ;
        //经办人
        private String oprusr ;



         public void setTrnamt(Object o){
            if (o instanceof String) {
                this.trnamt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.trnamt = (BigDecimal) o;
            }
        }

}