package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:txt:短信信息
*/
@Table("txt")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Txt extends AbstractModule
{

        public Txt(){
            super();
        }

        public Txt(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "txt";
        }

        //主键
        private String inr ;
        //移动电话
        private String mblpho ;
        //姓名
        private String nam ;
        //性别
        private String sex ;
        //汇票号码
        private String num ;
        //报文编号（20）
        private String ref ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //币种
        private String cur ;
        //日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date dat;
        //短信内容
        private String txt ;
        //回执状态
        private String rspsta ;
        //错误信息
        private String errmsg ;
        //短信模板
        private String txttyp ;
        //操作员
        private String usrnam ;
        //处理状态
        private String magsta ;
        //处理时间
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date magtime;
        //创建日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date crtdat;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}