package com.ceb.gjjs.mda.bo;

import java.util.*;
import java.math.BigDecimal;


import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.brilliance.mda.support.mybatis.entity.*;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import com.ceb.gjjs.mda.global.Platform;


/**
* TABLE:wtd:
*/
@Table("wtd")
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Wtd extends AbstractModule
{

        public Wtd(){
            super();
        }

        public Wtd(String name,IModule parent){
            super(name,parent);
        }

        @Override
        public String getTableName(){
            return "wtd";
        }

        //惟一编号
        private String inr ;
        //汇票号码
        private String drfnum ;
        //case编号
        private String casnum ;
        //报文编号
        private String msginr ;
        //业务参考号
        private String sevref ;
        //关联业务参考号
        private String relref ;
        //币种
        private String cur ;
        //金额
        private BigDecimal amt  = new BigDecimal("0.00");
        //起息日
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date vludat;
        //收发日期
        @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
        private Date seddat;
        //发报行
        private String sedbak ;
        //收报行
        private String revbak ;
        //报文接收方向
        private String megrevdrt ;
        //状态
        private String sta ;
        //类型
        private String typ ;
        //LJD主键
        private String ljdinr ;
        //所属实体
        private String etyinr ;
        //所属机构
        private String ptyinr ;
        //uetr
        private String uetr ;
        //GPI标识
        private String gpi ;
        //G渠道标识
        private String sweflg ;



         public void setAmt(Object o){
            if (o instanceof String) {
                this.amt = new BigDecimal((String) o);
            }
            if (o instanceof BigDecimal) {
                this.amt = (BigDecimal) o;
            }
        }

}