package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.OfficeVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Offp;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 首页
*/
@Transaction(vo= OfficeVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Office extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Office.class);

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Offp offp;


		public Office()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:office.@0004.script
        */
        @Rule(target="offp.auth",order=100)
        public boolean ruleOffpAuthN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("trnrel");

			return true;
        }

        /**
        *   source:office.@0005.script
        */
        @Rule(target="offp.back",order=100)
        public boolean ruleOffpBackN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("baksel");

			return true;
        }

        /**
        *   source:office.@0006.script
        */
        @Rule(target="offp.ped",order=100)
        public boolean ruleOffpPedN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("pensel");

			return true;
        }

        /**
        *   source:office.@0008.script
        */
        @Rule(target="offp.gat",order=100)
        public boolean ruleOffpGatN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("gatsel");

			return true;
        }



        /**
        *   source:office.@0000.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr = this.getSysmod().getPty().getInr();
			log.debug("{}","@@@@ setAuthNum @@@@");
			setAuthNum(ptyinr);
			log.debug("{}","@@@@ setBackNum @@@@");
			setBackNum(ptyinr);
			log.debug("{}","@@@@ setPedNum @@@@");
			setPedNum(ptyinr);
			log.debug("{}","@@@@ setGatNum @@@@");
			setGatNum(ptyinr);

			return true;
        }

        /**
        *   source:office.@0009.script
        */
        @Init(order=100)
        public boolean	init100R1(){
            IContext ctx = MdaEnv.getContext();
            
			String ptyinr = this.getSysmod().getPty().getInr();
			log.debug("{}","@@@@ setAuthNum @@@@");
			setAuthNum(ptyinr);
			log.debug("{}","@@@@ setBackNum @@@@");
			setBackNum(ptyinr);
			log.debug("{}","@@@@ setPedNum @@@@");
			setPedNum(ptyinr);
			log.debug("{}","@@@@ setGatNum @@@@");
			setGatNum(ptyinr);

			return true;
        }


        /**
        *   source:office.@0001.script
        */
        public void setAuthNum(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT COUNT(*) cnt FROM trn where sta='W' AND ptyinr = '"+ptyinr+"'";
			Argument<Integer> cntarg = new Argument<Integer>("cnt");
			Platform.mdbExecuteSQL(sql);
			;
			Platform.mdbFetchFields(cntarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  this.getOffp().setAutsize( ""+cntarg.value);
			}
			else
			{
			  this.getOffp().setAutsize( "0");
			}
			log.debug("{}","autsize: " + this.getOffp().getAutsize());
			Platform.mdbCloseCursor();
			
		}
        /**
        *   source:office.@0002.script
        */
        public void setPedNum(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT COUNT(*) cnt FROM spt WHERE sta = 'P' AND ptyinr = '" + ptyinr + "'";
			Argument<Integer> cntarg = new Argument<Integer>("cnt");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(cntarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  this.getOffp().setPedsize(""+cntarg.value);
			}
			else
			{
			  this.getOffp().setPedsize("0");
			}
			Platform.mdbCloseCursor();
			
		}
        /**
        *   source:office.@0003.script
        */
        public void setBackNum(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "SELECT COUNT(*) cnt FROM spt WHERE sta = 'B' AND ptyinr = '" + ptyinr + "'";
			Argument<Integer> cntarg = new Argument<Integer>("cnt");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(cntarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  this.getOffp().setBacksize(""+cntarg.value);
			}
			else
			{
			  this.getOffp().setBacksize("0");
			}
			Platform.mdbCloseCursor();
			
		}
        /**
        *   source:office.@0007.script
        */
        public void setGatNum(String ptyinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//设置待办文件夹数量
			String sql = "SELECT COUNT(*) cnt FROM spt WHERE sta = 'D' AND ptyinr = '" + ptyinr + "'";
			Argument<Integer> cntarg = new Argument<Integer>("cnt");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(cntarg);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  this.getOffp().setGatsize(""+cntarg.value);
			}
			else
			{
			  this.getOffp().setGatsize("0");
			}
			Platform.mdbCloseCursor();
			
		}



}