package com.ceb.gjjs.mda.manager;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.fasterxml.jackson.annotation.*;
import com.brilliance.mda.runtime.mda.util.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.vo.XxxtskVO;

import com.ceb.gjjs.mda.manager.module.Sysmod;
import com.ceb.gjjs.mda.manager.module.Tskmod;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.manager.module.Dtrmod;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
/**
* 自动清分处理服务交易
*/
@Transaction(vo= XxxtskVO.class)
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Xxxtsk extends AbstractTransaction{
		private static Logger log = LoggerFactory.getLogger(Xxxtsk.class);

		@BDGetter
		private Dtrmod dtrmod;

		@BDGetter
		private Sysmod sysmod;

		@BDGetter
		private Tskmod tskmod;


		public Xxxtsk()
        {
            super();
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:xxxtsk.@0000.script
        */
        public void service(IState state)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 报文自动清分处理服务
			  - state:IState 服务状态控制变量
			  * SWIFT库和境内外币库中的数据分别处理
			  */
			int swdRtn = 0;
			int fxdRtn = 0;
			while(state.getContinued() && this.getTskmod().isEnable2())
			{
			  if(Platform.checkFlgWithBussiness("swd"))
			  {
			    swdRtn = this.getDtrmod().distributeMessageAutomaticWithResult("swd",">");
			    // 防止解锁未成功
			    if(state.getContinued())
			      Platform.mdbUnlock(MdaEnv.getLoginUser());
			  }
			  if(Platform.checkFlgWithBussiness("fxd"))
			  {
			    fxdRtn = this.getDtrmod().distributeMessageAutomaticWithResult("fxd",">");
			    // 防止解锁未成功
			    if(state.getContinued())
			      Platform.mdbUnlock(MdaEnv.getLoginUser());
			  }
			  if(state.getContinued() && swdRtn == -1 && fxdRtn == -1)
			    state.sleep();
			}
		}




}