package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Cprlst extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Cprlst.class);

        //MPS表主键
        private String inr;

        //收发方向
        private String dir;

        //源渠道代码
        private String srcchncod;

        //当前渠道代码
        private String chncod;

        //下一渠道代码
        private String nxtchncod;

        //最终渠道代码
        private String tgtchncod;

        //当前报文
        private String smhinr;

        //消息处理状态
        private String sta;

        //消息回执状态
        private String rspsta;

        //消息接收时间
        private Date rcvdattim;

        //最近处理时间
        private Date lstdattim;

        //开始处理时间（需要延迟处理）
        private Date sttdattim;

        //最迟处理时间
        private Date tgtdattime;

        //发送时间
        private Date snddattim;

        //回执时间
        private Date rspdattim;

        //我方编号
        private String ownref;

        //对方编码
        private String othref;

        //发报机构代码
        private String sndbic;

        //收报机构代码
        private String rcvbic;

        //发报行的代理行
        private String t53bic;

        //清算行BIC
        private String actbic;

        //账号
        private String act;

        //币种
        private String cur;

        //金额
        private BigDecimal amt = new BigDecimal("0.00");

        //有效期
        private Date valdat;

        //消息类型(如:sf2)
        private String msgtyp;

        //消息格式类型(如:MT103)
        private String subtyp;

        //操作员
        private String usrnam;

        //处理附言
        private String excmsg;

        //费用明细
        private String dtlchg;

        //数字签名标志
        private String flg;

        //选择框
        private String chk;

        //gpi报文标识
        private String gpi;

        //uetr
        private String uetr;

        //信用证编号
        private String lcnb;

        //参与机构行号
        private String ptcbnk;

        //参与机构权限清单
        private String atrinf;

        //发送业务权限清单
        private String sndbns;

        //接收业务权限清单
        private String rcvbns;

        //NewField
        private String mif;

        //CIPS日间/夜间标识
        private String biztyp;




		public Cprlst()
        {
            super();
            setArgument();
        }

        public Cprlst(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }























































































}