package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Mpe;
import com.ceb.gjjs.mda.bo.Frm;
import com.ceb.gjjs.mda.bo.Mps;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.bo.Gpe;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Mdtmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Mdtmod.class);

        //报文展示
        private String msgdtl;

        //翻译电报码
        private IControl tnsbtn;

        //返回
        private IControl rtnbtn;

        //原文
        private IControl orgmsg;

        //展开
        private IControl expmsg;

        //保存报文Message的OBJ
        private String msg;

        //保存展开的报文
        private String emsg;

        //打印
        private IControl prt;

        //电报码
        private String src;

        //中文
        private String dst;

        //翻译
        private IControl trscod;

        //历史记录
        private IControl hisbtn;

        //查看错误
        private IControl lokerrcod;

        //gpi报文历史记录
        private IControl gpihisbtn;

        //存储交易名称
        private String frmnam;

        //展示UETR关联信息
        private IControl utrhisbtn;

        //G930报文
        private IControl g930btn;

        //G900报文
        private IControl g900btn;

        //应急报文流
        private IStream swemsgstm = new StreamImpl();

        //应急报文原报
        private String swemsg;

        //应急报文密文
        private String sweencmsg;

        //报文路径
        private String msgpth;

        //cips报文展开
        private IControl shwcipsdtl;

        //保存展开的cips报文
        private String cipsmsg;

        //cips报文展示页
        private String cipsdtl;

        //G990报文
        private IControl g990btn;


        @JsonIgnore
        @BDGetter
        private transient IPanel orgexpbtn;

        @JsonIgnore
        @BDGetter
        private transient IPanel mdp;

        @JsonIgnore
        @BDGetter
        private transient IPanel msgplft;

        @JsonIgnore
        @BDGetter
        private transient IPanel butp01;

        @JsonIgnore
        @BDGetter
        private transient IPanel rgt;

        @JsonIgnore
        @BDGetter
        private transient IPanel cipsmsgdtl;

        @JsonIgnore
        @BDGetter
        private transient IPanel cipsmsgshw;

        @JsonIgnore
        @BDGetter
        private transient IPanel gispmsgshwp;


	    @BDGetter
		private Smpmod smpmod;

	    @BDGetter
		private Smh smh;

		@BDGetter
		private ModuleList<Mpe> mpelst;

	    @BDGetter
		private Frm frm;

		@BDGetter
		private ModuleList<Gpe> gpelst;

	    @BDGetter
		private Mps mps;

		@BDGetter
		private ModuleList<Gpe> gpe192lst;

		@BDGetter
		private ModuleList<Gpe> gpeutrlst;


		public Mdtmod()
        {
            super();
            setArgument();
        }

        public Mdtmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:mdtmod.@0000.script
        */
        @Rule(target="rtnbtn",order=100)
        public boolean ruleRtnbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			

			return true;
        }

        /**
        *   source:mdtmod.@0009.script
        */
        @Rule(target="orgmsg",order=100)
        public boolean ruleOrgmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			if(!MdaUtils.isEmpty(this.getMsg()))
			{
			  this.setMsgdtl((String)this.getMsg());
			  
			}
			/* else
			  {
			  String path = $smpmod.getStoreFileFullPathName(
			  $smh\\docfil.getValue(),$smh\\docfxt.getValue());
			  String msg = getSwfMsg(path);
			  $msgdtl.setValue(msg);
			  $emsg.setValue(msg);//保存获取到的报文原文
			  }*/

			return true;
        }

        /**
        *   source:mdtmod.@0010.script
        */
        @Rule(target="expmsg",order=100)
        public boolean ruleExpmsgN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			this.setEmsg(NULLSTR);
			if(MdaUtils.isEmpty(this.getEmsg()))
			{
			  if(!MdaUtils.isEmpty(this.getMsg()) && !MdaUtils.isEmpty(this.getSmpmod().getMpi().getSubtyp())&&!MdaUtils.isEmpty(this.getSmpmod().getMpi().getMsgtyp()))
			  {

			    String em = expansion((String)this.getMsg(),this.getSmpmod().getMpi().getSubtyp(),this.getSmpmod().getMpi().getMsgtyp(),false);
			    if(em != null)
			    {
			      this.setMsgdtl(em);
			      this.setEmsg(em);
			    }

			  }
			}
			// else
			//   $msgdtl.setValue((String)$emsg.getValue());
			

			return true;
        }

        /**
        *   source:mdtmod.@0011.script
        */
        @Rule(target="tnsbtn",order=100)
        public boolean ruleTnsbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			String code = "";
			if(!MdaUtils.isEmpty(this.getMsg()))
			{
			  code = transCode(this.getMsg());
			}
			this.setMsgdtl( code);
			

			return true;
        }

        /**
        *   source:mdtmod.@0012.script
        */
        @Rule(target="trscod",order=100)
        public boolean ruleTrscodN100(){
            IContext ctx = MdaEnv.getContext();
            
			this.setDst( transfChinese(this.getSrc()));
			

			return true;
        }

        /**
        *   source:mdtmod.@0015.script
        */
        @Rule(target="hisbtn",order=100)
        public boolean ruleHisbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			Platform.mdbRead(this.getSmpmod().getMps(),new Argument<String>("inr",EQ,this.getSmpmod().getMpi().getInr()));
			log.info("{}","[MPS INR]"+this.getSmpmod().getMps().getInr());
			log.info("{}","[MPI INR]"+this.getSmpmod().getMpi().getInr());
			//读取mpe记录
			Argument mpearg = new Argument<String>("mpsinr",EQ,this.getSmpmod().getMps().getInr());
			if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getPntinr()))
			{
			  mpearg = mpearg.or("mpsinr",EQ,this.getSmpmod().getMps().getPntinr());
			}
			Platform.mdbReadset(this.getMpelst(),mpearg,new Argument<Date>("dattim",ASC));
			/*for(int i=0;i<$mpelst.size();i++)
			  {
			  Platform.clear($frm);
			  Platform.mdbRead($frm,new Argument("frm",EQ,$mpelst[i]\\frmnam.getValue()));
			  String key = $frm\\dsp.getValue();
			  String nam = Platform.getI18nValue("eibs",key);
			  $mpelst[i]\\frmnam = nam;
			  }*/
			log.debug("{}","mpelst长度"+this.getMpelst().fullSize());
			
			/*
			  String txt="";
			  txt = txt + #CT000044 + "              ";
			  txt = txt + #CT000045 + "  ";
			  txt = txt + #CT000046 + "                 ";
			  txt = txt + #CT000047 + "                 ";
			  txt = txt + #CT000048 + "  ";
			  txt = txt + #CT000049 + "  ";
			  txt = txt + #CT000050 + "\\r\\n";
			  for(#mpe mpe : $mpelst)
			  {
			  String dattim = Platform.format($$mpe\\dattim.getValue(),"yyyy/MM/dd HH:mm:ss");
			  String usr = $$mpe\\usr;
			  String chncod = $$mpe\\chncod;
			  String nxtchncod = $$mpe\\nxtchncod;
			  String prvsta = $$mpe\\prvsta;
			  String sta = $$mpe\\sta;
			  String pst = $$mpe\\txt;
			  //去除空字段
			  dattim = Platform.transnullString(dattim);
			  usr = Platform.transnullString(usr);
			  chncod = Platform.transnullString(chncod);
			  nxtchncod = Platform.transnullString(nxtchncod);
			  chncod = Platform.getCodetableLabel("chncod",chncod);
			  nxtchncod = Platform.getCodetableLabel("chncod",nxtchncod);
			  prvsta = Platform.transnullString(prvsta);
			  sta = Platform.transnullString(sta);
			  pst = Platform.transnullString(pst);
			  //对齐冗余
			  dattim = String.format("%-22s",dattim);
			  log.debug("dattim"+dattim.length());
			  usr = String.format("%-10s",usr);
			  chncod = String.format("%-25s",chncod);
			  nxtchncod = String.format("%-25s",nxtchncod);
			  prvsta = String.format("%-10s",prvsta);
			  sta = String.format("%-10s",sta);
			  //一行数据
			  txt=txt+dattim+usr+chncod+nxtchncod+prvsta+sta+pst+"\\r\\n";
			  }
			  $msgdtl = txt;
			  Platform.setModified($msgdtl);
			  */

			return true;
        }

        /**
        *   source:mdtmod.@0019.script
        */
        @Rule(target="lokerrcod",order=100)
        public boolean ruleLokerrcodN100(){
            IContext ctx = MdaEnv.getContext();
            
			/*如果报文被NCK，则根据错误码查找错误信息*/
			StringBuilder dspval = new StringBuilder();//错误翻译值缓冲区
			if(MdaUtils.isEmpty(this.getSmpmod().getMpi().getRpscod()))
			{
			  this.setMsgdtl("正常报文！");
			  return true;
			}
			String ecod = this.getSmpmod().getMpi().getRpscod();
			dspval.append(ecod);
			dspval.append("\r\n\r\n");
			String mty = this.getSmpmod().getMpi().getSubtyp();
			String sql = "SELECT chsdsp,engdsp FROM errcod WHERE ecod=? AND (mty LIKE ? OR mty ='ALL')";
			Platform.mdbExecuteSQL(sql,ecod,"'%"+mty+"%'");
			Argument<String> chsdsp = new Argument<String>("chsdsp");
			Argument<String> engdsp = new Argument<String>("engdsp");
			Platform.mdbFetchFields(chsdsp,engdsp);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  dspval.append("中文错误信息：");
			  dspval.append(chsdsp.value);
			  dspval.append("\r\n\r\n");
			  dspval.append("The English Error Message：");
			  dspval.append(engdsp.value);
			  this.setMsgdtl(dspval.toString());
			}
			else
			{
			  dspval.append("错误信息读取失败，请再试一次！");
			  this.setMsgdtl(dspval.toString());
			}
			Platform.mdbCloseCursor();
			

			return true;
        }

        /**
        *   source:mdtmod.@0022.script
        */
        @Rule(target="gpihisbtn",order=100)
        public boolean ruleGpihisbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","hislst");
			
			
			
			
			
			String frmnam = this.getFrmnam();
			if("gcvsel".equals(frmnam) || "gndsel".equals(frmnam) )
			{
			  
			  Platform.mdbReadset(this.getGpelst(),new Argument<Date>("credattim",ASC),new Argument<String>("orimpsinr",EQ,this.getSmpmod().getMpi().getInr()));
			  log.info("{}","gpelst长度为"+this.getGpelst().size());

			  
			  log.info("{}","gpelst");
			}
			else if("ggvsel".equals(frmnam) || "pndsel".equals(frmnam))
			{
			  
			  Platform.mdbReadset(this.getGpe192lst(),new Argument<Date>("credattim",ASC),new Argument<String>("orimpsinr",EQ,this.getSmpmod().getMpi().getInr()));
			  log.info("{}","gpe192lst长度为"+this.getGpe192lst().size());
			  
			  log.info("{}","gpe192lst");
			}

			return true;
        }

        /**
        *   source:mdtmod.@0023.script
        */
        @Rule(target="utrhisbtn",order=100)
        public boolean ruleUtrhisbtnN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.info("{}","uetrlst");
			
			
			
			
			
			Platform.mdbReadset(this.getGpeutrlst(),new Argument<Date>("credattim",ASC),new Argument<String>("uetr",EQ,this.getSmpmod().getMpi().getUetr()));
			log.info("{}","gpeutrlst长度为"+this.getGpeutrlst().size());
			
			log.info("{}","uetrlst");


			return true;
        }

        /**
        *   source:mdtmod.@0028.script
        */
        @Rule(target="shwcipsdtl",order=100)
        public boolean ruleShwcipsdtlN100(){
            IContext ctx = MdaEnv.getContext();
            
			if(MdaUtils.isEmpty(this.getCipsmsg()))
			{
			  ctx.setMessage("提示","该报文类型暂时不支持此功能");
			  return false;
			}
			this.setCipsdtl(this.getCipsmsg());
			
			//页面不可编辑
			//页面不可编辑
			

			return true;
        }



        /**
        *   source:mdtmod.@0018.script
        */
        @Init(order=1000)
        public boolean	init1000(){
            IContext ctx = MdaEnv.getContext();
            
			
			
			
			
			
			

			return true;
        }


        /**
        *   source:mdtmod.@0002.script
        */
        public void expain()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);

		}
        /**
        *   source:mdtmod.@0003.script
        */
        public List getTagLst(String subtyp,String msgtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(msgtyp == null || "".equals(msgtyp)||"".equals(subtyp))
			  return null;
			List tagList = new ArrayList();
			if("sf2".equals(msgtyp))
			{
			  if (!msgtyp.startsWith("MT"))
			    subtyp = "MT " + subtyp;
			}
			else if("txt".equals(msgtyp))
			{
			  if (!msgtyp.startsWith("FMT"))
			    subtyp = "FMT " + subtyp;
			}
			/*if (msgtyp.charAt(4) == '9')
			  msgtyp = "MT n" + msgtyp.substring(4);*/
			String sql = "SELECT inr,tag,fldnam,sta,cyc,mty,tno,midnam,msgdsp,chsdsp FROM mfd WHERE mty=? ORDER BY tno ASC";
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> tag = new Argument<String>("tag");
			Argument<String> fldnam = new Argument<String>("fldnam");
			Argument<String> sta = new Argument<String>("sta");
			Argument<String> cyc = new Argument<String>("cyc");
			Argument<String> mty = new Argument<String>("mty");
			Argument<Integer> tno = new Argument<Integer>("tno");
			Argument<String> midnam = new Argument<String>("midnam");
			Argument<String> msgdsp = new Argument<String>("msgdsp");
			Argument<String> chsdsp = new Argument<String>("chsdsp");
			Object session = Platform.esdbExecuteSQL("eibs",sql,subtyp);
			while(true)
			{
			  Platform.esdbFetchFields(session,tag,fldnam,sta,cyc,mty,tno,midnam,msgdsp,chsdsp);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    Map<String,String> tagMap = new HashMap<String,String>();
			    tagMap.put("inr", inr.value);
			    if(tag != null && !MdaUtils.isEmpty(tag))
			    {
			      if(tag.value.contains("79")&&mty.value.startsWith("FMT"))
			      {
			        tag.value = "79";
			      }
			    }
			    tagMap.put("tag", tag.value);
			    tagMap.put("fldnam",fldnam.value);
			    tagMap.put("sta", sta.value);
			    tagMap.put("cyc", cyc.value);
			    tagMap.put("mty", mty.value);
			    tagMap.put("tno", tno.value.toString());
			    tagMap.put("midnam", midnam.value);
			    tagMap.put("msgdsp",msgdsp.value);
			    tagMap.put("chsdsp",chsdsp.value);
			    tagList.add(tagMap);
			  }
			  else
			    break;
			}
			Platform.esdbCloseCursor(session);
			return tagList;
		}
        /**
        *   source:mdtmod.@0004.script
        */
        public String expansion(String arg,String subTyp,String msgTyp,boolean isFile)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  arg:传入参数，文件路径或直接为报文
			  msgTyp:报文类型
			  isFile:是否为文件，如是则为true，否则为false
			  */
			Object em = null;
			List tagLst = getTagLst(subTyp,msgTyp);
			if(tagLst == null || tagLst.size()==0)
			  return null;
			String funNam = null;
			if(isFile)
			  funNam = "expansionViaFile";
			else
			  funNam = "expansionViaMsg";
			em = MdaUtils.invoke("com.brilliance.swift.MessageReader",funNam,arg,tagLst);
			if(em != null)
			  return em.toString();
			else
			  return null;
		}
        /**
        *   source:mdtmod.@0006.script
        */
        public void initMdt(String smhinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.invoke("com.brilliance.swift.MessageReader","initTagCallback",new ICallback() {
				@Override
				public Object invoke(Object... paramVarArgs) {
					getTagPattern(paramVarArgs);
					return null;
				}
			});
			log.debug("{}","init 1st");
			Platform.mdbRead(this.getSmh(),new Argument<String>("inr",EQ,smhinr));
			log.debug("{}","init 2nd");
			if(!MdaUtils.isEmpty(this.getSmh().getInr()))
			{
			  log.debug("{}","init 3rd");
			  Platform.mdbRead(this.getSmpmod().getMpi(),new Argument<String>("inr",this.getSmh().getMpiinr()));
			  log.debug("{}","init 4th");
			  log.debug("{}",this.getSmh().getDocfil());
			  log.debug("{}",this.getSmh().getDocfxt());
			  log.debug("{}",this.getSmpmod().getFulldatapath());
			  log.info("{}","fullpath "+this.getSmpmod().getFulldatapath());
			  log.info("{}","5th");
			  String path = null;
			  if("cips|xml".contains(this.getSmh().getDocfxt()))
			    path = this.getSmpmod().getCipsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  else if("b2e|jsh".contains(this.getSmh().getDocfxt()))
			  {
			    path = this.getSmpmod().getB2eStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  }
			  else if("exl|elcs".contains(this.getSmh().getDocfxt()))
			  {
			    path = this.getSmpmod().getElcsStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  }
			  else
			    path = this.getSmpmod().getStoreFileFullPathName(this.getSmh().getDocfil(),this.getSmh().getDocfxt());
			  log.debug("{}","[MESSAGE PATH]:"+path);
			  if(MdaUtils.isEmpty(path))
			    ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000079"),MdaUtils.getI18NString("mdtmod","CT000080"));
			  else
			  {
			    log.debug("{}","path is not null..");
			    this.setMsgpth( path);
			    String msg = getSwfMsg(path);
			    if("cips|xml".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getCipsMsg(path);
			      String cipsdtl = getCipsDtl(path,this.getSmpmod().getMpi().getSubtyp());
			      this.setCipsmsg(cipsdtl);
			    }
			    if("exl|elcs".contains(this.getSmh().getDocfxt()))
			    {
			      msg = null;
			      msg = getElcsMsg(path);
			    }
			    if(MdaUtils.isEmpty(msg) || (msg == null))
			    {
			      //调用接口平台或JAVA方法获取文件服务器上对应目录的文件
			      log.debug("{}","getMessageFromFileServer...");
			      msg = ctx.absGet(Sysmod.class).getMessageFromFileTransfer(path);
			    }
			    this.setMsgdtl(msg);
			    this.setMsg(msg);//保存获取到的报文原文
			    log.trace("{}",msg);
			  }
			}
		}
        /**
        *   source:mdtmod.@0008.script
        */
        public String getSwfMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:mdtmod.@0013.script
        */
        public String transfChinese(String codeStr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//String rts = new String(byte[],"GBK");
			//检查电报码格式
			if(codeStr.length()<4||codeStr.length()%4 != 0)
			{
			  ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000034"),MdaUtils.getI18NString("mdtmod","CT000035"));
			  return "";
			}
			byte codeadd = Byte.parseByte("80",16);
			byte[] codebyte = new byte[2];
			codebyte[0] = Byte.parseByte(codeStr.substring(0,2),16);
			codebyte[0] = codebyte[0];
			codebyte[1] = Byte.parseByte(codeStr.substring(2,4),16);
			codebyte[1] = codebyte[1];
			log.debug("{}",Byte.toString(codebyte[0]));
			log.debug("{}",Byte.toString(codebyte[1]));
			return stringtrycatch(codebyte);
		}
        /**
        *   source:mdtmod.@0014.script
        */
        public String stringtrycatch(byte[] codebyte)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  return new String(codebyte,"GBK");
			}
			catch(Exception e)
			{
			  return "";
			}
		}
        /**
        *   source:mdtmod.@0016.script
        */
        public String[] getTagPattern(Object... tagNamArr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(tagNamArr == null || tagNamArr.length == 0)
			  return null;
			String tagNam = (String)tagNamArr[0];
			if(tagNam == null)
			  return null;
			String sql = "SELECT ptn,adj,desptn FROM tfi WHERE tag = ?";
			String ptnStr= null;
			Object session = Platform.esdbExecuteSQL("eibs",sql,tagNam);
			Argument<String> ptn = new Argument<String>("ptn");
			Argument<String> adj = new Argument<String>("adj");
			Argument<String> desptn = new Argument<String>("desptn");
			String[] ptnsArr = null;
			Platform.esdbFetchFields(session,ptn,adj,desptn);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  ptnsArr = new String[]{ptn.value,adj.value,desptn.value};
			}
			Platform.esdbCloseCursor(session);
			return ptnsArr;
		}
        /**
        *   source:mdtmod.@0017.script
        */
        public String transCode(String msg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String tmsg = (String)MdaUtils.invoke("com.brilliance.swift.MessageReader","transMsg",msg);
			return tmsg;
		}
        /**
        *   source:mdtmod.@0021.script
        */
        public String getCipsMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getCipsMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:mdtmod.@0024.script
        */
        public String getElcsMsg(String pth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(pth == null)
			  return null;
			Object obj = MdaUtils.invoke("com.brilliance.swift.MessageReader","getElcsMsg",pth);
			if(obj == null)
			  return null;
			else
			  return obj.toString();
		}
        /**
        *   source:mdtmod.@0025.script
        */
        public String loadSweMessage(boolean origMsg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String path = this.getMsgpth();
			log.debug("{}","[SF2 MESSAGE PATH]:"+path);
			if(origMsg)
			{
			  path = path.replace(".sf2",".gisp");
			}
			else
			{
			  path = path.replace(".sf2",".gispx");
			}
			log.debug("{}","[MESSAGE PATH]:"+path);
			IStream is = this.getSwemsgstm();
			MdaUtils.streamClear(is);
			Platform.mstreamLoad(is,path);
			return Platform.convertIStream2String(is);
		}
        /**
        *   source:mdtmod.@0026.script
        */
        public String getCipsDtl(String path,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!"111|112|301|302|303|304|309|356|357".contains(type))
			{
			  return "";
			}
			String propertiespath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			String propertiesname = "cips"+type+".properties";
			String filenam = MdaUtils.catPath(propertiespath,propertiesname);
			log.debug("{}","CIPS detail properties:"+filenam);
			Object[] paths = new Object[1];
			paths[0] = path;
			Object object = MdaUtils.invoke("com.brilliance.eibs.main.Client","scall","cipsmsgfromcips","msgfromcips",paths);
			Boolean obt = (Boolean)MdaUtils.invoke(object,"isSuccess");
			log.debug("{}","obt-------"+obt);
			if(!obt)
			{
			  ctx.setMessage(MdaUtils.getI18NString("mdtmod","CT000113"),MdaUtils.getI18NString("mdtmod","CT000114"));
			  return "";
			}
			//获取接口平台返回的内容
			Object[] obj = (Object[])MdaUtils.invoke(object,"getContent");//报文内容
			log.debug("{}","CIPS报文内容:"+obj);
			Map<String,Object> map = (Map<String,Object>)obj[1];//解析的map信息
			log.debug("{}","CIPS map:"+map);
			String str = dealCIPSMap(map,filenam,"",type);
			log.debug("{}","str:"+str);
			return str;
		}
        /**
        *   source:mdtmod.@0027.script
        */
        public String dealCIPSMap(Map<String,Object> map,String path,String value,String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			String strmap="";
			String ordernam = MdaUtils.getPropertyValue(path,value+"order");
			String[] orders= ordernam.split(",");
			Object obj = null;
			for(int i=0;i<orders.length;i++)
			{
			  String label = orders[i];
			  log.debug("{}",label);
			  int index = label.indexOf(".");
			  if(index>0)
			  {
			    obj = map.get(label.substring(0,index));
			  }
			  else
			  {
			    obj = map.get(label);
			  }
			  if(obj == null)
			  {
			    continue;
			  }
			  if(obj instanceof String)
			  {
			    String objstr = (String)obj;
			    strmap = dealCIPSString(label,objstr,path);

			  }
			  if(obj instanceof ArrayList)
			  {
			    ArrayList objlst = (ArrayList)obj;
			    strmap = dealCIPSLst(label,objlst,path);
			  }
			  if(obj instanceof Map)
			  {
			    Map objmap = (Map<String,Object>)obj;
			    String key = MdaUtils.getPropertyValue(path,label);
			    str.append(key).append(" : ").append("\r\n");
			    strmap = dealCIPSMap(objmap,path,label,"");
			  }
			  str.append(strmap);
			  //给111报文添加主体部分添加一行间隔
			  if("Ustrd".equals(label) && "111".equals(type) )
			  {
			    str.append("\r\n");
			  }
			  //给301、302、303、304、309报文添加主体部分添加一行间隔
			  if("Cntt".equals(label) && "301".equals(type) )
			  {
			    str.append("\r\n");
			  }
			  if("Rsn".equals(label) && "302".equals(type) )
			  {
			    str.append("\r\n");
			  }
			  if("HMsgRef".equals(label) && "303|304".contains(type))
			  {
			    str.append("\r\n");
			  }
			  if("MsgCntt".equals(label) && "309".equals(type) )
			  {
			    str.append("\r\n");
			  }
			}
			return str.toString();
		}
        /**
        *   source:mdtmod.@0029.script
        */
        public String dealCIPSString(String label,String obj,String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			String key = MdaUtils.getPropertyValue(path,label);
			str.append(key).append(" : ").append((String)obj).append("\r\n");
			return str.toString();
		}
        /**
        *   source:mdtmod.@0030.script
        */
        public String dealCIPSLst(String label,ArrayList obj,String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer str = new StringBuffer("");
			String key = MdaUtils.getPropertyValue(path,label);
			int length = obj.size();
			String strlst = "";
			for(int i=0;i<length;i++)
			{
			  if(obj.get(i) instanceof String)
			  {
			    strlst = (String)obj.get(i);
			    str.append(key).append(String.valueOf((i+1))).append(" : ").append(strlst).append("\r\n");
			  }
			  if(obj.get(i) instanceof Map)
			  {
			    Map lstmap = (Map<String,Object>)obj.get(i);
			    strlst = dealCIPSMap(lstmap,path,label,"");
			    str.append(key).append(String.valueOf((i+1))).append(" : ").append("\r\n");
			    str.append(strlst);
			  }
			}
			return str.toString();
		}





























































}