package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Efd;
import com.ceb.gjjs.mda.bo.Stb;
import com.ceb.gjjs.mda.bo.Bnssta;
import com.ceb.gjjs.mda.bo.Etg;
import com.ceb.gjjs.mda.bo.Spt;
import com.ceb.gjjs.mda.bo.Pty;
import com.ceb.gjjs.mda.bo.Usr;
import com.ceb.gjjs.mda.bo.Rol;
import com.ceb.gjjs.mda.bo.Url;
import com.ceb.gjjs.mda.bo.Usrlog;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Ety;
import com.ceb.gjjs.mda.bo.Fipsta;
import com.ceb.gjjs.mda.bo.Bch;
import com.ceb.gjjs.mda.bo.Sth;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Sysmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Sysmod.class);

        //是否是批量提交
        private String flg;

        //跨交易传递订单编号
        private String ordinr;

        //跨交易传递sptinr
        private String sptinr;

        //主页
        private IControl index;

        //退出
        private IControl logout;

        //上一个交易名称
        private String lsttrn;

        //动态OBJ
        private Object dynobj;

        //个人信息维护
        private IControl usrinf;

        //进入交易是否进行权限控制
        private String linkallow;

        //待办任务数据
        private IStream sptdatstm = new StreamImpl();

        //记账类型
        private List ktplst;

        //两位国别码
        private List shtctylst;

        //三位国别码
        private List lngctylst;



	    @BDGetter
		private Pty pty;

	    @BDGetter
		private Usr usr;

	    @BDGetter
		private Rol rol;

	    @BDGetter
		private Ety ety;

	    @BDGetter
		private Etg etg;

	    @BDGetter
		private Spt spt;

	    @BDGetter
		private Usrlog usrlog;

	    @BDGetter
		private Bch topbch;

	    @BDGetter
		private Bch ownbch;

	    @BDGetter
		private Spt wrkspt;

	    @BDGetter
		private Url usrrol;

	    @BDGetter
		private Sth sth;

	    @BDGetter
		private Stb stb;

	    @BDGetter
		private Fipsta fipsta;

	    @BDGetter
		private Bnssta bnssta;

	    @BDGetter
		private Efd efd;

	    @BDGetter
		private Efd efdtmp;

	    @BDGetter
		private Efd efdup;


		public Sysmod()
        {
            super();
            setArgument();
        }

        public Sysmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }

        /**
        *   source:sysmod.@0009.script
        */
        @Rule(target="index",order=100)
        public boolean ruleIndexN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("office");

			return true;
        }

        /**
        *   source:sysmod.@0010.script
        */
        @Rule(target="logout",order=100)
        public boolean ruleLogoutN100(){
            IContext ctx = MdaEnv.getContext();
            
			log.debug("{}","platform.logout");
			ctx.logout();

			return true;
        }

        /**
        *   source:sysmod.@0032.script
        */
        @Rule(target="usrinf",order=100)
        public boolean ruleUsrinfN100(){
            IContext ctx = MdaEnv.getContext();
            
			Platform.mchain("dbpusr");

			return true;
        }



        /**
        *   source:sysmod.@0007.script
        */
        @Init(order=100)
        public boolean	init100(){
            IContext ctx = MdaEnv.getContext();
            

			return true;
        }

        /**
        *   source:sysmod.@0042.script
        */
        @Init(order=500)
        public boolean	init500(){
            IContext ctx = MdaEnv.getContext();
            
			if(!"dbebrc".equals(Platform.sgetTransName()))
			{
			  //加载总行模型数据
			  MdaUtils.clear(this.getTopbch());
			  Platform.mdbRead(this.getTopbch(),new Argument("lev","0"));
			  int errorcode = ctx.getErrorCode();
			  //log.debug("读取总行BCH表记录,错误码:" + errorcode);
			  //加载柜员所属机构数据
			  MdaUtils.clear(this.getOwnbch());
			  //log.debug("usr bchcod:"+$usr\\bchcod.getValue());
			  Platform.mdbRead(this.getOwnbch(),new Argument<String>("branch",this.getUsr().getBchcod()));
			  errorcode = ctx.getErrorCode();
			  //log.debug("读取柜员所属BCH表记录,错误码:" + errorcode);
			}
			//读取所属机构、实体、实体组信息
			if(!MdaUtils.isEmpty(this.getUsr().getPtyinr()))
			{
			  MdaUtils.clear(this.getPty());
			  Platform.mdbRead(this.getPty(),new Argument("inr",this.getUsr().getPtyinr()));
			  int err = ctx.getErrorCode();
			  Platform.mdbConnect("eibs");
			  MdaUtils.clear(this.getEty());
			  MdaUtils.clear(this.getEtg());
			  if(!(MdaUtils.isBackground() || MdaUtils.isEmpty(this.getPty().getEtyinr())))
			  {
			    Platform.mdbRead(this.getEty(),new Argument("inr",this.getPty().getEtyinr()));
			    err = ctx.getErrorCode();
			    if(!MdaUtils.isEmpty(this.getEty().getEtginr()))
			    {
			      Platform.mdbRead(this.getEtg(),new Argument("inr",this.getEty().getEtginr()));
			      err = ctx.getErrorCode();
			    }
			  }
			}

			return true;
        }

        /**
        *   source:sysmod.@0066.script
        */
        @Init(order=101)
        public boolean	init101(){
            IContext ctx = MdaEnv.getContext();
            
			//Platform.setDefaultDB("eibs");
			log.debug("{}","sysmod init 101");
			if(!MdaUtils.isEmpty(this.getUsr().getInr()))
			{
			  log.debug("{}",ctx.getTransName() + ",usr.inr = " + this.getUsr().getInr()+ ",ety = " + this.getUsr().getPtynam());
			  return true;
			}
			String usrnam = MdaEnv.getLoginUser();
			log.debug("{}","usrnam:"+usrnam);
			Platform.mdbRead(this.getUsr(),new Argument<String>("nam",usrnam));
			if(MdaUtils.isEmpty(this.getUsr().getInr()))
			{
			  ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000171"),MdaUtils.getI18NString("sysmod","CT000172"));
			  return true;
			}
			Platform.mdbRead(this.getUsrrol(),new Argument<String>("usrinr",this.getUsr().getInr()));
			if(MdaUtils.isEmpty(this.getUsrrol().getUsrinr()))
			{
			  //Platform.message(#CT000173,#CT000174);
			  //log.debug("该用户没有关联信息，URL的USRINR为空");
			  return true;
			}
			Platform.mdbRead(this.getRol(),new Argument<String>("inr",this.getUsrrol().getRolinr()));
			log.debug("{}","url rolinr:"+this.getUsrrol().getRolinr());
			if(MdaUtils.isEmpty(this.getRol().getInr()))
			{
			  log.debug("{}","rol inr empty");
			  ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000193"),MdaUtils.getI18NString("sysmod","CT000194"));
			  return true;
			}
			log.info("{}","load usr OK! inr = "+this.getUsr().getInr()+".ety="+this.getUsr().getPtynam()+ ",rol=" + this.getRol().getNam());
			/*Platform.clear($bch);
			  log.debug("bchcod = "+$usr\\bchcod);
			  Platform.mdbRead($bch,new Argument<String>("branch",$usr\\bchcod.getValue()));
			  int errorcode = Platform.errorCode();
			  if(errorcode != NO_ERROR)
			  log.error("读取用户所属机构失败，错误码：" + errorcode);*/

			return true;
        }

        /**
        *   source:sysmod.@0067.script
        */
        @Init(order=200)
        public boolean	init200(){
            IContext ctx = MdaEnv.getContext();
            
			String sptInr = (String)ctx.restoreData("sptinr");
			if(!MdaUtils.isEmpty(sptInr))
			{
			  MdaUtils.clear(this.getSpt());
			  int errorcode = ctx.getErrorCode();
			  Platform.mdbRead(this.getSpt(),new Argument("inr",sptInr));
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			    ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000179"),MdaUtils.getI18NString("sysmod","CT000180"));
			  else
			  {
			    IStream sptstm = this.getSptdatstm();
			    MdaUtils.clear(sptstm);
			    if(!loadSptData(sptstm,this.getSpt().getInr()))
			    {
			      MdaUtils.clear(this.getSpt());
			      ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000181"),MdaUtils.getI18NString("sysmod","CT000182"));
			    }
			    else
			    {
			      IModule recGrpModule = MdaDriver.getModule(this,ctx.getRoot(),"mtabut\\mtagrp");
			      if(recGrpModule == null)
			      {
			        MdaUtils.clear(this.getSpt());
			        ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000183"),MdaUtils.getI18NString("sysmod","CT000184"));
			      }
			      else
			      {
			        MdaUtils.loadData(recGrpModule,sptstm);
			        if(ctx.getErrorCode() != NO_ERROR)
			        {
			          MdaUtils.clear(this.getSpt());
			          ctx.setMessage(MdaUtils.getI18NString("sysmod","CT000185"),MdaUtils.getI18NString("sysmod","CT000186"));
			        }
			      }
			    }
			  }
			}

			return true;
        }


        /**
        *   source:sysmod.@0006.script
        */
        public List<CodetableItem> getSysCurLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","getsyscurlst");
			List<CodetableItem> curLst = new ArrayList<CodetableItem>();
			curLst.add(new CodetableItem("",""));
			String sql = "SELECT cur,curnam FROM cur";
			Platform.mdbExecuteSQL(sql);
			Argument<String> cur = new Argument<String>("cur");
			Argument<String> curnam = new Argument<String>("curnam");
			while(true)
			{
			  Platform.mdbFetchFields(cur,curnam);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    CodetableItem c = new CodetableItem(cur.value,cur.value);
			    curLst.add(c);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return curLst;
		}
        /**
        *   source:sysmod.@0014.script
        */
        public boolean isHodBank(String bic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 直接通过ptytyp校验bic是否为我行账户行
			  */

			if(MdaUtils.isEmpty(bic))
			  return false;
			//boolean isHodbank=false;
			//String ptyinr=$pty\\inr.getValue();
			//if(Platform.isEmpty(ptyinr))
			//ptyinr ="00000000";
			//String sql="SELECT inr FROM pta WHERE ptatyp='C' AND objinr=(SELECT inr FROM pty WHERE extkey='"+bic+"') AND ptyinr='"
			//+ptyinr+"'";
			/*
			  String sql="SELECT inr FROM pta WHERE ptatyp='C' AND  EXISTS  (SELECT inr FROM pty WHERE extkey='"+bic
			  +"' AND inr=objinr)  AND objtyp ='pty' AND ptyinr='"+ptyinr+"'";
			  */
			String sql = "SELECT inr FROM pty WHERE ptytyp LIKE '%T%' AND EXTKEY='"+bic+"'";

			//增加实体查询条件
			sql = sql + ctx.absGet(Sysmod.class).getEtySql();

			Argument<String>inr = new Argument<String>("inr");
			Platform.mdbExecuteSQL(sql);
			boolean isExist=false;
			Platform.mdbFetchFields(inr);
			int err=ctx.getErrorCode();
			if(err==NO_ERROR)
			{
			  isExist=true;
			}
			Platform.mdbCloseCursor();
			return isExist;
		}
        /**
        *   source:sysmod.@0016.script
        */
        public List<CodetableItem> getCodeTable(String tblnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(tblnam))
			{
			  return null;
			}
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			String sql = "SELECT txt,cod FROM stb WHERE tbl = '" + tblnam + "' AND uil = 'zh_CN'";
			Argument<String> txtarg = new Argument<String>("txt");
			Argument<String> codarg = new Argument<String>("cod");
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(txtarg,codarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    cts.add(new CodetableItem(txtarg.value,codarg.value));
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			return cts;
		}
        /**
        *   source:sysmod.@0020.script
        */
        public String getPtyinrForBIC(String bic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 查询BIC的ptyinr
			  *- String bic bic 代码
			  * @ return String bic所对应的ptyinr，如果没有查询到记录则返回null
			  */
			if(MdaUtils.isEmpty(bic))
			  return null;
			bic = bic.replaceAll("'","");
			String sql = "SELECT inr FROM pty y WHERE EXTKEY='"+bic+"'";
			sql = sql+ctx.absGet(Sysmod.class).getEtySql("y");
			Argument<String> inr = new Argument<String>("inr");
			Object session = Platform.esdbExecuteSQL("swd",sql);
			Platform.esdbFetchFields(session,inr);
			int err = ctx.getErrorCode();
			Platform.esdbCloseCursor(session);
			if(err == NO_ERROR)
			{
			  return inr.value;
			}
			return null;
		}
        /**
        *   source:sysmod.@0029.script
        */
        public String getBnkNamForBIC(String bic,boolean isEngNam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 查询BIC的ptyinr
			  *- String bic bic 代码
			  * @ return String bic所对应的ptyinr，如果没有查询到记录则返回null
			  */
			if(MdaUtils.isEmpty(bic))
			  return null;
			String sql = "SELECT chnnam,engnam FROM pty WHERE  EXTKEY='"+bic+"'";
			Argument<String> chnnam = new Argument<String>("chnnam");
			Argument<String> engnam = new Argument<String>("engnam");
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(chnnam,engnam);
			int err=ctx.getErrorCode();
			Platform.mdbCloseCursor();
			if(err==NO_ERROR)
			{
			  if(isEngNam)
			    return engnam.value;
			  else
			    return chnnam.value;
			}
			return null;
		}
        /**
        *   source:sysmod.@0043.script
        */
        public boolean checkLinkAllowed(String frameName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 检测用户是否有权限进入交易
			  - frameName 当前交易名称,不带参数
			  @ boolean 有权限返回true,否则返回false
			  */
			if(MdaUtils.isEmpty(this.getLinkallow()))
			  return true;
			else
			{
			  if("office".equals(frameName))
			    return true;
			  else
			  {
			    return false;
			  }
			}
		}
        /**
        *   source:sysmod.@0045.script
        */
        public int perCheck()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	账户行发报比例验证（综合为100%）
			  */
			int result = 0;
			String sql = "SELECT per FROM agb,pty,pta"+
			  " WHERE pty.ptytyp LIKE '%T%'" + //账户行
			  " AND pta.ptyinr = pty.inr" +
			  " AND pta.objtyp = 'agb'" +
			  " AND pta.ptatyp = 'M'" +
			  " AND pta.objinr = agb.inr";
			Argument<BigDecimal> perarg = new Argument<BigDecimal>("per");
			double persum = 0;
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(perarg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    BigDecimal argval = perarg.value;
			    log.debug("{}","argval: " + argval);
			    if(!MdaUtils.isEmpty(argval))
			    {
			      persum += argval.doubleValue();
			      //log.debug("persum: " + persum);
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			log.debug("{}","persum: " + persum);
			if(persum == 100)
			{
			  result = 0;
			}
			else if(persum > 100)
			{
			  result = 1;
			}
			else if(persum < 100)
			{
			  result = -1;
			}
			return result;
		}
        /**
        *   source:sysmod.@0049.script
        */
        public List<CodetableItem> getBranchLevelCodetable()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			//分行可以维护支行
			if("1".equals(this.getOwnbch().getLev()))
			{
			  CodetableItem cti = new CodetableItem("支行","2");
			  cts.add(cti);
			}
			else if("0".equals(this.getOwnbch().getLev()))
			{
			  //总行可以维护分行,支行
			  CodetableItem cti1 = new CodetableItem("分行","1");
			  cts.add(cti1);
			  CodetableItem cti2 = new CodetableItem("支行","2");
			  cts.add(cti2);
			}
			return cts;
		}
        /**
        *   source:sysmod.@0050.script
        */
        public List<CodetableItem> getRootBranchLevelCodetable()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			CodetableItem cti = new CodetableItem("总行","0");
			cts.add(cti);
			return cts;
		}
        /**
        *   source:sysmod.@0051.script
        */
        public List<CodetableItem> getUpBranch(String ownlev ,String bchlev)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取上级行
			  - ownlev 自身机构级别
			  - bchlev 目标机构级别
			  @ List<CodetableItem> codetable
			  */
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			if("0".equals(bchlev))
			{
			  //如果目标行是总行,那么就只能选择总行自身
			}
			return cts;
		}
        /**
        *   source:sysmod.@0052.script
        */
        public List<CodetableItem> getAllowBranchCodetable(String userBranchInr,String userBranchLevel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 获取用户机构下辖机构
			  - userBranchInr 用户机构主键
			  - userBranchLevel 用户机构级别
			  @ List<CodetableItem> codetable
			  */
			List<CodetableItem> cts = new ArrayList<CodetableItem>();
			String sql = "";
			//如果是总行,则可以看到所有机构
			if("0".equals(userBranchLevel))
			{
			  sql = "SELECT INR,BCHKEY,NAM FROM BCH WHERE STA ='0' ORDER BY LEV,BCHKEY ASC";
			  Platform.mdbExecuteSQL(sql);
			}
			else
			{
			  //分支行只能查询自己及下辖机构
			  sql = "SELECT INR,BCHKEY,NAM FROM BCH WHERE STA = '0' AND (INR = ? OR PNTBCHINR = ?)";
			  Platform.mdbExecuteSQL(sql,userBranchInr,userBranchInr);
			}
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> bchkey = new Argument<String>("bchkey");
			Argument<String> nam = new Argument<String>("nam");
			while(true)
			{
			  Platform.mdbFetchFields(inr,bchkey,nam);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    CodetableItem c = new CodetableItem(bchkey.value + "-" + nam.value,inr.value);
			    cts.add(c);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return cts;
		}
        /**
        *   source:sysmod.@0053.script
        */
        public Argument getBranchArgument(String userBranchInr,String userBranchLevel,String fieldName)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql = "";
			//如果是总行,则可以看到所有机构
			if("0".equals(userBranchLevel))
			{
			  sql = "SELECT INR FROM BCH WHERE STA ='0' ORDER BY LEV,BCHKEY ASC";
			  Platform.mdbExecuteSQL(sql);
			}
			else
			{
			  //分支行只能查询自己及下辖机构
			  sql = "SELECT INR FROM BCH WHERE STA = '0' AND (INR = ? OR PNTBCHINR = ?)";
			  Platform.mdbExecuteSQL(sql,userBranchInr,userBranchInr);
			}
			Argument<String> inr = new Argument<String>("inr");
			List<String> list = new ArrayList<String>();
			while(true)
			{
			  Platform.mdbFetchFields(inr);
			  Platform.mdbCloseCursor();
			  if(ctx.getErrorCode()==NO_ERROR)
			    list.add(inr.value);
			  else
			    break;
			}
			String [] values = new String[list.size()];
			for(int i=0;i<list.size();i++)
			  values[i] = list.get(i);
			Argument arg = new Argument(fieldName,IN,values);
			return arg;
		}
        /**
        *   source:sysmod.@0054.script
        */
        public List<String> getAllBranch()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	根据当前登录用户所属机构查询其自身和所有下辖机构的机构inr
			  */
			if(MdaUtils.isEmpty(this.getOwnbch().getInr()))
			{
			  log.warn("{}","当前登录用户所属机构信息不存在");
			  return null;
			}
			String bchinr = this.getOwnbch().getInr();
			return this.getSubBranch(bchinr);
		}
        /**
        *   source:sysmod.@0055.script
        */
        public List<String> getSubBranch(String upbchinr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	递归查询下辖机构
			  */
			//  log.debug("upbchcod:" + upbchcod);
			List<String> bchlst = new ArrayList<String>();
			if(MdaUtils.isEmpty(upbchinr))
			{
			  return null;
			}
			upbchinr = upbchinr.trim();
			bchlst.add(upbchinr);
			List<String> curbchlst = new ArrayList<String>();
			String sql = "SELECT inr FROM bch WHERE pntbchinr = '" + upbchinr + "'";
			Platform.mdbExecuteSQL(sql);
			Argument<String> bcharg = new Argument<String>("inr");
			while(true)
			{
			  Platform.mdbFetchFields(bcharg);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    curbchlst.add(bcharg.value);
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			//  log.debug("curbchlst size:" + curbchlst.size());
			for(int i=0;i<curbchlst.size();i++)
			{
			  //log.debug("i:" + i);
			  String subbchinr = curbchlst.get(i);
			  if(MdaUtils.isEmpty(subbchinr))
			  {
			    continue;
			  }
			  if(upbchinr.equals(subbchinr.trim()))//所属机构为本身情况不再参与递归
			  {
			    continue;
			  }
			  ///递归查询此下辖机构的下辖机构号（包括自己）
			  List<String> subbchlst = getSubBranch(subbchinr);
			  if(subbchlst != null)
			  {
			    for(int j=0;j<subbchlst.size();j++)
			    {
			      // log.debug("i,j:" + i + "," + j);
			      bchlst.add(subbchlst.get(j));
			    }
			  }
			}
			return bchlst;
		}
        /**
        *   source:sysmod.@0057.script
        */
        public List<String> getAllBchinrSum(IDatafield df)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<String> bchinrlst = new ArrayList<String>();
			if(MdaUtils.isEmpty(df))
			{
			  bchinrlst = this.getAllBranch();
			}
			else
			{
			  bchinrlst.add((String)df.getValue());
			}
			return bchinrlst;
		}
        /**
        *   source:sysmod.@0058.script
        */
        public String getAllBchinrSumINString(IDatafield df)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<String> bchinrlst = this.getAllBchinrSum(df);
			String inString = "";
			for(int i=0;i<bchinrlst.size();i++)
			{
			  inString += bchinrlst.get(i) + ",";
			}
			inString = inString.substring(0,inString.length() - 1);
			return inString;
		}
        /**
        *   source:sysmod.@0059.script
        */
        public List<CodetableItem> getBranchCodetableByBranchLevel(String branchLevel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> ct = new ArrayList<CodetableItem>();
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> bchkey = new Argument<String>("bchkey");
			Argument<String> nam = new Argument<String>("nam");
			int errorcode = ctx.getErrorCode();
			Platform.mdbExecuteSQL("SELECT INR,BCHKEY,NAM FROM BCH WHERE STA = '0' AND LEV = ? ORDER BY BCHKEY",branchLevel);
			while(true)
			{
			  Platform.mdbFetchFields(inr,bchkey,nam);
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			    break;
			  CodetableItem c = new CodetableItem(
			    bchkey.value.toString().trim() + "-" + nam.value.toString().trim(),
			    inr.value);
			  ct.add(c);
			}
			Platform.mdbCloseCursor();
			//Platform.mdbConnect("eibs");
			return ct;
		}
        /**
        *   source:sysmod.@0060.script
        */
        public String getBicCodeByPtyInr(String ptyInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(ptyInr))
			  return "";
			Argument<String> extkey = new Argument<String>("extkey");
			Platform.mdbExecuteSQL("SELECT EXTKEY FROM PTY WHERE INR = ?",ptyInr);
			Platform.mdbFetchFields(extkey);
			Platform.mdbCloseCursor();
			if(!MdaUtils.isEmpty(extkey.value))
			  return extkey.value;
			else
			  return "";
		}
        /**
        *   source:sysmod.@0061.script
        */
        public String getBicCodeByBchInr(String bchInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(bchInr))
			  return "";
			Argument<String> extkey = new Argument<String>("extkey");
			Platform.mdbExecuteSQL("SELECT PTY.EXTKEY AS EXTKEY FROM PTY,BCH WHERE PTY.INR = BCH.PTYINR AND BCH.INR = ?",bchInr);
			Platform.mdbFetchFields(extkey);
			Platform.mdbCloseCursor();
			if(!MdaUtils.isEmpty(extkey.value))
			  return extkey.value;
			else
			  return "";
		}
        /**
        *   source:sysmod.@0062.script
        */
        public List<CodetableItem> getAllBranchCodetable()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<CodetableItem> ct = new ArrayList<CodetableItem>();
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> bchkey = new Argument<String>("bchkey");
			Argument<String> nam = new Argument<String>("nam");
			int errorcode = ctx.getErrorCode();
			Platform.mdbExecuteSQL("SELECT INR,BCHKEY,NAM FROM BCH WHERE STA = '0' ORDER BY LEV,BCHKEY");
			while(true)
			{
			  Platform.mdbFetchFields(inr,bchkey,nam);
			  errorcode = ctx.getErrorCode();
			  if(errorcode != NO_ERROR)
			    break;
			  CodetableItem c = new CodetableItem(
			    bchkey.value.toString().trim() + "-" + nam.value.toString().trim(),
			    inr.value);
			  ct.add(c);
			}
			Platform.mdbCloseCursor();
			return ct;
		}
        /**
        *   source:sysmod.@0063.script
        */
        public String getBranchNameByBchInr(String bchInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(bchInr))
			  return "";
			Argument<String> nam = new Argument<String>("nam");
			Platform.mdbExecuteSQL("SELECT NAM FROM BCH WHERE INR = ?",bchInr);
			Platform.mdbFetchFields(nam);
			Platform.mdbCloseCursor();
			if(!MdaUtils.isEmpty(nam.value))
			  return nam.value;
			else
			  return "";
		}
        /**
        *   source:sysmod.@0064.script
        */
        public String[] getAllBch()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  返回登录用户的所属机构及其下属机构的机构代码
			  */
			String[] bchlst = new String[100];
			String bch = this.getUsr().getBchcod();
			//
			if("9999".equals(bch))
			  bch = "7026";
			log.debug("{}","bch = "+bch);
			Platform.mdbRead(this.getOwnbch(),new Argument<String>("branch",bch));
			if(MdaUtils.isEmpty(this.getOwnbch().getBchlst()))
			{
			  bchlst[0] = bch;
			  return bchlst;
			}
			else
			{
			  log.debug("{}","bchlst = "+this.getOwnbch().getBchlst());
			  String bchlststr = this.getOwnbch().getBchlst();
			  String[] inrlst = bchlststr.split("\\|");
			  int k = 0;
			  for(String inr : inrlst)
			  {
			    k++;
			    log.debug("{}","inrlst["+k+"] = "+inr);
			  }
			  int lenth = inrlst.length;
			  log.debug("{}","lenth = "+ lenth);
			  if(1 == lenth)
			  {
			    bchlst[0] = bch;
			    return bchlst;
			  }
			  else
			  {
			    int i;
			    for(i = 0;i<lenth;i++)
			    {
			      log.debug("{}","inrlst["+i+"] = "+inrlst[i]);
			      Platform.mdbRead(this.getOwnbch(),new Argument<String>("inr",inrlst[i]));
			      log.debug("{}","errorcode = "+ctx.getErrorCode());
			      bchlst[i] = this.getOwnbch().getBranch();
			    }
			  }
			}
			for(String ls: bchlst)
			  log.debug("{}","bchlst = "+ls);
			return bchlst;
		}
        /**
        *   source:sysmod.@0065.script
        */
        public boolean isSptCorrectLoaded()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(this.getSpt().getInr()))
			  return false;
			else
			{
			  if("C".equals(this.getSpt().getSta()))
			    return true;
			  else
			    return false;
			}
		}
        /**
        *   source:sysmod.@0068.script
        */
        public String createSptEntry(IModule trnModule,String state,String smhInr,String trnInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getWrkspt());
			this.getWrkspt().setSta( state);
			this.getWrkspt().setSmhinr( smhInr);
			IDatafield<String> field = MdaDriver.getDatafield(trnModule,"bchinr");
			this.getWrkspt().setBchinr(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"iniusr");
			this.getWrkspt().setOprusr(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"bchkeyinr");
			this.getWrkspt().setOprogninr(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"objtyp");
			this.getWrkspt().setObjtyp(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"objinr");
			this.getWrkspt().setObjinr(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"ownref");
			this.getWrkspt().setOwnref(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"inifrm");
			this.getWrkspt().setFrm(field.getValue());
			this.getWrkspt().setDattim( MdaUtils.today());
			field = MdaDriver.getDatafield(trnModule,"nam");
			this.getWrkspt().setNam(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"objnam");
			this.getWrkspt().setObjnam(field.getValue());
			field = MdaDriver.getDatafield(trnModule,"reloricur");
			this.getWrkspt().setTrncur(field.getValue());
			IDatafield<BigDecimal> field1 = MdaDriver.getDatafield(trnModule,"reloriamt");
			this.getWrkspt().setTrnamt(field1.getValue());
			this.getWrkspt().setTrninr(trnInr);
			int errorcode = ctx.getErrorCode();
			Platform.sdbInsert(this.getWrkspt());
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return this.getWrkspt().getInr();
			else
			  return null;
		}
        /**
        *   source:sysmod.@0069.script
        */
        public boolean storeSptData(String sptInr,IStream is)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(sptInr))
			  return false;
			int errorcode = ctx.getErrorCode();
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"delete");
			if(!Platform.mfileExists(path))
			{
			  if(!Platform.mfileMkdirs(path))
			  {
			    log.error("{}","创建delete路径：" + path + "失败");
			    return false;
			  }
			  else
			    log.error("{}","创建delete路径：" + path + "成功");
			}
			path = MdaUtils.catPath(path,sptInr + ".dat");
			log.debug("{}","保存delete文件：" + path);
			Platform.mstreamSave(is,path);
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:sysmod.@0070.script
        */
        public boolean loadSptData(IStream os,String sptInr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(sptInr))
			  return false;
			MdaUtils.clear(os);
			String path = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"data");
			path = MdaUtils.catPath(path,"delete");
			path = MdaUtils.catPath(path,sptInr + ".dat");
			if(!Platform.mfileExists(path))
			  return false;
			log.debug("{}","加载DELETE：" + path);
			int errorcode = ctx.getErrorCode();
			Platform.mstreamLoad(os,path);
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:sysmod.@0071.script
        */
        public boolean changeSptStatus(IModule sptModule,String newStatus)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IDatafield<String> inrField = MdaDriver.getDatafield(sptModule,"inr");
			if(MdaUtils.isEmpty(inrField))
			  return false;
			IDatafield<String> staField = MdaDriver.getDatafield(sptModule,"sta");
			staField.setValue(newStatus);
			int errorcode = ctx.getErrorCode();
			Platform.mdbUpdate(sptModule);
			errorcode = ctx.getErrorCode();
			if(errorcode == NO_ERROR)
			  return true;
			else
			  return false;
		}
        /**
        *   source:sysmod.@0080.script
        */
        public List<CodetableItem> getKtpCodetableList()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","getKtpCodetableList");
			if(!MdaUtils.isEmpty(this.getKtplst()))
			{
			  List<CodetableItem> ctl = (List<CodetableItem>)this.getKtplst();
			  if(ctl.size() > 0)
			    return ctl;
			}
			List<CodetableItem> ctl = new ArrayList<CodetableItem>();
			ctl.add(new CodetableItem("",""));
			Argument<String> ktpNo = new Argument<String>("ktpno");
			Argument<String> ktpName = new Argument<String>("ktpnam");
			String sql = "SELECT KTPNO,KTPNAM FROM KTP WHERE 1=1 ";

			if(!MdaUtils.isBackground())
			{
			  //增加实体查询条件
			  sql += ctx.absGet(Sysmod.class).getEtySql();
			}
			Platform.mdbExecuteSQL(sql);
			while(true)
			{
			  Platform.mdbFetchFields(ktpNo,ktpName);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			    ctl.add(new CodetableItem(ktpName.value,ktpNo.value));
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			this.setKtplst( ctl);
			return ctl;
		}
        /**
        *   source:sysmod.@0081.script
        */
        public String getKtpCodetableLabel(String ktpNo)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//每次都读数据库效率很低
			List<CodetableItem> ctl = getKtpCodetableList();
			for(int i=0;i<ctl.size();i++)
			{
			  CodetableItem ct = ctl.get(i);
			  if(ct.getValue().equals(ktpNo))
			    return ct.getLabel();
			}
			return "";
		}
        /**
        *   source:sysmod.@0101.script
        */
        public List<CodetableItem> getCountryCodetable(int countryCodeLength)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","getCountryCodetable:" + countryCodeLength);
			if(countryCodeLength == 2 || countryCodeLength == 3)
			{
			  if(countryCodeLength == 2)
			  {
			    if(!MdaUtils.isEmpty(this.getShtctylst()))
			    {
			      List<CodetableItem> ctl = (List<CodetableItem>)this.getShtctylst();
			      if(ctl.size() > 0)
			        return ctl;
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getLngctylst()))
			    {
			      List<CodetableItem> ctl = (List<CodetableItem>)this.getLngctylst();
			      if(ctl.size() > 0)
			        return ctl;
			    }
			  }

			  List<CodetableItem> longCountryCodetable = new ArrayList<CodetableItem>();
			  longCountryCodetable.add(new CodetableItem("",""));
			  List<CodetableItem> shortCountryCodetable = new ArrayList<CodetableItem>();
			  shortCountryCodetable.add(new CodetableItem("",""));
			  Argument<String> sipcod = new Argument<String>("sipcod");
			  Argument<String> copcod = new Argument<String>("copcod");
			  Argument<String> dsp = new Argument<String>("dsp");
			  Platform.mdbExecuteSQL("SELECT SIPCOD,COPCOD,DSP FROM CNTCOD ORDER BY SIPCOD");
			  while(true)
			  {
			    Platform.mdbFetchFields(sipcod,copcod,dsp);//逐条取出记录
			    int errorCode = ctx.getErrorCode();//取出记录的执行结果
			    if(errorCode == NO_ERROR)
			    {
			      longCountryCodetable.add(new CodetableItem(copcod.value + "-" + dsp.value,copcod.value));
			      shortCountryCodetable.add(new CodetableItem(sipcod.value + "-" + dsp.value,sipcod.value));
			    }
			    else
			      break;
			  }
			  Platform.mdbCloseCursor();
			  this.setLngctylst( longCountryCodetable);
			  this.setShtctylst( shortCountryCodetable);
			  if(countryCodeLength == 2)
			    return shortCountryCodetable;
			  else
			    return longCountryCodetable;
			}
			else
			{
			  List<CodetableItem> ctl = new ArrayList<CodetableItem>();
			  ctl.add(new CodetableItem("",""));
			  return ctl;
			}
		}
        /**
        *   source:sysmod.@0114.script
        */
        public List<CodetableItem> getSysInnactLst()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","getsysinnactlst");
			List<CodetableItem> innLst = new ArrayList<CodetableItem>();
			innLst.add(new CodetableItem("",""));
			String sql = "SELECT DISTINCT PTYCOD,AREA FROM INNACT WHERE 1=1 ";
			//增加实体查询条件，20181108新加
			sql += ctx.absGet(Sysmod.class).getEtySql();
			sql += " ORDER BY PTYCOD ";

			Platform.mdbExecuteSQL(sql);
			Argument<String> area = new Argument<String>("area");
			Argument<String> ptycod = new Argument<String>("ptycod");
			while(true)
			{
			  Platform.mdbFetchFields(area,ptycod);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    CodetableItem c = new CodetableItem(area.value,ptycod.value);
			    innLst.add(c);
			  }
			  else
			    break;
			}
			Platform.mdbCloseCursor();
			return innLst;
		}
        /**
        *   source:sysmod.@0116.script
        */
        public String getEtySql(String tbl)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  //获取正常实体inr
			  String nometyinr = Platform.getCfgPropertyValue("etyandpty.properties","NormalEntityInr");
			  log.debug("nometyinr="+nometyinr);
			  if(Platform.isEmpty(nometyinr))
			  {
			  nometyinr="";
			  }
			  */
			String sql="";
			if(MdaUtils.isEmpty(this.getEty().getInr()))
			{
			  return sql;
			}
			if("00000001".equals(this.getEty().getInr()))
			{
			  sql = " AND ( "+tbl+".etyinr = '"+this.getEty().getInr()+"' OR "+tbl+".etyinr is null ) ";
			}
			else
			  sql = " AND "+tbl+".etyinr = '"+this.getEty().getInr()+"' ";
			return sql;
		}
        /**
        *   source:sysmod.@0117.script
        */
        public String getEtySql()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  String nometyinr = Platform.getCfgPropertyValue("etyandpty.properties","NormalEntityInr");
			  log.debug("NomEtyInr="+nometyinr);
			  //获取正常实体inr
			  if(Platform.isEmpty(nometyinr))
			  {
			  nometyinr="";
			  }
			  */
			String sql="";
			if(MdaUtils.isEmpty(this.getEty().getInr()))
			{
			  return sql;
			}
			if("00000001".equals(this.getEty().getInr()))
			{
			  sql = " AND ( etyinr = '"+this.getEty().getInr()+"' OR etyinr is null ) ";
			}
			else
			  sql = " AND etyinr = '"+this.getEty().getInr()+"' ";
			return sql;
		}
        /**
        *   source:sysmod.@0118.script
        */
        public Argument getEtyArg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  //获取正常实体inr
			  String nometyinr = Platform.getCfgPropertyValue("etyandpty.properties","NormalEntityInr");
			  if(Platform.isEmpty(nometyinr))
			  {
			  nometyinr="";
			  }
			  */
			if(MdaUtils.isEmpty(this.getEty().getInr()))
			{
			  return  new Argument("inr",ISNOTNULL);
			}
			Argument rlt = new Argument("etyinr",EQ,this.getEty().getInr());
			if("00000001".equals(this.getEty().getInr()))
			{
			  rlt = rlt.or(new Argument("etyinr",ISNULL));
			}
			return rlt;
		}
        /**
        *   source:sysmod.@0119.script
        */
        public void setEtyAndPty(IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isBackground())
			{
			  IDatafield etyinr = MdaDriver.getDatafield(mod,"etyinr");
			  IDatafield ptyinr = MdaDriver.getDatafield(mod,"ptyinr");
			  etyinr.setValue(ctx.absGet(Sysmod.class).getEty().getInr());
			  ptyinr.setValue(ctx.absGet(Sysmod.class).getPty().getInr());
			}
		}
        /**
        *   source:sysmod.@0120.script
        */
        public void setEtyAndPty(IModule mod,Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据swift代码区分报文是否属于自贸区
			if(MdaUtils.isBackground())
			{
			  String direct = "";
			  String bic="";
			  String act = "";
			  if("xxxtsk".equals(ctx.getTransName()))
			  {
			    direct = (String)map.get("direct");
			    bic="";
			    if("I".equals(direct))
			    {
			      bic=(String)map.get("sndbic");
			    }
			    else if("O".equals(direct))
			    {
			      bic=(String)map.get("rcvbic");
			      //act = (String)map.get("act");
			    }
			  }
			  else if("rxxtsk".equals(ctx.getTransName()))
			  {
			    String block1 = "" ;
			    String fombic = "" ;
			    if(!MdaUtils.isEmpty(map.get("block1")))
			    {
			      block1 = (String)map.get("block1");
			      fombic = block1.substring(3,15);
			      if(MdaUtils.isEmpty(fombic) && fombic.length()>11)
			      {
			        bic = fombic.substring(0,8) + fombic.substring(9,12);
			      }
			      else
			      {
			        bic = fombic ;
			      }
			    }
			    else if(!MdaUtils.isEmpty(map.get("direct")))
			    {//20200627新加，发汇增加自贸区判断
			      direct = (String)map.get("direct");
			      bic = "";
			      if("I".equals(direct))
			      {
			        bic = (String)map.get("sndbic");
			      }
			      else if("O".equals(direct))
			      {
			        bic = (String)map.get("rcvbic");
			      }
			    }
			  }
			  else if("yyotsk".equals(ctx.getTransName()))//
			  {
			    bic=(String)map.get("SNDBIC");
			  }

			  //if(Platform.isEmpty(act))
			  ctx.absGet(Sysmod.class).setEtyAndPtyByBIC(mod,bic);
			  //else
			  // $\\sysmod.setEtyAndPtyByBIC(mod,bic,act);
			
			}
		}
        /**
        *   source:sysmod.@0122.script
        */
        public void setEtyAndPtyByBIC(IModule mod,String bic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if( mod!=null && (!MdaUtils.isEmpty(bic)))
			{
			  if(bic.length()!=11 && bic.length()!=12)
			  {
			    return;
			  }
			  if(bic.length()==12)
			  {
			    bic = bic.substring(0,8) + bic.substring(9,12);
			  }
			  IDatafield etyinrField = MdaDriver.getDatafield(mod,"etyinr");
			  IDatafield ptyinrField = MdaDriver.getDatafield(mod,"ptyinr");
			  if(MdaUtils.isEmpty(bic))
			    return;
			  String bic1 = bic.replaceAll("'","");
			  String sql = "SELECT inr ptyinr,etyinr etyinr FROM pty WHERE EXTKEY='"+bic1+"'";
			  Argument<String>ptyinr=new Argument<String>("ptyinr");
			  Argument<String>etyinr=new Argument<String>("etyinr");
			  Object session = Platform.esdbExecuteSQL("swd",sql);
			  Platform.esdbFetchFields(session,ptyinr,etyinr);
			  int err = ctx.getErrorCode();
			  Platform.esdbCloseCursor(session);
			  if(err==NO_ERROR)
			  {
			    log.debug("{}","existed");
			    /*log.debug("0000"+etyinr.value);
			      String ptymsg = ptyinr.value;
			      String etymsg = etyinr.value;
			      log.debug("1111"+ptymsg);
			      if(Platform.isEmpty(ptymsg)||Platform.isEmpty(etymsg))
			      {
			      log.debug("2222"+ptymsg);
			      etymsg = "00000001";
			      ptymsg = "FI079709";
			      log.debug("3333"+ptymsg);
			      }*/
			    etyinrField.setValue(etyinr.value);
			    ptyinrField.setValue(ptyinr.value);
			  }
			  else if(err == NO_MORE_ROW)
			  {
			    log.debug("{}","unexisted");
			    etyinrField.setValue("00000001");
			    ptyinrField.setValue("FI079709");
			  }
			}
		}
        /**
        *   source:sysmod.@0123.script
        */
        public void setEtyAndPty(IModule desmod,IModule srcmod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(!MdaUtils.isEmpty(desmod)&&!MdaUtils.isEmpty(srcmod))
			{
			  IDatafield srcetyinr = MdaDriver.getDatafield(srcmod,"etyinr");
			  IDatafield srcptyinr = MdaDriver.getDatafield(srcmod,"ptyinr");
			  IDatafield desetyinr = MdaDriver.getDatafield(desmod,"etyinr");
			  IDatafield desptyinr = MdaDriver.getDatafield(desmod,"ptyinr");
			  desetyinr.setValue(srcetyinr.getValue());
			  desptyinr.setValue(srcptyinr.getValue());
			}
		}
        /**
        *   source:sysmod.@0125.script
        */
        public String  getPtyBic()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String  bic="PSBCCNBJXXX";
			if(!MdaUtils.isEmpty(this.getPty().getExtkey()))
			{
			  bic = this.getPty().getExtkey();
			}
			return bic;
		}
        /**
        *   source:sysmod.@0126.script
        */
        public String getLogicalAddress()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String adr="PSBCCNBJAXXX";
			String extkey = this.getPty().getExtkey();
			if(extkey!=null && extkey.length() > 8 )
			{
			  adr = extkey.substring(0,8)+"A"+extkey.substring(8);
			}
			else if(extkey!=null && extkey.length() == 8 )
			{
			  adr = extkey.substring(0,8)+"AXXX";
			}
			return adr;
		}
        /**
        *   source:sysmod.@0128.script
        */
        public String getEtySql(String tbl,IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="";
			IDatafield etyinr = MdaDriver.getDatafield(mod,"etyinr");
			String etyinrval = (String)etyinr.getValue();
			if(MdaUtils.isEmpty(etyinrval))
			{
			  return sql;
			}
			if("00000001".equals(etyinrval))
			{
			  sql = " AND ( "+tbl+".etyinr = '"+etyinrval+"' OR "+tbl+".etyinr is null ) ";
			}
			else
			  sql = " AND "+tbl+".etyinr = '"+etyinrval+"' ";
			return sql;
		}
        /**
        *   source:sysmod.@0129.script
        */
        public String getEtySql(IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String sql="";
			IDatafield etyinr = MdaDriver.getDatafield(mod,"etyinr");
			String etyinrval = (String)etyinr.getValue();
			if(MdaUtils.isEmpty(etyinrval))
			{
			  return sql;
			}
			if("00000001".equals(etyinrval))
			{
			  sql = " AND ( etyinr = '"+etyinrval+"' OR etyinr is null ) ";
			}
			else
			  sql = " AND etyinr = '"+etyinrval+"' ";
			return sql;
		}
        /**
        *   source:sysmod.@0130.script
        */
        public Argument getEtyArg(IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IDatafield etyinr = MdaDriver.getDatafield(mod,"etyinr");
			String etyinrval = (String)etyinr.getValue();
			if(MdaUtils.isEmpty(etyinrval))
			{
			  return new Argument("inr",ISNOTNULL);
			}
			Argument rlt = new Argument("etyinr",EQ,etyinrval);
			if("00000001".equals(etyinrval))
			{
			  rlt = rlt.or(new Argument("etyinr",ISNULL));
			}
			return rlt;
		}
        /**
        *   source:sysmod.@0131.script
        */
        public String getPtyinrForBIC(String bic,IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 查询BIC的ptyinr
			  *- String bic bic 代码
			  * @ return String bic所对应的ptyinr，如果没有查询到记录则返回null
			  */
			if(MdaUtils.isEmpty(bic))
			  return null;
			bic = bic.replaceAll("'","");
			String sql = "SELECT inr FROM pty y WHERE EXTKEY='"+bic+"'";
			sql = sql+ctx.absGet(Sysmod.class).getEtySql("y",mod);
			Argument<String>inr=new Argument<String>("inr");
			Object session = Platform.esdbExecuteSQL("swd",sql);
			Platform.esdbFetchFields(session,inr);
			int err = ctx.getErrorCode();
			Platform.esdbCloseCursor(session);
			if(err == NO_ERROR)
			{
			  return inr.value;
			}
			return null;
		}
        /**
        *   source:sysmod.@0132.script
        */
        public boolean isHodBank(String bic,IModule mod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 直接通过ptytyp校验bic是否为我行账户行
			  */
			if(MdaUtils.isEmpty(bic))
			  return false;
			//boolean isHodbank=false;
			//String ptyinr=$pty\\inr.getValue();
			//if(Platform.isEmpty(ptyinr))
			//ptyinr ="00000000";
			//String sql="SELECT inr FROM pta WHERE ptatyp='C' AND objinr=(SELECT inr FROM pty WHERE extkey='"+bic+"') AND ptyinr='"
			//+ptyinr+"'";
			/*
			  String sql="SELECT inr FROM pta WHERE ptatyp='C' AND  EXISTS  (SELECT inr FROM pty WHERE extkey='"+bic
			  +"' AND inr=objinr)  AND objtyp ='pty' AND ptyinr='"+ptyinr+"'";
			  */
			String sql = "SELECT inr FROM pty WHERE ptytyp LIKE '%T%' AND EXTKEY='"+bic+"'";

			//增加实体查询条件
			sql = sql + ctx.absGet(Sysmod.class).getEtySql(mod);

			Argument<String>inr=new Argument<String>("inr");
			Platform.mdbExecuteSQL(sql);
			boolean isExist=false;
			Platform.mdbFetchFields(inr);
			int err=ctx.getErrorCode();
			if(err==NO_ERROR)
			{
			  isExist=true;
			}
			Platform.mdbCloseCursor();
			return isExist;
		}
        /**
        *   source:sysmod.@0133.script
        */
        public void setEtyAndPtyCIPS(IModule mod,Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据swift代码区分报文是否属于自贸区
			if(MdaUtils.isBackground())
			{
			  String direct = "";
			  String bic="";
			  if("xxxtsk".equals(ctx.getTransName()))
			  {
			    direct = (String)map.get("direct");
			    bic="";
			    if("U".equals(direct))//发报
			    {
			      bic = (String)map.get("HSender");
			    }
			    else if("D".equals(direct))//收报
			    {
			      bic = (String)map.get("HReceiver");
			    }
			  }
			  else if("ljrtsk".equals(ctx.getTransName()))
			  {
			    bic = (String)map.get("HReceiver");
			  }
			  else if("ljotsk".equals(ctx.getTransName()))
			  {
			    bic = (String)map.get("SNDBIC");
			  }

			  ctx.absGet(Sysmod.class).setEtyAndPtyByBIC(mod,bic);

			}
		}
        /**
        *   source:sysmod.@0134.script
        */
        public void setEtyAndPtyByBIC(IModule mod,String bic,String act)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if( mod!=null && (!MdaUtils.isEmpty(bic)) &&(!MdaUtils.isEmpty(act)))
			{
			  if(bic.length()!=11 && bic.length()!=12)
			  {
			    return;
			  }
			  if(bic.length()==12)
			  {
			    bic = bic.substring(0,8) + bic.substring(9,12);
			  }

			  String sql1 = "SELECT actrul FROM ptyref WHERE bic ='PSBCCNBJZSH' ";
			  Argument argActrul = new Argument<String>("actrul");
			  String actrul = "";
			  ctx.getErrorCode();
			  Object session = Platform.esdbExecuteSQL("eibs",sql1);
			  int error = ctx.getErrorCode();
			  while(error==NO_ERROR)
			  {
			    Platform.esdbFetchFields(session,argActrul);
			    error = ctx.getErrorCode();
			    if(error==NO_ERROR)
			    {
			      actrul = (String)argActrul.value;
			    }
			  }
			  Platform.esdbCloseCursor(session);

			  //Platform.mdbConnect("swd");
			  IDatafield etyinrField = MdaDriver.getDatafield(mod,"etyinr");
			  IDatafield ptyinrField = MdaDriver.getDatafield(mod,"ptyinr");
			  if(MdaUtils.isEmpty(bic))
			    return;
			  String bic1 = bic.replaceAll("'","");
			  String sql = "SELECT inr ptyinr,etyinr etyinr FROM pty WHERE EXTKEY='"+bic1+"'";
			  Argument<String> ptyinr = new Argument<String>("ptyinr");
			  Argument<String> etyinr = new Argument<String>("etyinr");
			  Object session2 = Platform.esdbExecuteSQL("swd",sql);
			  Platform.esdbFetchFields(session2,ptyinr,etyinr);
			  int err = ctx.getErrorCode();
			  Platform.esdbCloseCursor(session2);
			  if(err==NO_ERROR)
			  {
			    if(bic1.equals("PSBCCNBJZSH")&&act.matches(actrul))
			    {
			      log.debug("{}","zimaoqu");
			      etyinrField.setValue(etyinr.value);
			      ptyinrField.setValue(ptyinr.value);
			    }
			    else
			    {
			      log.debug("{}","feizimaoqu");
			      etyinrField.setValue("00000001");
			      ptyinrField.setValue("FI079709");
			    }
			  }
			  else if(err == NO_MORE_ROW)
			  {
			    log.debug("{}","unexisted");
			    etyinrField.setValue("00000001");
			    ptyinrField.setValue("FI079709");
			  }
			}
		}
        /**
        *   source:sysmod.@0135.script
        */
        public void setEtyAndPty(IModule mod,Map map,String chncod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据swift代码区分报文是否属于自贸区
			if(MdaUtils.isBackground())
			{
			  String direct = "";
			  String bic="";
			  String act = "";
			  String subtyp = "";
			  if("xxxtsk".equals(ctx.getTransName()))
			  {//收报清分
			    direct = (String)map.get("direct");
			    bic="";
			    if("I".equals(direct))
			    {
			      bic=(String)map.get("sndbic");
			    }
			    else if("O".equals(direct))
			    {
			      bic = (String)map.get("rcvbic");
			      act = (String)map.get("act");
			      subtyp = (String)map.get("mty");
			    }
			  }
			  else if("yyotsk".equals(ctx.getTransName()))//
			  {
			    bic = (String)map.get("SNDBIC");
			  }
			  else if("rxxtsk".equals(ctx.getTransName()))
			  {//发报清分，20200627
			    String block1 = "" ;
			    String fombic = "" ;
			    if(!MdaUtils.isEmpty(map.get("block1")))
			    {
			      block1 = (String)map.get("block1");
			      fombic = block1.substring(3,15);
			      if(MdaUtils.isEmpty(fombic) && fombic.length()>11)
			      {
			        bic = fombic.substring(0,8) + fombic.substring(9,12);
			      }
			      else
			      {
			        bic = fombic ;
			      }
			    }
			    else if(!MdaUtils.isEmpty(map.get("direct")))
			    {//20200627新加，发汇增加自贸区判断
			      direct = (String)map.get("direct");
			      bic = "";
			      if("I".equals(direct))
			      {
			        bic=(String)map.get("sndbic");
			      }
			      else if("O".equals(direct))
			      {
			        bic=(String)map.get("rcvbic");
			      }
			    }
			  }

			  if(("SWT".equals(chncod) ||"SWE".equals(chncod)) && "103".equals(subtyp) &&!MdaUtils.isEmpty(act))
			    ctx.absGet(Sysmod.class).setEtyAndPtyByBIC(mod,bic,act);
			  else
			    ctx.absGet(Sysmod.class).setEtyAndPtyByBIC(mod,bic);

			}
		}
        /**
        *   source:sysmod.@0192.script
        */
        public String getHostName()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  java.net.InetAddress addr = null;
			  String ip = "";
			  String address = "";
			  addr = java.net.InetAddress.getLocalHost();
			  ip = addr.getHostAddress().toString();
			  address = addr.getHostName().toString();
			  return address;
			}
			catch(Exception e)
			{
			  log.error("{}",e);
			}
			return null;
		}
        /**
        *   source:sysmod.@0193.script
        */
        public String  getMessageFromFileTransfer(String path)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//20180507新加方法，根据传送的路径信息，从文件服务器上获取文件信息
			/**
			  **从文件服务器下载文件
			  **参数为文件存储的路径
			  **/
			byte[] buffer = null;
			String str = null;
			Object object = MdaUtils.invoke("cn.com.brilliance.psbc.client.imp.FileImp","fsDownload",path);
			if (MdaUtils.isEmpty(object) || object == null)
			{
			  log.info("{}","fileServer unexisted...");
			}
			else
			{
			  log.info("{}","fileServer existed...");
			  buffer = (byte[])object;
			  java.io.File file = new java.io.File(path);
			  if (!file.getParentFile().exists())
			  {
			    file.getParentFile().mkdirs();
			  }
			  try
			  {
			    java.io.FileOutputStream fos = new java.io.FileOutputStream(file);
			    try
			    {
			      fos.write(buffer);
			      fos.close();
			      str = new String(buffer);
			    }
			    catch (Exception e)
			    {
			      e.printStackTrace();
			    }
			  }
			  catch (Exception e1)
			  {
			    e1.printStackTrace();
			  }
			}

			return str;
		}
        /**
        *   source:sysmod.@0198.script
        */
        public String getHostIP()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  java.net.InetAddress addr = null;
			  String ip = "";
			  //String address = "";
			  addr = java.net.InetAddress.getLocalHost();
			  ip = addr.getHostAddress().toString();
			  //address = addr.getHostName().toString();
			  return ip;
			}
			catch(Exception e)
			{
			  log.error("{}",e);
			}
			return null;
		}
        /**
        *   source:sysmod.@0199.script
        */
        public String getSystemCodFromChncod(String chn)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(chn))
			  return null;
			else if(chn.equals("GHD"))
			  return "99700010000";
			else if(chn.equals("ZQS"))
			  return "99700020001";
			else if(chn.equals("GJS"))
			  return "99350010000";
			else if(chn.equals("RQZ"))
			  return "99300000000";
			return chn;
		}
        /**
        *   source:sysmod.@0201.script
        */
        public void sendMessagesToMonitorServerMQ(IModule mod,IModule mod1,String dir,Date nowdat,String befrspcod,String beftrncod,String aftrspcod,String afttrncod,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IDatafield sbt = MdaDriver.getDatafield(mod1,"subtyp");
			String subtyp = (String)sbt.getValue();
			log.debug("{}","----------------------------subtyp=="+subtyp);
			if("ACK".equals(subtyp) || "NCK".equals(subtyp))
			  return;
			//报文类监控信息
			IDatafield src = MdaDriver.getDatafield(mod,"srcchncod");
			String srcchncod = (String)src.getValue();
			IDatafield tgt = MdaDriver.getDatafield(mod,"tgtchncod");
			String tgtchncod = (String)tgt.getValue();
			IDatafield lst = MdaDriver.getDatafield(mod,"lstdattim");//最后更新时间
			Date lstdat = (Date)lst.getValue();
			IDatafield stt = MdaDriver.getDatafield(mod,"sttdattim");//前置开始处理时间
			Date sttdat = (Date)stt.getValue();
			IDatafield snd = MdaDriver.getDatafield(mod,"snddattim");//向接收方发送时间，可能为空
			String snddattim = null;
			if(!MdaUtils.isEmpty(snd.getValue()))
			  snddattim = MdaUtils.format(snd.getValue(),"yyyyMMddHHmmss");
			else if(!MdaUtils.isEmpty(nowdat))
			  snddattim = MdaUtils.format(nowdat,"yyyyMMddHHmmss");
			String ownref = null;
			IDatafield own = MdaDriver.getDatafield(mod1,"ownref");
			IDatafield oth = MdaDriver.getDatafield(mod1,"othref");
			if("<".equals(dir))
			  ownref = (String)own.getValue();
			else
			  ownref = (String)oth.getValue();

			//向MQ中传送应用服务器运行数据，传送方式为UTF-8格式，MAP信息，再Java代码中转换成JSON串
			Date dat = MdaUtils.today();
			String trndat = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd");
			String trntim = MdaUtils.format(MdaUtils.today(),"HH:mm:ss");

			Map<String,Object> map = new HashMap<String,Object>();
			map.put("ipaddr",ctx.absGet(Sysmod.class).getHostIP());//IP地址
			map.put("pickDate",trndat);//交易日期
			map.put("pickTime",trntim);//交易时间
			map.put("sourceSysId",getSystemCodFromChncod(srcchncod));//发起系统代码
			map.put("sourceTrancode",beftrncod);//前台交易码
			//String dattim = Platform.format($smpmod\\mps\\lstdattim.getValue(),"yyyyMMddHHmmss");
			//Date lstdat = Platform.parseDate(lstdattim,"yyyyMMddHHmmss");
			//Date sttdat = Platform.parseDate(sttdattim,"yyyyMMddHHmmss");
			int beftim = 0,afttim = 0;
			IDatafield isman = MdaDriver.getDatafield(mod,"isman");
			log.debug("{}","----------------------------isman=="+isman.getValue());
			if(MdaUtils.isEmpty(isman.getValue()))
			{
			  if(MdaUtils.isEmpty(snddattim))
			  {
			    long quot = lstdat.getTime() - sttdat.getTime();
			    beftim = (int)quot;
			  }
			  else
			  {
			    Date snddat = MdaUtils.parseDate(snddattim,"yyyyMMddHHmmss");
			    long quot1 = lstdat.getTime() - snddat.getTime();
			    long quot2 = snddat.getTime() - sttdat.getTime();
			    beftim = (int)quot2;
			    afttim = (int)quot1;
			  }
			}

			//String dattim = $smpmod\\mps\\lstdattim.getValue() - $smpmod\\mps\\rcvdattim.getValue();
			map.put("chTime",beftim);//渠道处理时长,报文发送时间-开始处理时间,beftim
			map.put("respCode",befrspcod);//前台响应码
			map.put("itSysId",getSystemCodFromChncod(tgtchncod));//受理系统代码
			map.put("itTrancode",afttrncod);//后台交易码
			map.put("itTimes",afttim);//受理系统处理时长，最后更新时间-报文发送时间,afttim
			map.put("itRetcode",aftrspcod);//后台响应码
			map.put("sendTranId",ownref);//交易流水号
			map.put("monitorId","");//监控号
			map.put("orderId","");//汇票号
			map.put("packageId",ownref);//报文编号
			//log.info("map:"+map);
			MdaUtils.invoke("cn.com.brilliance.psbc.service.mq.SendMessageToMonitorMQ","send",flg,map);
		}
        /**
        *   source:sysmod.@0219.script
        */
        public void sendLjdToMonitorServerMQ(IModule mod,String dir,Date nowdat,String befrspcod,String beftrncod,String aftrspcod,String afttrncod,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//逻辑要素类监控信息
			String srcchncod = null,tgtchncod = null;
			String srctmp = "99306000000";//支付前置系统码
			String tgttmp = "99700010000";//逻辑集中系统码
			IDatafield chncod = MdaDriver.getDatafield(mod,"chncod");
			if(!MdaUtils.isEmpty(chncod))
			{
			  String chn = (String)chncod.getValue();
			  if("WSP|CDP|CPD".contains(chn))
			    tgttmp = "993500000000";//国际业务
			}
			if(dir.equals(">"))
			{
			  srcchncod = srctmp;
			  tgtchncod = tgttmp;
			}
			else
			{
			  srcchncod = tgttmp;
			  tgtchncod = srctmp;
			}

			IDatafield lst = MdaDriver.getDatafield(mod,"lstdattim");//最后更新时间
			Date lstdat = (Date)lst.getValue();
			IDatafield cre = MdaDriver.getDatafield(mod,"credattim");//创建时间
			Date credat = (Date)cre.getValue();
			String snddattim = null;
			if(!MdaUtils.isEmpty(nowdat))
			  snddattim = MdaUtils.format(nowdat,"yyyyMMddHHmmss");

			String ownref = null;
			IDatafield own = MdaDriver.getDatafield(mod,"ownref");
			if(!MdaUtils.isEmpty(own))
			  ownref = (String)own.getValue();

			String bilnum = null;
			IDatafield bil = MdaDriver.getDatafield(mod,"bilnum");
			if(!MdaUtils.isEmpty(bil))
			  bilnum = (String)bil.getValue();

			String seqnum = null;
			IDatafield seq = MdaDriver.getDatafield(mod,"seqnum");
			if(!MdaUtils.isEmpty(seq))
			  seqnum = (String)seq.getValue();

			//向MQ中传送应用服务器运行数据，传送方式为UTF-8格式，MAP信息，再Java代码中转换成JSON串
			Date dat = MdaUtils.today();
			String trndat = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd");
			String trntim = MdaUtils.format(MdaUtils.today(),"HH:mm:ss");

			Map<String,Object> map = new HashMap<String,Object>();
			map.put("ipaddr",ctx.absGet(Sysmod.class).getHostIP());//IP地址
			map.put("pickDate",trndat);//交易日期
			map.put("pickTime",trntim);//交易时间
			map.put("sourceSysId",srcchncod);//发起系统代码
			map.put("sourceTrancode",beftrncod);//前台交易码
			//String dattim = Platform.format($smpmod\\mps\\lstdattim.getValue(),"yyyyMMddHHmmss");
			//Date lstdat = Platform.parseDate(lstdattim,"yyyyMMddHHmmss");
			//Date credat = Platform.parseDate(credattim,"yyyyMMddHHmmss");
			int beftim = 0,afttim = 0;
			if(MdaUtils.isEmpty(snddattim))
			{
			  long quot = lstdat.getTime() - credat.getTime();
			  beftim = (int)quot;
			}
			else
			{
			  Date snddat = MdaUtils.parseDate(snddattim,"yyyyMMddHHmmss");
			  long quot1 = lstdat.getTime() - snddat.getTime();
			  long quot2 = snddat.getTime() - credat.getTime();
			  beftim = (int)quot2;
			  afttim = (int)quot1;
			}

			//String dattim = $smpmod\\mps\\lstdattim.getValue() - $smpmod\\mps\\rcvdattim.getValue();
			map.put("chTime",beftim);//渠道处理时长,报文发送时间-开始处理时间,beftim
			map.put("respCode",befrspcod);//前台响应码
			map.put("itSysId",tgtchncod);//受理系统代码
			map.put("itTrancode",afttrncod);//后台交易码
			map.put("itTimes",afttim);//受理系统处理时长，最后更新时间-报文发送时间,afttim
			map.put("itRetcode",aftrspcod);//后台响应码
			map.put("sendTranId",seqnum);//交易流水号
			map.put("monitorId",ownref);//监控号
			map.put("orderId",bilnum);//汇票号
			map.put("packageId",ownref);//报文编号
			MdaUtils.invoke("cn.com.brilliance.psbc.service.mq.SendMessageToMonitorMQ","send",flg,map);
		}
        /**
        *   source:sysmod.@0224.script
        */
        public void sendOuterLjdToMonitorServerMQ(IModule mod,String tgt,String dir,Date nowdat,String befrspcod,String beftrncod,String aftrspcod,String afttrncod,String flg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//逻辑要素类监控信息
			String srcchncod = null,tgtchncod = null;
			// String srctmp = "99306000000";//支付前置系统码
			String tgttmp = "99700010000";//逻辑集中系统码
			IDatafield chncod = MdaDriver.getDatafield(mod,"chncod");
			if(!MdaUtils.isEmpty(chncod))
			{
			  String chn = (String)chncod.getValue();
			  if("WSP|CDP|CPD".contains(chn))
			    tgttmp = "993500000000";//国际业务
			}
			if(dir.equals(">"))
			{
			  srcchncod = tgt;
			  tgtchncod = tgttmp;
			}
			else
			{
			  srcchncod = tgttmp;
			  tgtchncod = tgt;
			}

			IDatafield lst = MdaDriver.getDatafield(mod,"lstdattim");//最后更新时间
			Date lstdat = (Date)lst.getValue();
			IDatafield cre = MdaDriver.getDatafield(mod,"credattim");//创建时间
			Date credat = (Date)cre.getValue();
			String snddattim = null;
			if(!MdaUtils.isEmpty(nowdat))
			  snddattim = MdaUtils.format(nowdat,"yyyyMMddHHmmss");

			String ownref = null;
			IDatafield own = MdaDriver.getDatafield(mod,"ownref");
			if(!MdaUtils.isEmpty(own))
			  ownref = (String)own.getValue();

			String bilnum = null;
			IDatafield bil = MdaDriver.getDatafield(mod,"bilnum");
			if(!MdaUtils.isEmpty(bil))
			  bilnum = (String)bil.getValue();

			String seqnum = null;
			IDatafield seq = MdaDriver.getDatafield(mod,"seqnum");
			if(!MdaUtils.isEmpty(seq))
			  seqnum = (String)seq.getValue();

			//向MQ中传送应用服务器运行数据，传送方式为UTF-8格式，MAP信息，再Java代码中转换成JSON串
			Date dat = MdaUtils.today();
			String trndat = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd");
			String trntim = MdaUtils.format(MdaUtils.today(),"HH:mm:ss");

			Map<String,Object> map = new HashMap<String,Object>();
			map.put("ipaddr",ctx.absGet(Sysmod.class).getHostIP());//IP地址
			map.put("pickDate",trndat);//交易日期
			map.put("pickTime",trntim);//交易时间
			map.put("sourceSysId",srcchncod);//发起系统代码
			map.put("sourceTrancode",beftrncod);//前台交易码
			//String dattim = Platform.format($smpmod\\mps\\lstdattim.getValue(),"yyyyMMddHHmmss");
			//Date lstdat = Platform.parseDate(lstdattim,"yyyyMMddHHmmss");
			//Date credat = Platform.parseDate(credattim,"yyyyMMddHHmmss");
			int beftim = 0,afttim = 0;
			if(MdaUtils.isEmpty(snddattim))
			{
			  long quot = lstdat.getTime() - credat.getTime();
			  beftim = (int)quot;
			}
			else
			{
			  Date snddat = MdaUtils.parseDate(snddattim,"yyyyMMddHHmmss");
			  long quot1 = lstdat.getTime() - snddat.getTime();
			  long quot2 = snddat.getTime() - credat.getTime();
			  beftim = (int)quot2;
			  afttim = (int)quot1;
			}

			//String dattim = $smpmod\\mps\\lstdattim.getValue() - $smpmod\\mps\\rcvdattim.getValue();
			map.put("chTime",beftim);//渠道处理时长,报文发送时间-开始处理时间,beftim
			map.put("respCode",befrspcod);//前台响应码
			map.put("itSysId",tgtchncod);//受理系统代码
			map.put("itTrancode",afttrncod);//后台交易码
			map.put("itTimes",afttim);//受理系统处理时长，最后更新时间-报文发送时间,afttim
			map.put("itRetcode",aftrspcod);//后台响应码
			map.put("sendTranId",seqnum);//交易流水号
			map.put("monitorId",ownref);//监控号
			map.put("orderId",bilnum);//汇票号
			map.put("packageId",ownref);//报文编号
			MdaUtils.invoke("cn.com.brilliance.psbc.service.mq.SendMessageToMonitorMQ","send",flg,map);
		}
        /**
        *   source:sysmod.@0266.script
        */
        public String getCtlSndmsgFlg()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 从ctl表中读取相关设置信息
			  */
			log.debug("{}","getctlflg");
			String sql = "SELECT val FROM ctl WHERE key = 'SNDMSG' ";
			String flg = "";
			Object session = Platform.esdbExecuteSQL("eibs",sql);
			Argument<String> val = new Argument<String>("val");
			while(true)
			{
			  Platform.esdbFetchFields(session,val);
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(!MdaUtils.isEmpty(val))
			      flg = val.value;
			  }
			  else
			    break;
			}
			Platform.esdbCloseCursor(session);
			return flg;
		}
        /**
        *   source:sysmod.@0268.script
        */
        public void sendAckToMonitorServerMQ(IModule mod,IModule mod1,String rspcod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			IDatafield src = MdaDriver.getDatafield(mod,"srcchncod");
			String srcchncod = (String)src.getValue();
			IDatafield tgt = MdaDriver.getDatafield(mod,"tgtchncod");
			String tgtchncod = (String)tgt.getValue();
			IDatafield own = MdaDriver.getDatafield(mod1,"ownref");
			String ownref = (String)own.getValue();

			String trndat = MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd");
			String trntim = MdaUtils.format(MdaUtils.today(),"HH:mm:ss");
			Map<String,Object> map = new HashMap<String,Object>();
			map.put("ipaddr",ctx.absGet(Sysmod.class).getHostIP());//IP地址
			map.put("pickDate",trndat);//交易日期
			map.put("pickTime",trntim);//交易时间
			map.put("sourceSysId",getSystemCodFromChncod(tgtchncod));//发起系统代码
			map.put("sourceTrancode","sf2");//前台交易码
			
			//map.put("chTime","");//渠道处理时长,报文发送时间-开始处理时间,beftim
			map.put("respCode",rspcod);//前台响应码
			map.put("itSysId",getSystemCodFromChncod(srcchncod));//受理系统代码
			map.put("itTrancode","sf2");//后台交易码
			//map.put("itTimes","");//受理系统处理时长，最后更新时间-报文发送时间,afttim
			map.put("itRetcode","000000");//后台响应码
			map.put("sendTranId",ownref);//交易流水号
			map.put("monitorId","");//监控号
			map.put("orderId","");//汇票号
			map.put("packageId",ownref);//报文编号
			//log.info("map:"+map);
			MdaUtils.invoke("cn.com.brilliance.psbc.service.mq.SendMessageToMonitorMQ","send","00",map);
		}
        /**
        *   source:sysmod.@0270.script
        */
        public /**
* 报送交易信息到海南自贸区资金进出岛数据监控
* 该方法供BD平台进行调用，用于封装发送数据。通过调用后端Java代码将组织好数据通过数据共享发送至海南自贸区数据监控。
* @param mpiMod         交易详细信息表信息
* @param mpsMod         交易主要信息表信息
* @param busiTyp        业务种类
* @param tranFlag 交易标识，例：SWT，FMT，CIPS
* @return null
*/
void sendMessageToHaiNanFTA(IModule mpiMod,IModule mpsMod)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,String> map = new HashMap<String,String>();
			// 设置接口规范可为空字段
			map.put("TRAN_ID", ""); // 1 交易序号
			map.put("CUSH_FX", ""); // 2 资金方向
			map.put("CUST_TRADE", ""); // 3 对公账户所属行业
			map.put("AREA_CODE", ""); // 4 交易账户所属行政区域代码
			map.put("IDENTITY_CARD", ""); // 5 账户证件号
			map.put("TRAN_ORG", ""); // 6 发起交易机构代码
			map.put("TARN_ORG_NAME", ""); // 7 发起交易机构名称
			map.put("ACCT_ORG", ""); // 8 转出账号所属机构代码
			map.put("ACCT_ORG_NAME", ""); // 9 转出账号所属机构名称
			map.put("ACCT_NRA", ""); // 10 转出账号NRA标识
			map.put("OPP_CUST_COUNTRY", ""); // 11 转出对手国家
			map.put("OPP_CUST_AREA", ""); // 12 转出对手账户所属地区（省份）
			map.put("OPP_BANK_CODE", ""); // 13 转入银行
			map.put("OPP_ACCT_ORG", ""); // 14 转入账号所属机构代码
			map.put("OPP_ACCT_ORG_NAME", ""); // 15 转入账号所属机构名称
			map.put("OPP_ACCT_NRA", ""); // 16 转入账号NRA标识
			map.put("IS_AFTER", ""); // 17 是否补报
			map.put("REMARK1", ""); // 18 备注1
			map.put("REMARK2", ""); // 19 备注2
			map.put("REMARK3", ""); // 20 备注3
			map.put("REMARK4", ""); // 21 备注4
			map.put("REMARK5", ""); // 22 备注5
			//获取表内参数
			log.info("{}","待报送数据字段：");
			log.info("{}","===========================================================================");
			IDatafield idsbt =  MdaDriver.getDatafield(mpiMod,"subtyp");
			String  sbt = String.valueOf(idsbt.getValue());
			String subtyps = "103,202,202COV,700,100,101,102,103,104,200,201,202,204,019,073" ;
			if(subtyps.indexOf(sbt)<=-1) return; //不符合上述类型报文不应进行数据报送
			log.info("{}","报送至海南自贸区资金进出岛监控的报文类型： "+ sbt);
			IDatafield iddir = MdaDriver.getDatafield(mpiMod,"dir") ;
			String  dir = String.valueOf(iddir.getValue());
			IDatafield idnxtchncod = MdaDriver.getDatafield(mpsMod,"nxtchncod") ;
			String  nxtchncod = String.valueOf(idnxtchncod.getValue());
			IDatafield idsrcchncod = MdaDriver.getDatafield(mpsMod,"srcchncod") ;
			String  srcchncod = String.valueOf(idsrcchncod.getValue());
			IDatafield  idmsgtyp = MdaDriver.getDatafield(mpiMod,"msgtyp") ;
			String  msgtyp = String.valueOf(idmsgtyp.getValue()) ;
			IDatafield idtran_time = MdaDriver.getDatafield(mpsMod,"lstdattim") ;
			String tran_time = MdaUtils.format(idtran_time.getValue(),"yyyy-MM-dd");
			log.info("{}","报送至海南自贸区资金进出岛监控的报文交易时间： "+ tran_time);
			map.put("TRAN_TIME",tran_time);
			IDatafield idtran_amt = MdaDriver.getDatafield(mpiMod,"amt");
			String tran_amt = String.valueOf(idtran_amt.getValue()) ;
			log.info("{}","报送至海南自贸区资金进出岛监控的报文交易金额： "+ tran_amt);
			map.put("TRAN_AMT",tran_amt);
			IDatafield idtran_ccy = MdaDriver.getDatafield(mpiMod,"cur") ;
			String tran_ccy = String.valueOf(idtran_ccy.getValue()) ;
			log.info("{}","报送至海南自贸区资金进出岛监控的报文交易币种： "+ tran_ccy);
			map.put("CCY",tran_ccy);

			String sendSyscod = "" ;
			String receSyscod = "" ;
			//获取收发报行
			if(">".equals(dir))
			{
			  if("ZQS".equals(nxtchncod))
			  {//资金清算
			    sendSyscod="99306000000";
			    receSyscod="99700020001";
			  }
			  else if("GJS".equals(nxtchncod))
			  {//国际结算
			    sendSyscod = "99306000000" ;
			    receSyscod = "99350010000" ;//可能是99350010001
			  }
			  else if("GHD".equals(nxtchncod))
			  {//逻辑集中
			    sendSyscod = "99700010000" ;
			    receSyscod = "99306000000" ;
			  }
			}
			else if("<".equals(dir))
			{
			  if("ZQS".equals(srcchncod))
			  {//资金清算
			    sendSyscod="99700020001";
			    receSyscod="99306000000";
			  }
			  else if("ZYS".equals(srcchncod))
			  {//新一代资金业务
			    sendSyscod="99710720000";
			    receSyscod="99306000000";
			  }
			  else if("GJS".equals(srcchncod))
			  {//国际结算
			    sendSyscod = "99350010000" ;
			    receSyscod = "99306000000" ;
			  }
			  else if("GHD".equals(srcchncod))
			  {//逻辑集中
			    sendSyscod = "99700010000" ;
			    receSyscod = "99306000000" ;
			  }
			}
			else
			{
			  log.info("{}","报送数据失败，原因收发方向不符或为空："+sbt);
			  return ;
			}
			map.put("SENDSYSCODE",sendSyscod);
			map.put("RECESYSCODE",receSyscod);
			log.info("{}","报送至海南自贸区资金进出岛监控的报文发送系统代码： "+ map.get("SENDSYSCODE") + " 接收系统代码"+ map.get("RECESYSCODE"));
			//获取收发报流水号
			String tran_no = "" ;
			if(">".equals(dir))
			{
			  IDatafield idothref = MdaDriver.getDatafield(mpiMod,"othref");
			  tran_no = String.valueOf(idothref.getValue()) ;
			}
			else
			{
			  IDatafield idownref = MdaDriver.getDatafield(mpiMod,"ownref");
			  tran_no = String.valueOf(idownref.getValue()) ;
			}
			map.put("TRAN_NO",tran_no);
			log.info("{}","报送至海南自贸区资金进出岛监控的报文交易流水号： "+ tran_no);

			//获取业务种类（BUSI_TYP） 国际结算	: 150001 ； 境外内币支付系统:  160002 ；          SWIFT系统： 170001
			String busi_type = "";
			if("sf2".equals(msgtyp))
			{
			  busi_type = "170001" ;//境外汇款
			}
			else if("txt".equals(msgtyp))
			{
			  busi_type = "160002" ;//境内外币支付
			}
			else
			{
			  busi_type = "150001" ;//汇款业务(国际汇款类)
			}
			log.info("{}","报送至海南自贸区资金进出岛监控的报文业务种类： "+ busi_type);
			map.put("BUSI_TYPE",busi_type);

			// 获取资金通道（CUSH_PASS）境外内币：160000；SWIFT系统：170000;其他：国际汇款 150000
			String cush_pass = "" ;
			if("sf2".equals(msgtyp))
			{
			  cush_pass = "170000" ;//SWIFT系统
			}
			else if("txt".equals(msgtyp))
			{
			  cush_pass = "160000" ;//境内外币支付
			}
			else
			{
			  cush_pass = "150000" ;//国际结算
			}
			log.info("{}","报送至海南自贸区资金进出岛监控的报文资金通道： "+ cush_pass);
			map.put("CUSH_PASS",cush_pass);

			// 获取账户类别（ACCT_TYP） 国结-对公，逻辑-个人；其他
			String acct_typ = "";
			if("GJS".equals(srcchncod)||"GJS".equals(nxtchncod))
			{
			  acct_typ = "02" ; //国结-对公
			}
			else if("GHD".equals(srcchncod)||"GHD".equals(nxtchncod))
			{
			  acct_typ = "01" ; //逻辑-个人
			}
			else
			{
			  acct_typ = "04" ; //04-其他
			}
			log.info("{}","报送至海南自贸区资金进出岛监控的报文账户类别： "+ acct_typ);
			map.put("ACCT_TYP",acct_typ);

			IDatafield idact = MdaDriver.getDatafield(mpiMod,"act");
			String acct_no = String.valueOf(idact.getValue()) ;
			log.info("{}","报送至海南自贸区资金进出岛监控的报文交易账号： "+ acct_no);
			map.put("ACCT_NO",acct_no);//转出账号或卡号？去哪里取
			
			map.put("ACCT_NAME","");//转出账号账户名称
			log.info("{}","报送至海南自贸区资金进出岛监控的报文转出账号或账户名称： "+ map.get("ACCT_NAME"));
			map.put("OPP_ACCT_NO","");//转入账号或卡号
			log.info("{}","报送至海南自贸区资金进出岛监控的报文转入账号或卡号： "+ map.get("OPP_ACCT_NO"));
			map.put("OPP_ACCT_NAME","");//转入账号账户名称
			log.info("{}","报送至海南自贸区资金进出岛监控的报文转入账号账户名称： "+ map.get("OPP_ACCT_NAME"));
			map.put("SINGLETYPE","N");//参考最终确认交易列表单边标识，传送Y或N
			log.info("{}","报送至海南自贸区资金进出岛监控的报文单边标识： "+ map.get("SINGLETYPE"));
			log.info("{}","===========================================================================");
			MdaUtils.invoke("cn.com.brilliance.psbc.service.eftp.SendMessageToHaiNanFTA","sendMessage",map);
		}
        /**
        *   source:sysmod.@0269.script
        */
        public void setEtyAndPtyELCS(IModule mod,Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isBackground())
			{
			  String direct = "";
			  String bic="";
			  if("xxxtsk".equals(ctx.getTransName()))
			  {
			    direct = (String)map.get("MesgDirection");
			    bic="";
			    if("U".equals(direct))//发报
			    {
			      bic = (String)map.get("OrigSender");
			    }
			    else if("D".equals(direct))//收报
			    {
			      bic = (String)map.get("OrigReceiver");
			    }
			  }

			  ctx.absGet(Sysmod.class).setEtyAndPtyByBIC(mod,bic);

			}
		}
        /**
        *   source:sysmod.@0271.script
        */
        public boolean efdInsertData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//本方法实现  新增日终文件数据库记录功能
			//新增
			//Platform.clear($efd);
			this.getEfd().setInr(MdaUtils.format(Platform.mdbCounter("eibs","efd"),"00000000"));
			this.getEfd().setCredattim(MdaUtils.today());

			/*
			  $efd\\tskid=map.get("tskid");
			  $efd\\tsknam=map.get("tsknam");
			  $efd\\filnam=map.get("filnam");
			  $efd\\filpth=map.get("filpth");
			  $efd\\sta=map.get("sta");
			  $efd\\typ=map.get("typ");
			  $efd\\cnt=map.get("cnt");
			  $efd\\syscode=map.get("syscode");
			  $efd\\chkdat=map.get("chkdat");
			  $efd\\befdat=map.get("befdat");
			  $efd\\accdat=map.get("accdat");
			  $efd\\nowdat=map.get("nowdat");
			  $efd\\yetdat=map.get("yetdat");
			  $efd\\sndtyp=map.get("sndtyp");
			  */
			Platform.mdbBegin("eibs");
			Platform.mdbInsert(this.getEfd());
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","新增efd记录成功，inr"+this.getEfd().getInr()+"，文件名为"+this.getEfd().getFilnam());
			  Platform.mdbCommit();
			  return true;
			}
			else
			{
			  log.info("{}","新增efd记录失败，当前操作文件名为"+this.getEfd().getFilnam());
			  Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:sysmod.@0272.script
        */
        public void storeEfdData(String tskid,String tsknam,String filnam,String filpth,String sta,String typ,
  String cnt ,String syscode,String chkdat,String befdat,String accdat,String nowdat,String yetdat,String sndtyp)
  		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			  //HashMap<String,String> map = new HashMap<String,String>();
			
			  this.getEfd().setTskid(tskid);
			  this.getEfd().setTsknam(tsknam);
			  this.getEfd().setFilnam(filnam);
			  this.getEfd().setFilpth(filpth);
			  this.getEfd().setSta(sta);
			  this.getEfd().setTyp(typ);
			  this.getEfd().setCnt(cnt);
			  this.getEfd().setSyscode(syscode);
			  this.getEfd().setChkdat(chkdat);
			  this.getEfd().setBefdat(befdat);
			  this.getEfd().setAccdat(accdat);
			  this.getEfd().setNowdat(nowdat);
			  this.getEfd().setYetdat(yetdat);
			  this.getEfd().setSndtyp(sndtyp);
			  /*
			    map.put("tskid",tskid);
			    map.put("tsknam",tsknam);
			    map.put("filnam",filnam);
			    map.put("filpth",filpth);
			    map.put("sta",sta);
			    map.put("typ",typ);
			    map.put("cnt",cnt);
			    map.put("syscode",syscode);
			    map.put("chkdat",chkdat);
			    map.put("befdat",befdat);
			    map.put("accdat",accdat);
			    map.put("nowdat",nowdat);
			    map.put("yetdat",yetdat);
			    map.put("sndtyp",sndtyp);
			    */

					}
        /**
        *   source:sysmod.@0273.script
        */
        public boolean efdUpdateData(String filnam,String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始操作efd记录");
			MdaUtils.clear(this.getEfdup());
			log.info("{}","当前待读取文件名："+filnam);
			Platform.mdbBegin("eibs");
			Platform.mdbRead("eibs",this.getEfdup(),new Argument<String>("filnam",EQ,filnam));
			log.info("{}","efd-inr-read"+this.getEfdup().getInr());
			if(!MdaUtils.isEmpty(this.getEfdup().getInr()))
			{
			  //$efdup\\sta=map.get("sta");
			  this.getEfdup().setSta( sta );
			  this.getEfdup().setLstdattim(MdaUtils.today());
			  Platform.mdbUpdate(this.getEfdup());
			}
			else
			{
			  log.info("{}","未能正确读取到当前文件所对应的efd记录，请联系开发人员");
			}

			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","更新efd记录成功，inr"+this.getEfdup().getInr()+"，文件名为"+this.getEfdup().getFilnam());
			  Platform.mdbCommit();
			  return true;
			}
			else
			{
			  log.info("{}","更新efd记录失败，当前操作文件名为"+this.getEfdup().getFilnam());
			  Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:sysmod.@0274.script
        */
        public boolean efdtmpInsertData()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//本方法实现  新增日终文件数据库记录功能
			//新增
			//Platform.clear($efd);
			this.getEfdtmp().setInr(MdaUtils.format(Platform.mdbCounter("eibs","efd"),"00000000"));
			this.getEfdtmp().setCredattim(MdaUtils.today());

			/*
			  $efd\\tskid=map.get("tskid");
			  $efd\\tsknam=map.get("tsknam");
			  $efd\\filnam=map.get("filnam");
			  $efd\\filpth=map.get("filpth");
			  $efd\\sta=map.get("sta");
			  $efd\\typ=map.get("typ");
			  $efd\\cnt=map.get("cnt");
			  $efd\\syscode=map.get("syscode");
			  $efd\\chkdat=map.get("chkdat");
			  $efd\\befdat=map.get("befdat");
			  $efd\\accdat=map.get("accdat");
			  $efd\\nowdat=map.get("nowdat");
			  $efd\\yetdat=map.get("yetdat");
			  $efd\\sndtyp=map.get("sndtyp");
			  */
			Platform.mdbBegin("eibs");
			Platform.mdbInsert(this.getEfdtmp());
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","新增efd记录成功，inr"+this.getEfdtmp().getInr()+"，文件名为"+this.getEfdtmp().getFilnam());
			  Platform.mdbCommit();
			  return true;
			}
			else
			{
			  log.info("{}","新增efd记录失败，当前操作文件名为"+this.getEfdtmp().getFilnam());
			  Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:sysmod.@0275.script
        */
        public boolean efdtmpUpdateData(String filnam,String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始操作efd记录");
			MdaUtils.clear(this.getEfdtmp());
			Platform.mdbBegin("eibs");
			Platform.mdbRead("eibs",this.getEfdtmp(),new Argument<String>("filnam",EQ,filnam));
			if(!MdaUtils.isEmpty(this.getEfdtmp().getInr()))
			{
			  //$efd\\sta=map.get("sta");
			  this.getEfdtmp().setSta( sta );
			  this.getEfdtmp().setLstdattim(MdaUtils.today());
			  Platform.mdbUpdate(this.getEfdtmp());
			}
			else
			{
			  log.info("{}","未能正确读取到当前文件所对应的efd记录，请联系开发人员");
			}

			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","更新efdtmp记录成功，inr"+this.getEfdtmp().getInr()+"，文件名为"+this.getEfdtmp().getFilnam());
			  Platform.mdbCommit();
			  return true;
			}
			else
			{
			  log.info("{}","更新efd记录失败，当前操作文件名为"+this.getEfdtmp().getFilnam());
			  Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:sysmod.@0276.script
        */
        public void storeEfdtmpData(String tskid,String tsknam,String filnam,String filpth,String sta,String typ,
  String cnt ,String syscode,String chkdat,String befdat,String accdat,String nowdat,String yetdat,String sndtyp)
  		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			  //HashMap<String,String> map = new HashMap<String,String>();
			
			  this.getEfdtmp().setTskid(tskid);
			  this.getEfdtmp().setTsknam(tsknam);
			  this.getEfdtmp().setFilnam(filnam);
			  this.getEfdtmp().setFilpth(filpth);
			  this.getEfdtmp().setSta(sta);
			  this.getEfdtmp().setTyp(typ);
			  this.getEfdtmp().setCnt(cnt);
			  this.getEfdtmp().setSyscode(syscode);
			  this.getEfdtmp().setChkdat(chkdat);
			  this.getEfdtmp().setBefdat(befdat);
			  this.getEfdtmp().setAccdat(accdat);
			  this.getEfdtmp().setNowdat(nowdat);
			  this.getEfdtmp().setYetdat(yetdat);
			  this.getEfdtmp().setSndtyp(sndtyp);
			  /*
			    map.put("tskid",tskid);
			    map.put("tsknam",tsknam);
			    map.put("filnam",filnam);
			    map.put("filpth",filpth);
			    map.put("sta",sta);
			    map.put("typ",typ);
			    map.put("cnt",cnt);
			    map.put("syscode",syscode);
			    map.put("chkdat",chkdat);
			    map.put("befdat",befdat);
			    map.put("accdat",accdat);
			    map.put("nowdat",nowdat);
			    map.put("yetdat",yetdat);
			    map.put("sndtyp",sndtyp);
			    */

					}
        /**
        *   source:sysmod.@0277.script
        */
        public boolean efdUpdateData(String filnam,String sta,String filpth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始操作efd记录");
			log.info("{}","当前待读取文件名："+filnam);
			MdaUtils.clear(this.getEfdup());
			Platform.mdbBegin("eibs");
			Platform.mdbRead("eibs",this.getEfdup(),new Argument<String>("filnam",EQ,filnam));
			log.info("{}","efd-inr-read"+this.getEfdup().getInr());
			if(!MdaUtils.isEmpty(this.getEfdup().getInr()))
			{
			  //$efdup\\sta=map.get("sta");
			  this.getEfdup().setSta( sta );
			  this.getEfdup().setFilpth( filpth);
			  this.getEfdup().setLstdattim(MdaUtils.today());
			  Platform.mdbUpdate(this.getEfdup());
			}
			else
			{
			  log.info("{}","未能正确读取到当前文件所对应的efd记录，请联系开发人员");
			}

			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","更新efd记录成功，inr"+this.getEfdup().getInr()+"，文件名为"+this.getEfdup().getFilnam());
			  Platform.mdbCommit();
			  return true;
			}
			else
			{
			  log.info("{}","更新efd记录失败，当前操作文件名为"+this.getEfdup().getFilnam());
			  Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:sysmod.@0278.script
        */
        public boolean efdtmpUpdateData(String filnam,String sta,String filpth)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始操作efd记录");
			MdaUtils.clear(this.getEfdtmp());
			Platform.mdbBegin("eibs");
			Platform.mdbRead("eibs",this.getEfdtmp(),new Argument<String>("filnam",EQ,filnam));
			if(!MdaUtils.isEmpty(this.getEfdtmp().getInr()))
			{
			  //$efd\\sta=map.get("sta");
			  this.getEfdtmp().setSta( sta );
			  this.getEfd().setFilpth( filpth);
			  this.getEfdtmp().setLstdattim(MdaUtils.today());
			  Platform.mdbUpdate(this.getEfdtmp());
			}
			else
			{
			  log.info("{}","未能正确读取到当前文件所对应的efd记录，请联系开发人员");
			}

			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","更新efdtmp记录成功，inr"+this.getEfdtmp().getInr()+"，文件名为"+this.getEfdtmp().getFilnam());
			  Platform.mdbCommit();
			  return true;
			}
			else
			{
			  log.info("{}","更新efd记录失败，当前操作文件名为"+this.getEfdtmp().getFilnam());
			  Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:sysmod.@0279.script
        */
        public boolean efdUpdateDataDsj(String filpth,String sta)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}","开始操作efd记录");
			log.info("{}","当前待读取文件路径："+filpth);
			MdaUtils.clear(this.getEfd());
			Platform.mdbBegin("eibs");
			Platform.mdbRead("eibs",this.getEfd(),new Argument<String>("filpth",EQ,filpth));
			log.info("{}","efd-inr-read"+this.getEfd().getInr());
			if(!MdaUtils.isEmpty(this.getEfd().getInr()))
			{
			  //$efd\\sta=map.get("sta");
			  this.getEfd().setSta( sta );
			  this.getEfd().setLstdattim(MdaUtils.today());
			  Platform.mdbUpdate(this.getEfd());
			}
			else
			{
			  log.info("{}","未能正确读取到当前文件所对应的efd记录，请联系开发人员");
			}

			if(ctx.getErrorCode() == NO_ERROR)
			{
			  log.info("{}","更新efd记录成功，inr"+this.getEfd().getInr());
			  Platform.mdbCommit();
			  return true;
			}
			else
			{
			  log.info("{}","更新efd记录失败，当前操作文件名为"+this.getEfd().getFilnam());
			  Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:sysmod.@0280.script
        */
        public String getCipsMessageId(String channel)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/**
			  *  channel   两位渠道
			  *  返回CIPS发报的报文流水号16位（  渠道 两位 + 年月日6位 + 计数器8位）
			  */
			String date = MdaUtils.format(MdaUtils.today(),"yyMMdd") ;
			String cnt = MdaUtils.format(Platform.mdbCounter("cips" + date),"00000000");
			log.debug("{}"," getCipsMessageId [ msgId =" + channel + date + cnt +" ]");
			return  channel + date + cnt ;
		}













































}