package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Tskctl;
import com.ceb.gjjs.mda.global.Platform;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Tskmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Tskmod.class);



		@BDGetter
		private ModuleList<Tskctl> lst;


		public Tskmod()
        {
            super();
            setArgument();
        }

        public Tskmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:tskmod.@0000.script
        */
        public String getNodeId()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			List<String> arguments = java.lang.management.ManagementFactory.getRuntimeMXBean().getInputArguments();
			String weblogicName = "AdminServer";
			for(String arg:arguments)
			{
			  if(arg.startsWith("-Dweblogic.Name="))
			  {
			    weblogicName = arg.substring("-Dweblogic.Name=".length());
			    break;
			  }
			}
			String hostName = null;
			try
			{
			  hostName=java.net.InetAddress.getLocalHost().getHostName();
			}
			catch (java.net.UnknownHostException e)
			{
			  e.printStackTrace();
			  log.error("{}",e.getMessage());
			}
			String rtn = weblogicName+"@"+hostName;
			return rtn;
		}
        /**
        *   source:tskmod.@0001.script
        */
        public boolean isEnable()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean flg1 = false,flg2 = false;
			flg1 = this.isBussnissEnable();
			flg2 = this.isServiceEnable();
			return flg1 && flg2;
		}
        /**
        *   source:tskmod.@0002.script
        */
        public void sleep(long millis)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			try
			{
			  java.lang.Thread.sleep(millis);
			}
			catch (Exception e)
			{
			  log.error("{}",e.getMessage());
			}
		}
        /**
        *   source:tskmod.@0003.script
        */
        public boolean isBussnissEnable()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//判断该服务器是否操作某业务
			boolean flg = false;
			String db = Platform.getDefaultDB();
			String beginDB = (String)Platform.getStoredData("BeginDB."+Platform.getModuleRoot()+Platform.addThreadIdIfIsBackground());
			if(beginDB !=null)
			{
			  db = beginDB;
			}
			flg = Platform.checkFlgWithBussiness(db);
			return flg;
		}
        /**
        *   source:tskmod.@0004.script
        */
        public boolean isServiceEnable()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//判断服务是否可启动状态，用于控制不可重复启动的交易
			/*
			  String trnnam = Platform.getTransName();
			  String nodeid = getNodeId();
			  String sql = " WHERE tsk = ? AND nod = ? AND sta = 'Enable' ";
			  List<String> argVal = new ArrayList<String>();
			  argVal.add(trnnam);
			  argVal.add(nodeid);
			
			  Platform.clear($lst);
			  int err = Platform.errorCode();
			  Platform.esdbReadset("eibs",$lst,0,sql,argVal.toArray());
			  err = Platform.errorCode();
			  if(err==NO_ERROR && $lst.size()>0)
			  {
			  if((!Platform.isEmpty($lst[0]\\sta)) && "enable".equals($lst[0]\\sta.getValue().trim().toLowerCase()))
			  {
			  return true;
			  }
			  else
			  {
			  if($lst[0]\\slptim.getValue() > 0)
			  {
			  sleep($lst[0]\\slptim.getValue());
			  }
			  return false;
			  }
			  }
			  return false;
			  */
			return true;
		}
        /**
        *   source:tskmod.@0005.script
        */
        public boolean isEnable2()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean flg = false;
			flg = this.isServiceEnable();
			return flg;
		}


}