package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Txh;
import com.ceb.gjjs.mda.bo.Txt;
import com.ceb.gjjs.mda.bo.Mon;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Txm;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* 
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Txtm extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Txtm.class);

        //NewField
        private Map keymap;

        //预警值
        private BigDecimal waramt = new BigDecimal("0.00");

        //清算行
        private String attbic;

        //报文类型
        private String subtyp;

        //报文编号
        private String ref;



	    @BDGetter
		private Txt txt;

	    @BDGetter
		private Txm txm;

		@BDGetter
		private ModuleList<Keyele> elelst;

	    @BDGetter
		private Txh txh;

	    @BDGetter
		private Mon mon;


		public Txtm()
        {
            super();
            setArgument();
        }

        public Txtm(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }



        /**
        *   source:txtm.@0008.script
        */
        @Init(order=50)
        public boolean	init50(){
            IContext ctx = MdaEnv.getContext();
            
			MdaUtils.clear(this.getMon());
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> rcvpho = new Argument<String>("rcvpho");
			Argument<String> sndmsg = new Argument<String>("sndmsg");
			String sql = "SELECT inr,begtim,endtim,rcvpho,sndmsg FROM mon where typ = '1' ";
			Platform.mdbExecuteSQL(sql);
			Platform.mdbFetchFields(inr,rcvpho,sndmsg);
			Platform.mdbCloseCursor();
			if(!MdaUtils.isEmpty(inr))
			{
			  this.getMon().setInr( inr.value);
			  this.getMon().setRcvpho( rcvpho.value);
			  this.getMon().setSndmsg( sndmsg.value);
			}
			log.debug("{}","error:"+ctx.getErrorCode());
			

			return true;
        }


        /**
        *   source:txtm.@0000.script
        */
        public boolean sendMessage(String cur,String bic,BigDecimal waramt,BigDecimal amt,Date dat)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean rtn = false;
			String beginDB = (String)Platform.getStoredData("BeginDB."+Platform.getModuleRoot()+Platform.addThreadIdIfIsBackground());
			if(beginDB != null)
			{
			  Platform.mdbCommit();
			}
			Platform.mdbBegin("eibs");
			this.initMon();
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(this.getMon().getInr()))
			{
			  log.info("{}","未找到短信提醒参数!");
			  return true;
			}
			if(!MdaUtils.isEmpty(this.getMon().getSndmsg()) && "1".equals(this.getMon().getSndmsg()))
			{
			  log.info("{}","未开启短信提醒!");
			  return true;
			}
			String phos = "";
			if(!MdaUtils.isEmpty(this.getMon().getRcvpho()))
			{
			  phos = this.getMon().getRcvpho().replaceAll(",|，|；",";");
			}
			else
			{
			  log.info("{}","收汇人手机号为空，不发送短信!");
			  return true;
			}
			String[] phoary = null;
			if(!MdaUtils.isEmpty(phos))
			  phoary = phos.split(";");
			else
			{
			  log.info("{}","收汇人手机号为空，不发送短信!");
			  return true;
			}
			for(int i=0;i<phoary.length;i++)
			{
			  log.debug("{}","Currently,send message to "+phoary[i]);
			  if(!sendMessageToAll(cur,bic,waramt,amt,dat,phoary[i]))
			  {
			    rtn = false;
			  }
			  else
			    rtn = true;
			}
			Platform.mdbCommit();
			int error = ctx.getErrorCode();
			if(error == NO_ERROR)
			  rtn = true;
			else
			{
			  Platform.mdbRollback();
			  rtn = false;
			}
			if(beginDB != null)
			{
			  Platform.mdbBegin();
			}
			return rtn;
		}
        /**
        *   source:txtm.@0001.script
        */
        public String generMsgTxt(String txmnam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//String txmnam = "YJ000000";
			log.info("{}","txmnam："+txmnam);
			Platform.esdbRead("eibs",this.getTxm(),new Argument<String>("inr",EQ,txmnam));
			log.info("{}","txm内容："+this.getTxm().getTxt());
			String txt = this.getTxm().getTxt();
			String rtnTxt = this.setKeyList(txt);
			return rtnTxt;
		}
        /**
        *   source:txtm.@0002.script
        */
        public String setKeyList(String txt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	提取模版中的要素(变量)，并根据已有值进行替换
			  - txt 待替换报文文本
			  @ txt 替换之后的报文文本
			  */
			Map keymap = this.getKeymap();
			String key = "";
			key="{#"+"MBLPHO"+"#}";//移动电话
			keymap.put(key,this.getTxt().getMblpho());

			key="{#"+"AMT"+"#}";//可用金额
			String amt = "0.00";
			if(!MdaUtils.isEmpty(this.getTxt().getAmt()))
			{
			  amt = new java.text.DecimalFormat("#.00").format(this.getTxt().getAmt());
			}
			log.debug("{}","amt:"+amt);
			keymap.put(key,amt);

			key="{#"+"WARAMT"+"#}";//预警值
			String waramt = "0.00";
			if(!MdaUtils.isEmpty(this.getWaramt()))
			{
			  waramt = new java.text.DecimalFormat("#.00").format(this.getWaramt());
			}
			log.debug("{}","waramt:"+waramt);
			//String waramt = new java.text.DecimalFormat("#.00").format($waramt.getValue());
			//keymap.put(key,$waramt.getValue());
			keymap.put(key,waramt);

			key="{#"+"ATTBIC"+"#}";//清算行
			keymap.put(key,this.getAttbic());

			key="{#"+"CUR"+"#}";//币种
			keymap.put(key,this.getCurDsp(this.getTxt().getCur()));

			key="{#"+"DAT"+"#}";//日期
			keymap.put(key,MdaUtils.format(this.getTxt().getDat(),"yyyy年MM月dd日"));
			//20171218新加
			key="{#"+"TYP"+"#}";//报文类型
			keymap.put(key,this.getSubtyp());
			key="{#"+"REF"+"#}";//报文编号
			keymap.put(key,this.getRef());

			this.setKeymap(keymap);
			//log.info("***************************: "+keymap);
			//提取出文本中没有实际值替换的要素列表
			List<String> keyList = this.getKeyListInMsgBlock(txt);
			log.info("{}","提取的要素列表："+keyList);
			for(int i = 0;i<keyList.size();i++)
			{
			  String keyName = keyList.get(i);
			  //log.info("============keyName==============:"+keyName);
			  Argument<String> namarg = new Argument<String>("nam",keyName);
			  Argument<String> valarg = new Argument<String>("val");
			  //log.info("=========namarg=======:"+namarg+";;;=====valarg====:"+valarg);
			  ///从要素Map中读取要素值，若有则对原文进行替换，用要素值替换要素文本
			  Object value = keymap.get(keyName);
			  //log.info("============value==============:"+value);
			  if(!MdaUtils.isEmpty(value))
			  {
			    valarg.value = value.toString();
			    txt = txt.replace(keyName,value.toString());
			  }
			  else
			  {
			    if("{#AMT#}".equals(keyName)||"{#WARAMT#}".equals(keyName))
			    {
			      valarg.value = "0.00";
			      txt = txt.replace(keyName,"0.00");
			    }
			    else
			    {
			      valarg.value = " ";
			      txt = txt.replace(keyName," ");
			    }
			    continue;
			  }
			  this.getElelst().add(namarg,valarg);
			}
			return txt;
		}
        /**
        *   source:txtm.@0003.script
        */
        public List<String> getKeyListInMsgBlock(String txt)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *	从文本中提取要素列表
			  -	txt 待提取的文本
			  @ 从文本中提取出来的要素列表
			  */
			List<String> keyList = new ArrayList<String>();
			String regex = "\\{#.+?#\\}";//要素以{#XXX#}形式存在
			///通过匹配器（Matcher）逐个匹配出要素，并添加到要素列表中
			Matcher keyMatcher = Pattern.compile(regex).matcher(txt);
			while(keyMatcher.find())
			{
			  keyList.add(keyMatcher.group());
			}
			return keyList;
		}
        /**
        *   source:txtm.@0004.script
        */
        public void save(String dsc)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  保存对短信操作的每一步。从短信编辑到短信复核
			  */
			//Platform.mdbBegin();
			String inr = MdaUtils.format(Platform.mdbCounter("txh"),"00000000");
			this.getTxh().setInr( inr);
			this.getTxh().setTxtinr( this.getTxt().getInr());
			this.getTxh().setMagtim( MdaUtils.today());
			this.getTxh().setUsr( MdaEnv.getLoginUser());
			this.getTxh().setFrmnam( ctx.getTransName());
			//处理说明
			this.getTxh().setDsc( dsc);
			Platform.mdbInsert(this.getTxh());
			/*if(Platform.errorCode()==NO_ERROR)
			  {
			  log.info("数据库TXH表插入数据成功！");
			  Platform.mdbCommit();
			  }
			  else
			  {
			  Platform.message(#CT000008,#CT000009);
			  Platform.mdbRollback();
			  }*/
		}
        /**
        *   source:txtm.@0005.script
        */
        public void sendMsgToReceiver(String msg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}",msg+"通知发送...");
			//加锁
			if(!Platform.sdbLock(this.getTxt()))
			{
			  log.info("{}","该短信正在被其他人处理！");
			  return;
			}

			String magsta = this.getTxt().getMagsta();
			log.info("{}","old magsta:"+magsta);
			String rspsta = this.getTxt().getRspsta();
			Platform.mdbRead(this.getTxt(),new Argument<String>("inr",EQ,this.getTxt().getInr()));
			log.info("{}","new txtinr:"+this.getTxt().getInr()+",new magsta:"+this.getTxt().getMagsta());
			boolean condition = magsta.equals(this.getTxt().getMagsta());
			if(!condition)
			{
			  log.info("{}","该短信已被其他人处理！");
			  Platform.sdbUnLock(this.getTxt());
			  return;
			}
			Map<String,Object> map = geneShortMessage(msg);
			//Platform.mdbBegin();
			this.getTxt().setMagsta( "1");
			this.getTxt().setMagtime( MdaUtils.today());
			log.debug("{}","txt send map:"+map);
			Object retmap = MdaUtils.invoke("cn.com.brilliance.psbc.service.msplatform.MsSyncShortConnAPI","sendShortMessage",map);
			log.info("{}",msg+"通知已发送！");
			Map<String,Object> returnmap = (Map<String,Object>)retmap;
			if(returnmap==null)
			  this.getTxt().setRspsta("0");
			else
			{
			  log.debug("{}","returnmap:"+returnmap);
			  rspsta = returnmap.get("rspState").toString();
			  if("0".equals(rspsta))
			  {
			    log.info("{}","发送成功");
			    this.getTxt().setRspsta("1");
			  }
			  else if(!"0".equals(rspsta))
			  {
			    log.info("{}","发送失败");
			    this.getTxt().setRspsta("2");
			    String errorMessage = (String)returnmap.get("messageError");
			    this.getTxt().setErrmsg( errorMessage);
			  }
			  else
			  {
			    log.info("{}","发送未回执");
			    this.getTxt().setRspsta("0");
			  }
			}

			log.info("{}","-----------开始更新数据--------");
			Platform.mdbUpdate(this.getTxt());

			if(ctx.getErrorCode()==NO_ERROR)
			{
			  //Platform.mdbCommit();
			  Platform.sdbUnLock(this.getTxt());
			  log.info("{}","commit successed");
			}
			else
			{
			  //Platform.mdbRollback();
			  Platform.sdbUnLock(this.getTxt());
			  log.info("{}","rollback of message");
			  return;
			}
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.debug("{}","保存操作历史");
			  save("发送"+msg+"通知");
			}
			
		}
        /**
        *   source:txtm.@0006.script
        */
        public Map<String,Object> geneShortMessage(String msg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,Object> sndmap= new HashMap<String,Object>();
			//短消息基本属性
			//收件人手机号
			sndmap.put("strDesMsisdn",this.getTxt().getMblpho());
			log.trace("{}","mblpho:"+this.getTxt().getMblpho());
			//收费手机号
			sndmap.put("strFeeMsisdn",this.getTxt().getMblpho());
			//业务类型
			sndmap.put("bustyp","MONITOR");
			//短消息内容
			sndmap.put("strContent",this.getTxt().getTxt());
			log.info("{}","成功生成"+msg+"通知");

			return sndmap;

		}
        /**
        *   source:txtm.@0007.script
        */
        public String getCurDsp(String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String  curnam = "";
			Object session = Platform.esdbExecuteSQL("eibs","SELECT curnam FROM cur WHERE cur ='"+cur+"'");//执行sql语句查询记录
			Argument<String> nam = new Argument<String>("curnam");//构造Label列
			while(true)
			{
			  Platform.esdbFetchFields(session,nam);//逐条取出记录
			  int errorCode = ctx.getErrorCode();//取出记录的执行结果
			  if(errorCode == NO_ERROR)
			  {
			    String codnam = nam.value;
			    if(!MdaUtils.isEmpty(codnam))
			      curnam = codnam;
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.esdbCloseCursor(session);
			return curnam;
		}
        /**
        *   source:txtm.@0009.script
        */
        public void initMon()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getMon());
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> rcvpho = new Argument<String>("rcvpho");
			Argument<String> sndmsg = new Argument<String>("sndmsg");
			String sql = "SELECT inr,begtim,endtim,rcvpho,sndmsg FROM mon where typ = '1' ";
			Object session =  Platform.esdbExecuteSQL("eibs",sql);
			Platform.esdbFetchFields(session,inr,rcvpho,sndmsg);
			Platform.esdbCloseCursor(session);
			if(!MdaUtils.isEmpty(inr))
			{
			  this.getMon().setInr( inr.value);
			  this.getMon().setRcvpho( rcvpho.value);
			  this.getMon().setSndmsg( sndmsg.value);
			}
			log.debug("{}","error:"+ctx.getErrorCode());
			
		}
        /**
        *   source:txtm.@0010.script
        */
        public boolean sendMessageToAll(String cur,String bic,BigDecimal waramt,BigDecimal amt,Date dat,String rcvpho)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTxt().setMblpho( rcvpho);
			this.getTxt().setAmt( MdaUtils.parseDecimal(amt));
			this.setWaramt( MdaUtils.parseDecimal(waramt));
			this.setAttbic( bic);
			this.getTxt().setCur( cur);
			this.getTxt().setDat( dat);//接收日期
			String txt = generMsgTxt("YJ000000");
			String inr = MdaUtils.format(Platform.mdbCounter("txt"),"00000000");
			this.getTxt().setInr( inr);
			//0代表“待发送”
			this.getTxt().setMagsta( "0");
			String usrnam = MdaEnv.getLoginUser();
			this.getTxt().setUsrnam( usrnam);
			this.getTxt().setTxt( txt);
			this.getTxt().setMagtime( MdaUtils.today());
			this.getTxt().setCrtdat( MdaUtils.today());
			//Platform.mdbBegin();
			Platform.mdbInsert(this.getTxt());
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  //Platform.mdbCommit();
			  log.info("{}","数据库TXT表插入数据成功！");
			  save("可用额度预警短信已编辑");
			  sendMsgToReceiver("可用额度预警短信");
			  return true;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("txtm","CT000050"),MdaUtils.getI18NString("txtm","CT000051"));
			  //Platform.mdbRollback();
			  return false;
			}
		}
        /**
        *   source:txtm.@0011.script
        */
        public boolean noticeToOperator(String cur,String typ,String ref)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean rtn = false;
			String beginDB = (String)Platform.getStoredData("BeginDB."+Platform.getModuleRoot()+Platform.addThreadIdIfIsBackground());
			if(beginDB != null)
			{
			  Platform.mdbCommit();
			}
			Platform.mdbBegin("eibs");
			this.initMon("4");
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(this.getMon().getInr()))
			{
			  log.info("{}","未找到短信提醒参数!");
			  return true;
			}
			if(!MdaUtils.isEmpty(this.getMon().getSndmsg()) && "1".equals(this.getMon().getSndmsg()))
			{
			  log.info("{}","未开启短信提醒!");
			  return true;
			}
			String phos = "";
			if(!MdaUtils.isEmpty(this.getMon().getRcvpho()))
			{
			  phos = this.getMon().getRcvpho().replaceAll(",|，|；",";");
			}
			else
			{
			  log.info("{}","收汇人手机号为空，不发送短信!");
			  return true;
			}
			String[] phoary = null;
			if(!MdaUtils.isEmpty(phos))
			  phoary = phos.split(";");
			else
			{
			  log.info("{}","收汇人手机号为空，不发送短信!");
			  return true;
			}
			for(int i=0;i<phoary.length;i++)
			{
			  log.debug("{}","Currently,send message to "+phoary[i]);
			  if(!sendMessageToAllOperator(cur,typ,ref,phoary[i]))
			  {
			    rtn = false;
			  }
			  else
			    rtn = true;
			}
			Platform.mdbCommit();
			int error = ctx.getErrorCode();
			if(error == NO_ERROR)
			  rtn = true;
			else
			{
			  Platform.mdbRollback();
			  rtn = false;
			}
			if(beginDB != null)
			{
			  Platform.mdbBegin();
			}
			return rtn;
		}
        /**
        *   source:txtm.@0012.script
        */
        public void initMon(String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getMon());
			Argument<String> inr = new Argument<String>("inr");
			Argument<String> rcvpho = new Argument<String>("rcvpho");
			Argument<String> sndmsg = new Argument<String>("sndmsg");
			String sql = "SELECT inr,begtim,endtim,rcvpho,sndmsg FROM mon where typ = '"+typ+"'";

			Object session =  Platform.esdbExecuteSQL("eibs",sql);
			Platform.esdbFetchFields(session,inr,rcvpho,sndmsg);
			Platform.esdbCloseCursor(session);
			if(!MdaUtils.isEmpty(inr))
			{
			  this.getMon().setInr( inr.value);
			  this.getMon().setRcvpho( rcvpho.value);
			  this.getMon().setSndmsg( sndmsg.value);
			}
			log.debug("{}","error:"+ctx.getErrorCode());
			
		}
        /**
        *   source:txtm.@0013.script
        */
        public boolean sendMessageToAllOperator(String cur,String typ,String ref,String rcvpho)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTxt().setMblpho( rcvpho);
			this.getTxt().setCur( cur);
			this.getTxt().setDat( MdaUtils.today());//接收日期
			this.setSubtyp( typ);
			this.setRef( ref);
			String txt = generMsgTxt("PD000000");
			String inr = MdaUtils.format(Platform.mdbCounter("txt"),"00000000");
			this.getTxt().setInr( inr);
			//0代表“待发送”
			this.getTxt().setMagsta( "0");
			String usrnam = MdaEnv.getLoginUser();
			this.getTxt().setUsrnam( usrnam);
			this.getTxt().setTxt( txt);
			this.getTxt().setMagtime( MdaUtils.today());
			this.getTxt().setCrtdat( MdaUtils.today());
			Platform.mdbInsert(this.getTxt());
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  log.info("{}","数据库TXT表插入数据成功！");
			  save("已排队短信已编辑");
			  sendMsgToReceiver("已排队短信");
			  return true;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("txtm","CT000070"),MdaUtils.getI18NString("txtm","CT000071"));
			  return false;
			}
		}
        /**
        *   source:txtm.@0014.script
        */
        public boolean snd192sMessage()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean rtn = false;
			String beginDB = (String)Platform.getStoredData("BeginDB."+Platform.getModuleRoot()+Platform.addThreadIdIfIsBackground());
			if(beginDB != null)
			{
			  Platform.mdbCommit();
			}
			Platform.mdbBegin("eibs");
			this.initMon("5");
			ctx.getErrorCode();
			if(MdaUtils.isEmpty(this.getMon().getInr()))
			{
			  log.info("{}","未找到短信提醒参数!");
			  return true;
			}
			if(!MdaUtils.isEmpty(this.getMon().getSndmsg()) && "1".equals(this.getMon().getSndmsg()))
			{
			  log.info("{}","未开启短信提醒!");
			  return true;
			}
			String phos = "";
			if(!MdaUtils.isEmpty(this.getMon().getRcvpho()))
			{
			  phos = this.getMon().getRcvpho().replaceAll(",|，|；",";");
			}
			else
			{
			  log.info("{}","收汇人手机号为空，不发送短信!");
			  return true;
			}

			String[] phoary = null;
			if(!MdaUtils.isEmpty(phos))
			  phoary = phos.split(";");
			else
			{
			  log.info("{}","收汇人手机号为空，不发送短信!");
			  return true;
			}
			for(int i=0;i<phoary.length;i++)
			{
			  log.debug("{}","Currently,send message to "+phoary[i]);
			  if(!sendMessageToAll(phoary[i]))
			  {
			    rtn = false;
			  }
			  else
			    rtn = true;
			}
			Platform.mdbCommit();
			int error = ctx.getErrorCode();
			if(error == NO_ERROR)
			  rtn = true;
			else
			{
			  Platform.mdbRollback();
			  rtn = false;
			}
			if(beginDB != null)
			{
			  Platform.mdbBegin();
			}
			return rtn;
		}
        /**
        *   source:txtm.@0015.script
        */
        public boolean sendMessageToAll(String rcvpho)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			this.getTxt().setMblpho( rcvpho);
			this.getTxt().setDat( MdaUtils.today());//接收日期
			String txt = generMsgTxt("ZF000000");
			String inr = MdaUtils.format(Platform.mdbCounter("txt"),"00000000");
			this.getTxt().setInr( inr);
			//0代表“待发送”
			this.getTxt().setMagsta( "0");
			String usrnam = MdaEnv.getLoginUser();
			this.getTxt().setUsrnam( usrnam);
			this.getTxt().setTxt( txt);
			this.getTxt().setMagtime( MdaUtils.today());
			this.getTxt().setCrtdat( MdaUtils.today());
			//Platform.mdbBegin();
			Platform.mdbInsert(this.getTxt());
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  //Platform.mdbCommit();
			  log.info("{}","数据库TXT表插入数据成功！");
			  save("短信已编辑");
			  sendMsgToReceiver("发送短信");
			  return true;
			}
			else
			{
			  ctx.setMessage(MdaUtils.getI18NString("txtm","CT000080"),MdaUtils.getI18NString("txtm","CT000081"));
			  //Platform.mdbRollback();
			  return false;
			}
		}
















}