package com.ceb.gjjs.mda.vo;

import java.util.Date;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.io.Serializable;

import com.brilliance.mda.runtime.annotation.RelPath;
import com.brilliance.mda.runtime.mda.DirType;
import com.brilliance.mda.runtime.mda.impl.ModuleList;
import com.brilliance.mda.runtime.request.BaseVO;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import com.brilliance.mda.support.jakson.serialize.BigDecimalSerializeRate;
import com.brilliance.mda.support.jakson.serialize.DecimalLength;

import com.ceb.gjjs.mda.manager.module.Rcvlst;
import lombok.Data;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
public class RcvselVO extends BaseVO implements Serializable{

    @JsonIgnore
    private static final long serialVersionUID = 1L;

    @RelPath(value="msggrp.rcvlst",dir=DirType.OUT)
    private ModuleList<Rcvlst> msggrp_rcvlst;

    @RelPath(value="rcvp.act",dir=DirType.BOTH)
    private String rcvp_act;

    @RelPath(value="rcvp.actbic",dir=DirType.BOTH)
    private String rcvp_actbic;

    @RelPath(value="rcvp.amtmax",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rcvp_amtmax;

    @RelPath(value="rcvp.amtmin",dir=DirType.BOTH)
    @JsonSerialize(using = BigDecimalSerializeRate.class)
    @DecimalLength(2)
    private BigDecimal rcvp_amtmin;

    @RelPath(value="rcvp.blksta",dir=DirType.BOTH)
    private String rcvp_blksta;

    @RelPath(value="rcvp.chnipt",dir=DirType.BOTH)
    private String rcvp_chnipt;

    @RelPath(value="rcvp.cur",dir=DirType.BOTH)
    private String rcvp_cur;

    @RelPath(value="rcvp.dtlchg",dir=DirType.BOTH)
    private String rcvp_dtlchg;

    @RelPath(value="rcvp.gpi",dir=DirType.BOTH)
    private String rcvp_gpi;

    @RelPath(value="rcvp.lcnb",dir=DirType.BOTH)
    private String rcvp_lcnb;

    @RelPath(value="rcvp.ldevim",dir=DirType.BOTH)
    private String rcvp_ldevim;

    @RelPath(value="rcvp.ldevis",dir=DirType.BOTH)
    private String rcvp_ldevis;

    @RelPath(value="rcvp.ldsvim",dir=DirType.BOTH)
    private String rcvp_ldsvim;

    @RelPath(value="rcvp.ldsvis",dir=DirType.BOTH)
    private String rcvp_ldsvis;

    @RelPath(value="rcvp.lstdatend",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rcvp_lstdatend;

    @RelPath(value="rcvp.lstdatsta",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rcvp_lstdatsta;

    @RelPath(value="rcvp.msgtyp",dir=DirType.BOTH)
    private String rcvp_msgtyp;

    @RelPath(value="rcvp.othref",dir=DirType.BOTH)
    private String rcvp_othref;

    @RelPath(value="rcvp.ownref",dir=DirType.BOTH)
    private String rcvp_ownref;

    @RelPath(value="rcvp.rcvdatend",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rcvp_rcvdatend;

    @RelPath(value="rcvp.rcvdatsta",dir=DirType.BOTH)
    @JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
    private Date rcvp_rcvdatsta;

    @RelPath(value="rcvp.revbak",dir=DirType.BOTH)
    private String rcvp_revbak;

    @RelPath(value="rcvp.sndbak",dir=DirType.BOTH)
    private String rcvp_sndbak;

    @RelPath(value="rcvp.sta",dir=DirType.BOTH)
    private String rcvp_sta;

    @RelPath(value="rcvp.subtyp",dir=DirType.BOTH)
    private String rcvp_subtyp;

    @RelPath(value="rcvp.tblvim",dir=DirType.BOTH)
    private String rcvp_tblvim;

    @RelPath(value="rcvp.tblvis",dir=DirType.BOTH)
    private String rcvp_tblvis;

    @RelPath(value="rcvp.uetr",dir=DirType.BOTH)
    private String rcvp_uetr;


}