package com.ceb.gjjs.mda.manager.module;

import java.util.*;
import java.math.BigDecimal;
import com.brilliance.mda.runtime.mda.*;
import com.brilliance.mda.runtime.mda.impl.*;
import com.brilliance.mda.runtime.annotation.*;
import com.brilliance.mda.runtime.mda.driver.*;
import static com.brilliance.mda.runtime.mda.Constants.*;
import com.brilliance.mda.runtime.mda.util.*;
import com.fasterxml.jackson.annotation.*;
import java.util.regex.*;
import lombok.Getter;
import lombok.Setter;
import com.ceb.gjjs.mda.bo.Fxebnk;
import com.ceb.gjjs.mda.bo.Fxdcom;
import com.ceb.gjjs.mda.bo.Csn;
import com.ceb.gjjs.mda.bo.Usrtab;
import com.ceb.gjjs.mda.bo.Fxd;
import com.ceb.gjjs.mda.bo.Dta;
import com.ceb.gjjs.mda.bo.Smh;
import com.ceb.gjjs.mda.bo.Fxdrig;
import com.ceb.gjjs.mda.bo.Fxdrel;
import com.ceb.gjjs.mda.bo.Qrd;
import com.ceb.gjjs.mda.bo.Cetcsn;
import com.ceb.gjjs.mda.bo.Dtr;
import com.ceb.gjjs.mda.bo.Mpe;
import com.ceb.gjjs.mda.bo.Fxdpat;
import com.ceb.gjjs.mda.bo.Cpm;
import com.ceb.gjjs.mda.bo.Fxbank;
import com.ceb.gjjs.mda.bo.Mar;
import com.ceb.gjjs.mda.bo.Noz;
import com.ceb.gjjs.mda.bo.Dat;
import com.ceb.gjjs.mda.bo.Ptyref;
import com.ceb.gjjs.mda.bo.Cpstim;
import com.ceb.gjjs.mda.bo.Mps;
import com.ceb.gjjs.mda.bo.Elctim;
import com.ceb.gjjs.mda.bo.Cpsact;
import com.ceb.gjjs.mda.bo.Cpy;
import com.ceb.gjjs.mda.global.Platform;
import com.ceb.gjjs.mda.bo.Chn;
import com.ceb.gjjs.mda.bo.Png;
import com.ceb.gjjs.mda.bo.Mpi;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
* Distribute Rule Module
*/
@JsonIgnoreProperties(ignoreUnknown = true)
@Getter
@Setter
public class Dtrmod extends AbstractModule{
		private static Logger log = LoggerFactory.getLogger(Dtrmod.class);

        //保存报文文件流
        private IStream is = new StreamImpl();



		@BDGetter
		private ModuleList<Dtr> dtrlst;

	    @BDGetter
		private Mps mps;

	    @BDGetter
		private Mps submps;

	    @BDGetter
		private Mpe mpe;

	    @BDGetter
		private Mpi mpi;

	    @BDGetter
		private Mpe submpe;

	    @BDGetter
		private Dat dat;

	    @BDGetter
		private Smpmod smpmod;

		@BDGetter
		private ModuleList<Dta> dtalst;

		@BDGetter
		private ModuleList<Smh> smhlst;

		@BDGetter
		private ModuleList<Mps> mpslst;

		@BDGetter
		private ModuleList<Chn> chnlst;

	    @BDGetter
		private Qrd qrd;

	    @BDGetter
		private Csn csn;

		@BDGetter
		private ModuleList<Csn> csnlst;

		@BDGetter
		private ModuleList<Fxbank> bnklst;

	    @BDGetter
		private Fxbank fxbank;

	    @BDGetter
		private Usrtab usrtab;

		@BDGetter
		private ModuleList<Usrtab> usrtabs;

	    @BDGetter
		private Txtm txtm;

	    @BDGetter
		private Ptyref ptyref;

		@BDGetter
		private ModuleList<Ptyref> ptyreflst;

	    @BDGetter
		private Cpsact cpsact;

	    @BDGetter
		private Cpy cpy;

	    @BDGetter
		private Cpm cpm;

	    @BDGetter
		private Noz noz;

		@BDGetter
		private ModuleList<Noz> nozlst;

	    @BDGetter
		private Mpi mpitmp;

	    @BDGetter
		private Fxebnk fxebnk;

	    @BDGetter
		private Elctim elctim;

	    @BDGetter
		private Cetcsn cetcsn;

	    @BDGetter
		private Cpstim cpstim;

	    @BDGetter
		private Fxd fxd;

	    @BDGetter
		private Fxdpat fxdpat;

	    @BDGetter
		private Fxdrel fxdrel;

	    @BDGetter
		private Fxdrig fxdrig;

	    @BDGetter
		private Fxdcom fxdcom;

	    @BDGetter
		private Swemod swemod;

	    @BDGetter
		private Mar mar;

	    @BDGetter
		private Mpi inmpi;

	    @BDGetter
		private Mpi outmpi;

	    @BDGetter
		private Png png;


		public Dtrmod()
        {
            super();
            setArgument();
        }

        public Dtrmod(String name,IModule parent)
        {
            super(name,parent);
            setArgument();
        }

        public void setArgument()
        {
        }




        /**
        *   source:dtrmod.@0000.script
        */
        public boolean distributeMessageAutomatic(String db,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 报文自动清分处理
			  * 1, 先读取指定报文类型（例如：sf2）所有清分规则；
			  * 2, 逐条进行报文渠道字符串（chnstr）正则表达式匹配检查 （例如：SWT或GJSSWT）;
			  * 3, 渠道字符串匹配则进行报文类型字符串（typstr）正则表达式匹配检查（例如：103）；
			  * 4, 渠道和报文类型匹配则再进行域字符串（tagstr）函数检查（例如：$ref(#20)）；
			  */
			/// 获取并锁定一条需要自动清分记录（MPS，将会自动读取相关MPE、SMH、CHN信息）
			// if($smpmod.fetchAndLockMessage(db,"XXX","A"))
			if(this.getSmpmod().fetchAndLockMessage(db,"XXX","A",dir))
			{
			  /// 获取报文类型
			  String messageType = this.getSmpmod().getSmh().getDocfxt();
			  /// 开始本次处理事务
			  Platform.mdbBegin();
			  /// 获取或新创建报文信息(如果失败则设置为需要手工清分)
			  if(!this.getSmpmod().getOrCreateMessageInformation(messageType))
			  {
			    /// 累加错误信息
			    this.getSmpmod().getSmh().setXxxcnt( this.getSmpmod().getSmh().getXxxcnt()+ 1);
			    Platform.mdbUpdate(this.getSmpmod().getSmh());
			    /// 如果错误次数少于3次则认为“等待同步文件”，否则置错误不再处理
			    if(this.getSmpmod().getSmh().getXxxcnt()>3)
			      this.getSmpmod().updatekWithUnlock("XXX",null,null,"E","无法读取或创建报文信息！"); // 状态为E则为错误状态
			    else
			      this.getSmpmod().updatekWithUnlock("XXX",null,null,"A","等待集群主机同步文件..."); // 状态为A则继续进行清分
			    Platform.mdbCommit();
			    return false;
			  }
			  else
			  {
			    if("E".equals(this.getSmpmod().getMps().getSta()))
			    {
			      this.getSmpmod().updatekWithUnlock("XXX",null,null,"E","GISP异常报文,不做后续处理"); // 状态为E则为错误状态
			      Platform.mdbCommit();
			      return false;
			    }
			  }
			  if(this.getSmpmod().checkNeedValidate())	//检查是否需要人工检查再放行
			  {
			    log.debug("{}","验证需要复查，不再进行余下处理");
			    Platform.mdbCommit();
			    return false;
			  }
			  /// 生成渠道字符串
			  String channelStr = this.getSmpmod().getMps().getSrcchncod();
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getTgtchncod()))
			    channelStr += this.getSmpmod().getMps().getTgtchncod();
			  else
			    channelStr += "ALL"; // 注：所有渠道
			  /// 生成报文类型字符串
			  String typeStr = this.getSmpmod().getMpi().getSubtyp();
			  if(typeStr==null)
			    typeStr = "";
			  /// 读取当前报文的所有规则并按level进行排序
			  /// (FIXME) 需要加入生效时间判断
			  if(!MdaUtils.isEmpty(this.getSmpmod().getNxtsmh().getDocfxt()))
			    messageType = this.getSmpmod().getNxtsmh().getDocfxt();
			  Platform.esdbReadset("eibs",this.getDtrlst(),0,new Argument("msgtyp",messageType),new Argument("lvl",ASC),new Argument("chnstr",ASC));
			  log.info("{}","size:"+this.getDtrlst().fullSize());
			  String stepTraceStr = "";
			  log.debug("{}","channelStr,typeStr:\t"+channelStr+"\t"+typeStr);
			  /// 逐条清分规则进行处理
			  for(com.ceb.gjjs.mda.bo.Dtr dtr : this.getDtrlst())
			  {
			    log.debug("{}","chnstr,typestr,tagstr:\t"+dtr.getChnstr()+"\t"+dtr.getTypstr()+"\t"+dtr.getTagstr());
			    /// 检查渠道字符串与当前规则是否匹配
			    if(checkMatches(channelStr,dtr.getChnstr()))
			    {
			      log.debug("{}","channelStr.matched.");
			      /// 检查报文类型字符串与当前规则是否匹配
			      if(checkMatches(typeStr,dtr.getTypstr()))
			      {
			        log.debug("{}","typeStr.matched.");
			        /// 执行报文域的匹配检查
			        if(checkTagMatches(dtr.getTagstr()))
			        {
			          log.debug("{}","tagStr.matched.");
			          /// 记录该规则已匹配执行
			          stepTraceStr += "\r\n" + dtr.getRulnam();
			          /*String beginDB = (String)Platform.getStoredData("BeginDB."+Platform.getModuleRoot()+Platform.addThreadIdIfIsBackground());
			            if(beginDB == null)
			            {
			            Platform.mdbBegin();
			            }*/
			          /// 执行报文规则检查脚本（直接返回步骤，值以逗号隔开为先后关系，分隔符|隔开为并列关系即抄送）
			          String steps = getChannelStepValue(dtr.getSmpstp());
			          if(!MdaUtils.isEmpty(steps))
			          {

			            log.debug("{}","steps:"+steps);
			            /// 记录并处理mps状态信息
			            this.getSmpmod().getMps().setStp( steps);
			            /// 将应执行步骤、已匹配规则信息进行具体步骤执行
			            processMessageBySteps(steps, stepTraceStr);

			            //20181226 针对收报的103|202COV|192新增加reptrksta的值，后续自动回复199报文
			            if(">".equals(this.getSmpmod().getMps().getDir()) && MdaUtils.isEmpty(this.getSmpmod().getMps().getReptrksta()) && "GPI".equals(this.getSmpmod().getMpi().getGpi())
			              && ("103|202COV|202|192".contains(this.getSmpmod().getMpi().getSubtyp())))
			            {
			              this.getSmpmod().getMps().setReptrksta("W");
			            }

			            /// 下一渠道和目标渠道均不为空且不为自动清分处理渠道则表达清分已经成功！
			            if(!"XXX".equals(this.getSmpmod().getMps().getNxtchncod())&&!MdaUtils.isEmpty(this.getSmpmod().getMps().getNxtchncod())
			              &&!"XXX".equals(this.getSmpmod().getMps().getTgtchncod())&&!MdaUtils.isEmpty(this.getSmpmod().getMps().getTgtchncod()))
			            {

			              //记录黑名单状态
			              if("BLK".equals(this.getSmpmod().getMps().getNxtchncod()))
			                this.getSmpmod().getMps().setIsblk( "X");
			              // if(("GHD|GJS|ZQS".indexOf($smpmod\\mps\\tgtchncod.getValue())>=0)&&(!$smpmod\\mpi\\subtyp.getValue().matches("[0-9]9[0-9]")))
			
			              if(("GHD|ZQS".indexOf(this.getSmpmod().getMps().getTgtchncod())>=0)
			                &&(("103".equals(this.getSmpmod().getMpi().getSubtyp()))
			              &&("sf2".equals(this.getSmpmod().getMpi().getMsgtyp()))
			              ||("100|101|102|103|104".contains(this.getSmpmod().getMpi().getSubtyp()))
			              &&("txt".equals(this.getSmpmod().getMpi().getMsgtyp()))))
			              //20200430修改，国际结算1、2字头报文也需等待950-暂不上
			              /* if (("GHD|GJS|ZQS".indexOf($smpmod\\mps\\tgtchncod.getValue()) >= 0) && (
			              ("103|202|202COV".contains($smpmod\\mpi\\subtyp.getValue())) &&
			              ("sf2".equals($smpmod\\mpi\\msgtyp.getValue())) || (
			              ("100|101|102|103|104|200|201|202|204".contains($smpmod\\mpi\\subtyp.getValue())) &&
			              ("txt".equals($smpmod\\mpi\\msgtyp.getValue())))))*/
			            {
			              MdaUtils.clear(this.getSmpmod().getMpe());
			              this.getSmpmod().getMpe().setMpsinr(this.getSmpmod().getMps().getInr());
			              this.getSmpmod().getMpe().setChncod(this.getSmpmod().getMps().getChncod());
			              this.getSmpmod().getMpe().setNxtchncod(this.getSmpmod().getMps().getNxtchncod());
			              this.getSmpmod().getMpe().setSmhinr(this.getSmpmod().getMps().getSmhinr());
			              this.getSmpmod().getMpe().setNxtsmhinr(this.getSmpmod().getMps().getSmhinr());
			              this.getSmpmod().getMpe().setDattim(new Date());
			              this.getSmpmod().getMpe().setUsr(MdaEnv.getLoginUser());
			              this.getSmpmod().getMpe().setFrmnam(ctx.getTransName());
			              this.getSmpmod().getMpe().setPrvsta(this.getSmpmod().getMps().getSta());
			              this.getSmpmod().getMpe().setSta("L");
			              this.getSmpmod().getMpe().setTxt("等待关联勾销");
			              this.getSmpmod().getMpe().setRspsta(this.getSmpmod().getMps().getNxtsta());
			              this.getSmpmod().getMpe().setPrvrspsta(this.getSmpmod().getMps().getSta());
			              Platform.sdbInsert(this.getSmpmod().getMpe());
			              this.getSmpmod().getMps().setSta("L");
			            }

			            Platform.mdbUpdate(this.getSmpmod().getMps());
			            Platform.mdbCommit();
			            if(ctx.getErrorCode()!=NO_ERROR)
			            {
			              log.info("{}","commit error");
			              //Platform.mdbRollback();
			              return false;
			            }
			            log.debug("{}","xxxtsk isblk :"+this.getSmpmod().getMps().getIsblk());
			            //20190416添加代码，如是192s报文，但下一渠道是黑名单的，需向业务发送短信提醒
			            /* if("192".equals($smpmod\\mpi\\subtyp.getValue()) && "sf2".equals($smpmod\\mpi\\msgtyp.getValue()) && "GPI".equals($smpmod\\mpi\\gpi.getValue())
			              && (("C".equals($smpmod\\mps\\isblk.getValue()) || "BLK".equals($smpmod\\mps\\nxtchncod.getValue()))))
			              {
			              log.info("192s清分至黑名单...");
			              boolean flg = $txtm.snd192sMessage($smpmod\\mpi\\othref.getValue(),$smpmod\\mps\\rcvdattim.getValue());
			              log.info("flg:"+flg);
			              }*/
			            if("xml".equals(this.getSmpmod().getMpi().getMsgtyp()) && "111|112|113".contains(this.getSmpmod().getMpi().getSubtyp()))
			            {
			              this.getSwemod().createOrUpdateSedEntryForCips(this.getSmpmod().getMpi().getSubtyp(),this.getSmpmod().getMps(),this.getSmpmod().getMpi());
			            }
			            return true;
			          }
			        }
			      } // 报文域匹配处理结束
			    } // 报文类型字符串匹配结束
			  } // 渠道字符串匹配结束
			} // 逐条循环清分规则结束
			this.getSmpmod().updatekWithUnlock("XXX",null,null,"X","无已定义规则可进行自动清分！");
			Platform.mdbCommit();

			if("xml".equals(this.getSmpmod().getMpi().getMsgtyp()) && "111|112|113".contains(this.getSmpmod().getMpi().getSubtyp()))
			{
			  this.getSwemod().createOrUpdateSedEntryForCips(this.getSmpmod().getMpi().getSubtyp(),this.getSmpmod().getMps(),this.getSmpmod().getMpi());
			}

			//20181219添加代码，如是192s报文，但下一渠道是黑名单或人工清分的，需向业务发送短信提醒
			/*if("192".equals($smpmod\\mpi\\subtyp.getValue()) && "sf2".equals($smpmod\\mpi\\msgtyp.getValue()) && "GPI".equals($smpmod\\mpi\\gpi.getValue())
			  && ( (("X".equals($smpmod\\mps\\sta.getValue()) && ("XXX".equals($smpmod\\mps\\nxtchncod.getValue()) || Platform.isEmpty($smpmod\\mps\\nxtchncod.getValue()))))))
			  {
			  log.info("192s无已定义的清分规则...");
			  boolean flg = $txtm.snd192sMessage($smpmod\\mpi\\othref.getValue(),$smpmod\\mps\\rcvdattim.getValue());
			  log.info("flg:"+flg);
			  }*/
			return false;
			}
			return false;
		}
        /**
        *   source:dtrmod.@0002.script
        */
        public String getChannelStepValue(String expression)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 为空直接返回空串
			if(MdaUtils.isEmpty(expression))
			  return "";
			log.debug("{}","expression:"+expression);
			/// 判断是否为 ? : 的选择判断表达式
			if(expression.matches("[^\\?]*\\?[^\\:]*\\:.*"))
			{
			  /// 为表达式需要进行处理，但如果不为简单一次表达式不能够进行处理（返回空）
			  if(!expression.matches("[^\\?]*\\?[^\\:\\?]*\\:[^\\:\\?]*"))
			    return "";
			  /// 拆分表达式的三部分，再进行二次解析
			  String[] values = expression.split("\\?|\\:");
			  log.info("{}","debug:"+values[0]+"\t"+values[1]+"\t"+values[2]);
			  /// 第一部分为判断表达式，第二、三部分为返回值
			  if((Boolean)doExpression(values[0],false))
			    return (String)doExpression(values[1],"");
			  else
			    return (String)doExpression(values[2],"");
			}
			else
			{ /// 非选择判断表达式则直接进行解析返回
			  return (String)doExpression(expression,"");
			}
		}
        /**
        *   source:dtrmod.@0011.script
        */
        public void processMessageBySteps(String stepStr, String stepTraceStr)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 根据已知的步骤进行清分
			log.debug("{}","stepStr:"+stepStr);
			/// 选择拆分需要前后执行的逻辑
			String[] followSteps = stepStr.split(",");
			if(followSteps.length==1)
			{ /// 非先后次序的步骤处理
			  String nextStepStr = followSteps[0];
			  /// 按并列执行(即抄送)进行分拆
			  String[] nextSteps = nextStepStr.split("\\|");
			  if(nextSteps.length==1 && !"XXX".equals(nextSteps[0]))
			  { /// 仅单步处理（无并行也无前后逻辑，即完全匹配该渠道），若下一渠道已有非XXX值不给进行更新
			    /// 目标渠道已设置（该处理针对下一渠道已处理成功，但仍进行最终渠道的清分判断，例如：需要先行发送DXZ，再发送给XXX--仍需要判断的渠道）
			    /// 以上两种情况均属于清分成功（所以想做先后处理一定要在此类规则之前）
			    if("XXX".equals(this.getSmpmod().getMps().getNxtchncod()))
			      this.getSmpmod().updatekWithUnlock("XXX",nextSteps[0],nextSteps[0],null,stepTraceStr);
			    else
			      this.getSmpmod().updatekWithUnlock("XXX",null,nextSteps[0],null,stepTraceStr);
			  }
			  else if(nextSteps.length==2)
			  { // 并列处理步骤（表示抄送方式）
			    //20190613新加判断，针对910延时后的第二次清分，将不再抄送至对销账
			    if(checkNozFor910())
			    {
			      Date processDate = new Date();
			      // 新建抄送渠道处理记录 （smpmod为原模型不要在模块外执行变更操作）
			      this.getMps().copyValues(this.getSmpmod().getMps()); // 相关关联报文等值通过复制获取
			      this.getMps().setInr( Platform.sdbCounter("mps"));
			      this.getMps().setPntinr( this.getSmpmod().getMps().getInr()); // 关联之前的MPS记录
			      this.getMps().setNxtchncod( nextSteps[0]);
			      this.getMps().setTgtchncod( nextSteps[0]);
			      this.getMps().setDir( ""); // 内部数据交换
			      this.getMps().setSta( "M"); // 默认抄送均为内部渠道
			      this.getMps().setNxtsta( "M");
			      this.getMps().setRcvdattim( processDate); // 报文接收时间
			      this.getMps().setLstdattim( processDate); // 最近处理执行时间
			      this.getMps().setSttdattim( processDate); // 开始处理时间
			      Platform.mdbInsert(this.getMps());
			      // 新建抄送渠道处理详细信息
			      this.getMpe().setMpsinr( this.getMps().getInr());
			      this.getMpe().setChncod( "XXX");
			      this.getMpe().setNxtchncod( nextSteps[0]);
			      this.getMpe().setSmhinr( this.getMps().getSmhinr());
			      this.getMpe().setDattim( processDate);
			      this.getMpe().setSta( "M");
			      this.getMpe().setUsr( MdaEnv.getLoginUser());
			      this.getMpe().setFrmnam( ctx.getTransName());
			      this.getMpe().setTxt( "系统自动抄送报文");
			      Platform.sdbInsert(this.getMpe());
			    }
			    if(!"XXX".equals(nextSteps[1]))
			      this.getSmpmod().updatekWithUnlock("XXX",nextSteps[1],nextSteps[1],null,stepTraceStr);
			    /// 如果另一步为XXX则继续进行后面的清分规则
			  }
			}
			/*else if(followSteps.length==2)
			  { /// 这里先后渠道仅支持先内部交换，再外部渠道（两个都不再有并列或先后渠道），更繁杂的处理再完善
			  $smpmod.updatekWithUnlock("XXX",followSteps[0],followSteps[1],"M",stepTraceStr);
			  }*/
			else if(followSteps.length==2)
			{ /// Alex150127(这里先后渠道仅支持先内部交换，再外部渠道（两个都不再有并列或先后渠道），更繁杂的处理再完善)
			  //$smpmod.updatekWithUnlock("XXX",followSteps[0],followSteps[1],"M",stepTraceStr);
			  ///新增并列发送渠道
			  log.debug("{}","先后渠道，需新建mps记录。。"+followSteps[0]+followSteps[1]);
			  if(!"XXX".equals(followSteps[0]))
			  {

			    Date processDate = new Date();
			    // 新建并行渠道处理记录 （smpmod为原模型不要在模块外执行变更操作）
			    this.getMps().copyValues(this.getSmpmod().getMps()); // 相关关联报文等值通过复制获取
			    this.getMps().setInr( Platform.sdbCounter("mps"));
			    this.getMps().setPntinr( this.getSmpmod().getMps().getInr()); // 关联之前的MPS记录
			    this.getMps().setNxtchncod( followSteps[1]);
			    this.getMps().setTgtchncod( followSteps[1]);
			    this.getMps().setDir( ">"); // 收报并行渠道
			    this.getMps().setSta( "W"); // 放行至并行渠道
			    this.getMps().setNxtsta( "W"); //待发送
			    this.getMps().setRcvdattim( processDate); // 报文接收时间
			    this.getMps().setLstdattim( processDate); // 最近处理执行时间
			    Platform.mdbInsert(this.getMps());
			    // 新建并行渠道处理详细信息
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( "XXX");
			    this.getMpe().setNxtchncod( followSteps[1]);
			    this.getMpe().setSmhinr( this.getMps().getSmhinr());
			    this.getMpe().setDattim( processDate);
			    this.getMpe().setSta( "W");
			    this.getMpe().setUsr( MdaEnv.getLoginUser());
			    this.getMpe().setFrmnam( ctx.getTransName());
			    this.getMpe().setTxt( "并行处理报文");
			    Platform.sdbInsert(this.getMpe());

			    if(!"XXX".equals(followSteps[0]))
			      this.getSmpmod().updatekWithUnlock("XXX",followSteps[0],followSteps[0],null,stepTraceStr);
			    /// 如果另一步为XXX则继续进行后面的清分规则
			  }
			}
			else if(followSteps.length==3)
			{
			  ///新增并列发送渠道
			  log.debug("{}","先后渠道，需新建mps记录。。"+followSteps[0]+followSteps[1]+followSteps[2]);
			  if(!"XXX".equals(followSteps[0]) && !"XXX".equals(followSteps[1]))
			  {
			    Date processDate = new Date();
			    // 新建并行渠道处理记录 （smpmod为原模型不要在模块外执行变更操作）
			    this.getMps().copyValues(this.getSmpmod().getMps()); // 相关关联报文等值通过复制获取
			    this.getMps().setInr( Platform.sdbCounter("mps"));
			    this.getMps().setPntinr( this.getSmpmod().getMps().getInr()); // 关联之前的MPS记录
			    this.getMps().setNxtchncod( followSteps[1]);
			    this.getMps().setTgtchncod( followSteps[1]);
			    this.getMps().setDir( ">"); // 收报并行渠道
			    this.getMps().setSta( "W"); // 放行至并行渠道
			    this.getMps().setNxtsta( "W"); //待发送
			    this.getMps().setRcvdattim( processDate); // 报文接收时间
			    this.getMps().setLstdattim( processDate); // 最近处理执行时间
			    Platform.mdbInsert(this.getMps());
			    // 新建并行渠道处理详细信息
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( "XXX");
			    this.getMpe().setNxtchncod( followSteps[1]);
			    this.getMpe().setSmhinr( this.getMps().getSmhinr());
			    this.getMpe().setDattim( processDate);
			    this.getMpe().setSta( "W");
			    this.getMpe().setUsr( MdaEnv.getLoginUser());
			    this.getMpe().setFrmnam( ctx.getTransName());
			    this.getMpe().setTxt( "并行-1处理报文");
			    Platform.sdbInsert(this.getMpe());

			    MdaUtils.clear(this.getSubmps());
			    MdaUtils.clear(this.getSubmpe());
			    //Date processDate = new Date();
			    // 新建并行渠道处理记录 （smpmod为原模型不要在模块外执行变更操作）
			    this.getSubmps().copyValues(this.getSmpmod().getMps()); // 相关关联报文等值通过复制获取
			    this.getSubmps().setInr( Platform.sdbCounter("mps"));
			    this.getSubmps().setPntinr( this.getSmpmod().getMps().getInr()); // 关联之前的submps记录
			    this.getSubmps().setNxtchncod( followSteps[2]);
			    this.getSubmps().setTgtchncod( followSteps[2]);
			    this.getSubmps().setDir( ">"); // 收报并行渠道
			    this.getSubmps().setSta( "W"); // 放行至并行渠道
			    this.getSubmps().setNxtsta( "W"); //待发送
			    this.getSubmps().setRcvdattim( processDate); // 报文接收时间
			    this.getSubmps().setLstdattim( processDate); // 最近处理执行时间
			    Platform.mdbInsert(this.getSubmps());
			    // 新建并行渠道处理详细信息
			    this.getSubmpe().setMpsinr( this.getSubmps().getInr());
			    this.getSubmpe().setChncod( "XXX");
			    this.getSubmpe().setNxtchncod( followSteps[2]);
			    this.getSubmpe().setSmhinr( this.getSubmps().getSmhinr());
			    this.getSubmpe().setDattim( processDate);
			    this.getSubmpe().setSta( "W");
			    this.getSubmpe().setUsr( MdaEnv.getLoginUser());
			    this.getSubmpe().setFrmnam( ctx.getTransName());
			    this.getSubmpe().setTxt( "并行-2处理报文");
			    Platform.sdbInsert(this.getSubmpe());

			    if(!"XXX".equals(followSteps[0]))
			      this.getSmpmod().updatekWithUnlock("XXX",followSteps[0],followSteps[0],null,stepTraceStr);
			    /// 如果另一步为XXX则继续进行后面的清分规则
			  }
			  /*if(!"XXX".equals(followSteps[1]))
			    {
			    if(!"XXX".equals(followSteps[1]))
			    $smpmod.updatekWithUnlock("XXX",followSteps[1],followSteps[1],null,stepTraceStr);
			    /// 如果另一步为XXX则继续进行后面的清分规则
			    }*/
			}

		}
        /**
        *   source:dtrmod.@0010.script
        */
        public Object doExpression(String expression, Object defaultValue)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 如果表达式为空，直接返回默认值
			if(MdaUtils.isEmpty(expression))
			  return defaultValue;
			log.debug("{}","expression:"+expression);
			/// 按判断表达式进行分割（仅支持==，注：判断选择表达式应该已事选分割处理）
			String[] expressions = expression.split("==");
			/// 无论是否为为判断表达式，均有第一部分
			expression = expressions[0];
			/// 判断是否为函数表达式
			if(expression.matches("\\w*\\(.*\\)"))
			{
			  /// 函数表达式再行调用函数表达式分析处理
			  Object value = doMethodExpression(expression, defaultValue);
			  /// 之前判断表达式分割成功，而且前续函数表达式返回值为字符串时（返回是否相等的判断）
			  if(expressions.length>1 && value instanceof String)
			    return expressions[1].equals(value);
			  /// 返回函数表达式值
			  return value;
			}
			/// 非函数表达式直接返回值
			return expression;
		}
        /**
        *   source:dtrmod.@0012.script
        */
        public Object doMethodExpression(String expression, Object defaultValue)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 函数表达式处理，但复杂函数暂时不处理直接返回默认值
			if(!expression.matches("\\w*\\([^\\(\\)]*\\)"))
			  return defaultValue;
			/// 按函数各部分进行分拆
			String[] values = expression.split("\\(|,|\\)");
			try
			{
			  /// 第一部分为函数名（系统默认为do_xxx函数）
			  String methodName = "do_"+values[0];
			  log.debug("{}","methodName:" + methodName);
			  /// 从第二部分开始为函数的参数值
			  List arguments = new ArrayList();
			  for(int i=1;i<values.length;i++)
			  { /// 为空参数不列入参数
			    if(!MdaUtils.isEmpty(values[i]))
			    {
			      if("nam".equals(values[i]))//L1105改动
			      {
			        /*String nam = (String)Platform.restoreData("nam");
			          log.debug("nam value "+nam);*/
			        String nam = getMsgNam();//取报文中户名，L1105改动
			        arguments.add(nam);
			      }
			      else
			        arguments.add(this.getSmpmod().getTagValue(values[i]));
			    }//L1105改动
			  }
			  log.debug("{}","arugments.size:"+arguments.size());

			  /// 按参数数量调用指定函数（argument...无法调用，最多支持4个参数的函数）
			  switch(arguments.size())
			  {
			    case 0:
			    return MdaUtils.invoke(this,methodName);
			    case 1:
			    return MdaUtils.invoke(this,methodName,arguments.get(0));
			    case 2:
			    return MdaUtils.invoke(this,methodName,arguments.get(0),arguments.get(1));
			    case 3:
			    return MdaUtils.invoke(this,methodName,arguments.get(0),arguments.get(1),arguments.get(2));
			    case 4:
			    return MdaUtils.invoke(this,methodName,arguments.get(0),arguments.get(1),arguments.get(2),arguments.get(3));
			  }
			}
			catch(Exception e)
			{
			  log.debug("{}","调用函数失败返回默认值...", e);
			}
			return defaultValue;
		}
        /**
        *   source:dtrmod.@0001.script
        */
        public boolean checkTagMatches(String expression)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/// 如果表达式为空直接返回匹配
			if(MdaUtils.isEmpty(expression))
			  return true;
			/// 找到所有的#tag=expression字符串
			Pattern pattern = Pattern.compile("\\w+\\=[^\\,]*");
			Matcher matcher = pattern.matcher(expression);
			while(matcher.find())
			{
			  String str = expression.substring(matcher.start(), matcher.end());
			  String[] values = str.split("=");
			  log.debug("{}","match(tag/pattern):"+values[0]+"\t"+values[1]);
			  if(!checkMatches(this.getSmpmod().getTagValue(values[0]),values[1]))
			    return false;
			}
			return true;
		}
        /**
        *   source:dtrmod.@0003.script
        */
        public boolean checkMatches(String value, String pattern)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 检查指定字符串是否匹配正规表达式
			  - value:String 待检查字符串
			  - pattern:String 正则表达式
			  @ boolean 返回是否匹配
			  */
			// 如果正规表达为空返回匹配
			if(MdaUtils.isEmpty(pattern))
			  return true;
			//SWN为SWT和NZF通用清分规则
			pattern = pattern.replaceAll("SWN","(SWT|NZF)");
			// 执行正式匹配发生异常返回不匹配
			try
			{
			  log.info("{}","value/pattern:"+value+"\t"+pattern+"\t"+value.matches(pattern));
			  return value.matches(pattern);
			}
			catch(Exception e)
			{
			}
			return false;
		}
        /**
        *   source:dtrmod.@0004.script
        */
        public boolean do_ref(String reference,String messageType,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 发报交易，比较发报流水号是否有重复
			log.debug("{}","do_ref");
			ctx.getErrorCode(); // 清空errorCode;
			// 收报时20域为对象参考号，发报为20域为我方参考号
			/*if(">".equals(dir))
			  Platform.mdbRead($mpi,new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("inr",NE,$smpmod\\mpi\\inr));
			  else if("<".equals(dir))
			  Platform.mdbRead($mpi,new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("inr",NE,$smpmod\\mpi\\inr));
			  */
			if("300".equals(messageType) && ">".equals(dir))
			{//报文类型为300来报进行如下比较 20191125新一代来报300报文发报行加入判重规则
			  Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("valdat",this.getSmpmod().getMpi().getValdat()).and("sndbic",this.getSmpmod().getMpi().getSndbic()).and("inr",NE,this.getSmpmod().getMpi().getInr()));
			}
			else
			{//往报300与其他类型报文，判重规则不变
			  if(">".equals(dir))
			    Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("inr",NE,this.getSmpmod().getMpi().getInr()));
			  else if("<".equals(dir))
			    Platform.mdbRead(this.getMpi(),new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("inr",NE,this.getSmpmod().getMpi().getInr()));
			}
			return ctx.getErrorCode()==NO_ERROR; // 如果为零则找到相同记录，则作为疑似重复记录
					}
        /**
        *   source:dtrmod.@0005.script
        */
        public boolean do_n20sha(String value1,String value2)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 发报交易，比较20域以外SHA值是否有重复
			log.debug("{}","do_n20sha");
			Platform.mdbRead(this.getMpi(),new Argument("n20sha",value1).and("dir","<").and("subtyp",value2).and("inr",NE,this.getSmpmod().getMpi().getInr()));
			int errorCode = ctx.getErrorCode();
			log.debug("{}","errorcode:"+errorCode);
			return errorCode==NO_ERROR;
		}
        /**
        *   source:dtrmod.@0006.script
        */
        public String do_tgtchn()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","<---- do_tgtchn");
			return this.getSmpmod().getMps().getTgtchncod();
		}
        /**
        *   source:dtrmod.@0007.script
        */
        public boolean do_actbnk(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 查询是否为帐户行
			log.debug("{}","<---- do_actbnk");
			return false;
		}
        /**
        *   source:dtrmod.@0008.script
        */
        public String do_pntchn(String value)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 查询收报相关编号关联原发报我行编号，并返回原发报渠道
			//||"NOREF".equalsIgnoreCase(value)||"NONREF".equalsIgnoreCase(value)||"NONE".equalsIgnoreCase(value))
			if(MdaUtils.isEmpty(value))
			  return "";
			/*从配置文件读取相关设置信息*/
			String propertyPath = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			propertyPath = MdaUtils.catPath(propertyPath,"xxxtskpntchn21.properties");
			String reg = this.getSmpmod().getPropertyValues(propertyPath,"reg");
			log.debug("{}","xxxtsk do_pntchn reg:"+reg);
			log.debug("{}","xxxtsk d0_pntchn value:"+value);
			if(value.matches(reg))
			{
			  log.debug("{}","xxxtsk do_pntchn matches reg...");
			  return "";
			}
			int errorcode = ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),new Argument("ownref",value).and("dir","<"),new Argument("gendat",DESC));
			errorcode = ctx.getErrorCode();
			log.debug("{}","read mpi record with errorcode:" + errorcode);
			if(!MdaUtils.isEmpty(this.getMpi().getInr()))
			{
			  log.debug("{}","xxxtsk do_pntchn diff date:"+MdaUtils.add(MdaUtils.today(),java.util.Calendar.MONTH,-6));
			  if(MdaUtils.diff(this.getMpi().getGendat(),MdaUtils.add(MdaUtils.today(),java.util.Calendar.MONTH,-6))<0)
			  {
			    log.debug("{}","xxxtsk do_pntchn before half yeah return null...");
			    return "";
			  }
			}
			if(errorcode == NO_ERROR)
			{
			  Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    if(!"HWE".equals(this.getMps().getSrcchncod())&&!"FWE".equals(this.getMps().getSrcchncod()))
			    {
			      if("CWE".equals(this.getMps().getSrcchncod())&&"CPS".equals(this.getMps().getTgtchncod()))
			      {
			        return "GHD";
			      }
			      else
			        return this.getMps().getSrcchncod();
			    }
			    else if("HWE".equals(this.getMps().getSrcchncod()))
			    {
			      return "QAA";
			    }
			    else if("FWE".equals(this.getMps().getSrcchncod()))
			    {
			      return "FAA";
			    }
			  }
			}
			else if(errorcode == 228)
			{
			  Argument arg = new Argument("othref",value);
			  arg = arg.and(new Argument("dir",">"));
			  Argument arg1 = new Argument("ownref",NE,value);
			  arg1 = arg1.or(new Argument("ownref",ISNULL));
			  arg = arg.and(arg1);
			  Platform.mdbRead(this.getMpi(),arg);
			  errorcode = ctx.getErrorCode();
			  log.debug("{}",">pntchn(21) errorcode:"+errorcode);
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      String tgtchncod = this.getMps().getTgtchncod();
			      log.debug("{}",">pntchn(21) tgtchncod:"+tgtchncod);
			      MdaUtils.clear(this.getMps());
			      MdaUtils.clear(this.getMpi());
			      if(! MdaUtils.isEmpty(tgtchncod))
			        return tgtchncod;
			      else
			        return "";
			    }
			  }
			}
			return "";
		}
        /**
        *   source:dtrmod.@0009.script
        */
        public String do_acknak(String type,String sendNumber,String responeCode)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			// 查询发报相关流水号匹配ack/nak信息(对应发报流水、境外渠道代码为SWT和状态为D)
			Argument argument = new Argument("sndnum",sendNumber).and("dir","<");
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    Date processDate = new Date();
			    this.getMps().setSta( "F");
			    this.getMps().setLstdattim( processDate);
			    this.getMps().setRspdattim( processDate);
			    MdaUtils.clear(this.getMpe());
			    String isNACK = "";//通知的状态：ACK为1，NCK为2；
			    if("ACK".equals(type))
			    {
			      this.getMps().setRspsta( "A");
			      this.getMpe().setTxt( "ACK报文自动处理");
			      isNACK = "1";
			    }
			    else
			    {
			      this.getMps().setRspsta( "N");
			      this.getMpe().setTxt( "NCK:" + responeCode);
			      MdaUtils.clear(this.getSubmps());
			      this.getSubmps().setPntinr( this.getMps().getInr());
			      this.getSubmps().setDir( this.getMps().getDir());
			      this.getSubmps().setSrcchncod( "XXX");
			      this.getSubmps().setNxtchncod( "MAN");
			      this.getSubmps().setSta( "M");
			      this.getSubmps().setRspsta( "");
			      this.getSubmps().setRcvdattim( processDate);
			      this.getSubmps().setLstdattim( processDate);
			      this.getSubmps().setSttdattim( processDate);
			      this.getSubmps().setChncod( "SWT");
			      Platform.sdbInsert(this.getSubmps());
			      /*新增一条mpe*/
			      this.getSubmpe().setMpsinr( this.getMps().getInr());
			      this.getSubmpe().setChncod( "SWT");
			      this.getSubmpe().setNxtchncod( "MAN");
			      this.getSubmpe().setSmhinr( this.getSubmps().getInr());
			      this.getSubmpe().setDattim( processDate);
			      this.getSubmpe().setPrvsta( "F");
			      this.getSubmpe().setSta( "M");
			      Platform.sdbInsert(this.getSubmpe());
			      isNACK = "2";
			    }
			    Platform.mdbUpdate(this.getMps());
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( "SWT");
			    this.getMpe().setNxtchncod( "");
			    this.getMpe().setSmhinr( this.getMps().getInr());
			    this.getMpe().setDattim( processDate);
			    this.getMpe().setPrvsta( "D");
			    this.getMpe().setSta( "F");
			    Platform.sdbInsert(this.getMpe());
			    /// 如果是资金清算发出的报文，则发送异步相应(该报文记录本身返回OOO无需清分)
			    /// 国际汇兑系统不能接收NCK/ACK信息(该报文记录返回OOO无需清分)
			    String sourceChannel = this.getMps().getSrcchncod();
			    log.debug("{}","收报源渠道："+sourceChannel);

			    //发送ACK、NCK报文信息至监控
			    try
			    {
			      if(!"GHD".equals(sourceChannel))
			      {
			        ctx.absGet(Sysmod.class).sendAckToMonitorServerMQ(this.getMps(),this.getMpi(),type);
			      }
			    }
			    catch(Exception e)
			    {
			      log.error("{}",e);
			    }

			    if("ZQS".equals(sourceChannel) || "ZYS".equals(sourceChannel))
			    {
			      log.debug("{}","给资金清算发送异步相应...");
			      String typ = "202";
			      if(!MdaUtils.isEmpty(this.getMpi().getSubtyp()))
			      {
			        typ = this.getMpi().getSubtyp();
			      }
			      log.debug("{}","ACK对应原发报类型:"+typ);
			      noticeToZQS(isNACK,typ);
			      //noticeToZQS(isNACK);
			    }
			    else if("ZYW".equals(sourceChannel))
			    {
			      log.debug("{}","给资金业务发送异步相应...");
			      String typ = "";
			      if(!MdaUtils.isEmpty(this.getMpi().getSubtyp()))
			      {
			        typ = this.getMpi().getSubtyp();
			      }
			      log.debug("{}","ACK对应原发报类型:"+typ);
			      noticeToZYW(isNACK,typ);
			    }
			    else if("QAA".equals(sourceChannel))
			      return "OOO";
			    else if(!"GHD".equals(sourceChannel))
			      return this.getMps().getSrcchncod();
			  }
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0013.script
        */
        public boolean noticeToZQS(String sta,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *当收到ACK或则NCK的时候，给资金清算发送异步响应
			  */
			ctx.getErrorCode();//清除ERROR CODE
			Map<String,String> ds = new HashMap<String,String>();
			String mpiinr = this.getMpi().getInr();
			String sql = "SELECT docfil,docfxt FROM smh WHERE mpiinr = ? AND (docfxt = 'jsn' or docfxt = 'nxl' ) ";
			Argument<String> docfil = new Argument<String>("docfil");
			Argument<String> docfxt = new Argument<String>("docfxt");
			Platform.mdbExecuteSQL(sql,mpiinr);
			Platform.mdbFetchFields(docfil,docfxt);
			log.info("{}","docfxt:"+docfxt.value);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  Platform.mdbCloseCursor();
			  String jsnpth = this.getSmpmod().getStoreFileFullPathName(docfil.value,docfxt.value);//原报路径
			  ds.put("jsnpth",jsnpth);//返回原报给外部代码填充要发送的响应报文
			  String ref20 = this.getMpi().getOwnref();//返回20域编号
			  // ds.put("ref20",ref20);
			  /*String datStr = String.valueOf(Platform.today().getTime());
			    ds.put("seqno",datStr.substring(datStr.length() - 17));*/
			  // ds.put("sta",sta);//告知资金清算状态
			  // ds.put("subtyp",typ);//20160727,新加位元原报文类型
			  String date = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  String msgtyp = docfxt.value;
			  Platform.esdbRead("eibs",this.getDat(),new Argument("inr","00000000"));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    String accdat = this.getDat().getAccdat();
			    ds.put("ACCDAT",accdat);
			    log.info("{}","异步返回的状态:"+sta);
			    //20190123将参数字段在此添加
			    ds.put("SEQNO",accdat + "993060" + MdaUtils.format(MdaUtils.today(),"HHmmss"));//流水号
			    String sysseq = this.getMpi().getSystrackn();
			    if(!MdaUtils.isEmpty(sysseq))
			      ds.put("SYS_TRACE_NO",sysseq.toString());//系统间流水号
			    else
			    {
			      sysseq  = "993060000000" + accdat + MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss") +"0";
			      ds.put("SYS_TRACE_NO",sysseq.toString());//系统间流水号
			    }
			    ds.put("LOCALTIME",MdaUtils.format(MdaUtils.today(),"HHmmss"));
			    ds.put("LOCALDATE",date);
			    ds.put("TRANBRANCH","99999999");
			    ds.put("TELLER_CODE","");//柜员号
			    ds.put("RESPINFO","");//返回信息
			    ds.put("TRADEFLAG","A");
			    ds.put("CHANNEL_TYPE","29");
			    ds.put("CLEARDATE",accdat);//清算日期
			    ds.put("SENDINST","99306000000");//发送系统代码
			    ds.put("RESPCODE","");//返回码
			    ds.put("PCODE","020780");
			    ds.put("ORGMSGTYPE",typ);
			    ds.put("BIC_TX_NO",ref20);
			    ds.put("PROC_STAT",sta);

			    /// 1-SWIFT,2-CIPS,3-G渠道
			    if("sf2".equalsIgnoreCase(this.getMpi().getMsgtyp()))
			    {
			      if("SWE".equals(this.getMps().getTgtchncod()))
			      {
			        ds.put("TRAN_WAY","3");
			      }
			      else
			      {
			        ds.put("TRAN_WAY","1");
			      }
			    }
			    else
			    {
			      ds.put("TRAN_WAY","2");
			    }

			    if("nxl".equals(msgtyp))
			    {
			      if(!MdaUtils.isEmpty(this.getMpi().getCur()))
			        ds.put("CURRENCY",this.getMpi().getCur());
			      if(!MdaUtils.isEmpty(this.getMpi().getAmt()))
			        ds.put("ORGAMOUNT",this.getMpi().getAmt().toPlainString());
			      if(!MdaUtils.isEmpty(this.getMpi().getOwnref()))
			        ds.put("ORGSEQNO",this.getMpi().getOwnref());
			      MdaUtils.invoke("cn.com.brilliance.psbc.service.zjqs.handle.QSSendServiceHandler","dealPCODE020780_NXL",ds);//发送新一代资金业务报文异步通知
			    }
			    else
			    {
			      ds.put("TRADEFLAG","0");
			      MdaUtils.invoke("cn.com.brilliance.psbc.service.zjqs.handle.QSSendServiceHandler","dealPCODE020780",ds);//发送异步相应
			    }

			    log.debug("{}","Auto To Zqs Successed.....");
			    return true;
			  }
			  else
			  {
			    return false;
			  }
			}
			else
			{
			  Platform.mdbCloseCursor();
			  return false;
			}
		}
        /**
        *   source:dtrmod.@0015.script
        */
        public boolean do_actblacklist(String account)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检测账号是否存在在账号黑名单中
			log.debug("{}","do_actblacklist");
			Platform.esdbReadset("eibs",this.getDtalst(),0);
			int errorcode = ctx.getErrorCode();
			log.debug("{}","do_actblacklist dtalst size:" + this.getDtalst().size());
			if(!account.startsWith("FT"))
			{
			  account = accountFilter(account);
			}
			log.debug("{}","待过滤黑名单账户："+account);
			for(com.ceb.gjjs.mda.bo.Dta dta : this.getDtalst())
			{
			  if(!MdaUtils.isEmpty(dta.getAct()))
			  {
			    String accountFilter = dta.getAct();
			    if(accountFilter.startsWith("*") && accountFilter.endsWith("*"))
			    {
			      accountFilter = accountFilter.substring(1,accountFilter.length() - 1);
			      if(account.contains(accountFilter))
			      {
			        log.debug("{}","1账号在账户黑名单中.");
			        log.trace("{}","账号[" + account + "]在账户黑名单中.");
			        return true;
			      }
			    }
			    else if(accountFilter.startsWith("*"))
			    {
			      accountFilter = accountFilter.substring(1);
			      if(account.endsWith(accountFilter))
			      {
			        log.debug("{}","2账号在账户黑名单中.");
			        log.trace("{}","账号[" + account + "]在账户黑名单中.");
			        return true;
			      }
			    }
			    else if(accountFilter.endsWith("*"))
			    {
			      accountFilter = accountFilter.substring(0,accountFilter.length() - 1);
			      if(account.startsWith(accountFilter))
			      {
			        log.debug("{}","3账号在账户黑名单中.");
			        log.trace("{}","账号[" + account + "]在账户黑名单中.");
			        return true;
			      }
			    }
			    else
			    {
			      if(!MdaUtils.isEmpty(accountFilter)&&account.equals(accountFilter))
			      {
			        log.debug("{}","4账号在账户黑名单中.");
			        log.trace("{}","账号[" + account + "]在账户黑名单中.");
			        return true;
			      }
			    }
			  }
			}
			log.debug("{}","账号不在账户黑名单中.");
			log.trace("{}","账号[" + account + "]不在账户黑名单中.");
			return false;
		}
        /**
        *   source:dtrmod.@0016.script
        */
        public String accountFilter(String account)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//将账号转换成纯数字的格式,去掉符号
			String number = "0123456789";
			char [] chars = account.toCharArray();
			String newAccount = "";
			for(char chr : chars)
			{
			  String str = String.valueOf(chr);
			  if(number.indexOf(str) >= 0)
			    newAccount += str;
			}
			log.debug("{}","将账号转换成纯数字的格式,去掉符号");
			log.debug("{}","accountFilter change [" + account + "] to [" + newAccount + "].");
			return newAccount;
		}
        /**
        *   source:dtrmod.@0017.script
        */
        public String do_find900910Parent(String reference,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//收到的900/910报文根据原103报文的清分路径进行清分
			log.debug("{}","do_find900910Parent103");
			log.debug("{}","reference:" + reference);
			log.debug("{}","messageType:" + messageType);

			//默认为自动清分
			String targetChannel = "XXX";

			//初始化渠道信息,将业务渠道加载到内存中
			MdaUtils.clear(this.getChnlst());
			Platform.esdbReadset("eibs",this.getChnlst(),0,new Argument("typ","B"));

			//清空errorcode
			ctx.getErrorCode();

			// > 表示收报,< 表示发报
			if("900".equals(messageType))
			{
			  //处理900报文,查发报103
			  Platform.mdbRead(this.getMpi(),new Argument("ownref",reference).and("dir","<").and("subtyp","103"));
			  if(ctx.getErrorCode() != NO_ERROR)
			  {
			    //如果查找103出现错误,则查找202
			    Platform.mdbRead(this.getMpi(),new Argument("ownref",reference).and("dir","<").and("subtyp","202"));
			    ctx.getErrorCode();
			  }
			}
			else
			{
			  //处理910报文,查收报103
			  Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",">").and("subtyp","103"));
			  if(ctx.getErrorCode() != NO_ERROR)
			  {
			    //如果查找103出现错误,则查找202
			    Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",">").and("subtyp","202"));
			    ctx.getErrorCode();
			  }
			}

			//如果找到了MPI的INR
			if(! MdaUtils.isEmpty(this.getMpi().getInr()))
			{
			  log.debug("{}","mpiInr:" + this.getMpi().getInr());

			  //根据MPI的INR查找SMH记录
			  MdaUtils.clear(this.getSmhlst());
			  Platform.mdbReadset(this.getSmhlst(),new Argument("mpiinr",this.getMpi().getInr()),new Argument("inr",ASC));
			  ctx.getErrorCode();
			  if(this.getSmhlst().fullSize() > 0)
			  {
			    //List<String> smhinrList = new ArrayList<String>();
			    String [] smhinrList = new String[this.getSmhlst().size()];
			    int i = 0;
			    for(com.ceb.gjjs.mda.bo.Smh smh : this.getSmhlst())
			    {
			      smhinrList[i] = (smh.getInr());
			      log.debug("{}","smhInr:" + smh.getInr());
			      i++;
			    }

			    //根据SMH的INR查找MPS记录
			    MdaUtils.clear(this.getMpslst());
			    Platform.mdbReadset(this.getMpslst(),new Argument("smhinr",IN,smhinrList));
			    if(this.getMpslst().fullSize() > 0)
			    {
			      //如果找到了多笔,或者单笔,都要校验一下渠道是否是业务渠道
			      for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			      {
			        log.debug("{}","mpsInr:" + mps.getInr() + " mpsSrcChnCod:" + mps.getSrcchncod() + " mpsTgtChnCod:" + mps.getTgtchncod());
			        if(MdaUtils.isEmpty(mps.getDir()))
			          continue;
			        if("<".equals(mps.getDir()) && MdaUtils.isEmpty(mps.getSrcchncod()))
			          continue;
			        if(">".equals(mps.getDir()) && MdaUtils.isEmpty(mps.getTgtchncod()))
			          continue;
			        for(com.ceb.gjjs.mda.bo.Chn chn : this.getChnlst())
			        {
			          if("900".equals(messageType))
			          {
			            //发报,用srcchncod去找原渠道
			            if(mps.getSrcchncod().equals(chn.getCod()))
			            {
			              targetChannel = mps.getSrcchncod();
			              break;
			            }
			          }
			          else
			          {
			            //收报,用srcchncod去找原渠道
			            if(mps.getTgtchncod().equals(chn.getCod()))
			            {
			              targetChannel = mps.getTgtchncod();
			              break;
			            }
			          }
			        }
			        if(! "XXX".equals(targetChannel))
			        {
			          //查询是否有对应CASE，若有则同时抄送查询查复，否则不抄送
			          Platform.mdbRead(this.getQrd(),new Argument("relref",this.getSmhlst().getElement(0).getInr()));
			          if(!MdaUtils.isEmpty(this.getQrd().getCasnum()))
			          {
			            log.debug("{}","do_find900910Parent case number:"+this.getQrd().getCasnum());
			            targetChannel = "QAA|" + targetChannel;
			          }
			          else
			            break;
			        }
			      }
			    }
			    else
			      log.debug("{}","mpsList is null");
			  }
			  else
			    log.debug("{}","smhList is null");
			}
			else
			{
			  log.debug("{}","could not find parnet 103/202.");
			  if("910".equals(messageType))
			  {
			    if(delayedFor910())
			    { //报文为910报文，并且成功添加noz记录
			      targetChannel = "YSQ";

			      log.debug("{}","该910将进入延时清分状态");
			    }
			  }

			}

			MdaUtils.clear(this.getMpslst());
			log.debug("{}","targetChannel:" + targetChannel);
			return targetChannel;
		}
        /**
        *   source:dtrmod.@0018.script
        */
        public String getMsgNam()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.info("{}",this.getSmpmod().getSmh().getDocfil());
			log.info("{}",this.getSmpmod().getSmh().getDocfxt());
			// 未读取到MPI信息则重新生成(不同报文动态调用指定类型的方法)
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			if(!Platform.mfileExists(fileName))
			{ // 文件不存在可能为对方服务器还未能够同步至本机，这里往后延长处理时间5秒(MPS记录更新在返回的函数中处理)
			  log.warn("{}","报文文件不存在，可能还在集群服务器同步过程过，延迟5秒后再处理. fileName=" + fileName);
			  this.getMps().setSttdattim( MdaUtils.add(this.getMps().getSttdattim(),DATE_SECOND,5));
			  return null;
			}
			IStream is = this.getIs();
			MdaUtils.clear(is);
			Platform.mstreamLoad(is,fileName);
			String msg = this.transfromStreamToString(is);
			String nam = this.anlyMsgNam(msg);
			return nam;
		}
        /**
        *   source:dtrmod.@0019.script
        */
        public String transfromStreamToString(IStream is)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			StringBuffer sb = new StringBuffer();
			try
			{
			  java.io.InputStream ins = is.getInputStream();
			  byte[] buf = new byte[1024];
			  int len = -1;
			  while ((len = ins.read(buf)) != -1)
			  {
			    String str = new String(buf,0,len);
			    sb.append(str);
			  }
			}
			catch(Exception e)
			{
			  log.debug("{}","Stream提取文本异常：" + e);
			}
			return sb.toString();
		}
        /**
        *   source:dtrmod.@0020.script
        */
        public String anlyMsgNam(String msg)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","通过解析报文内容，存储户名");
			//log.trace("报文内容："+msg);
			String nam = null;
			//根据报文文件内容得到报文每个场域的值
			Map<Integer,String> map = (Map<Integer,String>)MdaUtils.invoke("com.brilliance.swift.MessageReader","anlyMsgHead",msg);
			//报文正文4场的内容
			String hd4 = map.get(4);
			//分析4场内容，存入一个LIST中进行进一步解析
			List<String[] > kv = (List<String[] >)MdaUtils.invoke("com.brilliance.swift.MessageReader","msgTxtAnly",hd4);
			for(int i = 0;i < kv.size();i++)
			{
			  String [] strArr = kv.get(i);
			  //59 收汇人信息或59F
			  if((strArr[0].matches("59")||strArr[0].matches("59F")||strArr[0].matches("59A")) && strArr[1] != null)
			  {
			    int index = this.getLinePos(strArr[1]);
			    if(index > -1)
			    {
			      String pyenamadr = strArr[1].substring(index+2);
			      log.debug("{}","anlyMsg pyenamadr:"+pyenamadr);
			      String [] arr = pyenamadr.split("\\r\\n?");
			      nam = arr[0];
			      //Platform.storeData("nam",nam);
			      return nam;
			    }
			  }
			}
			return null;
		}
        /**
        *   source:dtrmod.@0021.script
        */
        public int getLinePos(String str)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//屏蔽不同系统的换行符差异，获取换行符位置
			if (str == null)
			  return -1;
			int idxr = str.indexOf("\r");
			int idxn = str.indexOf("\n");
			if (idxr > -1 && idxn > -1)// \\r\\n连接在一起
			{
			  return idxr < idxn ? idxr : idxn;
			  }
			  else
			  {
			    return idxr <= idxn ? idxn : idxr;// 单个\\r或者\\n的情况，返回较大的
			  }
					}
        /**
        *   source:dtrmod.@0022.script
        */
        public boolean do_namblacklist(String nam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//检测账号是否存在在账号黑名单中
			log.debug("{}","do_namblacklist");
			// Argument arg = new Argument<String>("nam",NE,"");
			Platform.esdbReadset("eibs",this.getDtalst(),0);
			int errorcode = ctx.getErrorCode();
			log.debug("{}","do_namblacklist dtalst size:" + this.getDtalst().size());
			nam = namFilter(nam);
			log.debug("{}","待过滤黑名单户名："+nam);
			for(com.ceb.gjjs.mda.bo.Dta dta : this.getDtalst())
			{
			  if(!MdaUtils.isEmpty(dta.getNam()))
			  {
			    String namFilter = dta.getNam();
			    if(namFilter.contains("*"))
			    {
			      if(namFilter.startsWith("*") && namFilter.endsWith("*"))
			      {
			        namFilter = namFilter.substring(1,namFilter.length() - 1);
			        if(nam.contains(namFilter))
			        {
			          log.debug("{}","1户名在户名黑名单中.");
			          log.trace("{}","户名[" + nam + "]在户名黑名单中.");
			          return true;
			        }
			      }
			      else if(namFilter.startsWith("*"))
			      {
			        namFilter = namFilter.substring(1);
			        if(nam.endsWith(namFilter))
			        {
			          log.debug("{}","2户名在户名黑名单中.");
			          log.trace("{}","户名[" + nam + "]在户名黑名单中.");
			          return true;
			        }
			      }
			      else if(namFilter.endsWith("*"))
			      {
			        namFilter = namFilter.substring(0,namFilter.length() - 1);
			        if(nam.startsWith(namFilter))
			        {
			          log.debug("{}","3户名在户名黑名单中.");
			          log.trace("{}","户名[" + nam + "]在户名黑名单中.");
			          return true;
			        }
			      }
			      else
			      {
			        String[] str = namFilter.split("\\*");
			        if(nam.endsWith(str[1])&&nam.startsWith(str[0]))
			        {
			          log.debug("{}","4户名在户名黑名单中.");
			          log.trace("{}","户名[" + nam + "]在户名黑名单中.");
			          return true;
			        }
			      }
			    }
			    else
			    {
			      if(nam.equals(namFilter))
			      {
			        log.debug("{}","5户名在户名黑名单中.");
			        log.trace("{}","户名[" + nam + "]在户名黑名单中.");
			        return true;
			      }
			    }
			  }
			}
			log.debug("{}","户名不在户名黑名单中.");
			log.trace("{}","户名[" + nam + "]不在户名黑名单中.");
			return false;
		}
        /**
        *   source:dtrmod.@0023.script
        */
        public String namFilter(String nam)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//将户名转换成只含数字和字符的格式,去掉空格或其他符号,要求全部大写
			String value = nam.replaceAll("[^a-zA-Z0-9]", "").toUpperCase();
			log.debug("{}","将户名转换成只含数字和字符的格式");
			log.debug("{}","namFilter change [" + nam + "] to [" + value + "].");
			return value;
		}
        /**
        *   source:dtrmod.@0024.script
        */
        public String do_fmtNotice(String type )
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *type---报文类型；fmtNumber-----原业务报文20域编号
			  *
			  */
			// 查询收报010和020通知报文的原fmt参考号来关联更显原业务报文状态
			Map<String,String> map1 = (Map<String,String>)ctx.restoreData("map1");
			Map<String,String> map2 = (Map<String,String>)ctx.restoreData("map2");
			String fmtNumber=null;
			String subtyp= null;
			String responeCode=null;
			String notsta=null;
			String addinf=null;
			String cur = null;
			if("010|025".indexOf(type)>=0 )
			{
			  log.debug("{}","010 or 025.....");
			  fmtNumber = (String)map2.get("/D90/");
			  subtyp = (String)map2.get("/F31/");
			  cur = (String)map2.get("/G51/");
			  log.debug("{}","010/025 原报文类型"+subtyp);
			}
			else if("020".equals(type))
			{
			  fmtNumber=(String)map2.get("/D95/");
			  subtyp=(String)map2.get("/F31/");
			}
			else
			{
			  fmtNumber=(String)map1.get("21");//新增192-已撤消状态终态，需更新mps表
			  //subtyp=(String)map1.get("21");
			}
			log.debug("{}","010/020/025/192 原FMT号"+fmtNumber);
			if("192".equals(type))
			{
			  log.debug("{}","192测试...");
			  notsta=map1.get("76");//报文处理状态
			
			}
			else
			{
			  responeCode=map2.get("/F00/");//报文处理码
			  notsta=map2.get("/E56/");//报文处理状态30,31,32,40，70,71
			  addinf=map2.get("/F85/");//附言
			}
			//Argument argument = new Argument("ownref",fmtNumber).and("dir","<").and("subtyp",subtyp);//根据原发报报文20域，报文类型来查找原关联报文
			Argument argument = new Argument("ownref",fmtNumber).and("dir","<");//根据原发报报文20域，报文类型来查找原关联报文
			if(!MdaUtils.isEmpty(subtyp))
			{
			  argument = argument.and("subtyp",subtyp);
			}
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			int errorcode=ctx.getErrorCode();
			log.debug("{}","errorcode"+errorcode);
			if(errorcode==NO_ERROR)
			{
			  log.debug("{}","errorcode"+errorcode);
			  if("088".equals(this.getMpi().getSubtyp()))
			  {
			    MdaUtils.clear(this.getCsn());
			    Platform.mdbRead(this.getCsn(),new Argument<String>("relinr",this.getMpi().getInr()));
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      if(responeCode.endsWith("0000"))
			        this.getCsn().setSta( "02");//审核通过
			      else
			        this.getCsn().setSta( "01");//审核失败
			      Platform.mdbUpdate(this.getCsn());
			    }
			  }
			  Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.debug("{}","notsta"+notsta+"type"+type);
			    Date processDate = new Date();
			    this.getMps().setLstdattim( processDate);
			    this.getMps().setRspdattim( processDate);
			    MdaUtils.clear(this.getMpe());
			    String isNotic = "";//处理状态
			    if("30".equals(notsta))
			    {
			      this.getMps().setRspsta( "1");
			      this.getMpe().setTxt( "人行返回处理状态-已拒绝"+",报文处理码:" + responeCode + ",附言:"+addinf);
			      isNotic = "30";
			    }
			    else if("31".equals(notsta))
			    {
			      this.getMps().setRspsta( "2");
			      this.getMpe().setTxt( "人行返回处理状态-已排队");
			      isNotic = "31";
			    }
			    else if("32".equals(notsta))
			    {
			      this.getMps().setRspsta( "3");
			      this.getMpe().setTxt( "人行返回处理状态-已清算");
			      isNotic = "32";
			    }
			    else if("40".equals(notsta))
			    {
			      this.getMps().setRspsta( "4");
			      this.getMpe().setTxt( "人行返回处理状态-已退回");
			      isNotic = "32";
			    }
			    else if("192".equals(type)&& "0".equals(map1.get("76")))
			    {
			      log.debug("{}","192测试...");
			      this.getMps().setRspsta( "5");
			      this.getMpe().setTxt( "人行返回处理状态-已撤销");
			      isNotic = "0";
			    }
			    else if("70".equals(notsta))
			    {
			      this.getMps().setRspsta( "7");
			      this.getMpe().setTxt( "人行返回处理状态-收报行拒绝"+",报文处理码:" + responeCode + ",附言:"+addinf);
			      isNotic = "70";

			    }
			    else if ("71".equals(notsta))
			    {
			      this.getMps().setRspsta( "6");
			      this.getMpe().setTxt( "人行返回处理状态-收报行收妥");
			      isNotic = "71";
			    }
			    else
			    {
			      this.getMpe().setTxt( "报文处理码:" + responeCode + ",附言:"+addinf);
			      MdaUtils.clear(this.getSubmps());
			      this.getSubmps().setPntinr( this.getMps().getInr());
			      this.getSubmps().setDir( this.getMps().getDir());
			      this.getSubmps().setSrcchncod( "XXX");
			      this.getSubmps().setNxtchncod( "MAN");
			      this.getSubmps().setSta( "M");
			      this.getSubmps().setRspsta( "");
			      this.getSubmps().setRcvdattim( processDate);
			      this.getSubmps().setLstdattim( processDate);
			      this.getSubmps().setSttdattim( processDate);
			      this.getSubmps().setChncod( "FMT");
			      Platform.sdbInsert(this.getSubmps());
			      /*新增一条mpe*/
			      this.getSubmpe().setMpsinr( this.getMps().getInr());
			      this.getSubmpe().setChncod( "FMT");
			      this.getSubmpe().setNxtchncod( "MAN");
			      this.getSubmpe().setSmhinr( this.getSubmps().getInr());
			      this.getSubmpe().setDattim( processDate);
			      this.getSubmpe().setPrvsta( "F");
			      this.getSubmpe().setSta( "M");
			      Platform.sdbInsert(this.getSubmpe());
			      isNotic = "020";
			    }
			    Platform.mdbUpdate(this.getMps());
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( "FMT");
			    this.getMpe().setNxtchncod( "");
			    this.getMpe().setSmhinr( this.getMps().getInr());
			    this.getMpe().setDattim( processDate);
			    this.getMpe().setPrvsta( "D");
			    this.getMpe().setSta( "F");
			    Platform.sdbInsert(this.getMpe());
			    //是否通知关联系统
			    String sourceChannel = this.getMps().getSrcchncod();
			    log.debug("{}","收报源渠道："+sourceChannel);
			    /*if("ZQS".equals(sourceChannel))
			      {
			      log.debug("给资金清算发送异步相应...");
			      noticeToZQS(isNACK);
			      }*/
			    if("31".equals(isNotic))
			    {//20171218,增加已排队短信通知
			      this.getTxtm().noticeToOperator(cur,subtyp,fmtNumber);
			    }
			    if(!"GHD".equals(sourceChannel)&& !"025".equals(type) && !"FWE".equals(sourceChannel))
			      return this.getMps().getSrcchncod();
			  }

			}

			return "OOO";
		}
        /**
        *   source:dtrmod.@0025.script
        */
        public String do_rtnMessage(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//064登录应答，066退出应答，084变更确认,089绑定关系变更通知
			Map<String,String> map1 = (Map<String,String>)ctx.restoreData("map1");
			Map<String,String> map2 = (Map<String,String>)ctx.restoreData("map2");
			String fmttyp = (String)map1.get("12");
			String fmtNumber = (String)map1.get("20");
			log.debug("{}","FMT业务参考号："+fmtNumber);
			String addinf = null;
			String responeCode = null;
			if("084".equals(type)&&"084".equals(fmttyp))
			{//间接参与者行号信息变更确认
			  log.debug("{}","间接参与者行号信息变更确认...");
			  responeCode = (String)map2.get("/F00/");//报文处理码
			  String dat = (String)map2.get("/B00/");//委托日期
			  String chgnum = (String)map2.get("/D16/");//变更期数
			  String rspsta = (String)map2.get("/E56/");//处理状态，0-全部成功，1-汇总失败，2-明细失败
			  int num = MdaUtils.parseInt(map2.get("/D00/"));//明细数目
			  if(num>0 && "2".equals(rspsta))//明细汇总失败，明细清单显示失败明细
			  {
			    List<String> lst = new ArrayList<String>();
			    String obj = (String)map2.get("/H00/");
			    String[] bic = obj.split("\\r\\n");
			    for(int j =1;j<bic.length;j++){
			      log.debug("{}","明细信息:"+bic[j]);
			    String[] val = bic[j].split("/");
			    log.debug("{}","间接参与者行号:"+val[2]);
			    lst.add(val[2]);
			  }
			  MdaUtils.clear(this.getBnklst());
			  Platform.mdbReadset(this.getBnklst(),new Argument<String>("sta","00").or(new Argument<String>("sta","01")));//未审核或审核失败记录
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    for(com.ceb.gjjs.mda.bo.Fxbank pbt2 : this.getBnklst())
			    {
			      if(lst.contains(pbt2.getBic()))
			      {
			        log.debug("{}","明细汇总失败...");
			        pbt2.setSta( "01");//审核失败
			      }
			      else if("2".equals(pbt2.getLstupdate()))
			      {
			        pbt2.setSta( "49");//已注销
			        pbt2.setLosdat( MdaUtils.today());//失效日期
			      }
			      else if("13".contains(pbt2.getLstupdate()))
			      {
			        pbt2.setSta( "48");//已生效
			        pbt2.setBegdat( MdaUtils.today());//生效日期
			        pbt2.setLosdat( MdaUtils.parseDate("22991231","yyyyMMdd"));
			      }
			      pbt2.setChangeterm( chgnum);
			      pbt2.setTime( MdaUtils.today());
			      Platform.mdbUpdate(pbt2);
			    }
			  }
			}
			else if(num == 0 && "0".equals(rspsta))//全部成功
			{
			  log.debug("{}","全部成功...");
			  MdaUtils.clear(this.getBnklst());
			  Platform.mdbReadset(this.getBnklst(),new Argument<String>("sta","00").or(new Argument<String>("sta","01")));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    for(com.ceb.gjjs.mda.bo.Fxbank pbt : this.getBnklst())
			    {
			      if("2".equals(pbt.getLstupdate()))
			      {
			        pbt.setSta( "49");//已注销
			        pbt.setLosdat( MdaUtils.today());//失效日期
			      }
			      else if("13".contains(pbt.getLstupdate()))
			      {
			        pbt.setSta( "48");//已生效
			        pbt.setBegdat( MdaUtils.today());//生效日期
			        pbt.setLosdat( MdaUtils.parseDate("22991231","yyyyMMdd"));
			      }
			      pbt.setChangeterm( chgnum);
			      pbt.setTime( MdaUtils.today());
			      Platform.mdbUpdate(pbt);
			    }
			  }
			}
			else if(num == 0 && "1".equals(rspsta))//全部失败
			{
			  log.debug("{}","汇总失败...");
			  MdaUtils.clear(this.getBnklst());
			  Platform.mdbReadset(this.getBnklst(),new Argument<String>("sta","00").or(new Argument<String>("sta","01")));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    for(com.ceb.gjjs.mda.bo.Fxbank pbt1 : this.getBnklst())
			    {
			      pbt1.setSta( "01");//审核失败
			      Platform.mdbUpdate(pbt1);
			    }
			  }
			}
			}
			else if("064".equals(type)&&"064".equals(fmttyp))
			{ //登录应答报文
			log.debug("{}","登录应答...");
			String dat = (String)map2.get("/B31/");//当前日期
			String dattim = (String)map2.get("/B73/");//返回时间
			String rspcod = (String)map2.get("/F00/");//报文处理码
			String rspinf = (String)map2.get("/F86/");//返回信息
			//String rcvbic = (String)map0.get("sndbic");//接收行BIC
			String ownref = (String)map1.get("20");
			MdaUtils.clear(this.getUsrtab());
			Platform.mdbRead(this.getUsrtab(),new Argument<String>("sta","00"),new Argument<String>("reqnum",ownref));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  if(rspcod.endsWith("0000"))
			    this.getUsrtab().setSta( "02");//审核通过
			  else
			    this.getUsrtab().setSta( "01");//审核失败
			  this.getUsrtab().setMancod( rspcod);
			  this.getUsrtab().setRspinf( rspinf);
			  //$usrtab\\rcvcod = rcvbic;
			  this.getUsrtab().setCurdat( MdaUtils.parseDate(dat,"yyyyMMdd"));
			  this.getUsrtab().setRsptim( MdaUtils.parseDate(dattim,"yyyyMMddhhmmss"));
			  Platform.mdbUpdate(this.getUsrtab());
			}
			}
			else if("066".equals(type)&&"066".equals(fmttyp))
			{ //退出应答报文
			log.debug("{}","退出应答...");
			String rspcod = (String)map2.get("/F00/");//报文处理码
			String rspinf = (String)map2.get("/F86/");//返回信息
			//String rcvbic = (String)map0.get("sndbic");//接收行BIC
			String ownref = (String)map1.get("20");
			MdaUtils.clear(this.getUsrtab());
			Platform.mdbRead(this.getUsrtab(),new Argument<String>("sta","00"),new Argument<String>("reqnum",ownref));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  if(rspcod.endsWith("0000"))
			    this.getUsrtab().setSta( "02");//审核通过
			  else
			    this.getUsrtab().setSta( "01");//审核失败
			  this.getUsrtab().setMancod( rspcod);
			  this.getUsrtab().setRspinf( rspinf);
			  //$usrtab\\rcvcod = rcvbic;
			  Platform.mdbUpdate(this.getUsrtab());
			}
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0026.script
        */
        public String do_findFmtchnParent(String reference,String messageType)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//收到的191-9查询查复报文根据报文中21域（原报文20域参考号）来找报文的清分路径进行清分
			log.debug("{}","do_find191-9fmt。。。。");
			log.debug("{}","reference:" + reference);
			log.debug("{}","messageType:" + messageType);

			//默认为自动清分
			String targetChannel = "XXX";

			//初始化渠道信息,将业务渠道加载到内存中
			MdaUtils.clear(this.getChnlst());
			Platform.esdbReadset("eibs",this.getChnlst(),0,new Argument("typ","B"));

			//清空errorcode
			ctx.getErrorCode();

			// > 表示收报,< 表示发报
			if("191|193|194|195|196|199".indexOf(messageType)>=0 )
			{
			  //处理查询查复类报文报文,查原收发报文的tgtchncod（此处无需考虑收发）
			
			  Platform.mdbRead(this.getMpi(),new Argument("othref",reference).or("ownref",reference),new Argument("subtyp",NE,messageType));
			  if(ctx.getErrorCode() != NO_ERROR)
			  {
			    //如果查找出现错误
			    //Platform.mdbRead($mpi,new Argument("ownref",reference).and("dir","<").and("subtyp","202"));
			    ctx.getErrorCode();
			  }
			}

			//如果找到了MPI的INR
			if(! MdaUtils.isEmpty(this.getMpi().getInr()))
			{
			  log.debug("{}","mpiInr:" + this.getMpi().getInr());

			  //根据MPI的INR查找SMH记录
			  MdaUtils.clear(this.getSmhlst());
			  Platform.mdbReadset(this.getSmhlst(),new Argument("mpiinr",this.getMpi().getInr()),new Argument("inr",ASC));
			  ctx.getErrorCode();
			  if(this.getSmhlst().fullSize() > 0)
			  {
			    //List<String> smhinrList = new ArrayList<String>();
			    String [] smhinrList = new String[this.getSmhlst().size()];
			    int i = 0;
			    for(com.ceb.gjjs.mda.bo.Smh smh : this.getSmhlst())
			    {
			      smhinrList[i] = (smh.getInr());
			      log.debug("{}","smhInr:" + smh.getInr());
			      i++;
			    }

			    //根据SMH的INR查找MPS记录
			    MdaUtils.clear(this.getMpslst());
			    Platform.mdbReadset(this.getMpslst(),new Argument("smhinr",IN,smhinrList));
			    if(this.getMpslst().fullSize() > 0)
			    {
			      //如果找到了多笔,或者单笔,都要校验一下渠道是否是业务渠道
			      for(com.ceb.gjjs.mda.bo.Mps mps : this.getMpslst())
			      {
			        log.debug("{}","mpsInr:" + mps.getInr() + " mpsSrcChnCod:" + mps.getSrcchncod() + " mpsTgtChnCod:" + mps.getTgtchncod());
			        if(MdaUtils.isEmpty(mps.getDir()))
			          continue;
			        if("<".equals(mps.getDir()) && MdaUtils.isEmpty(mps.getSrcchncod()))
			          continue;
			        if(">".equals(mps.getDir()) && MdaUtils.isEmpty(mps.getTgtchncod()))
			          continue;
			        for(com.ceb.gjjs.mda.bo.Chn chn : this.getChnlst())
			        {
			          if("191|193|194|195|196|199".indexOf(messageType)>=0)
			          {
			            //发报,用srcchncod去找原渠道
			            if(mps.getSrcchncod().equals(chn.getCod()) && "<".equals(mps.getDir()))
			            {
			              targetChannel = mps.getSrcchncod();
			              break;
			            }
			            //收报,用tgtchncod去找原渠道
			            if(mps.getTgtchncod().equals(chn.getCod()) && ">".equals(mps.getDir()))
			            {
			              targetChannel = mps.getTgtchncod();
			              break;
			            }
			          }
			        }
			        if(! "XXX".equals(targetChannel))
			        {
			          //查询是否有对应CASE，若有则同时抄送查询查复，否则不抄送
			          Platform.mdbRead(this.getQrd(),new Argument("relref",this.getSmhlst().getElement(0).getInr()));
			          if(!MdaUtils.isEmpty(this.getQrd().getCasnum()))
			          {
			            log.debug("{}","do_findfmt case number:"+this.getQrd().getCasnum());
			            targetChannel = "QAA|" + targetChannel;
			          }
			          else
			            break;
			        }
			      }
			    }
			    else
			      log.debug("{}","mpsList is null");
			  }
			  else
			    log.debug("{}","smhList is null");
			}
			else
			  log.debug("{}","could not find parnet 查询查复191-9报文");

			MdaUtils.clear(this.getMpslst());
			log.debug("{}","targetChannel:" + targetChannel);
			return targetChannel;
		}
        /**
        *   source:dtrmod.@0027.script
        */
        public String do_send042Message()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//接收042报文，自动发送短信
			Map<String,String> map1 = (Map<String,String>)ctx.restoreData("map1");
			Map<String,String> map2 = (Map<String,String>)ctx.restoreData("map2");
			String fmtNumber = (String)map1.get("20");//业务参考号
			String fmttyp = (String)map1.get("12");//报文子类型号
			log.debug("{}","042ownref："+fmtNumber);
			Date dat = MdaUtils.parseDate(map2.get("/B00/"),"yyyyMMdd");//委托日期
			String bic = (String)map2.get("/A06/");//清算行行号
			String cur = (String)map2.get("/G51/");//币种
			String num = (String)map2.get("/E34/");//预警类型，1 预警
			BigDecimal waramt = MdaUtils.parseDecimal(map2.get("/C76/").replace(',','.'));//可用额度预警值
			BigDecimal amt = MdaUtils.parseDecimal(map2.get("/C72/").replace(',','.'));//可用额度值
			if(this.getTxtm().sendMessage(cur,bic,waramt,amt,dat))
			{
			  Date processDate = new Date();
			  this.getSmpmod().getMps().setSta( "F");
			  this.getSmpmod().getMps().setLstdattim( processDate);
			  this.getSmpmod().getMps().setRspdattim( processDate);
			  Platform.mdbUpdate(this.getSmpmod().getMps());

			  this.getMpe().setMpsinr( this.getSmpmod().getMps().getInr());
			  this.getMpe().setChncod( "FMT");
			  this.getMpe().setNxtchncod( "");
			  this.getMpe().setSmhinr( this.getSmpmod().getMps().getInr());
			  this.getMpe().setDattim( processDate);
			  this.getMpe().setPrvsta( "D");
			  this.getMpe().setSta( "F");
			  Platform.sdbInsert(this.getMpe());
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0028.script
        */
        public String do_updateFxbankMessage(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//080参与者行号变更通知
			Map<String,String> map1 = (Map<String,String>)ctx.restoreData("map1");
			Map<String,String> map2 = (Map<String,String>)ctx.restoreData("map2");
			String fmttyp = (String)map1.get("12");
			String fmtNumber = (String)map1.get("20");
			log.debug("{}","FMT080业务参考号："+fmtNumber);
			if("080".equals(type)&&"080".equals(fmttyp))
			{//参与者行号通知
			  String dat = (String)map2.get("/B00/");//委托日期
			  String chgnum = (String)map2.get("/D16/");//变更期数
			  int num = MdaUtils.parseInt(map2.get("/D00/"));//明细数目
			  if(num>0)
			  {
			    String obj = (String)map2.get("/H00/");//明细清单
			    String[] msg = obj.split("\\r\\n\\/1\\/");//以‘\\r\\n/1/’分割
			    List<String> lst = new ArrayList<String>();
			    for(int j=1;j<msg.length;j++){
			      String str = msg[j].replaceAll("\r\n//", "");//去除回车换行和连接符号
			    // str = str.replace("//", "");//去除连接符号
			    lst.add(str);
			  }
			  log.debug("{}","明细清单数:"+lst.size());
			  for(int i = 0;i<lst.size();i++){
			    String str = lst.get(i);
			  log.debug("{}","明细信息..."+str);
			  String[] val = str.split("/");
			  int len = val.length;
			  log.debug("{}","明细信息位元个数..."+len);
			  String bic = val[2];
			  MdaUtils.clear(this.getFxbank());
			  Platform.mdbRead(this.getFxbank(),new Argument<String>("bic",bic));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.debug("{}","更新fxbank信息...");
			    loadFxbankMsg(val,chgnum);
			    Platform.mdbUpdate(this.getFxbank());
			  }
			  else
			  {
			    log.debug("{}","新增fxbank信息...");
			    MdaUtils.clear(this.getFxbank());
			    loadFxbankMsg(val,chgnum);
			    Platform.sdbInsert(this.getFxbank());
			  }
			}
			}
			}
			return "XXX";
		}
        /**
        *   source:dtrmod.@0029.script
        */
        public void loadFxbankMsg(String[] val,String chgnum)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","加载fxbank信息...");
			int len = val.length;
			this.getFxbank().setBnktyp( val[0]);//参与者类型
			this.getFxbank().setDirectbic( val[1]);//直接参与者行号
			this.getFxbank().setBic( val[2]);//参与者行号
			this.getFxbank().setHafnam( val[3]);//参与者简称
			this.getFxbank().setFulnam( val[4]);//参与者全称
			this.getFxbank().setAddress( val[5]);//参与者地址
			this.getFxbank().setPhone( val[6]);//联系电话
			this.getFxbank().setLnkman( val[7]);//联系人
			this.getFxbank().setPoscod( val[8]);//邮编
			this.getFxbank().setEmail( val[9]);//EMAIL地址
			this.getFxbank().setProvcod( val[12]);//省属代码
			this.getFxbank().setCitycod( val[13]);//地市代码
			if(len>14)
			{
			  this.getFxbank().setBnkcod( val[14]);//金融机构代码，可为空
			}
			if(len>15)
			{
			  this.getFxbank().setPostscript( val[15]);//备注，可为空
			}
			String begdat = val[10];//生效日期
			String lstupdate = val[11];//变更类型，1新增 ，2撤销，3变更
			if("2".equals(lstupdate))
			{
			  this.getFxbank().setLstupdate( "2");//最近更新操作
			  this.getFxbank().setSta( "49");//已撤销
			  this.getFxbank().setLosdat( MdaUtils.parseDate(begdat,"yyyyMMdd"));//失效日期
			}
			else if("1|3".contains(lstupdate))
			{
			  this.getFxbank().setLstupdate( lstupdate);//最近更新操作
			  this.getFxbank().setSta( "48");//已生效
			  this.getFxbank().setBegdat( MdaUtils.parseDate(begdat,"yyyyMMdd"));//生效日期
			  this.getFxbank().setLosdat( MdaUtils.parseDate("22991231","yyyyMMdd"));//失效日期
			}
			this.getFxbank().setChangeterm( chgnum);//变更期数
			this.getFxbank().setTime( MdaUtils.today());//更新时间
					}
        /**
        *   source:dtrmod.@0030.script
        */
        public boolean do_BicActNoErr(String bic,String act)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(bic)||MdaUtils.isEmpty(act))
			  return true;
			String actrul = "";
			String sql = "SELECT actrul FROM ptyref WHERE bic = '"+bic+"' ";
			Argument argActrul = new Argument<String>("actrul");
			ctx.getErrorCode();
			Object session = Platform.esdbExecuteSQL("eibs",sql);
			int err = ctx.getErrorCode();
			if(err==NO_ERROR)
			{
			  Platform.esdbFetchFields(session,argActrul);
			  err = ctx.getErrorCode();
			  if(err==NO_ERROR)
			    actrul = (String)argActrul.value;
			}
			Platform.esdbCloseCursor(session);

			if(MdaUtils.isEmpty(actrul))
			{
			  log.debug("{}","无账号规则");
			  return true;
			}
			if(!act.matches(actrul))
			{
			  log.info("{}","BIC与账号不匹配");
			  return false;
			}
			return true;
		}
        /**
        *   source:dtrmod.@0031.script
        */
        public boolean do_BicActMatch(String bic,String act)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/* BicActMatch(rcvbic,act)?XXX:DZF
			  * 值为true-XXX,否则DZF报文转发
			  */
			//20180718修改，仅收报行为ZSH，账号不符进收报转发
			if(MdaUtils.isEmpty(bic)||MdaUtils.isEmpty(act))
			  return true;
			String actrul = "";
			String sql = "SELECT actrul FROM ptyref WHERE bic = '"+bic+"' ";
			Argument argActrul = new Argument<String>("actrul");
			ctx.getErrorCode();
			Object session = Platform.esdbExecuteSQL("eibs",sql);
			int err = ctx.getErrorCode();
			if(err==NO_ERROR)
			{
			  Platform.esdbFetchFields(session,argActrul);
			  err = ctx.getErrorCode();
			  if(err==NO_ERROR)
			    actrul = (String)argActrul.value;
			}
			Platform.esdbCloseCursor(session);

			if(MdaUtils.isEmpty(actrul))
			{
			  log.info("{}","无账号规则");
			  //20180718修改
			  //return false;
			  return true;
			  //查找非总行的账号匹配规则
			  //20171026修改
			  //return !actMatchOtherRcvBic(bic,act);
			}
			if(!act.matches(actrul))
			{
			  log.info("{}","BIC与账号不匹配");
			  if("PSBCCNBJZSH".equals(bic))
			    return false;
			  //20180718修改
			  //return !actMatchOtherBic(bic,act);
			}
			return true;
		}
        /**
        *   source:dtrmod.@0032.script
        */
        public boolean actMatchOtherBic(String bic,String act)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean result = false;
			String sql = "SELECT actrul FROM ptyref WHERE bic <> '"+bic+"' ";
			Argument argActrul = new Argument<String>("actrul");
			ctx.getErrorCode();
			Object session = Platform.esdbExecuteSQL("eibs",sql);
			int err = ctx.getErrorCode();
			while(err==NO_ERROR)
			{
			  Platform.esdbFetchFields(session,argActrul);
			  err = ctx.getErrorCode();
			  if(err==NO_ERROR)
			  {
			    //20171026修改
			    //if(act.matches((String)argActrul.value) && (!"PSBCCNBJZSH".equals(bic)) )
			    if(act.matches((String)argActrul.value))
			    {
			      log.info("{}","账号与其它机构BIC匹配");
			      result= true;
			      break;
			    }
			  }
			}
			Platform.esdbCloseCursor(session);
			return result;
		}
        /**
        *   source:dtrmod.@0033.script
        */
        public boolean actMatchOtherRcvBic(String bic,String act)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean result = false;
			String sql = "SELECT actrul FROM ptyref WHERE bic <> '"+bic+"'  AND bic <> 'PSBCCNBJXXX' ";
			Argument argActrul = new Argument<String>("actrul");
			ctx.getErrorCode();
			Platform.mdbExecuteSQL(sql);
			int err = ctx.getErrorCode();
			while(err==NO_ERROR)
			{
			  Platform.mdbFetchFields(argActrul);
			  err = ctx.getErrorCode();
			  if(err==NO_ERROR)
			  {
			    if(act.matches((String)argActrul.value))
			    {
			      log.info("{}","账号与其它机构BIC匹配");
			      result= true;
			      break;
			    }
			  }
			}
			Platform.mdbCloseCursor();
			return result;
		}
        /**
        *   source:dtrmod.@0034.script
        */
        public String do_CPSNotice(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *type---报文类型；
			  *304:撤销应答,需更新原撤销报文
			  *306 业务状态查询应答，需更新原业务报文状态
			  *308 通用签名信息业务应答
			  *601:支付确认
			  *900:通用确认
			  *912:丢弃通知
			  *132：CCP业务回执、153：清算机构借贷通知、314结算排队查询应答
			  *orgnum-----原业务报文20域编号
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("cipsmap");
			log.debug("{}","cipsmap:"+map);
			String orgnum = null;
			String relorgnum = null;//关联原业务报文
			String subtyp = null;
			String responeCode = null;
			String notsta = null;
			String addinf = null;
			String relnotsta = null;
			String reladdinf = null;
			//304/306/308/132/153/314/601/900
			if(!MdaUtils.isEmpty(map.get("OrgnlMsgId")))
			{
			  orgnum = map.get("OrgnlMsgId").toString();//原报文标识号
			}

			if(!MdaUtils.isEmpty(map.get("PrcCdAndInf")))
			{
			  addinf = map.get("PrcCdAndInf").toString();//业务处理码+处理信息
			}

			if("900|912|601".contains(type) &&!MdaUtils.isEmpty(map.get("OrgnlTp")))
			{
			  subtyp = map.get("OrgnlTp").toString();//原报文类型
			  subtyp = subtyp.substring(5,8);
			}

			/*if("601".equals(type) && !Platform.isEmpty(map.get("OrgnlTp")))
			  {
			  subtyp = map.get("OrgnlTp").toString();//原报文类型
			  subtyp = subtyp.substring(5,8);
			  }*/
			if(!MdaUtils.isEmpty(map.get("StsId")))
			{
			  notsta = map.get("StsId").toString();//业务处理状态
			}
			if(!MdaUtils.isEmpty(map.get("PrcSts")))
			{
			  notsta = map.get("PrcSts").toString();//业务处理状态
			}
			//912丢弃通知，无处理状态
			//304撤销应答  orgnum = map.get("OrgnlInstrId").toString();
			if("304".equals(type)&&!MdaUtils.isEmpty(map.get("OrgnlInstrId")))
			{
			  relorgnum = map.get("OrgnlInstrId").toString();//原撤销报文标识号
			}
			else if("306".equals(type))
			{//如果状态查询成功，更新原业务报文处理状态
			  //如果查询未成功，则更新原查询申请报文处理状态
			  if(!MdaUtils.isEmpty(map.get("BusinessReport")))
			  {
			    Map<String,Object> submap = (Map<String,Object>)map.get("BusinessReport");
			    if(!MdaUtils.isEmpty(submap.get("OrgnlMsgId")))//原报文标识号
			    relorgnum = submap.get("OrgnlMsgId").toString();
			    if(!MdaUtils.isEmpty(submap.get("PrcSts")))//业务处理状态
			    relnotsta = submap.get("PrcSts").toString();
			    if(!MdaUtils.isEmpty(map.get("PrcCdAndInf")))
			      reladdinf = map.get("PrcCdAndInf").toString();//业务处理码+处理信息
			  }
			  if(!MdaUtils.isEmpty(map.get("OperationalError")))
			  {
			    Map<String,Object> submap = (Map<String,Object>)map.get("OperationalError");
			    if(!MdaUtils.isEmpty(submap.get("Prtry")))//业务处理状态
			    notsta = submap.get("Prtry").toString();
			    if(!MdaUtils.isEmpty(map.get("Desc")))
			      addinf = map.get("Desc").toString();//业务处理码+处理信息
			  }
			}
			else if("912".equals(type))
			{
			  notsta = "DIUQI";//已撤消状态终态，需更新mps表
			}
			if("304".equals(type))
			{
			  //更新对应业务报文状态
			  updateRelMsgStatus(type,relorgnum,notsta,addinf);
			}
			else if("306".equals(type))
			{
			  //更新对应业务报文状态
			  updateRelMsgStatus(type,relorgnum,relnotsta,reladdinf);
			}
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMps());
			Argument argument = new Argument("ownref",orgnum).and("dir","<").and("msgtyp","xml");//根据原发报报文20域，报文类型来查找原关联报文
			if("132".equals(type))
			{
			  argument = argument.and("subtyp","131");
			}
			/*else if("153".equals(type))
			  {
			  argument = argument.and("subtyp","151");
			  }*/
			else if("314".equals(type))
			{
			  argument = argument.and("subtyp","313");
			}
			else if("304".equals(type))
			{
			  argument = argument.and("subtyp","303");
			}
			else if("306".equals(type))
			{
			  argument = argument.and("subtyp","305");
			}
			else if("308".equals(type))
			{
			  argument = argument.and("subtyp","307");
			}
			else if(!MdaUtils.isEmpty(subtyp))
			{
			  //来报135->往报136->来报601,来报153->往报154->来报601;
			  //来报601关联的原报文为135和153,但是需要修改往报的136和154的数据库状态rspsta;
			  //所以601报文中的原报文标识号关联到mpi的othref字段;并且要选定报文类型(136,154);
			  if("135".equals(subtyp))
			  {
			    argument = new Argument("othref",orgnum).and("dir","<").and("msgtyp","xml");
			    argument = argument.and("subtyp","136");
			  }
			  else if("153".equals(subtyp))
			  {
			    argument = new Argument("othref",orgnum).and("dir","<").and("msgtyp","xml");
			    argument = argument.and("subtyp","154");
			  }
			  else
			  {
			    argument = argument.and("subtyp",subtyp);
			  }
			}
			else
			  ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			int errorcode = ctx.getErrorCode();
			log.debug("{}","errorcode:"+errorcode);
			if(errorcode==NO_ERROR)
			{
			  if("903".equals(this.getMpi().getSubtyp()))//数字证书绑定通知
			  {
			    MdaUtils.clear(this.getCsn());
			    Platform.mdbRead(this.getCsn(),new Argument<String>("relinr",this.getMpi().getInr()),new Argument("sta","D"));
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      if(notsta.contains("SUCD"))
			        this.getCsn().setSta( "02");//审核通过
			      else
			        this.getCsn().setSta( "01");//审核失败
			      Platform.mdbUpdate(this.getCsn());
			    }
			  }
			  Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.debug("{}","notsta:"+notsta+"type:"+type);
			    Date processDate = new Date();
			    this.getMps().setLstdattim( processDate);
			    this.getMps().setRspdattim( processDate);
			    MdaUtils.clear(this.getMpe());
			    String isNotic = "";//处理状态
			    if("RJCT".equals(notsta))
			    {
			      this.getMps().setRspsta( "R");
			      this.getMpe().setTxt( "人行返回处理状态-已拒绝"+",处理信息:"+addinf);
			      //isNotic = "RJCT";
			    }
			    else if("PDNG".equals(notsta))
			    {
			      this.getMps().setRspsta( "Q");
			      this.getMpe().setTxt( "人行返回处理状态-结算排队");
			      //isNotic = "PDNG";
			      if("601".equals(type))
			      {
			        // 处理CIPS排队信息
			        saveCipsPending(map);
			      }
			    }
			    else if("ACSC".equals(notsta))
			    {
			      this.getMps().setRspsta( "C");
			      this.getMpe().setTxt( "人行返回处理状态-已结算");
			      //isNotic = "ACSC";
			    }
			    else if("EDRN".equals(notsta))
			    {
			      this.getMps().setRspsta( "T");
			      this.getMpe().setTxt( "人行返回处理状态-日终退回");
			      //isNotic = "EDRN";
			    }
			    else if("304".equals(type)&& "SUCD".equals(notsta))
			    {
			      this.getMps().setRspsta( "5");
			      this.getMpe().setTxt( "人行返回处理状态-已撤销");
			      //isNotic = "0";
			    }
			    else if((!"304".equals(type))&&"SUCD".equals(notsta))
			    {
			      this.getMps().setRspsta( "S");
			      this.getMpe().setTxt( "人行返回处理状态-已成功");
			      //isNotic = "SUCD";
			    }
			    else if("FRWD".equals(notsta))
			    {
			      this.getMps().setRspsta( "8");
			      this.getMpe().setTxt( "人行返回处理状态-已转发");
			      // isNotic = "FRWD";
			    }
			    else if ("RSVL".equals(notsta))
			    {
			      this.getMps().setRspsta( "D");
			      this.getMpe().setTxt( "人行返回处理状态-已处理");
			      //isNotic = "RSVL";
			    }

			    else if ("DIUQI".equals(notsta))
			    {
			      this.getMps().setRspsta( "G");
			      this.getMpe().setTxt( "人行已丢弃该笔报文");
			      //isNotic = "CAND";
			    }
			    else if ("CAND".equals(notsta))
			    {
			      this.getMps().setRspsta( "5");
			      this.getMpe().setTxt( "人行返回处理状态-已撤销");
			      //isNotic = "CAND";
			    }
			    else if ("NETD".equals(notsta))
			    {
			      this.getMps().setRspsta( "9");
			      this.getMpe().setTxt( "人行返回处理状态-已轧差");
			      //isNotic = "CAND";
			    }
			    else if ("RJPT".equals(notsta))
			    {
			      this.getMps().setRspsta( "r");
			      this.getMpe().setTxt( "人行返回处理状态-参与者拒绝");
			      //isNotic = "CAND";
			    }
			    else
			    {
			      this.getMpe().setTxt( "处理信息:"+addinf);
			      MdaUtils.clear(this.getSubmps());
			      this.getSubmps().setPntinr( this.getMps().getInr());
			      this.getSubmps().setDir( this.getMps().getDir());
			      this.getSubmps().setSrcchncod( "XXX");
			      this.getSubmps().setNxtchncod( "MAN");
			      this.getSubmps().setSta( "M");
			      this.getSubmps().setRspsta( "");
			      this.getSubmps().setRcvdattim( processDate);
			      this.getSubmps().setLstdattim( processDate);
			      this.getSubmps().setSttdattim( processDate);
			      this.getSubmps().setChncod( "CPS");
			      Platform.sdbInsert(this.getSubmps());
			      /*新增一条mpe*/
			      this.getSubmpe().setMpsinr( this.getMps().getInr());
			      this.getSubmpe().setChncod( "CPS");
			      this.getSubmpe().setNxtchncod( "MAN");
			      this.getSubmpe().setSmhinr( this.getSubmps().getInr());
			      this.getSubmpe().setDattim( processDate);
			      this.getSubmpe().setPrvsta( "F");
			      this.getSubmpe().setSta( "M");
			      Platform.sdbInsert(this.getSubmpe());
			      //isNotic = "020";
			    }
			    Platform.mdbUpdate(this.getMps());
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( "CPS");
			    this.getMpe().setNxtchncod( "");
			    this.getMpe().setSmhinr( this.getMps().getInr());
			    this.getMpe().setDattim( processDate);
			    this.getMpe().setPrvsta( "D");
			    this.getMpe().setSta( "F");
			    Platform.sdbInsert(this.getMpe());

			  }

			  //是否通知关联系统
			  String sourceChannel = this.getMps().getSrcchncod();
			  log.debug("{}","收报源渠道："+sourceChannel);
			  if("CWE|CAA".contains(sourceChannel) && "912".equals(type))
			    return "OOO";
			  if(!"CWE".equals(sourceChannel) && !"715".equals(type))
			    return this.getMps().getSrcchncod();
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0035.script
        */
        public String do_rtnCIPSMessage(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *357 清算账户信息查询应答
			  *713 跨境明细核对应答
			  *715 原报文下载应答
			  *302 答复报文
			  *806 登录/退出应答
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("cipsmap");
			String orgnum = (String)map.get("OrgnlMsgId");//357/713/806
			if(!MdaUtils.isEmpty(map.get("Case")))//715/302报文
			{
			  Map<String,Object> submap = (Map<String,Object>)map.get("Case");
			  if(!MdaUtils.isEmpty(submap.get("OrgnlMsgId")))//原报文标识号
			  orgnum = submap.get("OrgnlMsgId").toString();
			}
			log.debug("{}","CIPS业务参考号："+orgnum);
			//357只有查询失败时才返回处理状态和处理信息，BizErr子信息下
			//713无返回处理状态和处理信息
			String addinf = null;
			String notsta = null;
			if(!MdaUtils.isEmpty(map.get("PrcCdAndInf")))
			{
			  addinf = map.get("PrcCdAndInf").toString();//业务处理码+处理信息
			}
			if(!MdaUtils.isEmpty(map.get("PrcSts")))
			{
			  notsta = map.get("PrcSts").toString();//业务处理状态
			  log.debug("{}","业务处理状态..." + map.get("PrcSts").toString());
			}
			if("806".equals(type))
			{
			  //登录、退出应答报文
			  log.debug("{}","登录/退出应答...");
			  String loginoprtp = null;//登陆，登出标识
			  String dat = null;
			  log.debug("{}","当前系统日期..." + map.get("CurSysDt").toString());
			  if(!MdaUtils.isEmpty(map.get("CurSysDt")))
			    dat = map.get("CurSysDt").toString();
			  log.debug("{}","登陆标识号..." + map.get("LoginOprTp").toString());
			  if(!MdaUtils.isEmpty(map.get("LoginOprTp")))
			    loginoprtp = map.get("LoginOprTp").toString();
			  MdaUtils.clear(this.getUsrtab());
			  Platform.mdbRead(this.getUsrtab(),new Argument<String>("sta","00"),new Argument<String>("reqnum",orgnum),new Argument("typ","1"));
			  int errorcode = ctx.getErrorCode();
			  log.debug("{}","errorcode: "+errorcode);
			  if(errorcode==NO_ERROR)
			  {
			    String info = "";
			    if(addinf != null)
			    {
			      info = addinf.substring(3,8);
			    }
			    log.debug("{}","loginfo...." + info);
			    //若返回状态为“RJCT”,返回信息业务处理码为后五位为"W0001"(重复签到)。审核状态为'02'且系统登陆状态为'D'。
			    if((notsta.equals("RSVL")&&loginoprtp.equals("LOGN"))||(notsta.equals("RJCT") && info.equals("W0001")))
			    {
			      this.getUsrtab().setSta( "02");//审核通过
			      this.getUsrtab().setLogsta( "D");//登陆
			    }
			    //若返回状态为“RJCT”,返回信息业务处理码为后五位为"W0002"(重复签退)。审核状态为'02'且系统登陆状态为'N'。
			    else if(notsta.equals("RSVL")&&loginoprtp.equals("LOGF")||(notsta.equals("RJCT") && info.equals("W0002")))
			    {
			      this.getUsrtab().setSta( "02");//审核通过
			      this.getUsrtab().setLogsta( "N");//离线
			    }
			    else if(notsta.equals("RJCT"))
			    {
			      this.getUsrtab().setSta( "01");//审核失败
			      this.getUsrtab().setLogsta( "E");//错误
			    }
			    this.getUsrtab().setMancod( notsta);
			    this.getUsrtab().setRspinf( addinf);
			    if(!MdaUtils.isEmpty(dat))
			      this.getUsrtab().setCurdat( MdaUtils.parseDate(dat,"yyyyMMdd"));
			    else
			      this.getUsrtab().setCurdat( MdaUtils.today());
			    Platform.mdbUpdate(this.getUsrtab());
			  }
			}
			else if("357".equals(type))
			{ //357只有查询失败时才返回处理状态和处理信息，BizErr子信息下
			  log.debug("{}","清算账户信息查询应答...");
			  String bic = map.get("MmbId").toString();
			  if(!MdaUtils.isEmpty(map.get("Acct")))
			  {
			    //查询成功，返回账户信息
			    Map<String,Object> submap = (Map<String,Object> )map.get("Acct");
			    String acctyp = submap.get("Prtry").toString();
			    String waramt = submap.get("AmtWthCcy").toString();//货币符号固定填写CNY
			    waramt = waramt.substring(3);
			    String begamt = null;
			    String curamt = null;
			    String debsumamt = null;
			    String crdsumamt = null;
			    String injectamt = null;
			    String injecttyp = null;
			    //起始余额
			    if(!MdaUtils.isEmpty(submap.get("BeginMulBal")))
			    {
			      Map<String,Object> begmap = (Map<String,Object>)submap.get("BeginMulBal");
			      if(!MdaUtils.isEmpty(begmap.get("Amt")))
			        begamt = begmap.get("Amt").toString();
			    }
			    //当前余额
			    if(!MdaUtils.isEmpty(submap.get("CurMulBal")))
			    {
			      Map<String,Object> curmap = (Map<String,Object>)submap.get("CurMulBal");
			      if(!MdaUtils.isEmpty(curmap.get("Amt")))
			        curamt = curmap.get("Amt").toString();
			    }
			    //借记排队总金额
			    if(!MdaUtils.isEmpty(submap.get("DbitMulBal")))
			    {
			      Map<String,Object> debmap = (Map<String,Object>)submap.get("DbitMulBal");
			      if(!MdaUtils.isEmpty(debmap.get("Amt")))
			        debsumamt = debmap.get("Amt").toString();
			    }
			    //贷记排队总金额
			    if(!MdaUtils.isEmpty(submap.get("CrdtMulBal")))
			    {
			      Map<String,Object> crdmap = (Map<String,Object>)submap.get("CrdtMulBal");
			      if(!MdaUtils.isEmpty(crdmap.get("Amt")))
			        crdsumamt = crdmap.get("Amt").toString();
			    }
			    //注资信息
			    if(!MdaUtils.isEmpty(submap.get("CapMulBal")))
			    {
			      Map<String,Object> injmap = (Map<String,Object>)submap.get("CapMulBal");
			      if(!MdaUtils.isEmpty(injmap.get("Amt")))//注资最低限额
			      injectamt = injmap.get("Amt").toString();
			      if(!MdaUtils.isEmpty(injmap.get("Id")))//注资状态，FDRC：注资成功， FDWT：待注资
			      injecttyp = injmap.get("Id").toString();
			    }
			    MdaUtils.clear(this.getCpsact());
			    Platform.mdbRead(this.getCpsact(),new Argument("dirbic",bic));
			    this.getCpsact().setDirbic( bic);
			    this.getCpsact().setActtyp( acctyp);
			    this.getCpsact().setInjectminamt( MdaUtils.parseDecimal(injectamt));
			    this.getCpsact().setAmt( MdaUtils.parseDecimal(curamt));
			    this.getCpsact().setInjecttyp( injecttyp);
			    this.getCpsact().setWaramt( MdaUtils.parseDecimal(waramt));
			    this.getCpsact().setBegamt( MdaUtils.parseDecimal(begamt));
			    this.getCpsact().setDeballamt( MdaUtils.parseDecimal(debsumamt));
			    this.getCpsact().setCrdallamt( MdaUtils.parseDecimal(crdsumamt));
			    this.getCpsact().setCredattim( MdaUtils.today());
			    int errorcode = ctx.getErrorCode();
			    if(errorcode == NO_ERROR)
			    {
			      //存在账户信息，更新记录
			      Platform.mdbUpdate(this.getCpsact());
			    }
			    else if(errorcode == NO_MORE_ROW)
			    {
			      //无记录信息，新增记录
			      Platform.sdbInsert(this.getCpsact());
			    }
			  }
			  if(!MdaUtils.isEmpty(map.get("BizErr")))
			  {
			    //查询失败，返回错误信息
			    Map<String,Object> submap = (Map<String,Object>)map.get("BizErr");
			    if(!MdaUtils.isEmpty(submap.get("PrcSts")))
			      notsta = submap.get("PrcSts").toString();
			    if(!MdaUtils.isEmpty(submap.get("PrcCdAndInf")))
			      addinf = submap.get("PrcCdAndInf").toString();
			  }
			}
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMps());
			//根据原发报报文20域，报文类型来查找原关联报文,更新原记录回执状态
			Argument argument = new Argument("ownref",orgnum).and("dir","<");
			if("806".equals(type))
			  argument = argument.and("subtyp","805");
			else if("715".equals(type))
			  argument = argument.and("subtyp","714");
			else if("713".equals(type))
			  argument = argument.and("subtyp","712");
			else if("302".equals(type))
			  argument = argument.and("subtyp","301");
			else if("357".equals(type))
			  argument = argument.and("subtyp","356");
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()),new Argument("sta","D"));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  Date processDate = new Date();
			  this.getMps().setLstdattim( processDate);
			  this.getMps().setRspdattim( processDate);
			  MdaUtils.clear(this.getMpe());
			  if("RJCT".equals(notsta))
			  {
			    this.getMps().setRspsta( "1");
			    this.getMpe().setTxt( "人行返回处理状态-已拒绝"+",处理信息:"+addinf);
			  }
			  else if ("RSVL".equals(notsta))
			  {
			    this.getMps().setRspsta( "D");
			    this.getMpe().setTxt( "人行返回处理状态-已处理");
			  }
			  else if(MdaUtils.isEmpty(notsta))
			  {
			    if("302".equals(type))
			    {
			      this.getMps().setRspsta( "d");
			      this.getMpe().setTxt( "人行已答复");
			    }
			    else
			    {
			      this.getMps().setRspsta( "t");
			      this.getMpe().setTxt( "人行已应答");
			    }
			  }
			  Platform.mdbUpdate(this.getMps());
			  this.getMpe().setMpsinr( this.getMps().getInr());
			  this.getMpe().setChncod( "CPS");
			  this.getMpe().setNxtchncod( "");
			  this.getMpe().setSmhinr( this.getMps().getInr());
			  this.getMpe().setDattim( processDate);
			  this.getMpe().setPrvsta( "D");
			  this.getMpe().setSta( "F");
			  Platform.sdbInsert(this.getMpe());
			}
			if("357|302".contains(type) && !"CWE".equals(this.getMps().getSrcchncod()))
			  return this.getMps().getSrcchncod();
			else if("806".equals(type))
			  return "XXX";
			else
			  return "OOO";
		}
        /**
        *   source:dtrmod.@0036.script
        */
        public boolean do_CIPSref(String reference,String messageType,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","do_CIPSref");
			ctx.getErrorCode(); // 清空errorCode;
			// 收报时20域为对象参考号，发报为20域为我方参考号
			if(">".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","xml").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			else if("<".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","xml").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			return ctx.getErrorCode()==NO_ERROR; // 如果为零则找到相同记录，则作为疑似重复记录
					}
        /**
        *   source:dtrmod.@0037.script
        */
        public void insertMpsMpe(String chn)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Date processDate = new Date();
			// 新建并行渠道处理记录 （smpmod为原模型不要在模块外执行变更操作）
			this.getMps().copyValues(this.getSmpmod().getMps()); // 相关关联报文等值通过复制获取
			this.getMps().setInr( Platform.sdbCounter("mps"));
			this.getMps().setPntinr( this.getSmpmod().getMps().getInr()); // 关联之前的MPS记录
			this.getMps().setNxtchncod( chn);
			this.getMps().setTgtchncod( chn);
			this.getMps().setDir( ">"); // 收报并行渠道
			this.getMps().setSta( "W"); // 放行至并行渠道
			this.getMps().setNxtsta( "W"); //待发送
			this.getMps().setRcvdattim( processDate); // 报文接收时间
			this.getMps().setLstdattim( processDate); // 最近处理执行时间
			Platform.mdbInsert(this.getMps());
			// 新建并行渠道处理详细信息
			this.getMpe().setMpsinr( this.getMps().getInr());
			this.getMpe().setChncod( "XXX");
			this.getMpe().setNxtchncod( chn);
			this.getMpe().setSmhinr( this.getMps().getSmhinr());
			this.getMpe().setDattim( processDate);
			this.getMpe().setSta( "W");
			this.getMpe().setUsr( MdaEnv.getLoginUser());
			this.getMpe().setFrmnam( ctx.getTransName());
			this.getMpe().setTxt( "并行处理报文");
			Platform.sdbInsert(this.getMpe());
		}
        /**
        *   source:dtrmod.@0038.script
        */
        public String do_B2ENotice(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *type---报文类型；
			  * b2e0019 资金主动调拨
			  * b2e0005 当日余额查询
			  * b2e0073 主动推送-余额变动信息
			  * b2e0001 签到交易
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("b2emap");
			log.debug("{}","b2emap:"+map);
			String orgnum = null;
			String subtyp = null;
			String notsta = null;
			String addinf = null;
			if(!MdaUtils.isEmpty(map.get("TRNCOD")))
			{
			  subtyp = map.get("TRNCOD").toString();//交易代码
			}
			if(!MdaUtils.isEmpty(map.get("MSGID")))
			{
			  orgnum = map.get("MSGID").toString();//原报文标识号
			}
			if(!MdaUtils.isEmpty(map.get("RSPMSG")))
			{
			  addinf = map.get("RSPMSG").toString();//业务处理信息
			}
			if(!MdaUtils.isEmpty(map.get("RSPCOD")))
			{
			  notsta = map.get("RSPCOD").toString();//业务处理状态
			}

			Argument argument = new Argument("ownref",orgnum).and("dir","<").and("msgtyp","b2e");//根据原发报报文20域，报文类型来查找原关联报文
			if(!MdaUtils.isEmpty(subtyp))
			{
			  subtyp =  subtyp.substring(4,7);
			  argument = argument.and("subtyp",subtyp);
			}
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			int errorcode = ctx.getErrorCode();
			log.debug("{}","errorcode:"+errorcode);
			if(errorcode==NO_ERROR)
			{
			  Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.debug("{}","notsta:"+notsta+"type:"+type);
			    Date processDate = new Date();
			    this.getMps().setLstdattim( processDate);
			    this.getMps().setRspdattim( processDate);
			    MdaUtils.clear(this.getMpe());
			    String isNotic = "";//处理状态
			    if("B001".equals(notsta))
			    {
			      this.getMps().setRspsta( "S");
			      this.getMpe().setTxt( "中行返回处理状态-已成功"+",处理信息:"+addinf);
			    }
			    else
			    {
			      this.getMps().setRspsta( "R");
			      this.getMpe().setTxt( "中行返回处理状态-已拒绝"+",处理信息:"+addinf);
			      MdaUtils.clear(this.getSubmps());
			      this.getSubmps().setPntinr( this.getMps().getInr());
			      this.getSubmps().setDir( this.getMps().getDir());
			      this.getSubmps().setSrcchncod( "XXX");
			      this.getSubmps().setNxtchncod( "MAN");
			      this.getSubmps().setSta( "M");
			      this.getSubmps().setRspsta( "");
			      this.getSubmps().setRcvdattim( processDate);
			      this.getSubmps().setLstdattim( processDate);
			      this.getSubmps().setSttdattim( processDate);
			      this.getSubmps().setChncod( "ZHQ");
			      Platform.sdbInsert(this.getSubmps());
			      /*新增一条mpe*/
			      this.getSubmpe().setMpsinr( this.getMps().getInr());
			      this.getSubmpe().setChncod( "ZHQ");
			      this.getSubmpe().setNxtchncod( "MAN");
			      this.getSubmpe().setSmhinr( this.getSubmps().getInr());
			      this.getSubmpe().setDattim( processDate);
			      this.getSubmpe().setPrvsta( "F");
			      this.getSubmpe().setSta( "M");
			      Platform.sdbInsert(this.getSubmpe());
			    }
			    Platform.mdbUpdate(this.getMps());
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( "ZHQ");
			    this.getMpe().setNxtchncod( "");
			    this.getMpe().setSmhinr( this.getMps().getInr());
			    this.getMpe().setDattim( processDate);
			    this.getMpe().setPrvsta( "D");
			    this.getMpe().setSta( "F");
			    Platform.sdbInsert(this.getMpe());
			    //是否通知关联系统
			    String sourceChannel = this.getMps().getSrcchncod();
			    log.debug("{}","收报源渠道："+sourceChannel);
			    return this.getMps().getSrcchncod();
			  }
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0039.script
        */
        public boolean do_B2Eref(String reference,String messageType,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","do_B2Eref");
			ctx.getErrorCode(); // 清空errorCode;
			// 收报时20域为对象参考号，发报为20域为我方参考号
			if(">".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			else if("<".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			return ctx.getErrorCode()==NO_ERROR; // 如果为零则找到相同记录，则作为疑似重复记录
					}
        /**
        *   source:dtrmod.@0040.script
        */
        public boolean do_B2Erelref(String reference,String messageType,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","do_B2Erelref");
			ctx.getErrorCode(); // 清空errorCode;
			// 收报时20域为对象参考号，发报为20域为我方参考号
			if(">".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			else if("<".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			return ctx.getErrorCode()==NO_ERROR; // 如果为零则找到相同记录，则作为疑似重复记录
					}
        /**
        *   source:dtrmod.@0042.script
        */
        public boolean do_B2ECheckBustype()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 本方法用于判断向清算发送的073报文
			  * 清算只需接收和对账两个业务类型，7516手动划拨和7501自动划拨
			  * b2e0073 主动推送-余额变动信息
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("b2emap");
			log.debug("{}","b2emap:"+map);
			String bustyp = null;
			if(!MdaUtils.isEmpty(map.get("BUSTYPE")))
			{
			  bustyp = map.get("BUSTYPE").toString();//交易代码
			  log.debug("{}","...仅7516/7501/7502两种业务类型才发往清算系统...");
			  log.debug("{}","b2e0073推送消息业务类型："+bustyp);
			}
			if(!MdaUtils.isEmpty(bustyp) && "7516|7501|7502".contains(bustyp))
			  return true;
			else
			  return false;
		}
        /**
        *   source:dtrmod.@0043.script
        */
        public boolean do_NXLref(String reference,String messageType,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","do_NXLref");
			ctx.getErrorCode(); // 清空errorCode;
			// 收报时20域为对象参考号，发报为20域为我方参考号
			if(">".equals(dir))
			  ctx.getDaoSession().dbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","sf2").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			// Platform.dbRead($mpi,new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,$smpmod\\mpi\\inr));
			else if("<".equals(dir))
			  ctx.getDaoSession().dbRead(this.getMpi(),new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","sf2").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			// Platform.dbRead($mpi,new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,$smpmod\\mpi\\inr));
			return ctx.getErrorCode()==NO_ERROR; // 如果为零则找到相同记录，则作为疑似重复记录
					}
        /**
        *   source:dtrmod.@0044.script
        */
        public boolean do_NXLrelref(String reference,String messageType,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","do_NXLrelref");
			ctx.getErrorCode(); // 清空errorCode;
			// 收报时20域为对象参考号，发报为20域为我方参考号
			if(">".equals(dir))
			  ctx.getDaoSession().dbRead(this.getMpi(),new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			else if("<".equals(dir))
			  ctx.getDaoSession().dbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","b2e").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			return ctx.getErrorCode()==NO_ERROR; // 如果为零则找到相同记录，则作为疑似重复记录
					}
        /**
        *   source:dtrmod.@0045.script
        */
        public boolean noticeToZYW(String sta,String typ)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *当收到ACK或则NCK的时候，给资金清算发送异步响应
			  */
			ctx.getErrorCode();//清除ERROR CODE
			Map<String,String> m = new HashMap<String,String>();
			String mpiinr = this.getMpi().getInr();
			String sql = "SELECT docfil,docfxt FROM smh WHERE mpiinr = ? AND docfxt = 'nxl' ";
			Argument<String> docfil = new Argument<String>("docfil");
			Argument<String> docfxt = new Argument<String>("docfxt");
			Platform.mdbExecuteSQL(sql,mpiinr);
			Platform.mdbFetchFields(docfil,docfxt);
			if(ctx.getErrorCode() == NO_ERROR)
			{
			  Platform.mdbCloseCursor();
			  String jsnpth = this.getSmpmod().getStoreFileFullPathName(docfil.value,docfxt.value);//原报路径
			  String ref20 = this.getMpi().getOwnref();//返回20域编号
			  String ref21 = this.getMpi().getOthref();
			  //20181129新增，增加发送字段：系统唯一跟踪号。并发送给资金业务
			  //20190704新增，重发报文时保证系统跟踪号变化，本例子生成系统跟踪号后同步写回MPI
			  Platform.mdbRead(this.getMpitmp(),new Argument<String>("sndnum",this.getMpi().getSndnum()),new Argument<Object>("subtyp",IN,new String[]{"ACK","NCK"}));
			  String systrackno = "99306000000"+MdaUtils.format(new Date(),"yyyyMMdd")+Platform.sdbCounter("rad","000000000000000");
			  this.getMpitmp().setSystrackn( systrackno);
			  Platform.mdbUpdate(this.getMpitmp());
			  //String seqno = $mpi\\sndnum;
			  String sndSeqNo = this.getMpi().getSrcnum();
			  log.info("{}","原资金业务流水："+sndSeqNo);
			  //  匹配秘钥20190102根据最新ESB规范更新（更新前）
			  String date = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			  String seqno = "0"+date+mpiinr;
			  m.put("SEQNO",seqno);  //流水号
			  m.put("CHANNEL_TYPE","29");      //渠道标识符
			  m.put("TRANSINST","99306000000");   //消费方
			  m.put("DESTINST","99710720001");               //提供方
			  m.put("SENDINST","99306000000");  //请求方
			  m.put("LOCALTIME",MdaUtils.format(MdaUtils.today(),"HHmmss"));
			  m.put("LOCALDATE",date);
			  m.put("CLEARDATE",Platform.getAccountDate());
			  m.put("MAC","");
			  m.put("TRADEFLAG","0");              //服务性质
			  m.put("RESPCODE","");
			  m.put("RESPINFO","");
			  m.put("VerNo","");   //版本号
			  m.put("yu21",ref21);
			  m.put("yu20",ref20);
			  m.put("subtyp",typ);
			  m.put("SYS_TRACE_NO",systrackno); //20181129新增 ：系统跟踪号
			  m.put("sndSeqNo",sndSeqNo);
			  if("1".equals(sta))
			    m.put("rspsta","ACK");
			  else
			    m.put("rspsta","NCK");

			  /// 1-SWIFT,2-CIPS,3-G渠道
			  if("sf2".equalsIgnoreCase(this.getMpi().getMsgtyp()))
			  {
			    if("SWE".equals(this.getMps().getTgtchncod()))
			    {
			      m.put("TRAN_WAY","3");
			    }
			    else
			    {
			      m.put("TRAN_WAY","1");
			    }
			  }
			  else
			  {
			    m.put("TRAN_WAY","2");
			  }

			  log.info("{}","异步返回的状态:"+sta);
			  MdaUtils.invoke("cn.com.brilliance.psbc.service.zjyw.SendServiceClient","sendACKNCK",m);//发送异步相应
			  log.debug("{}","Auto To Zqs Successed.....");
			  return true;
			}
			else
			{
			  Platform.mdbCloseCursor();
			  return false;
			}
		}
        /**
        *   source:dtrmod.@0046.script
        */
        public void save199ToGpe(String msgtyp,String gpival)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(gpival))
			  gpival = "";
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.info("{}","fileName:"+fileName);

			Map<String, String> map=(Map<String, String>)MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",fileName);
			if ("196".equals(msgtyp))
			{
			  String info76 = map.get("info76");
			  log.info("{}","info76:"+info76);
			  //第一个换行位置
			  int index = this.getLinePos(info76);
			  if (index != -1)
			  {
			    log.debug("{}","------------index----------------:"+index);
			    String msginfo = info76.substring(0, index);
			    log.info("{}","msginfo:"+msginfo);
			    String[] rspsta = msginfo.split("/");
			    int arrlen = rspsta.length;
			    this.getSmpmod().getGpe().setRspsta( rspsta[1]);
			    if(arrlen>2)
			    {
			      this.getSmpmod().getGpe().setRspcod( rspsta[2]);
			    }
			    String bic = info76.substring(index+2);
			    log.info("{}","bic:"+bic);
			    String[] strbic = bic.split("/");
			    if (strbic.length == 2)
			    {
			      log.info("{}","bic11: " + strbic[0] + "," + strbic[1]);
			      this.getSmpmod().getGpe().setOrgbic( strbic[0]);
			      this.getSmpmod().getGpe().setFwdbic( strbic[1]);
			    }
			    else
			    {
			      log.info("{}","bic12: " + bic);
			      this.getSmpmod().getGpe().setOrgbic( bic);
			    }
			  }
			  else
			  {
			    String[] rspsta = info76.split("/");
			    int arrlen = rspsta.length;
			    this.getSmpmod().getGpe().setRspsta( rspsta[1]);
			    if(arrlen > 2)
			    {
			      this.getSmpmod().getGpe().setRspcod( rspsta[2]);
			    }
			  }
			}
			else
			{
			  String addinfo = map.get("addinfo");
			  log.info("{}","addinfo:"+addinfo);
			  if("002".equals(gpival))
			  {
			    log.info("{}","处理针对192回复的199s");
			    int index = this.getLinePos(addinfo);
			    if(index > 0)
			    {
			      String frtLin = addinfo.substring(0, index);// 第一行
			      if(frtLin.startsWith("/"))
			      {
			        log.info("{}","针对192回复的199.");
			        String[] str = frtLin.split("/");
			        if (str.length == 3)
			        {
			          log.info("{}","First状态11: " + str[1] + "," + str[2]);
			          this.getSmpmod().getGpe().setRspsta( str[1]);
			          this.getSmpmod().getGpe().setRspcod( str[2]);
			        }
			        else if (str.length == 2)
			        {
			          log.info("{}","First状态21: " + str[1]);
			          this.getSmpmod().getGpe().setRspsta( str[1]);
			        }
			      }
			      String sndLin = addinfo.substring(index + 2);// 第二行
			      log.info("{}","sndline:" + sndLin);
			      String[] strbic = sndLin.split("/");
			      if (strbic.length == 2)
			      {
			        log.info("{}","Second银行12: " + strbic[0] + "," + strbic[1]);
			        this.getSmpmod().getGpe().setOrgbic( strbic[0]);
			        this.getSmpmod().getGpe().setFwdbic( strbic[1]);
			      }
			      else
			      {
			        log.info("{}","Second银行22: " + sndLin);
			        this.getSmpmod().getGpe().setOrgbic( sndLin);
			      }
			    }
			    else
			    {
			      String[] bic = addinfo.split("/");
			      if (bic.length == 3)
			      {
			        log.info("{}","First状态12: " + bic[1] + "," + bic[2]);
			        this.getSmpmod().getGpe().setRspsta( bic[1]);
			        this.getSmpmod().getGpe().setRspcod( bic[2]);
			      }
			      else if (bic.length == 2)
			      {
			        log.info("{}","First状态22: " + bic[1]);
			        this.getSmpmod().getGpe().setRspsta( bic[1]);
			      }
			    }
			  }
			  else
			  {
			    log.info("{}","处理针对103回复的199s");
			    //第一个换行位置
			    int index = this.getLinePos(addinfo);
			    log.debug("{}","------------index----------------:"+index);
			    //日期和时间,前面有
			    if(index > -1 && addinfo.startsWith("//"))
			    {
			      this.getSmpmod().getGpe().setStasndtim( MdaUtils.parseDate("20"+addinfo.substring(2,11)+"00","yyyyMMddHHmmss"));
			      log.info("{}","------------stasndtim----------------:"+this.getSmpmod().getGpe().getStasndtim());
			      //20190124新加，添加时区信息
			      this.getSmpmod().getGpe().setUtc( addinfo.substring(12,index));
			      log.info("{}","------------utc----------------:"+this.getSmpmod().getGpe().getUtc());
			    }
			    //train为从第二行开始所有内容
			    String trainfo = addinfo.substring(index+2);
			    log.info("{}","-------------trainfo-----------------:"+trainfo);

			    /*
			      //第二行状态代码+原因代码
			      if(arr[1].indexOf("/") != -1)
			      {
			      String[] rspinfo = arr[1].trim().split("/");
			      $smpmod\\gpe\\rspcod = rspinfo[1];
			      $smpmod\\gpe\\rspsta = rspinfo[0];
			      }
			      else
			      $smpmod\\gpe\\rspsta = arr[1].trim();
			      log.info("------------stacod----------------:"+$smpmod\\gpe\\rspcod.getValue());
			
			      //第三行状态发起行（BIC）+转发行（BIC）
			      if(arr[2].indexOf("/") != -1)
			      {
			      String[] bic = arr[2].trim().split("/");
			      $smpmod\\gpe\\orgbic = bic[0];
			      $smpmod\\gpe\\fwdbic = bic[1];
			      log.info("orgbic:"+$smpmod\\gpe\\rspcod.getValue()+",fwdbic:"+$smpmod\\gpe\\fwdbic.getValue());
			      }
			      else
			      {
			      $smpmod\\gpe\\orgbic=arr[2].trim();
			      log.info("orgbic:"+$smpmod\\gpe\\orgbic.getValue());
			      }
			
			      */

			    //secindex 为第二行的回车符位置
			    int secindex = this.getLinePos(trainfo);
			    if(secindex > -1 && trainfo.startsWith("//"))
			    {
			      //secline 第二行为状态码内容
			      String secline = trainfo.substring(2,secindex);
			      if(secline.indexOf("/") != -1)
			      {
			        String[] rspinfo = secline.trim().split("/");
			        this.getSmpmod().getGpe().setRspcod( rspinfo[1]);
			        this.getSmpmod().getGpe().setRspsta( rspinfo[0]);
			      }
			      else
			        this.getSmpmod().getGpe().setRspsta( secline.trim());
			      log.info("{}","------------stacod----------------:"+this.getSmpmod().getGpe().getRspcod());
			    }

			    String thirdinfo = trainfo.substring(secindex+2);//thirdinfo为第三行开始的后续内容
			    int thirdindex = this.getLinePos(thirdinfo);//thirdindex为第三行的换行符位置
			    if(thirdindex > -1 && thirdinfo.startsWith("//"))
			    {
			      //第三行状态发起行以及转发行bic信息
			      String thirdline = thirdinfo.substring(2,thirdindex);
			      if(thirdline.indexOf("/") != -1)
			      {
			        String[] arrbic = thirdline.split("/");
			        if(arrbic.length == 4)
			        {
			          //PSBCCNB0/PSBCCNB0/CLRG/FDW
			          this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			          this.getSmpmod().getGpe().setFwdbic( arrbic[1]);
			          this.getSmpmod().getGpe().setSetmth( arrbic[2]);
			          this.getSmpmod().getGpe().setClrsys( arrbic[3]);
			          log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic()+",fwdbic:"+this.getSmpmod().getGpe().getFwdbic());
			          log.info("{}","setmth:"+this.getSmpmod().getGpe().getSetmth()+",clrsys:"+this.getSmpmod().getGpe().getClrsys());
			        }
			        else if(arrbic.length == 3)
			        {
			          this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			          this.getSmpmod().getGpe().setFwdbic( arrbic[1]);
			          this.getSmpmod().getGpe().setSetmth( arrbic[2]);

			          log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic()+",fwdbic:"+this.getSmpmod().getGpe().getFwdbic());
			          log.info("{}","setmth:"+this.getSmpmod().getGpe().getSetmth());
			        }
			        else if(arrbic.length == 2)
			        {
			          this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			          this.getSmpmod().getGpe().setFwdbic( arrbic[1]);
			          log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic()+",fwdbic:"+this.getSmpmod().getGpe().getFwdbic());
			        }
			        else
			        {
			          this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			          log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic());
			        }
			      }
			      else
			      {
			        this.getSmpmod().getGpe().setOrgbic(thirdline.trim());
			        log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic());
			      }

			    }

			    String lastinfo = thirdinfo.substring(thirdindex+2);//lastinfo 为后续所有内容 因不会有‘//’这种特殊情况，不再做特殊处理
			
			    //根据//进行拆分报文内容，拆分后的内容赋值给arr数组
			    String[] arr = lastinfo.split("//");
			    int arrlegth = arr.length;
			    log.info("{}","------------arrlegth----------------:"+arrlegth);

			    //第四行货币和金额      可能会出现费用信息字段，所以需要分情况处理
			    if(arr[1].indexOf("/") != -1 )
			    {
			      String fourLine = arr[1];
			      String[] arrFourline = fourLine.split("/");
			      this.getSmpmod().getGpe().setCur( arrFourline[0].substring(0,3));
			      log.info("{}","cur:"+this.getSmpmod().getGpe().getCur());
			      this.getSmpmod().getGpe().setAmt( new BigDecimal(arrFourline[0].substring(3).replace(",",".")));
			      log.info("{}","amt:"+this.getSmpmod().getGpe().getAmt());
			    }
			    else
			    {
			      this.getSmpmod().getGpe().setCur( arr[1].substring(0,3));
			      log.info("{}","cur:"+this.getSmpmod().getGpe().getCur());
			      this.getSmpmod().getGpe().setAmt( new BigDecimal(arr[1].trim().substring(3).replace(",",".")));
			      log.info("{}","amt:"+this.getSmpmod().getGpe().getAmt());
			    }

			    //20190415涉及汇率转换 存储原始币种，转换币种，以及汇率
			    if(arrlegth > 3 && !MdaUtils.isEmpty(arr[2]) && arr[2].startsWith("EXCH") && !MdaUtils.isEmpty(arr[2]))
			    {
			      log.info("{}","beginning contains EXCH:");
			      log.info("{}",arr[3]);
			      //第五行以EXCH开头，涉及汇率转换
			      String[] arrFive = arr[3].split("/");
			      log.info("{}","arrFive length:"+arrFive.length);
			      this.getSmpmod().getGpe().setOricur( arrFive[0].substring(0,3));
			      log.info("{}","oricur:"+this.getSmpmod().getGpe().getOricur());
			      this.getSmpmod().getGpe().setExgcur( arrFive[1].substring(0,3));
			      log.info("{}","exgcur:"+this.getSmpmod().getGpe().getExgcur());
			      this.getSmpmod().getGpe().setExgrat( new BigDecimal(arrFive[2].trim().replace(",",".")));
			      log.info("{}","exgrat:"+this.getSmpmod().getGpe().getExgrat());
			    }

			    //如果有第五行的话是原始币种，格式为71F:币种，金额。只存最后一行的原始金额和币种
			    if(arrlegth > 2)
			    {
			      this.getSmpmod().getGpe().setDeucur( arr[arrlegth - 1].trim().substring(5,8));
			      log.info("{}","扣费币种："+this.getSmpmod().getGpe().getDeucur());
			      this.getSmpmod().getGpe().setDeuamt( new BigDecimal(arr[arrlegth - 1].trim().substring(8).replace(",",".")));
			      log.info("{}","扣费金额："+this.getSmpmod().getGpe().getDeuamt());
			    }

			  }
			}
			//20190108新加，添加UETR相关信息
			this.getSmpmod().getGpe().setDir( this.getSmpmod().getMpi().getDir());
			this.getSmpmod().getGpe().setSndbic( this.getSmpmod().getMpi().getSndbic());
			this.getSmpmod().getGpe().setRcvbic( this.getSmpmod().getMpi().getRcvbic());
			this.getSmpmod().getGpe().setUetr( this.getSmpmod().getMpi().getUetr());
			this.getSmpmod().getGpe().setUsrnam( MdaEnv.getLoginUser());

			//20190116新增，添加gpe的mpstim字段
			if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getDir()))
			{
			  log.debug("{}","新增，添加gpe的mpstim字段");
			  if("<".equals(this.getSmpmod().getMps().getDir()))
			    this.getSmpmod().getGpe().setMpstim(this.getSmpmod().getMps().getSnddattim());
			  else
			    this.getSmpmod().getGpe().setMpstim(this.getSmpmod().getMps().getRcvdattim());
			}
		}
        /**
        *   source:dtrmod.@0047.script
        */
        public String do_uetrfindParent(String reference, String msgtyp)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","do_uetrfindParent");
			MdaUtils.clear(this.getSmpmod().getGpe());
			MdaUtils.clear(this.getSmpmod().getMpitmp());
			MdaUtils.clear(this.getSmpmod().getMpstmp());
			MdaUtils.clear(this.getSmpmod().getSmhlst());
			MdaUtils.clear(this.getQrd());
			MdaUtils.clear(this.getChnlst());
			boolean alertsFlg = false;
			String targetChannel = "XXX";
			if (MdaUtils.isEmpty(reference))
			{
			  return targetChannel;
			}
			log.debug("{}","reference:"+reference);
			log.debug("{}","msgtyp:"+msgtyp);
			log.info("{}","mpsinr:"+this.getSmpmod().getMps().getInr());
			log.info("{}","mpiinr:"+this.getSmpmod().getMpi().getInr());
			log.info("{}","smhinr:"+this.getSmpmod().getSmh().getInr());

			Platform.esdbReadset("eibs",this.getChnlst(),0,new Argument("typ", "B"));
			ctx.getErrorCode();
			if ("192".equals(msgtyp))
			{
			  if (">".equals(this.getSmpmod().getMps().getDir()))
			  {
			    String ownref = this.getSmpmod().getMpi().getOwnref();
			    log.info("{}","ownref:" + ownref);
			    Platform.mdbRead(this.getSmpmod().getMpitmp(),new Argument("uetr", reference).and("othref", ownref).and("subtyp", "103"));
			  }
			  else
			  {
			    String othref = this.getSmpmod().getMpi().getOthref();
			    log.info("{}","othref:" + othref);
			    Platform.mdbRead(this.getSmpmod().getMpitmp(),new Argument("uetr", reference).and("ownref", othref).and("subtyp", "103"));
			  }
			  ctx.getErrorCode();

			  if (!MdaUtils.isEmpty(this.getSmpmod().getMpitmp().getInr()))
			  {
			    log.debug("{}","mpitmp inr:"+this.getSmpmod().getMpitmp().getInr());
			    Platform.mdbRead(this.getSmpmod().getMpstmp(),new Argument("inr", this.getSmpmod().getMpitmp().getInr()));
			    ctx.getErrorCode();
			    if (!MdaUtils.isEmpty(this.getSmpmod().getMpstmp().getInr()))
			    {
			      if (!MdaUtils.isEmpty(this.getSmpmod().getMpstmp().getTgtchncod()))
			      {
			        targetChannel=this.getSmpmod().getMpstmp().getTgtchncod();
			        String srcchncod=this.getSmpmod().getMpstmp().getSrcchncod();
			        //判断是否有case,有则跳过，无则需抄送到查询查复
			        Platform.mdbRead(this.getQrd(),new Argument("relref", this.getSmpmod().getSmh().getInr()));
			        ctx.getErrorCode();
			        if(("GHD".equals(targetChannel) || "GHD".equals(srcchncod)) && MdaUtils.isEmpty(this.getQrd().getCasnum()))
			          targetChannel = "QAA|" + targetChannel;
			      }
			    }
			  }
			  else
			    log.info("{}","could not uetr find parnet 103s");

			}
			else
			{
			  String[] subtyp = {"103","202","202COV","192"};
			  if (">".equals(this.getSmpmod().getMps().getDir()))
			  {
			    //20190415新加，若是TRCKCHZ0VAL或TRCKCHZZVAL，则为alerts报警报文，需分开处理-20190415
			    if(! MdaUtils.isEmpty(this.getSmpmod().getMpi().getSndbic()))
			    {
			      String sndbic = this.getSmpmod().getMpi().getSndbic();
			      log.info("{}","sndbic:"+sndbic);
			      if("TRCKCHZ0VAL".equals(sndbic) || "TRCKCHZZVAL".equals(sndbic))
			        alertsFlg = true;
			    }

			    String ownref = this.getSmpmod().getMpi().getOwnref();
			    log.info("{}","ownref:" + ownref);
			    String gpival = this.getSmpmod().getMpi().getGpival();
			    if(MdaUtils.isEmpty(gpival))
			      gpival = "";
			    else
			      gpival = gpival.trim();
			    log.info("{}","gpival:"+gpival);
			    Platform.mdbRead(this.getSmpmod().getMpitmp(),new Argument("uetr", reference).and("ownref", ownref).and("gpival", gpival).and("subtyp", IN, subtyp));
			    if("299".equals(this.getSmpmod().getMpi().getSubtyp()) && "001".equals(this.getSmpmod().getMpi().getGpival()) && !MdaUtils.isEmpty(this.getSmpmod().getMpi().getUetr()) && MdaUtils.isEmpty(this.getSmpmod().getMpitmp().getInr()))
			    {
			      log.info("{}","未收到对应202COV报文,直接查找收汇103记录");
			      ctx.getErrorCode();
			      Platform.mdbRead(this.getSmpmod().getMpitmp(),new Argument("uetr", reference).and("dir",">").and("gpival", this.getSmpmod().getMpi().getGpival().trim()).and("subtyp", IN, subtyp));
			    }
			  }
			  else
			  {
			    String othref = this.getSmpmod().getMpi().getOthref();
			    log.info("{}","othref:" + othref);
			    String gpival = this.getSmpmod().getMpi().getGpival();
			    if(MdaUtils.isEmpty(gpival))
			      gpival = "";
			    else
			      gpival = gpival.trim();
			    log.info("{}","gpival:"+gpival);
			    Platform.mdbRead(this.getSmpmod().getMpitmp(),new Argument("uetr", reference).and("othref", othref).and("gpival", gpival).and("subtyp", IN, subtyp));
			  }

			  ctx.getErrorCode();

			  log.debug("{}","mpitmp inr:"+this.getSmpmod().getMpitmp().getInr());

			  Platform.mdbRead(this.getSmpmod().getMpstmp(),new Argument("inr", this.getSmpmod().getMpitmp().getInr()));
			  ctx.getErrorCode();
			  //不必判断原103/202/202cov报文是否存在，均存储GPE表
			
			  if("<".equals(this.getSmpmod().getMps().getDir()))
			  {
			    //针对发报，判断是否存有GPE记录，有则更新，无则新增
			    Platform.mdbRead(this.getSmpmod().getGpe(),new Argument("mpsinr", this.getSmpmod().getMps().getInr()));
			    ctx.getErrorCode();

			    if(MdaUtils.isEmpty(this.getSmpmod().getGpe().getInr()))
			    {
			      if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getGpi()))
			      {
			        if(alertsFlg)
			          saveAlerts199ToGpe(msgtyp,this.getSmpmod().getMpi().getGpival());
			        else
			          save199ToGpe(msgtyp,this.getSmpmod().getMpi().getGpival());
			        this.getSmpmod().getGpe().setOrimpsinr( this.getSmpmod().getMpstmp().getInr());
			        this.getSmpmod().getGpe().setMpsinr( this.getSmpmod().getMps().getInr());
			        this.getSmpmod().getGpe().setTxt( "xxxtsk清分处理,存入gpe表");
			        this.getSmpmod().getGpe().setCredattim( MdaUtils.today());
			        this.getSmpmod().getGpe().setSubtyp( msgtyp);
			        Platform.sdbInsert(this.getSmpmod().getGpe());
			      }
			      targetChannel=this.getSmpmod().getMpstmp().getSrcchncod();
			    }
			    else
			    {
			      if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getGpi()))
			      {
			        this.getSmpmod().getGpe().setOrimpsinr( this.getSmpmod().getMpstmp().getInr());
			        this.getSmpmod().getGpe().setUpddattim( MdaUtils.today());
			        this.getSmpmod().getGpe().setTxt( this.getSmpmod().getGpe().getTxt()+",xxxtsk更新gpe表记录");
			        this.getSmpmod().getGpe().setSndbic( this.getSmpmod().getMpi().getSndbic());
			        this.getSmpmod().getGpe().setRcvbic( this.getSmpmod().getMpi().getRcvbic());
			        this.getSmpmod().getGpe().setDir( this.getSmpmod().getMps().getDir());
			        this.getSmpmod().getGpe().setUetr( this.getSmpmod().getMpi().getUetr());
			        Platform.mdbUpdate(this.getSmpmod().getGpe());
			      }
			      targetChannel = this.getSmpmod().getMpstmp().getSrcchncod();
			    }

			    if("196".equals(msgtyp) && "<".equals(this.getSmpmod().getMps().getDir()))
			    {
			      //针对回复的196进行特殊处理,20190117新加
			      log.info("{}","针对发报196报文进行特殊处理.");
			      if (!MdaUtils.isEmpty(this.getSmpmod().getMpstmp().getSrcchncod()))
			      {
			        targetChannel = this.getSmpmod().getMpstmp().getSrcchncod();
			        String tgtchncod = this.getSmpmod().getMpstmp().getTgtchncod();
			        //判断是否有case,有则跳过，无则需抄送到查询查复
			        Platform.mdbRead(this.getQrd(),new Argument("relref", this.getSmpmod().getSmh().getInr()));
			        ctx.getErrorCode();
			        if(("GHD".equals(tgtchncod) || "GHD".equals(targetChannel)) && MdaUtils.isEmpty(this.getQrd().getCasnum()) && !alertsFlg)
			          targetChannel = "QAA|" + targetChannel;
			      }
			    }
			  }
			  else
			  {
			    if(!MdaUtils.isEmpty(this.getSmpmod().getMpi().getGpi()))
			    {
			      if(alertsFlg)
			        saveAlerts199ToGpe(msgtyp,this.getSmpmod().getMpi().getGpival());
			      else
			        save199ToGpe(msgtyp,this.getSmpmod().getMpi().getGpival());
			      this.getSmpmod().getGpe().setOrimpsinr( this.getSmpmod().getMpstmp().getInr());
			      this.getSmpmod().getGpe().setMpsinr( this.getSmpmod().getMps().getInr());
			      this.getSmpmod().getGpe().setTxt( "xxxtsk清分处理,存入gpe表");
			      this.getSmpmod().getGpe().setCredattim( MdaUtils.today());
			      this.getSmpmod().getGpe().setSubtyp( msgtyp);
			      Platform.sdbInsert(this.getSmpmod().getGpe());
			    }

			    targetChannel = this.getSmpmod().getMpstmp().getSrcchncod();

			    if("199".equals(msgtyp) && ">".equals(this.getSmpmod().getMps().getDir()) && "192".equals(this.getSmpmod().getMpitmp().getSubtyp())
			      && "HWE|QAA".contains(targetChannel) && "PDCR".equals(this.getSmpmod().getGpe().getRspsta())
			    && !MdaUtils.isEmpty(this.getSmpmod().getGpe().getRspcod()) && "S000|S001|S002|S003|S004".contains(this.getSmpmod().getGpe().getRspcod()))
			    {
			      targetChannel = "GHD";
			    }

			    //299报文不抄送到查询查复，20190429修改
			    if("299".equals(this.getSmpmod().getMpi().getSubtyp()) && "001".equals(this.getSmpmod().getMpi().getGpival()) && !MdaUtils.isEmpty(this.getSmpmod().getMpi().getUetr()) && !MdaUtils.isEmpty(this.getSmpmod().getMpitmp().getInr()))
			    {
			      log.info("{}","获取收汇103记录的目标渠道");
			      targetChannel = this.getSmpmod().getMpstmp().getTgtchncod();
			      //299报文不抄送到查询查复，20190429修改
			      /*if("GHD".equals(targetChannel) && !alertsFlg )
			        targetChannel = "QAA|" + targetChannel;*/
			    }
			  }

			  //判断是否存在关联报文，设置原报文reptrksta状态，20190417修改 已上线
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMpstmp().getInr()) && ">".equals(this.getSmpmod().getMpstmp().getDir()) && "<".equals(this.getSmpmod().getMps().getDir()))
			  {
			    if("103".equals(this.getSmpmod().getMpitmp().getSubtyp()) && "199".equals(this.getSmpmod().getMpi().getSubtyp()))
			    {
			      this.getSmpmod().getMpstmp().setReptrksta( "D");
			      Platform.mdbUpdate(this.getSmpmod().getMpstmp());
			    }
			    else if("202COV".equals(this.getSmpmod().getMpitmp().getSubtyp()) && "299".equals(this.getSmpmod().getMpi().getSubtyp()))
			    {
			      this.getSmpmod().getMpstmp().setReptrksta( "D");
			      Platform.mdbUpdate(this.getSmpmod().getMpstmp());
			    }
			    else if("192".equals(this.getSmpmod().getMpitmp().getSubtyp()) && "196|199".contains(this.getSmpmod().getMpi().getSubtyp()))
			    {
			      this.getSmpmod().getMpstmp().setReptrksta( "D");
			      Platform.mdbUpdate(this.getSmpmod().getMpstmp());
			    }

			  }

			  if((!"196".equals(msgtyp) || !"002".equals(this.getSmpmod().getMpi().getGpival())) && !alertsFlg )
			  {
			    //存储更改199报文记录，记录金额、币种信息
			    this.getSmpmod().getMpi().setAmt( this.getSmpmod().getGpe().getAmt());
			    this.getSmpmod().getMpi().setCur( this.getSmpmod().getGpe().getCur());
			    Platform.mdbUpdate(this.getSmpmod().getMpi());
			  }
			}
			log.debug("{}","targetChannel1:" + targetChannel);
			if("HWE".equals(targetChannel) && !alertsFlg )
			{
			  targetChannel =  "QAA";
			}
			//20190415新加，alerts告警信息，除国结外，不进行处理
			if(!"GJS".equals(targetChannel) && alertsFlg )
			{
			  targetChannel =  "OOO";
			}

			log.debug("{}","targetChannel2:" + targetChannel);
			if("SWE".equals(targetChannel))
			  targetChannel = "SWT";

			log.debug("{}","targetChannel Final:" + targetChannel);
			return targetChannel;
		}
        /**
        *   source:dtrmod.@0048.script
        */
        public /**
*根据910报文的发报行和账户信息判断是否需要将该报文发送至资金业务渠道
*报文发报行和账号信息需要与配置文件中的发报行和账号信息完全匹配
*@param reference 20
*@param dir "<" or ">"
*@return boolean flag
*/
boolean do_exactMatchEndChannel(String reference,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			String fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			fileName = MdaUtils.catPath(fileName,"910chnactmsg.properties");
			String send_bic = null;//发报行BIC
			String account_msg = null ;//账号信息
			log.info("{}","do_exactMatchEndChannel start---->");
			boolean flag = false;
			ctx.getErrorCode();
			if(dir!=null&&dir!=""&&">".equals(dir))
			{
			  ctx.getDaoSession().dbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir));
			}
			else
			{
			  log.info("{}","报文收发方向不正确......");
			  return flag;
			}
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  send_bic = this.getMpi().getSndbic();
			  if(!MdaUtils.isEmpty(send_bic))
			  {
			    account_msg = MdaUtils.getPropertyValue(fileName,send_bic);
			    if(!MdaUtils.isEmpty(account_msg)&&account_msg.indexOf(this.getMpi().getAct())>=0)
			    {
			      flag = true ;
			      log.info("{}","账号信息匹配成功");
			    }
			    else
			    {
			      log.info("{}","加载收报行账号信息失败或配置账号信息与报文存档信息不一致！！！");
			    }
			  }
			  else
			  {
			    log.info("{}","加载报文存档信息失败！！！");
			  }
			}
			if(flag)
			{
			  log.info("{}","do start matching fields ---->");
			  Map<String,String> paramMap = new HashMap<String,String>() ;
			  String sql = "select regcol from smcreg where regsys ='ZYW' and msgdir='>' and msgTyp = '910' and recsta = '1' " ;
			  Argument<String> regcol = new Argument<String>("regcol");
			  /// 获取报文信息
			  String fullPathName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			  List<String> regList = new ArrayList<String>();
			  log.info("{}","sql : "+sql.toString());
			  Platform.mdbExecuteSQLWithDb("swd",sql.toString());
			  while(true)
			  {
			    Platform.mdbFetchFields(regcol);
			    if(ctx.getErrorCode() == NO_ERROR)
			    {
			      if(!MdaUtils.isEmpty(regcol.value))
			      {//防止因参数变化而数据库中还未加入此字段导致匹配失败
			        log.info("{}","register field: --> "+String.valueOf(regcol.value));
			        regList.add(String.valueOf(regcol.value));
			      }
			    }
			    else
			    {
			      break ;
			    }
			  }
			  Platform.mdbCloseCursor();
			  paramMap = getRegisterMsgFValues(fullPathName,regList);
			  log.info("{}","paramMap:"+paramMap);
			  log.info("{}","账号信息匹配成功,开始匹配域注册字段。do_match910PSField starting---->");
			  flag = registerFieldIntercepter("ZYW","910",">",paramMap,"AND") ;
			  if(flag)
			  {
			    log.info("{}","该910报文符合新一代注册910报文规则。");
			  }
			  else
			  {
			    log.info("{}","该910报文不符合新一代注册910报文规则，无法确定其清分最终渠道！");
			  }
			}
			return flag ;

		}
        /**
        *   source:dtrmod.@0049.script
        */
        public void saveAlerts199ToGpe(String msgtyp,String gpival)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(gpival))
			  gpival = "";
			String fileName = this.getSmpmod().getStoreFileFullPathName(this.getSmpmod().getSmh().getDocfil(),this.getSmpmod().getSmh().getDocfxt());
			log.info("{}","fileName:"+fileName);
			Map<String, String> map=(Map<String, String>)MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",fileName);
			if ("199".equals(msgtyp))
			{
			  String addinfo = map.get("addinfo");
			  log.info("{}","addinfo:"+addinfo);
			  log.info("{}","TRCKCHZZVAL/TRCKCHZ0VAL返回的的199s");
			  //第一个换行位置
			  int index = this.getLinePos(addinfo);
			  log.debug("{}","------------index----------------:"+index);
			  //日期和时间,前面有
			  if(index > -1 && addinfo.startsWith("//"))
			  {
			    this.getSmpmod().getGpe().setStasndtim( MdaUtils.parseDate("20"+addinfo.substring(2,11)+"00","yyyyMMddHHmmss"));
			    log.info("{}","------------stasndtim----------------:"+this.getSmpmod().getGpe().getStasndtim());
			    //20190124新加，添加时区信息
			    this.getSmpmod().getGpe().setUtc( addinfo.substring(12,index));
			    log.info("{}","------------utc----------------:"+this.getSmpmod().getGpe().getUtc());
			  }
			  //train为从第二行开始所有内容
			  String trainfo = addinfo.substring(index+2);
			  log.info("{}","-------------trainfo-----------------:"+trainfo);

			  //secindex 为第二行的回车符位置
			  int secindex = this.getLinePos(trainfo);
			  if(secindex > -1 && trainfo.startsWith("//"))
			  {
			    //secline 第二行为状态码内容
			    String secline = trainfo.substring(2,secindex);
			    if(secline.indexOf("/") != -1)
			    {
			      String[] rspinfo = secline.trim().split("/");
			      this.getSmpmod().getGpe().setRspcod( rspinfo[1]);
			      this.getSmpmod().getGpe().setRspsta( rspinfo[0]);
			    }
			    else
			      this.getSmpmod().getGpe().setRspsta( secline.trim());
			    log.info("{}","------------stacod----------------:"+this.getSmpmod().getGpe().getRspcod());
			  }

			  String thirdinfo = trainfo.substring(secindex+2);//thirdinfo为第三行开始的后续内容
			  int thirdindex = this.getLinePos(thirdinfo);//thirdindex为第三行的换行符位置
			  if(thirdindex > -1 && thirdinfo.startsWith("//"))
			  {
			    //第三行状态发起行以及转发行bic信息
			    String thirdline = thirdinfo.substring(2,thirdindex);
			    if(thirdline.indexOf("/") != -1)
			    {
			      String[] arrbic = thirdline.split("/");
			      if(arrbic.length == 4)
			      {
			        //PSBCCNB0/PSBCCNB0/CLRG/FDW
			        this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			        this.getSmpmod().getGpe().setFwdbic( arrbic[1]);
			        this.getSmpmod().getGpe().setSetmth( arrbic[2]);
			        this.getSmpmod().getGpe().setClrsys( arrbic[3]);
			        log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic()+",fwdbic:"+this.getSmpmod().getGpe().getFwdbic());
			        log.info("{}","setmth:"+this.getSmpmod().getGpe().getSetmth()+",clrsys:"+this.getSmpmod().getGpe().getClrsys());
			      }
			      else if(arrbic.length == 3)
			      {
			        this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			        this.getSmpmod().getGpe().setFwdbic( arrbic[1]);
			        this.getSmpmod().getGpe().setSetmth( arrbic[2]);

			        log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic()+",fwdbic:"+this.getSmpmod().getGpe().getFwdbic());
			        log.info("{}","setmth:"+this.getSmpmod().getGpe().getSetmth());
			      }
			      else if(arrbic.length == 2)
			      {
			        this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			        this.getSmpmod().getGpe().setFwdbic( arrbic[1]);
			        log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic()+",fwdbic:"+this.getSmpmod().getGpe().getFwdbic());
			      }
			      else
			      {
			        this.getSmpmod().getGpe().setOrgbic( arrbic[0]);
			        log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic());
			      }
			    }
			    else
			    {
			      this.getSmpmod().getGpe().setOrgbic(thirdline.trim());
			      log.info("{}","orgbic:"+this.getSmpmod().getGpe().getOrgbic());
			    }

			  }
			}
			//20190108新加，添加UETR相关信息
			this.getSmpmod().getGpe().setDir( this.getSmpmod().getMpi().getDir());
			this.getSmpmod().getGpe().setSndbic( this.getSmpmod().getMpi().getSndbic());
			this.getSmpmod().getGpe().setRcvbic( this.getSmpmod().getMpi().getRcvbic());
			this.getSmpmod().getGpe().setUetr( this.getSmpmod().getMpi().getUetr());
			this.getSmpmod().getGpe().setUsrnam( MdaEnv.getLoginUser());

			//20190116新增，添加gpe的mpstim字段
			if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getDir()))
			{
			  log.debug("{}","新增，添加gpe的mpstim字段");
			  if("<".equals(this.getSmpmod().getMps().getDir()))
			    this.getSmpmod().getGpe().setMpstim( this.getSmpmod().getMps().getSnddattim());
			  else
			    this.getSmpmod().getGpe().setMpstim( this.getSmpmod().getMps().getRcvdattim());
			}
		}
        /**
        *   source:dtrmod.@0050.script
        */
        public boolean delayedFor910()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getNoz());
			MdaUtils.clear(this.getNozlst());
			String mpsinr = this.getSmpmod().getMps().getInr();
			Platform.mdbReadset("swd",this.getNozlst(),new Argument<String>("mpsinr",mpsinr));
			if(this.getNozlst().size() == 0)
			{
			  String nozinr = MdaUtils.format(Platform.mdbCounter("noz"),"00000000");
			  this.getNoz().setInr( nozinr);
			  this.getNoz().setMpsinr( mpsinr);
			  this.getNoz().setXxxtsktim(MdaUtils.today());
			  this.getNoz().setSta( "W");
			  Platform.mdbInsert(this.getNoz());
			  return true;
			}
			else
			{
			  return false;
			}

		}
        /**
        *   source:dtrmod.@0051.script
        */
        public boolean checkNozFor910()
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getNoz());
			MdaUtils.clear(this.getNozlst());
			String mpsinr = this.getSmpmod().getMps().getInr();
			Platform.mdbReadset("swd",this.getNozlst(),new Argument<String>("mpsinr",mpsinr));
			if(this.getNozlst().size() == 0)
			{
			  return true;
			}
			else
			{
			  return false;
			}
		}
        /**
        *   source:dtrmod.@0052.script
        */
        public boolean do_ELCSref(String reference,String messageType,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","do_ELCSref");
			ctx.getErrorCode(); // 清空errorCode;
			// 收报时20域为对象参考号，发报为20域为我方参考号
			if(">".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("othref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","exl").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			else if("<".equals(dir))
			  Platform.mdbRead(this.getMpi(),new Argument("ownref",reference).and("dir",dir).and("subtyp",messageType).and("msgtyp","exl").and("inr",NE,this.getSmpmod().getMpi().getInr()));
			return ctx.getErrorCode()==NO_ERROR; // 如果为零则找到相同记录，则作为疑似重复记录
					}
        /**
        *   source:dtrmod.@0053.script
        */
        public String do_rtnELCSMessage(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *806 登录/退出应答
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("elcsmap");
			log.debug("{}","登录登出处理开始 elcsmap:"+map);

			Map orgmap = (Map)map.get("OrgnlGrpInf");
			String orgnum = (String)orgmap.get("OrgnlMsgId");
			log.debug("{}","elcs业务参考号："+orgnum);
			Map nwmap = (Map)map.get("LoginRspnInf");

			String cdinf = "";
			String stas = null;
			String dat = null;
			if(!MdaUtils.isEmpty(nwmap.get("ProcCd")))
			{
			  cdinf = nwmap.get("ProcCd").toString();//业务处理码
			}
			if(!MdaUtils.isEmpty(nwmap.get("RjctInf")))
			{
			  cdinf = cdinf + nwmap.get("RjctInf").toString();//业务拒绝信息
			}
			if(!MdaUtils.isEmpty(nwmap.get("PrcSts")))
			{
			  stas = nwmap.get("PrcSts").toString();//处理状态
			}
			if(!MdaUtils.isEmpty(nwmap.get("CurOrgnlSysDt")))
			  dat = nwmap.get("CurOrgnlSysDt").toString();

			MdaUtils.clear(this.getUsrtab());
			Platform.mdbRead(this.getUsrtab(),new Argument<String>("sta","00"),new Argument<String>("reqnum",orgnum),new Argument("typ","2"));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  if(stas.equals("SUCD"))
			    this.getUsrtab().setSta( "02");//审核通过
			  else if(stas.equals("RJCT"))
			    this.getUsrtab().setSta( "01");//审核失败
			  this.getUsrtab().setMancod( stas);
			  this.getUsrtab().setRspinf( cdinf);
			  if(!MdaUtils.isEmpty(dat))
			    this.getUsrtab().setCurdat( MdaUtils.parseDate(dat,"yyyyMMdd"));
			  else
			    this.getUsrtab().setCurdat( MdaUtils.today());
			  Platform.mdbUpdate(this.getUsrtab());
			}

			return "XXX";
			//return "OOO";
					}
        /**
        *   source:dtrmod.@0054.script
        */
        public String do_ELCSNotice(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *type---报文类型；
			  *104 222
			  *900:通用处理确认
			  *911 报文丢弃通知
			  *723原报文下载应答
			  *903数字证书
			  *990
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("elcsmap");
			log.debug("{}","elcsmap:"+map);

			String orgnum = null;
			String subtyp = null;
			String responeCode = null;
			String notsta = null;
			String addinf = "";
			Map<String,Object> dmap = null;
			Argument argument = new Argument("msgtyp","exl").and("dir","<");//查找原关联报文
			
			if("104|222|900".contains(type))
			{
			  dmap = (Map<String,Object>)map.get("OrgnlGrpHdr");
			  if(!MdaUtils.isEmpty(dmap.get("OrgnlMsgId")))
			    orgnum = dmap.get("OrgnlMsgId").toString();//原报文标识号
			
			  if(!MdaUtils.isEmpty(dmap.get("OrgnlMsgTp")))
			  {
			    subtyp = dmap.get("OrgnlMsgTp").toString();//原报文类型
			    subtyp = subtyp.substring(5,8);
			  }
			  if(!MdaUtils.isEmpty(dmap.get("OrgnlMT")))
			  {
			    subtyp = dmap.get("OrgnlMT").toString();//原报文类型
			    subtyp = subtyp.substring(5,8);
			  }
			}

			if("911|990".contains(type))
			{
			  if("911".equals(type))
			  {
			    dmap = (Map<String,Object>)map.get("DscrdInf");
			  }
			  else
			  {
			    dmap = (Map<String,Object>)map.get("ConfInf");
			  }
			  String snr = null;
			  Date  snddte = new Date();
			  Date snddte1 = new Date();

			  if(!MdaUtils.isEmpty(dmap.get("MsgId")))//原通讯识别号
			  {
			    orgnum = dmap.get("MsgId").toString();
			  }
			  if(!MdaUtils.isEmpty(dmap.get("OrigSndr")))
			  {
			    snr = dmap.get("OrigSndr").toString();
			  }
			  if(!MdaUtils.isEmpty(dmap.get("OrigSndDt")))
			  {
			    String snddate = dmap.get("OrigSndDt").toString();
			    snddte= MdaUtils.parseDate(snddate,"yyyyMMdd");//报文发送时间
			    snddte1 = MdaUtils.add(snddte,1);
			  }
			  if(!MdaUtils.isEmpty(dmap.get("MT")))
			  {
			    subtyp = dmap.get("MT").toString();//原报文类型
			    subtyp = subtyp.substring(5,8);
			  }
			  if(!MdaUtils.isEmpty(dmap.get("PrcCd")))
			  {
			    notsta = dmap.get("PrcCd").toString();//业务处理码
			  }
			  if(!MdaUtils.isEmpty(dmap.get("RjctInf")))
			  {
			    addinf = dmap.get("RjctInf").toString();//业务拒绝信息
			  }
			  log.debug("{}","orgnum|snr|snddte|snddte1:"+orgnum+"|"+snr+"|"+snddte+"|"+snddte1);
			  argument = argument.and("msgid",orgnum).and("sndbic",snr).and("gendat",GE,snddte).and("gendat",LT,snddte1);
			}
			else
			{
			  if("903".equals(type))
			  {
			    dmap = (Map<String,Object>)map.get("GrpHdr");

			    String creDtTm = null;
			    String instgDrctPty = null;
			    String instgPty = null;
			    String sysCd = null;
			    String chgTp = null;
			    if(!MdaUtils.isEmpty(dmap.get("MsgId")))
			    {
			      orgnum = dmap.get("MsgId").toString();
			    }
			    if(!MdaUtils.isEmpty(dmap.get("CreDtTm")))
			    {
			      creDtTm = dmap.get("CreDtTm").toString();
			    }
			    Map<String,Object> ddmap = (Map<String,Object>)dmap.get("InstgPty");
			    if(!MdaUtils.isEmpty(ddmap.get("InstgDrctPty")))
			    {
			      instgDrctPty = ddmap.get("InstgDrctPty").toString();
			    }
			    if(!MdaUtils.isEmpty(ddmap.get("InstgPty")))
			    {
			      instgPty = ddmap.get("InstgPty").toString();
			    }
			    if(!MdaUtils.isEmpty(dmap.get("SysCd")))
			    {
			      sysCd = dmap.get("SysCd").toString();
			    }

			    Map<String,Object> cmap = (Map<String,Object>)map.get("CertNtfctnInf");
			    if(!MdaUtils.isEmpty(cmap.get("ChgTp")))
			    {
			      chgTp = cmap.get("ChgTp").toString();
			    }
			    String orgstr = instgPty+orgnum+"|"+creDtTm+"|"+instgDrctPty+"|"+sysCd+"|"+chgTp+"|";
			    String signstr = (String)ctx.restoreData("signstr");
			    String result =(String)MdaUtils.invoke("com.brilliance.dzxt.framework.signature.eLCSignature","verify903",orgstr,signstr,chgTp);
			    int errorcode = ctx.getErrorCode();
			    String[] str = result.split("\\|");
			    if(str.length!=1)
			    {
			      MdaUtils.clear(this.getCetcsn());
			      if("CC00".equals(chgTp))
			      {
			        Argument<String> certdn = new Argument<String>("certdn");
			        String sql="select certdn from cetcsn where bnkcod = ? and syscd = ?";
			        Platform.mdbExecuteSQL(sql,str[1],"ELCS");
			        Platform.mdbFetchFields(certdn);
			        Platform.mdbCloseCursor();
			        if("ELCS".equals(sysCd))
			        {
			          if(certdn.value==null)
			          {
			            this.getCetcsn().setBnkcod( str[1]);
			            this.getCetcsn().setCertdn( str[2]);
			            this.getCetcsn().setCertsn( str[3]);
			            this.getCetcsn().setCertefdat( str[4]);
			            this.getCetcsn().setCertindat( str[5]);
			            this.getCetcsn().setCerbdy( str[6]);
			            this.getCetcsn().setSubtyp( "903");
			            this.getCetcsn().setCsntyp( chgTp);
			            this.getCetcsn().setGendat( new Date());

			            this.getCetcsn().setSyscd( sysCd);
			            this.getCetcsn().setFlg( "Y");
			            this.getCetcsn().setCsntyp( "CC00");
			            Platform.sdbInsert(this.getCetcsn());
			            errorcode = ctx.getErrorCode();
			            log.debug("{}",errorcode);
			            log.info("{}","错误信息："+ errorcode);
			            if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			            {
			              log.info("{}","elcs证书信息新增成功");
			            }
			            else
			            {
			              log.info("{}","elcs证书信息新增失败");
			            }
			          }
			          else
			          {
			            Platform.mdbRead(this.getCetcsn(),new Argument<String>("bnkcod",str[1]),new Argument<String>("syscd","ELCS"));
			            errorcode = ctx.getErrorCode();
			            if(errorcode == NO_ERROR )
			            {
			              this.getCetcsn().setCertdn( str[2]);
			              this.getCetcsn().setCertsn( str[3]);
			              this.getCetcsn().setCertefdat( str[4]);
			              this.getCetcsn().setCertindat( str[5]);
			              this.getCetcsn().setCerbdy( str[6]);
			              this.getCetcsn().setSubtyp( "903");
			              this.getCetcsn().setCsntyp( chgTp);
			              this.getCetcsn().setGendat( new Date());

			              this.getCetcsn().setSyscd( sysCd);
			              this.getCetcsn().setFlg( "Y");
			              this.getCetcsn().setCsntyp( "CC00");
			              Platform.mdbUpdate(this.getCetcsn());
			              errorcode = ctx.getErrorCode();
			              if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			              {
			                log.info("{}","已有elcs证书更新成功");
			              }
			              else
			              {
			                log.info("{}","已有elcs证书更新失败");
			              }
			            }
			            else
			            {
			              log.info("{}","未找到对应的银行证书信息"+str[1]);
			            }
			          }
			        }
			        else
			        {

			          sql="select certdn from cetcsn where bnkcod = ? and syscd = ?";
			          Platform.mdbExecuteSQL(sql,str[1],sysCd);
			          Platform.mdbFetchFields(certdn);
			          Platform.mdbCloseCursor();
			          if(certdn.value==null)
			          {
			            this.getCetcsn().setBnkcod( str[1]);
			            this.getCetcsn().setCertdn( str[2]);
			            this.getCetcsn().setCertsn( str[3]);
			            this.getCetcsn().setCertefdat( str[4]);
			            this.getCetcsn().setCertindat( str[5]);
			            this.getCetcsn().setCerbdy( str[6]);
			            this.getCetcsn().setSubtyp( "903");
			            this.getCetcsn().setCsntyp( chgTp);
			            this.getCetcsn().setGendat( new Date());
			            this.getCetcsn().setSyscd( sysCd);
			            this.getCetcsn().setCsntyp( "CC00");
			            Platform.sdbInsert(this.getCetcsn());
			            errorcode = ctx.getErrorCode();
			            log.debug("{}",errorcode);
			            log.info("{}","错误信息："+ errorcode);
			            if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			            {
			              log.info("{}","非elcs证书信息新增成功");
			            }
			            else
			            {
			              log.info("{}","非elcs证书信息新增失败");
			            }
			          }
			          else
			          {
			            Platform.mdbRead(this.getCetcsn(),new Argument<String>("bnkcod",str[1]),new Argument<String>("syscd",sysCd));
			            errorcode = ctx.getErrorCode();
			            if(errorcode == NO_ERROR )
			            {
			              this.getCetcsn().setCertdn( str[2]);
			              this.getCetcsn().setCertsn( str[3]);
			              this.getCetcsn().setCertefdat( str[4]);
			              this.getCetcsn().setCertindat( str[5]);
			              this.getCetcsn().setCerbdy( str[6]);
			              this.getCetcsn().setSubtyp( "903");
			              this.getCetcsn().setCsntyp( chgTp);
			              this.getCetcsn().setGendat( new Date());

			              this.getCetcsn().setSyscd( sysCd);
			              this.getCetcsn().setFlg( "Y");
			              this.getCetcsn().setCsntyp( "CC00");
			              Platform.mdbUpdate(this.getCetcsn());
			              errorcode = ctx.getErrorCode();
			              if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			              {
			                log.info("{}","已有非elcs证书更新成功");
			              }
			              else
			              {
			                log.info("{}","已有非elcs证书更新失败");
			              }
			            }
			            else
			            {
			              log.info("{}","未找到对应的银行证书信息"+str[1]);
			            }
			          }

			        }

			      }
			      else if("CC01".equals(chgTp))
			      {
			        Platform.mdbRead(this.getCetcsn(),new Argument<String>("bnkcod",str[1]),new Argument<String>("syscd","ELCS"));
			        errorcode = ctx.getErrorCode();
			        if(errorcode == NO_ERROR)
			        {
			          this.getCetcsn().setCertdn( str[2]);
			          this.getCetcsn().setCertsn( str[3]);
			          this.getCetcsn().setCertefdat( str[4]);
			          this.getCetcsn().setCertindat( str[5]);
			          this.getCetcsn().setCerbdy( str[6]);
			          this.getCetcsn().setSubtyp( "903");
			          this.getCetcsn().setCsntyp( chgTp);
			          this.getCetcsn().setGendat( new Date());
			          this.getCetcsn().setCsntyp( "CC01");
			          Platform.mdbUpdate(this.getCetcsn());
			          errorcode = ctx.getErrorCode();
			          if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			          {
			            log.info("{}","证书信息更新成功");
			          }
			          else
			          {
			            log.info("{}","证书信息更新失败");
			          }
			        }
			        else
			        {
			          log.info("{}","未找到对应的银行证书信息"+str[1]);
			        }

			      }
			      else if("CC02".equals(chgTp))
			      {
			        Platform.mdbRead(this.getCetcsn(),new Argument<String>("bnkcod",str[1]),new Argument<String>("syscd","ELCS"));
			        errorcode = ctx.getErrorCode();
			        if(errorcode == NO_ERROR )
			        {
			          if("ELCS".equals(sysCd))
			          {
			            this.getCetcsn().setFlg( "N");
			            this.getCetcsn().setCsntyp( "CC02");
			            Platform.mdbUpdate(this.getCetcsn());
			          }
			          else
			          {
			            Platform.mdbRead(this.getCetcsn(),new Argument<String>("bnkcod",str[1]));
			            errorcode = ctx.getErrorCode();
			            if(errorcode == NO_ERROR)
			            {
			              Platform.mdbDelete(this.getCetcsn());
			            }
			          }
			          errorcode = ctx.getErrorCode();
			          if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			          {
			            log.info("{}","证书解绑信息更新成功");
			          }
			          else
			          {
			            log.info("{}","证书解绑信息更新失败");
			          }
			        }
			        else
			        {
			          log.info("{}","未找到对应的银行证书信息"+str[1]);
			        }
			      }
			    }
			    else
			    {
			      MdaUtils.clear(this.getMpi());
			      Platform.mdbRead(this.getMpi(),new Argument("othref",orgnum));
			      if(ctx.getErrorCode()==NO_ERROR)
			      {
			        MdaUtils.clear(this.getMps());
			        Platform.mdbRead(this.getMps(),new Argument<String>("inr",this.getMpi().getInr()));
			        log.info("{}","mpsinr ====="+this.getMps().getInr());
			        this.getMps().setFlg( "1");
			        log.info("{}","903报文验签失败");
			        Platform.mdbUpdate(this.getMps());
			        if(ctx.getErrorCode()==NO_ERROR)
			        {
			          log.info("{}","数据库更新成功");
			        }
			        else
			        {
			          log.info("{}","数据库更新失败");
			        }
			      }
			      else
			      {
			        log.info("{}","未查到对应的mpi记录");
			      }
			    }
			  }
			  else if("900".equals(type))
			  {
			    dmap = (Map<String,Object>)map.get("CmonConfInf");
			    if(!MdaUtils.isEmpty(dmap.get("PrcSts")))
			    {
			      notsta = dmap.get("PrcSts").toString();//业务处理码
			    }
			    if(!MdaUtils.isEmpty(dmap.get("PrcCd")))
			    {
			      addinf = dmap.get("PrcCd").toString();//业务拒绝信息
			    }
			    if(!MdaUtils.isEmpty(dmap.get("RjctInf")))
			    {
			      addinf = addinf + dmap.get("RjctInf").toString();//业务拒绝信息
			    }

			  }
			  else if("723".equals(type))
			  {
			    dmap = (Map<String,Object>)map.get("DplctDtls");
			    if(!MdaUtils.isEmpty(dmap.get("OrgnlMsgPrcSts")))
			      notsta = dmap.get("OrgnlMsgPrcSts").toString();//原报文处理状态
			
			    if(!MdaUtils.isEmpty(dmap.get("OrgnlMsgId")))
			      orgnum = dmap.get("OrgnlMsgId").toString();//原报文标识号
			
			    if(!MdaUtils.isEmpty(dmap.get("OrgnlMsgTp")))
			    {
			      subtyp = dmap.get("OrgnlMsgTp").toString();//原报文类型
			      subtyp = subtyp.substring(5,8);
			    }
			  }
			  else if("104".equals(type))
			  {

			    dmap = (Map<String,Object>)map.get("ModConfInfo");

			    if(!MdaUtils.isEmpty(dmap.get("ModfyStat")))
			    {
			      notsta = dmap.get("ModfyStat").toString();//修改状态
			    }
			    if(!MdaUtils.isEmpty(dmap.get("Rsn")))
			    {
			      addinf = dmap.get("Rsn").toString();//理由
			    }
			  }
			  else if("222".equals(type))
			  {
			    dmap = (Map<String,Object>)map.get("PmtRslt");

			    if(!MdaUtils.isEmpty(dmap.get("StsCd")))
			    {
			      notsta = dmap.get("StsCd").toString();//清算状态   取值，文档中没有提到 ，测试注意
			    }
			    if(!MdaUtils.isEmpty(dmap.get("Desc")))
			    {
			      addinf = dmap.get("Desc").toString();//处理信息
			    }
			  }
			  log.debug("{}","orgnum"+orgnum);
			  argument = argument.and("ownref",orgnum);
			}
			log.debug("{}","subtyp+notsta+addinf:"+subtyp+"|"+notsta+"|"+addinf);

			if(!MdaUtils.isEmpty(subtyp))
			{
			  argument = argument.and("subtyp",subtyp);
			}
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			int errorcode = ctx.getErrorCode();
			log.debug("{}","errorcode:"+errorcode);
			if(errorcode==NO_ERROR)
			{
			  if("903".equals(this.getMpi().getSubtyp()))//数字证书绑定通知
			  {
			    MdaUtils.clear(this.getCetcsn());
			    Platform.mdbRead(this.getCetcsn(),new Argument<String>("relinr",this.getMpi().getInr()));
			    errorcode = ctx.getErrorCode();
			    if(errorcode == NO_ERROR || errorcode == NO_MORE_ROW )
			    {
			      this.getCetcsn().setSta( "02");//审核通过
			      Platform.mdbUpdate(this.getCetcsn());
			    }
			  }
			  Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			  if(ctx.getErrorCode()==NO_ERROR)
			  {
			    log.debug("{}","notsta|type|rspsta:"+notsta+type+this.getMps().getRspsta());
			    Date processDate = new Date();
			    this.getMps().setLstdattim( processDate);
			    this.getMps().setRspdattim( processDate);
			    MdaUtils.clear(this.getMpe());
			    if("990".equals(type)&&"W".equals(this.getMps().getRspsta()))
			    {
			      this.getMps().setRspsta( "P");
			      this.getMpe().setTxt( "成功发往PMTS-MBFE");
			    }
			    if("911".equals(type))
			    {
			      this.getMps().setRspsta( "G");
			      this.getMpe().setTxt( "人行已丢弃该笔报文");
			    }

			    if("RJCT".equals(notsta))
			    {
			      this.getMps().setRspsta( "R");
			      this.getMpe().setTxt( "人行返回处理状态-已拒绝"+",处理信息:"+addinf);
			    }
			    else if("PDNG".equals(notsta))
			    {
			      this.getMps().setRspsta( "Q");
			      this.getMpe().setTxt( "人行返回处理状态-结算排队");
			    }
			    else if("ACSC".equals(notsta))
			    {
			      this.getMps().setRspsta( "3");
			      this.getMpe().setTxt( "人行返回处理状态-已请算");
			    }
			    else if("EDRN".equals(notsta))
			    {
			      this.getMps().setRspsta( "T");
			      this.getMpe().setTxt( "人行返回处理状态-日终退回");
			    }
			    else if("SUCD".equals(notsta))
			    {
			      this.getMps().setRspsta( "S");
			      this.getMpe().setTxt( "人行返回处理状态-已成功");
			    }
			    else if("ACSP".equals(notsta))
			    {
			      this.getMps().setRspsta( "X");
			      this.getMpe().setTxt( "人行返回处理状态-待清算");
			    }
			    else if("ACPT".equals(notsta))
			    {
			      this.getMps().setRspsta( "Y");
			      this.getMpe().setTxt( "人行返回处理状态-已同意");
			    }

			    else if("PR09".equals(notsta))
			    {
			      this.getMps().setRspsta( "R");
			      this.getMpe().setTxt( "人行返回处理状态-已拒绝"+",处理信息:"+addinf);
			    }
			    else if("PR00".equals(notsta))
			    {
			      this.getMps().setRspsta( "8");
			      this.getMpe().setTxt( "人行返回处理状态-已转发");
			    }
			    else if("PR01".equals(notsta))
			    {
			      this.getMps().setRspsta( "r");
			      this.getMpe().setTxt( "人行返回处理状态-待认证");
			    }
			    else if("PR02".equals(notsta))
			    {
			      this.getMps().setRspsta( "F");
			      this.getMpe().setTxt( "人行返回处理状态-已付款");
			    }
			    else if("PR03".equals(notsta))
			    {
			      this.getMps().setRspsta( "9");
			      this.getMpe().setTxt( "人行返回处理状态-已轧差");
			    }
			    else if("PR04".equals(notsta))
			    {
			      this.getMps().setRspsta( "3");
			      this.getMpe().setTxt( "人行返回处理状态-已清算");
			    }
			    else if("PR05".equals(notsta))
			    {
			      this.getMps().setRspsta( "S");
			      this.getMpe().setTxt( "人行返回处理状态-已成功");
			    }
			    else if("PR06".equals(notsta))
			    {
			      this.getMps().setRspsta( "Z");
			      this.getMpe().setTxt( "人行返回处理状态-待处理");
			    }
			    else if("PR07".equals(notsta))
			    {
			      this.getMps().setRspsta( "D");
			      this.getMpe().setTxt( "人行返回处理状态-已处理");
			    }
			    else if("PR08".equals(notsta))
			    {
			      this.getMps().setRspsta( "5");
			      this.getMpe().setTxt( "人行返回处理状态-已撤销");
			    }
			    else if("PR10".equals(notsta))
			    {
			      this.getMps().setRspsta( "a");
			      this.getMpe().setTxt( "人行返回处理状态-已确认");
			    }
			    else if("PR11".equals(notsta))
			    {
			      this.getMps().setRspsta( "B");
			      this.getMpe().setTxt( "人行返回处理状态-轧差排队");
			    }
			    else if("PR12".equals(notsta))
			    {
			      this.getMps().setRspsta( "H");
			      this.getMpe().setTxt( "人行返回处理状态-清算排队");
			    }
			    else if("PR13".equals(notsta))
			    {
			      this.getMps().setRspsta( "b");
			      this.getMpe().setTxt( "人行返回处理状态-清算异常，待重新清算");
			    }
			    else if("PR16".equals(notsta))
			    {
			      this.getMps().setRspsta( "I");
			      this.getMpe().setTxt( "人行返回处理状态-已冻结待清算");
			    }
			    else if("PR17".equals(notsta))
			    {
			      this.getMps().setRspsta( "J");
			      this.getMpe().setTxt( "人行返回处理状态-已划回");
			    }
			    else if("PR18".equals(notsta))
			    {
			      this.getMps().setRspsta( "4");
			      this.getMpe().setTxt( "人行返回处理状态-已退回");
			    }
			    else if("PR21".equals(notsta))
			    {
			      this.getMps().setRspsta( "K");
			      this.getMpe().setTxt( "人行返回处理状态-已止付");
			    }
			    else if("PR22".equals(notsta))
			    {
			      this.getMps().setRspsta( "M");
			      this.getMpe().setTxt( "人行返回处理状态-已冲正");
			    }
			    else if("PR23".equals(notsta))
			    {
			      this.getMps().setRspsta( "n");
			      this.getMpe().setTxt( "人行返回处理状态-已整包退回");
			    }
			    else if("PR24".equals(notsta))
			    {
			      this.getMps().setRspsta( "O");
			      this.getMpe().setTxt( "人行返回处理状态-NPC未受理");
			    }
			    else if("PR25".equals(notsta))
			    {
			      this.getMps().setRspsta( "V");
			      this.getMpe().setTxt( "人行返回处理状态-已部分退回");
			    }
			    else if("PR32".equals(notsta))
			    {
			      this.getMps().setRspsta( "U");
			      this.getMpe().setTxt( "人行返回处理状态-已超期（逾期退回）");
			    }

			    else
			    {
			      this.getMpe().setTxt( "处理信息:"+addinf);
			      MdaUtils.clear(this.getSubmps());
			      this.getSubmps().setPntinr( this.getMps().getInr());
			      this.getSubmps().setDir( this.getMps().getDir());
			      this.getSubmps().setSrcchncod( "XXX");
			      this.getSubmps().setNxtchncod( "MAN");
			      this.getSubmps().setSta( "M");
			      this.getSubmps().setRspsta( "");
			      this.getSubmps().setRcvdattim( processDate);
			      this.getSubmps().setLstdattim( processDate);
			      this.getSubmps().setSttdattim( processDate);
			      this.getSubmps().setChncod( "ELS");
			      Platform.sdbInsert(this.getSubmps());
			      /*新增一条mpe*/
			      this.getSubmpe().setMpsinr( this.getMps().getInr());
			      this.getSubmpe().setChncod( "ELS");
			      this.getSubmpe().setNxtchncod( "MAN");
			      this.getSubmpe().setSmhinr( this.getSubmps().getInr());
			      this.getSubmpe().setDattim( processDate);
			      this.getSubmpe().setPrvsta( "F");
			      this.getSubmpe().setSta( "M");
			      Platform.sdbInsert(this.getSubmpe());
			    }
			    Platform.mdbUpdate(this.getMps());
			    this.getMpe().setMpsinr( this.getMps().getInr());
			    this.getMpe().setChncod( "ELS");
			    this.getMpe().setNxtchncod( "");
			    this.getMpe().setSmhinr( this.getMps().getInr());
			    this.getMpe().setDattim( processDate);
			    this.getMpe().setPrvsta( "D");
			    this.getMpe().setSta( "F");
			    Platform.sdbInsert(this.getMpe());
			    if("723".equals(type))
			      return "GJS";
			    if("990".equals(type))
			      return "OOO";

			    log.debug("{}","收报源渠道："+this.getMps().getSrcchncod());
			    return this.getMps().getSrcchncod();

			  }
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0055.script
        */
        public String do_instFxebnkMsg(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("elcsmap");
			log.debug("{}","行名行号处理开始 elcsmap:"+map);

			Map nbmap=(Map)map.get("NbInf");
			String bic = null;
			String chgterm=nbmap.get("ChngNb").toString();//变更期数
			if(!MdaUtils.isEmpty(map.get("ChngInf")))
			{
			  List< Map<String,Object> > lst = (List< Map<String,Object> >)map.get("ChngInf");
			  for(int i=0;i<lst.size();i++)
			  {
			    MdaUtils.clear(this.getFxebnk());
			    Map<String,Object> submap = (Map<String,Object>)lst.get(i);
			    Map chgmap=(Map)submap.get("ChngCtrl");
			    if(!MdaUtils.isEmpty(chgmap.get("ChngTp")))
			      this.getFxebnk().setChngtp( chgmap.get("ChngTp").toString());
			    if(!MdaUtils.isEmpty(chgmap.get("FctvTp")))
			      this.getFxebnk().setFctvtp( chgmap.get("FctvTp").toString());
			    if(!MdaUtils.isEmpty(chgmap.get("FctvDt")))
			    {
			      String begdat = chgmap.get("FctvDt").toString();
			      this.getFxebnk().setBegdat( MdaUtils.parseDate(begdat,"yyyyMMdd"));
			    }
			    if(!MdaUtils.isEmpty(chgmap.get("IfctvDt")))
			    {
			      String losdat = chgmap.get("IfctvDt").toString();
			      this.getFxebnk().setLosdat( MdaUtils.parseDate(losdat,"yyyyMMdd"));
			    }
			    if(!MdaUtils.isEmpty(submap.get("BkCd")))
			    {
			      bic = submap.get("BkCd").toString();
			      this.getFxebnk().setBic( bic);
			    }
			    if(!MdaUtils.isEmpty(submap.get("PtcptTp")))
			      this.getFxebnk().setBnktyp( submap.get("PtcptTp").toString());
			    if(!MdaUtils.isEmpty(submap.get("BkCtgyCd")))
			      this.getFxebnk().setHbcod( submap.get("BkCtgyCd").toString());
			    if(!MdaUtils.isEmpty(submap.get("DrctBkCd")))
			      this.getFxebnk().setDirectbic( submap.get("DrctBkCd").toString());
			    if(!MdaUtils.isEmpty(submap.get("LglPrsn")))
			      this.getFxebnk().setLglpsn( submap.get("LglPrsn").toString());
			    if(!MdaUtils.isEmpty(submap.get("NdCd")))
			      this.getFxebnk().setNdcd( submap.get("NdCd").toString());
			    if(!MdaUtils.isEmpty(submap.get("CityCd")))
			      this.getFxebnk().setCitycod( submap.get("CityCd").toString());
			    if(!MdaUtils.isEmpty(submap.get("PtcptNm")))
			      this.getFxebnk().setFulnam( submap.get("PtcptNm").toString());

			    String sgn = "";
			    if(!MdaUtils.isEmpty(submap.get("Sgn")))
			      sgn = submap.get("Sgn").toString();

			    if("1".equals(sgn))
			      this.getFxebnk().setSgn( "加入");
			    else if("0".equals(sgn))
			      this.getFxebnk().setSgn( "未加入");
			    if(!MdaUtils.isEmpty(submap.get("HghPtcpt")))
			      this.getFxebnk().setHbcod( submap.get("HghPtcpt").toString());
			    if(!MdaUtils.isEmpty(submap.get("BrBkCd")))
			      this.getFxebnk().setBrbkcd( submap.get("BrBkCd").toString());
			    if(!MdaUtils.isEmpty(submap.get("ChrgBkCd")))
			      this.getFxebnk().setChrcd( submap.get("ChrgBkCd").toString());

			    Platform.mdbRead(this.getFxebnk(),new Argument<String>("bic",bic));
			    if(ctx.getErrorCode()==NO_ERROR)
			    {
			      log.debug("{}","更新fxebnk信息...");
			      Platform.mdbUpdate(this.getFxebnk());
			    }
			    else
			    {
			      log.debug("{}","新增fxebnk信息...");
			      Platform.sdbInsert(this.getFxebnk());
			    }

			  }
			}
			return "XXX";
		}
        /**
        *   source:dtrmod.@0056.script
        */
        public String do_instElctimMsg(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getElctim());
			Map<String,Object> elcmap = (Map<String,Object>)ctx.restoreData("elcsmap");
			log.debug("{}","系统状态变更处理开始 elcsmap:"+elcmap);
			String time=null;

			Map map=(Map)elcmap.get("SysStsInf");
			String orgsysdat=map.get("OrgnlSysDt").toString();
			time = orgsysdat.replace("-","");
			log.info("{}","orgsysdat time :"+time);
			this.getElctim().setOrgsysdt(  MdaUtils.parseDate(time,"yyyyMMdd"));//原系统日期
			
			if(!MdaUtils.isEmpty(map.get("OrgnlSysSts")))
			  this.getElctim().setOrgsyssta( map.get("OrgnlSysSts").toString());//原系统状态
			
			if(!MdaUtils.isEmpty(map.get("CurSysDt")))
			{
			  String cursysdat = map.get("CurSysDt").toString();
			  time = cursysdat.replace("-","");
			  log.info("{}","cursysdat time :"+time);
			  this.getElctim().setSysdt( MdaUtils.parseDate(time,"yyyyMMdd"));//系统当前日期
			}
			if(!MdaUtils.isEmpty(map.get("CurSysSts")))
			  this.getElctim().setSyssta( map.get("CurSysSts").toString());//系统当前状态
			
			if(!MdaUtils.isEmpty(map.get("OnLnSwitch")))
			{
			  this.getElctim().setOnlnsta( map.get("OnLnSwitch").toString());//线上清算开关
			}
			log.info("{}","elctim onlnsta :"+this.getElctim().getOnlnsta());

			if(!MdaUtils.isEmpty(map.get("BkChngNb")))
			{
			  this.getElctim().setBkchnnb( map.get("BkChngNb").toString());//行名行号变更期数
			}
			if(!MdaUtils.isEmpty(map.get("ParamChngNb")))
			{
			  this.getElctim().setParchnnb( map.get("ParamChngNb").toString());//系统参数变更期数
			}

			Map hmap=(Map)elcmap.get("GrpHdr");
			if(!MdaUtils.isEmpty(hmap.get("Rmk")))
			  this.getElctim().setRmk( hmap.get("Rmk").toString());
			log.info("{}","elctim rmk :"+this.getElctim().getRmk());

			log.info("{}","CreDtTm :"+hmap.get("CreDtTm").toString());
			if(!MdaUtils.isEmpty(hmap.get("CreDtTm")))
			{
			  String sndtim = hmap.get("CreDtTm").toString();
			  String tim1 = sndtim.replace("T","");
			  String tim2 = tim1.replace("-","");
			  String tim3 = tim2.replace(":","");
			  log.info("{}","sndtim :"+sndtim);
			  this.getElctim().setOrgsystm( MdaUtils.parseDate(tim3,"yyyyMMddHHmmss"));//报文发送时间
			}
			log.info("{}","elctim orgsystm :"+this.getElctim().getOrgsystm());

			log.debug("{}","新增elctim信息...");
			Platform.sdbInsert(this.getElctim());
			log.debug("{}","errorcode:"+ctx.getErrorCode());

			return "XXX";
		}
        /**
        *   source:dtrmod.@0057.script
        */
        public /**
* <p>该方法目前用于新一代资金业务系统910报文过滤</p>
* <p>方法支持扩展至任何系统注册域字段过滤，方法针对传入参数regCol进行查询表中规则</p>
* <p>注：该方法只支持部分业务需求，如需特殊处理逻辑，则可能本方法不再适用</p>
* <p>根据系统注册规则返回过滤后的结果</p>
* @param sysCod  : 注册系统码
* @param msgTyp  : 报文类型
* @param fieMap  : 报文域字段和值
* @param msgDir  : 报文方向
* @param operator :匹配类型 分为批量匹配和单记录匹配。批量匹配类型分为：ADN/OR;单记录匹配类型为：null
* @return 报文域中值符合注册信息返回true , 否则返回false
*/
boolean  registerFieldIntercepter(String sysCod,String msgTyp,String msgDir , Map<String,String> fieMap ,String operator)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			if(MdaUtils.isEmpty(sysCod))
			{
			  log.info("{}","注册系统不能为空！");
			  return false;
			}
			if(MdaUtils.isEmpty(msgDir))
			{
			  log.info("{}","系统注册报文收发方向不能为空！");
			  return false;
			}
			if(MdaUtils.isEmpty(fieMap))
			{
			  log.info("{}","待匹配注册字段字段为空，立即返回！");
			  return false;
			}
			/* if(Platform.isEmpty(operator))
			  {
			  //作为默认操作符，但默认情况可能造成判断结果不准确
			  log.info("当前 operator 为空,operator 分为两种情况，当 'operator ==  OR' 表示多条规则仅一条符合即可; 当 'operator ==  AND' 时，表示多条规则必须同时符合，默认情况下'OR'.");
			  return false;
			  }
			  */
			log.info("{}","注册系统："+sysCod+" 注册报文类型："+msgTyp+" 注册报文方向："+msgDir+" 待校验报文域对应值："+fieMap+" 待校验报文域关系："+operator);
			StringBuffer sql = new StringBuffer("select regcol,regval,ctrkey from smcreg where recsta = '1' and regsys = '").append(sysCod).append("' and").append(" msgdir='").append(msgDir).append("'");
			if(!MdaUtils.isEmpty(msgTyp))
			{
			  /**确定报文类型：MT910  ； 对所有报文类型有效：ALL**/
			  sql.append(" and msgtyp = '").append(msgTyp).append("'");
			}
			Argument<String> regcol = new Argument<String>("regcol");
			Argument<String> regval = new Argument<String>("regval");
			Argument<String> ctrkey = new Argument<String>("ctrkey");
			Map<String,Map<String,String> > regModel = new HashMap<String,Map<String,String> >();
			log.info("{}","sql : "+sql.toString());
			Platform.mdbExecuteSQLWithDb("swd",sql.toString());
			boolean result = true;
			while(true)
			{
			  Platform.mdbFetchFields(regcol,regval,ctrkey);
			  Map<String,String> regRecord = new HashMap<String,String>();
			  if(ctx.getErrorCode() == NO_ERROR)
			  {
			    /**将注册信息加入列表**/
			    if(!MdaUtils.isEmpty(regcol.value))
			    {
			      regRecord.put("ctrkey",String.valueOf(ctrkey.value));
			      regRecord.put("regval",String.valueOf(regval.value));
			      regModel.put(String.valueOf(regcol.value),regRecord);
			    }
			  }
			  else
			  {
			    break;
			  }
			}
			Platform.mdbCloseCursor();
			/*开始匹配注册信息**/
			int     compCounter = 0 ;   			//比较计数器
			int     noMatchKeyCounter = 0 ;    //无注册信息对应key匹配计数器
			log.info("{}","regModel size：" +regModel.size()+" regModel content:"+regModel);
			for(Map.Entry<String,String> entry : fieMap.entrySet())
			{
			  log.info("{}","begin matching. match field is  "+entry.getKey()+" register model is containsKey result : "+ regModel.containsKey(entry.getKey()));
			  if(regModel.containsKey(entry.getKey()))
			  {
			    boolean compResult = false;   //记录比较结果
			    log.info("{}","begin matching operator.");
			    /**数据库中存在注册规则**/
			    Map<String,String> regRecord = regModel.get(entry.getKey()) ;
			    log.info("{}","begin matching ctrkey. current matching ctrkey is  "+regRecord.get("ctrkey"));
			    if("1".equals(regRecord.get("ctrkey")))
			    {//in
			      log.info("{}","报文"+entry.getKey().substring(1)+"域字段值中需出现与"+regRecord.get("regval")+"以“|”分隔开的任意一条规则相匹配的值");
			      String[] records = String.valueOf(regRecord.get("regval")).split("\\|");//获取注册的域字段信息，可能为多条，可能为一条，以“|”分隔
			      //匹配单条注册规则   注册规则 只能出现in 和  not in两种情况，分别使用 1==in和0==not in来进行处理。当符合该记录注册规则时应返回true,不符合时应返回false。等待后续处理
			      for(int i = 0 ;i < records.length ; i++)
			      {
			        log.info("{}","当前报文域字段值："+entry.getValue()+" 与注册报文域值 ："+records[i]+" 开始进行比对。待比对总数为  "+records.length+" 次，正在比较第 "+ (i+1) +" 次");
			        if((entry.getValue().replaceAll(" ","").replaceAll("\r\n","")).indexOf(records[i].replaceAll(" ","").replaceAll("\r\n","")) >= 0 )//防止因空格 回车造成比较结果不准确
			        {
			          //存在任意一条符合的注册规则，则跳出循环，进行下一个域字段判断
			          compResult = true ;
			          break ;
			        }
			      }
			      log.info("{}"," 报文域字段域注册域字段比较结果为："+compResult);
			    }
			    else
			    {//not in
			      log.info("{}","报文"+entry.getKey().substring(1)+"域字段值中不能出现与"+regRecord.get("regval")+"以“|”分隔开的任意一条规则相匹配的值");
			      String[] records = String.valueOf(regRecord.get("regval")).split("\\|");
			      for(int i = 0 ;i < records.length ; i++)
			      {
			        log.info("{}","当前报文域字段值："+entry.getValue()+" 与注册报文域值 ："+records[i]+" 开始进行比对。待比对总数为  "+records.length+" 次，正在比较第 "+ (i+1) +" 次");
			        if((entry.getValue().replaceAll(" ","").replaceAll("\r\n","")).indexOf(records[i].replaceAll(" ","").replaceAll("\r\n","")) < 0)//防止因空格 回车造成比较结果不准确
			        {
			          //存在任意一条符合的注册规则，则比较下一条，直至所有符合所有注册信息
			          compResult = true ;
			          continue;
			        }
			        else
			        {
			          compResult = false ;
			          break ;
			        }
			      }
			      log.info("{}"," 当前报文域字段与该字段注册规则比较结果为："+compResult);
			    }
			    //匹配操作符  用于判断匹配类型属于批量匹配还是单记录匹配，当operator==null时为单条匹配，当operator==and时为批量需同时成立匹配类型，当operator==or时为批量仅一条成立即可匹配类型
			    //单字段校验注册类型
			    if(compResult && null==operator )
			    {
			      result = true;
			      break ;
			    }
			    if(!compResult && null==operator )
			    {

			      result = false;
			      break ;
			    }
			    //多字段校验，并且需要同时成立  e.g:报文20域  21域应同时符合条件时应使用该操作符
			    if(!compResult && "AND".equals(operator))
			    {
			      result = false;
			      break ;
			    }
			    if(compResult && "AND".equals(operator))
			    {
			      compCounter++ ;			 //增加计数器
			      compResult = false ;//重置比较结果
			      continue ;
			    }
			    //多字段校验，任意一条符合条件即可  e.g:报文52域  72任意一条符合注册值即可
			    if(!compResult && "OR".equals(operator))
			    {
			      compCounter++ ;
			      continue ;
			    }
			    if(compResult && "OR".equals(operator))
			    {//特殊 : 50A 50k 50Z  出现任意一次情况
			      result = true;
			      break ;
			    }
			  }
			  else
			  {
			    /**当前情况可能出现在非动态 匹配时由于编码人员将过期或已删除的字段加入匹配参数中出现**/
			    log.info("{}","域字段"+entry.getKey()+"无注册规则信息信息或规则已被停用");
			    noMatchKeyCounter++ ;
			    compCounter++ ;
			  }
			}
			//校验传入记录是否有不存在注册字段情况  用于删除后或不知道该记录规则是否可用状态保证正确性
			//循环结束
			//特殊情况：当前注册类型中不包括待校验域字段，应使用noMatchKeyCounter作为判断标准。该情况应返回true
			if(noMatchKeyCounter == fieMap.size())
			{
			  return true ;
			}
			if(compCounter == fieMap.size() && operator == "AND")
			{//在AND操作符下全部满足条件
			  return true ;
			}
			if(compCounter == fieMap.size() && operator == "OR")
			{//在or操作符下全部不满足条件
			  return false ;
			}
			return result ;
		}
        /**
        *   source:dtrmod.@0058.script
        */
        public Map<String, String> getRegisterMsgFValues(String fullFilePath, List<String> regFieldList)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			Map<String, String> paramMap = new HashMap();
			Map<String, String> map;
			if ((!MdaUtils.isEmpty(fullFilePath)) && (!MdaUtils.isEmpty(regFieldList)))
			{
			  Object object = MdaUtils.invoke("com.brilliance.swift.MessageReader","getSwfMsgInfo",new Object[] { fullFilePath });
			  if ((object != null) && ((object instanceof Map)))
			  {
			    map = (Map)object;
			    for (String element : regFieldList)
			    {
			      if (!MdaUtils.isEmpty(map.get(element)))
			      {
			        paramMap.put(element, map.get(element));
			      }
			    }
			  }
			}
			return paramMap;
		}
        /**
        *   source:dtrmod.@0059.script
        */
        public /*
* 检测来报320币种  当来报320币种为CNY时不应清分报文到新一代，否则清分报文到新一代
*/
boolean  do_check320Cur(String ref , String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			boolean flag = false;
			ctx.getErrorCode();
			if(dir!=null&&dir!=""&&">".equals(dir))
			{
			  ctx.getDaoSession().dbRead(this.getMpi(),new Argument("othref",ref).and("dir",dir));
			  if("CNY".equals(String.valueOf(this.getMpi().getCur()).trim()))
			  {
			    flag = true ;
			  }
			}
			else
			{
			  flag = true ;
			  log.info("{}","报文收发方向不正确......");
			}

			return flag ;
		}
        /**
        *   source:dtrmod.@0060.script
        */
        public boolean  updateRelMsgStatus(String type,String orgnum, String notsta,String addinf)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			//根据原发报报文20域，报文类型来查找原关联报文,更新原记录回执状态
			Argument argument = new Argument("ownref",orgnum).and("dir","<");
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  Date processDate = new Date();
			  this.getMps().setLstdattim( processDate);
			  this.getMps().setRspdattim( processDate);
			  MdaUtils.clear(this.getMpe());
			  if("RJCT".equals(notsta))
			  {
			    this.getMps().setRspsta( "R");
			    this.getMpe().setTxt( "人行返回处理状态-已拒绝"+",处理信息:"+addinf);
			  }
			  else if("PDNG".equals(notsta))
			  {
			    this.getMps().setRspsta( "Q");
			    this.getMpe().setTxt( "人行返回处理状态-结算排队");
			  }
			  else if("ACSC".equals(notsta))
			  {
			    this.getMps().setRspsta( "C");
			    this.getMpe().setTxt( "人行返回处理状态-已结算");
			  }
			  else if("EDRN".equals(notsta))
			  {
			    this.getMps().setRspsta( "T");
			    this.getMpe().setTxt( "人行返回处理状态-日终退回");
			  }
			  else if("304".equals(type)&& "SUCD".equals(notsta))
			  {
			    this.getMps().setRspsta( "5");
			    this.getMpe().setTxt( "人行返回处理状态-已撤销");
			    //isNotic = "0";
			  }
			  else if((!"304".equals(type))&&"SUCD".equals(notsta))
			  {
			    this.getMps().setRspsta( "S");
			    this.getMpe().setTxt( "人行返回处理状态-已成功");
			  }
			  else if("FRWD".equals(notsta))
			  {
			    this.getMps().setRspsta( "8");
			    this.getMpe().setTxt( "人行返回处理状态-已转发");
			  }
			  else if ("RSVL".equals(notsta))
			  {
			    this.getMps().setRspsta( "D");
			    this.getMpe().setTxt( "人行返回处理状态-已处理");
			  }
			  else if ("DIUQI".equals(notsta))
			  {
			    this.getMps().setRspsta( "G");
			    this.getMpe().setTxt( "人行已丢弃该笔报文");
			  }
			  else if ("CAND".equals(notsta))
			  {
			    this.getMps().setRspsta( "5");
			    this.getMpe().setTxt( "人行返回处理状态-已撤销");
			  }
			  Platform.mdbUpdate(this.getMps());
			  this.getMpe().setMpsinr( this.getMps().getInr());
			  this.getMpe().setChncod( "CPS");
			  this.getMpe().setNxtchncod( "");
			  this.getMpe().setSmhinr( this.getMps().getInr());
			  this.getMpe().setDattim( processDate);
			  this.getMpe().setPrvsta( "D");
			  this.getMpe().setSta( "F");
			  Platform.sdbInsert(this.getMpe());
			}
			return true;
		}
        /**
        *   source:dtrmod.@0061.script
        */
        public String do_instCpstimMsg(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getCpstim());
			Map<String,Object> cpsmap = (Map<String,Object>)ctx.restoreData("cipsmap");
			log.debug("{}","系统状态变更处理开始 cipsmap:"+cpsmap);
			String time=null;

			String orgsysdat=cpsmap.get("OrgnlSysDt").toString();
			time = orgsysdat.replace("-","");
			log.info("{}","orgsysdat time :"+time);
			this.getCpstim().setOrgsysdt(  MdaUtils.parseDate(time,"yyyyMMdd"));//原系统日期
			
			if(!MdaUtils.isEmpty(cpsmap.get("OrgnlSysSts")))
			{
			  this.getCpstim().setOrgsyssta( cpsmap.get("OrgnlSysSts").toString());//原系统状态
			}

			if(!MdaUtils.isEmpty(cpsmap.get("CurSysDt")))
			{
			  String cursysdat = cpsmap.get("CurSysDt").toString();
			  time = cursysdat.replace("-","");
			  log.info("{}","cursysdat time :"+time);
			  this.getCpstim().setSysdt( MdaUtils.parseDate(time,"yyyyMMdd"));//系统当前日期
			}
			if(!MdaUtils.isEmpty(cpsmap.get("CurSysSts")))
			{
			  this.getCpstim().setSyssta( cpsmap.get("CurSysSts").toString());//系统当前状态
			}

			if(!MdaUtils.isEmpty(cpsmap.get("NxtSysDt")))
			{
			  String nxtsysdat = cpsmap.get("NxtSysDt").toString();
			  time = nxtsysdat.replace("-","");
			  log.info("{}","nxtsysdat time :"+time);
			  this.getCpstim().setNxtsysdt( MdaUtils.parseDate(time,"yyyyMMdd"));//系统下一日期
			}

			if(!MdaUtils.isEmpty(cpsmap.get("MmbChngNb")))
			{
			  this.getCpstim().setMmbchnnb( cpsmap.get("MmbChngNb").toString());//参与者变更期数
			}
			log.info("{}","cpstim mmbchnnb :"+this.getCpstim().getMmbchnnb());

			if(!MdaUtils.isEmpty(cpsmap.get("ParamChngNb")))
			{
			  this.getCpstim().setParchnnb( cpsmap.get("ParamChngNb").toString());//公共参数变更期数
			}
			if(!MdaUtils.isEmpty(cpsmap.get("DrctMmbChngNb")))
			{
			  this.getCpstim().setDrcmmbchnnb( cpsmap.get("DrctMmbChngNb").toString());//间参所属直参变更期数
			}
			if(!MdaUtils.isEmpty(cpsmap.get("Ustrd")))
			{
			  this.getCpstim().setUstrd( cpsmap.get("Ustrd").toString());//附言
			}

			String snddat = null;
			String sndtim = null;
			String date = null;
			log.info("{}","HSendDate :"+cpsmap.get("HSendDate").toString());
			if(!MdaUtils.isEmpty(cpsmap.get("HSendDate")))
			{
			  snddat = cpsmap.get("HSendDate").toString();
			  log.info("{}","snddat :"+snddat);
			}
			if(!MdaUtils.isEmpty(cpsmap.get("HSendTime")))
			{
			  sndtim = cpsmap.get("HSendTime").toString();
			  log.info("{}","sndtim :"+sndtim);

			}
			date = snddat + sndtim;
			this.getCpstim().setOrgsystm( MdaUtils.parseDate(date,"yyyyMMddHHmmss"));//报文发送时间
			log.info("{}","cpstim orgsystm :"+this.getCpstim().getOrgsystm());

			log.debug("{}","新增cpstim信息...");
			Platform.sdbInsert(this.getCpstim());
			log.debug("{}","errorcode:"+ctx.getErrorCode());

			return "XXX";
		}
        /**
        *   source:dtrmod.@0062.script
        */
        public String do_cpsQuitBy807(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			MdaUtils.clear(this.getUsrtab());
			MdaUtils.clear(this.getUsrtabs());
			//查询处理状态为‘02’且类型为‘1’即CIPS数据,经rsptim倒序排序的数据
			Platform.mdbReadset("fxd",this.getUsrtabs(),0,"where sta = '02' and typ = '1' order by rsptim desc");
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  //若拿到的第一条数据的登陆状态为‘D’,则表示当前系统为登陆状态
			  if(this.getUsrtabs().size() > 0 && this.getUsrtabs().getElement(0).getLogsta().equals("D"))
			  {
			    //807报文接收方为邮储，发送方为人行
			    log.debug("{}","强制签退开始...");
			    String msgcod = "C" + MdaUtils.format(MdaUtils.today(),"yyMMddHHmmssSSS");
			    String sndnam = "CIPSCNSHXXX";
			    Date snddat = MdaUtils.parseDate(MdaUtils.format(MdaUtils.today(),"yyyyMMdd"),"yyyyMMdd");
			    String msgref = "";
			    String rcvnam = "PSBCCNBJXXX";
			    //入库
			    Platform.mdbBegin();
			    this.getUsrtab().setReqnum( msgcod);
			    this.getUsrtab().setSubtyp( "807");
			    this.getUsrtab().setSndcod( sndnam);
			    this.getUsrtab().setRcvcod( rcvnam);
			    String time = MdaUtils.format(MdaUtils.today(),"yyyyMMddHHmmss");
			    this.getUsrtab().setRsptim( MdaUtils.parseDate(time,"yyyyMMddHHmmss"));
			    this.getUsrtab().setCurdat( MdaUtils.parseDate(time.substring(0,8),"yyyyMMdd"));
			    this.getUsrtab().setSta( "02");//人行返回807报文，直接置处理状态为成功状态
			    this.getUsrtab().setMpiinr( this.getSmpmod().getMpi().getInr());
			    this.getUsrtab().setTyp( "1");
			    this.getUsrtab().setLogsta( "N");//离线
			    Platform.sdbInsert(this.getUsrtab());
			    Platform.mdbCommit();
			    int errorcode = ctx.getErrorCode();
			    if(errorcode != NO_ERROR)
			    {
			      log.debug("{}","强制签退插入数据库失败");
			      Platform.mdbRollback();
			    }
			    else
			    {
			      log.debug("{}","强制签退成功!");
			    }
			  }
			  else
			  {
			    log.debug("{}","系统处于签退状态！");
			  }
			}
			return "XXX";
		}
        /**
        *   source:dtrmod.@0063.script
        */
        public boolean do_gChannelCheck(String rcvBnkBic, String actBnkBic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			///判断是否需要进入SWIFT应急支付渠道。
			///rcvBnkBic: 收报行BIC
			///actBnkBic: 账户行BIC
			log.debug("{}","gChannelCheck:" + this.getSmpmod().getMps().getSwetyp() + "," + this.getSmpmod().getMps().getInr() + "," + rcvBnkBic + "," + actBnkBic);
			if("S".equals(this.getSmpmod().getMps().getSwetyp()))
			{
			  log.debug("{}","指定清分渠道为SWIFT");
			  return false;
			}

			boolean isEmergency = true;
			if("E".equals(this.getSmpmod().getMps().getSwetyp()))
			{
			  log.debug("{}","指定清分渠道为G渠道");
			}
			else if(MdaUtils.isEmpty(this.getSmpmod().getMps().getSwetyp()) || "A".equals(this.getSmpmod().getMps().getSwetyp()))
			{
			  log.debug("{}","根据业务要素判断清分渠道");
			  if(!MdaUtils.isEmpty(actBnkBic))
			  {
			    if(!this.getSwemod().checkIsSweBank(actBnkBic))
			    {
			      isEmergency = false;
			    }
			  }

			  if(isEmergency && !MdaUtils.isEmpty(rcvBnkBic))
			  {
			    if(!this.getSwemod().checkIsSweBank(rcvBnkBic))
			    {
			      isEmergency = false;
			    }
			  }
			}

			if(isEmergency)
			{
			  log.debug("{}","do_gChannel");
			  this.getSmpmod().getMps().setNxtchncod( "SWE");
			  this.getSmpmod().getMps().setTgtchncod( "SWE");
			  this.getSmpmod().getMps().setSta( "A");
			  Platform.mdbUpdate(this.getSmpmod().getMps());

			  MdaUtils.clear(this.getMpe());
			  this.getMpe().setChncod( "XXX");
			  this.getMpe().setDattim( MdaUtils.today());
			  this.getMpe().setMpsinr( this.getSmpmod().getMps().getInr());
			  this.getMpe().setUsr( MdaEnv.getLoginUser());
			  this.getMpe().setNxtchncod( this.getSmpmod().getMps().getTgtchncod());
			  this.getMpe().setSmhinr( this.getSmpmod().getSmh().getInr());
			  this.getMpe().setPrvsta( "W");
			  this.getMpe().setSta( "A");
			  this.getMpe().setTxt( "由SWIFT渠道转至G渠道");
			  this.getMpe().setFrmnam( ctx.getTransName());
			  Platform.sdbInsert(this.getMpe());
			  if(ctx.getErrorCode() == NO_ERROR)
			    return true;
			}

			return false;
		}
        /**
        *   source:dtrmod.@0064.script
        */
        public String do_cpsChangeBaseData(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *901 参与者信息变更通知报文
			  *902 业务权限变更通知报文
			  *904 系统参数变更通知报文
			  *906 间参所属直参变更通知报文
			  *376 互助协议申请报文
			  *377 互助协议应答报文
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("cipsmap");
			log.debug("{}","执行cpsChangeBaseData方法，type的值为"+type);
			String chngNb = "";
			int errcod = 0;
			if(type.equals("901"))
			{
			  log.debug("{}","开始处理901");
			  Platform.mdbRead(this.getFxd(),new Argument("filtyp","13"),new Argument("sta","0"));
			  errcod = ctx.getErrorCode();
			  log.debug("{}","ChndInf--------:");
			  if(errcod == NO_ERROR && !MdaUtils.isEmpty(map.get("ChngInf")))
			  {
			    chngNb = String.valueOf(map.get("ChngNb"));//变更期数
			    List<Map> chngInf = (List<Map>)map.get("ChngInf");
			    for(Map chngInfEntry:chngInf)
			    {
			      if(!MdaUtils.isEmpty(chngInfEntry.get("ChngTp")))
			      {
			        String chngtp = String.valueOf(chngInfEntry.get("ChngTp"));//变更类型
			        log.debug("{}","901变更类型:"+chngtp);
			        String cod = String.valueOf(chngInfEntry.get("MmbId"));//参与者行号
			        Platform.mdbRead(this.getFxdpat(),new Argument<String>("cod",cod));
			        //新增，修改，撤销参与者变更信息
			        if(chngtp.equals("ADDD"))
			        {
			          if(MdaUtils.isEmpty(this.getFxdpat()))
			          {
			            this.getFxdpat().setCod( String.valueOf(chngInfEntry.get("MmbId")));//参与者行号
			            this.getFxdpat().setChnnam( String.valueOf(chngInfEntry.get("MmbNmChn")));//参与者中文行名
			            this.getFxdpat().setEngnam( String.valueOf(chngInfEntry.get("MmbNmEng")));//参与者英文行名
			            this.getFxdpat().setCty( String.valueOf(chngInfEntry.get("CntyAndRgCd")));//国别（地区）代码
			            this.getFxdpat().setBakcat( String.valueOf(chngInfEntry.get("BankCatg")));//参与者资格标识
			            this.getFxdpat().setCtdbak( String.valueOf(chngInfEntry.get("Cstd")));//所属资金托管行
			            this.getFxdpat().setCbtype( String.valueOf(chngInfEntry.get("DmtFlag")));//境内标识
			            this.getFxdpat().setLei( String.valueOf(chngInfEntry.get("Lei")));//法人机构识别编码
			            this.getFxdpat().setEffdat( String.valueOf(chngInfEntry.get("FctvDt")));//变更生效日期
			            this.getFxdpat().setTel( String.valueOf(chngInfEntry.get("Tel")));//电话
			            this.getFxdpat().setAddress( String.valueOf(chngInfEntry.get("AdrLine")));//地址
			            this.getFxdpat().setZipcod( String.valueOf(chngInfEntry.get("ZipCode")));//邮编
			            this.getFxdpat().setMal( String.valueOf(chngInfEntry.get("Mail")));//邮箱
			            this.getFxdpat().setNam( String.valueOf(chngInfEntry.get("Contact")));//联系人
			            this.getFxdpat().setPresta( this.getFxdpat().getSta());//前一次更新状态
			            this.getFxdpat().setSta( chngtp);//当前更新状态
			            this.getFxdpat().setIssueno( chngNb);//变更期数
			            this.getFxdpat().setFxdinr( this.getFxd().getInr());//fxd主键
			            Platform.sdbInsert(this.getFxdpat());
			          }
			          else
			          {
			            this.getFxdpat().setCod( String.valueOf(chngInfEntry.get("MmbId")));//参与者行号
			            this.getFxdpat().setChnnam( String.valueOf(chngInfEntry.get("MmbNmChn")));//参与者中文行名
			            this.getFxdpat().setEngnam( String.valueOf(chngInfEntry.get("MmbNmEng")));//参与者英文行名
			            this.getFxdpat().setCty( String.valueOf(chngInfEntry.get("CntyAndRgCd")));//国别（地区）代码
			            this.getFxdpat().setBakcat( String.valueOf(chngInfEntry.get("BankCatg")));//参与者资格标识
			            this.getFxdpat().setCtdbak( String.valueOf(chngInfEntry.get("Cstd")));//所属资金托管行
			            this.getFxdpat().setCbtype( String.valueOf(chngInfEntry.get("DmtFlag")));//境内标识
			            this.getFxdpat().setLei( String.valueOf(chngInfEntry.get("Lei")));//法人机构识别编码
			            this.getFxdpat().setEffdat( String.valueOf(chngInfEntry.get("FctvDt")));//变更生效日期
			            this.getFxdpat().setTel( String.valueOf(chngInfEntry.get("Tel")));//电话
			            this.getFxdpat().setAddress( String.valueOf(chngInfEntry.get("AdrLine")));//地址
			            this.getFxdpat().setZipcod( String.valueOf(chngInfEntry.get("ZipCode")));//邮编
			            this.getFxdpat().setMal( String.valueOf(chngInfEntry.get("Mail")));//邮箱
			            this.getFxdpat().setNam( String.valueOf(chngInfEntry.get("Contact")));//联系人
			            this.getFxdpat().setPresta( this.getFxdpat().getSta());//前一次更新状态
			            this.getFxdpat().setSta( chngtp);//当前更新状态
			            this.getFxdpat().setIssueno( chngNb);//变更期数
			            this.getFxdpat().setFxdinr( this.getFxd().getInr());//fxd主键
			            Platform.mdbUpdate(this.getFxdpat());
			          }
			        }
			        else if(chngtp.equals("MODI")||chngtp.equals("DELE"))
			        {
			          if(MdaUtils.isEmpty(this.getFxdpat()))
			          {
			            log.warn("{}","当前修改/删除的直接参与者不存在！");
			            return "OOO";
			          }
			          this.getFxdpat().setChnnam( String.valueOf(chngInfEntry.get("MmbNmChn")));//参与者中文行名
			          this.getFxdpat().setEngnam( String.valueOf(chngInfEntry.get("MmbNmEng")));//参与者英文行名
			          this.getFxdpat().setCty( String.valueOf(chngInfEntry.get("CntyAndRgCd")));//国别（地区）代码
			          this.getFxdpat().setBakcat( String.valueOf(chngInfEntry.get("BankCatg")));//参与者资格标识
			          if(!MdaUtils.isEmpty(String.valueOf(chngInfEntry.get("Cstd"))))
			          {
			            this.getFxdpat().setCtdbak( String.valueOf(chngInfEntry.get("Cstd")));//所属资金托管行
			          }
			          this.getFxdpat().setCbtype( String.valueOf(chngInfEntry.get("DmtFlag")));//境内标识
			          this.getFxdpat().setLei( String.valueOf(chngInfEntry.get("Lei")));//法人机构识别编码
			          this.getFxdpat().setEffdat( String.valueOf(chngInfEntry.get("FctvDt")));//变更生效日期
			          if(!MdaUtils.isEmpty(String.valueOf(chngInfEntry.get("Tel"))))
			          {
			            this.getFxdpat().setTel( String.valueOf(chngInfEntry.get("Tel")));//电话
			          }
			          if(!MdaUtils.isEmpty(String.valueOf(chngInfEntry.get("AdrLine"))))
			          {
			            this.getFxdpat().setAddress( String.valueOf(chngInfEntry.get("AdrLine")));//地址
			          }
			          if(!MdaUtils.isEmpty(String.valueOf(chngInfEntry.get("ZipCode"))))
			          {
			            this.getFxdpat().setZipcod( String.valueOf(chngInfEntry.get("ZipCode")));//邮编
			          }
			          if(!MdaUtils.isEmpty(String.valueOf(chngInfEntry.get("Mail"))))
			          {
			            this.getFxdpat().setMal( String.valueOf(chngInfEntry.get("Mail")));//邮箱
			          }
			          if(!MdaUtils.isEmpty(String.valueOf(chngInfEntry.get("Contact"))))
			          {
			            this.getFxdpat().setNam( String.valueOf(chngInfEntry.get("Contact")));//联系人
			          }
			          if(this.getFxdpat().getSta() != null)
			          {
			            this.getFxdpat().setPresta( this.getFxdpat().getSta());//前一次更新状态
			          }
			          this.getFxdpat().setSta( chngtp);//当前更新状态
			          this.getFxdpat().setIssueno( chngNb);//变更期数
			          this.getFxdpat().setFxdinr( this.getFxd().getInr());//fxd主键
			          Platform.mdbUpdate(this.getFxdpat());
			        }
			      }
			    }
			  }
			  else
			  {
			    if(errcod != NO_ERROR)
			      log.debug("{}","fxd记录读取失败");
			    //return false;
			  }
			  return "XXX";
			}
			else if(type.equals("902"))
			{
			  log.debug("{}","开始处理902");
			  Platform.mdbRead(this.getFxd(),new Argument("filtyp","19"),new Argument("sta","0"));
			  errcod = ctx.getErrorCode();
			  log.debug("{}","AuthrtyInf--------:");
			  List<Map> authrtyInf = (List<Map>)map.get("AuthrtyInf");
			  for(Map authrtyInftry:authrtyInf)
			  {
			    String initPtcpt = String.valueOf(authrtyInftry.get("InitPtcpt"));
			    Platform.mdbDelete(this.getFxdrig(),new Argument("bic",initPtcpt));
			    List<String> sndMT = (List<String>) authrtyInftry.get("SendMT");
			    Date upddat = MdaUtils.today();
			    if(sndMT.size()>0)
			    {
			      for(String sndMTEntry:sndMT)
			      {
			        this.getFxdrig().setBic( initPtcpt);
			        this.getFxdrig().setUpddat( upddat);
			        this.getFxdrig().setSndtyp( "SEND");
			        this.getFxdrig().setMsgtyp( sndMTEntry);
			        this.getFxdrig().setFxdinr( this.getFxd().getInr());
			        Platform.sdbInsert(this.getFxdrig());
			      }
			    }
			    List<String> rcvMT = (List<String>) authrtyInftry.get("RcvMT");
			    if(rcvMT.size()>0)
			    {
			      for(String rcvMTEntry:rcvMT)
			      {
			        this.getFxdrig().setBic( initPtcpt);
			        this.getFxdrig().setUpddat( upddat);
			        this.getFxdrig().setSndtyp( "RECV");
			        this.getFxdrig().setMsgtyp( rcvMTEntry);
			        this.getFxdrig().setFxdinr( this.getFxd().getInr());
			        Platform.sdbInsert(this.getFxdrig());
			      }
			    }
			  }
			  return "XXX";
			}
			else if(type.equals("904"))
			{
			  log.debug("{}","开始处理904");
			  Platform.mdbRead(this.getFxd(),new Argument("filtyp","9"),new Argument("sta","0"));
			  errcod = ctx.getErrorCode();
			  chngNb = String.valueOf(map.get("ChngNb")); //变更期数
			  String chngRcrdNb = String.valueOf(map.get("ChngRcrdNb")); //变更数据个数
			  String fctvTp =	String.valueOf(map.get("FctvTp")); //生效类型
			  Date fctvDt = new Date();
			  if("EFIM".equals(fctvTp))
			  {
			    fctvDt = MdaUtils.parseDate(MdaUtils.format(MdaUtils.today(),"yyyy-MM-dd HH:mm:ss"),"yyyy-MM-dd HH:mm:ss");//生效日期
			  }
			  if("EFSD".equals(fctvTp))
			  {
			    fctvDt = MdaUtils.parseDate(String.valueOf(map.get("FctvDt")),"yyyy-MM-dd HH:mm:ss"); //生效日期
			  }

			  List<Map> sysParamInf = (List<Map>) map.get("SysParamInf"); //公共数据
			  for(Map sysParamInfEntry :sysParamInf)
			  {
			    String chgTp = String.valueOf(sysParamInfEntry.get("ChgTp")); //变更类型
			    log.debug("{}","904变更类型:"+chgTp);
			    String comcod = String.valueOf(sysParamInfEntry.get("CmonDataCd"));
			    MdaUtils.clear(this.getFxdcom());
			    Platform.mdbRead(this.getFxdcom(),new Argument<String>("comcod",comcod));
			    if("ADDD".equals(chgTp))
			    {
			      if(MdaUtils.isEmpty(this.getFxdcom()))
			      {
			        this.getFxdcom().setChgtyp( chgTp);
			        this.getFxdcom().setComtyp( String.valueOf(sysParamInfEntry.get("CmonDataTp"))); //公共数据类型
			        this.getFxdcom().setComcod( String.valueOf(sysParamInfEntry.get("CmonDataCd")));	//公共数据代码
			        this.getFxdcom().setComnam( String.valueOf(sysParamInfEntry.get("CmonDataNmChn"))); //公共数据中文名
			        if(!MdaUtils.isEmpty(String.valueOf(sysParamInfEntry.get("CmonDataNmEng"))))
			        {
			          this.getFxdcom().setComengnam( String.valueOf(sysParamInfEntry.get("CmonDataNmEng"))); //公共数据英文名
			        }
			        this.getFxdcom().setVal( String.valueOf(sysParamInfEntry.get("CmonDataVal"))); //公共数据值
			        this.getFxdcom().setSta( "0");
			        this.getFxdcom().setChangeterm( chngNb);
			        this.getFxdcom().setNum( chngRcrdNb);
			        this.getFxdcom().setTyp( fctvTp);
			        this.getFxdcom().setEffdat( fctvDt);
			        this.getFxdcom().setFxdinr( this.getFxd().getInr());
			        Platform.sdbInsert(this.getFxdcom());
			      }
			      else
			      {
			        this.getFxdcom().setChgtyp( chgTp);
			        this.getFxdcom().setComtyp( String.valueOf(sysParamInfEntry.get("CmonDataTp"))); //公共数据类型
			        this.getFxdcom().setComcod( String.valueOf(sysParamInfEntry.get("CmonDataCd")));	//公共数据代码
			        this.getFxdcom().setComnam( String.valueOf(sysParamInfEntry.get("CmonDataNmChn"))); //公共数据中文名
			        if(!MdaUtils.isEmpty(String.valueOf(sysParamInfEntry.get("CmonDataNmEng"))))
			        {
			          this.getFxdcom().setComengnam( String.valueOf(sysParamInfEntry.get("CmonDataNmEng"))); //公共数据英文名
			        }
			        this.getFxdcom().setVal( String.valueOf(sysParamInfEntry.get("CmonDataVal"))); //公共数据值
			        this.getFxdcom().setSta( "0");
			        this.getFxdcom().setChangeterm( chngNb);
			        this.getFxdcom().setNum( chngRcrdNb);
			        this.getFxdcom().setTyp( fctvTp);
			        this.getFxdcom().setEffdat( fctvDt);
			        this.getFxdcom().setFxdinr( this.getFxd().getInr());
			        Platform.mdbUpdate(this.getFxdcom());
			      }
			    }
			    if("MODI".equals(chgTp)||"DELE".equals(chgTp))
			    {
			      if(MdaUtils.isEmpty(this.getFxdcom()))
			      {
			        log.warn("{}","当前修改/删除的公共数据不存在！");
			        return "XXX";
			      }
			      this.getFxdcom().setChgtyp( chgTp);
			      this.getFxdcom().setComtyp( String.valueOf(sysParamInfEntry.get("CmonDataTp"))); //公共数据类型
			      this.getFxdcom().setComcod( String.valueOf(sysParamInfEntry.get("CmonDataCd")));	//公共数据代码
			      this.getFxdcom().setComnam( String.valueOf(sysParamInfEntry.get("CmonDataNmChn"))); //公共数据中文名
			      this.getFxdcom().setComengnam( String.valueOf(sysParamInfEntry.get("CmonDataNmEng"))); //公共数据英文名
			      if("MODI".equals(chgTp))
			      {
			        if(MdaUtils.diff(fctvDt,MdaUtils.today())>0)
			        {
			          this.getFxdcom().setUpdval( String.valueOf(sysParamInfEntry.get("CmonDataVal"))); //公共数据值
			        }
			        else
			        {
			          if(!MdaUtils.isEmpty(this.getFxdcom().getUpdval()))
			          {
			            this.getFxdcom().setVal( this.getFxdcom().getUpdval());
			          }
			          this.getFxdcom().setUpdval( String.valueOf(sysParamInfEntry.get("CmonDataVal"))); //公共数据值
			        }
			      }
			      this.getFxdcom().setSta( "0");
			      this.getFxdcom().setChangeterm( chngNb);
			      this.getFxdcom().setNum( chngRcrdNb);
			      this.getFxdcom().setTyp( fctvTp);
			      this.getFxdcom().setEffdat( fctvDt);
			      this.getFxdcom().setUpddat( MdaUtils.today());
			      this.getFxdcom().setFxdinr( this.getFxd().getInr());
			      Platform.mdbUpdate(this.getFxdcom());
			    }
			  }
			  return "XXX";
			}
			else if(type.equals("906"))
			{
			  log.debug("{}","开始处理906");
			  Platform.mdbRead(this.getFxd(),new Argument("filtyp","16"),new Argument("sta","0"));
			  errcod = ctx.getErrorCode();
			  chngNb = String.valueOf(map.get("ChngNb"));
			  List<Map> chnginf = (List<Map>)map.get("ChngInf");
			  for(Map chnginfEntry:chnginf)
			  {
			    String flg = String.valueOf(chnginfEntry.get("ChngTp"));
			    MdaUtils.clear(this.getFxdrel());
			    Platform.mdbRead(this.getFxdrel(),new Argument<String>("cod",String.valueOf(chnginfEntry.get("MmbId"))),new Argument<String>("drbankcod",String.valueOf(chnginfEntry.get("DrctBkCd"))),new Argument<String>("updtyp","ADDD"));
			    if("ADDD".equals(flg))
			    {
			      if(MdaUtils.isEmpty(this.getFxdrel()))
			      {
			        this.getFxdrel().setCod( String.valueOf(chnginfEntry.get("MmbId")));
			        this.getFxdrel().setDrbankcod( String.valueOf(chnginfEntry.get("DrctBkCd")));
			        this.getFxdrel().setEffdat( String.valueOf(chnginfEntry.get("FctvDt")));
			        this.getFxdrel().setPreupdtyp( "");
			        this.getFxdrel().setUpdtyp( flg);
			        this.getFxdrel().setIssueno( chngNb);
			        this.getFxdrel().setFxdinr( this.getFxd().getInr());
			        Platform.sdbInsert(this.getFxdrel());
			      }
			      else
			      {
			        this.getFxdrel().setCod( String.valueOf(chnginfEntry.get("MmbId")));
			        this.getFxdrel().setDrbankcod( String.valueOf(chnginfEntry.get("DrctBkCd")));
			        this.getFxdrel().setEffdat( String.valueOf(chnginfEntry.get("FctvDt")));
			        this.getFxdrel().setPreupdtyp( "");
			        this.getFxdrel().setUpdtyp( flg);
			        this.getFxdrel().setIssueno( chngNb);
			        this.getFxdrel().setFxdinr( this.getFxd().getInr());
			        Platform.mdbUpdate(this.getFxdrel());
			      }
			    }
			    if("DELE".equals(flg))
			    {
			      if(MdaUtils.isEmpty(this.getFxdrel()))
			      {
			        log.warn("{}","当前撤销的直间参关系不存在！");
			        return "XXX";
			      }
			      if(MdaUtils.diff(MdaUtils.parseDate(this.getFxdrel().getEffdat(),"yyyy-MM-dd"),MdaUtils.today())>0)
			      {
			        log.warn("{}","当前撤销的直间参关系没有生效！");
			        return "XXX";
			      }
			      else
			      {
			        this.getFxdrel().setEffdat( String.valueOf(chnginfEntry.get("FctvDt")));
			        this.getFxdrel().setPreupdtyp( this.getFxdrel().getUpdtyp());
			        this.getFxdrel().setUpdtyp( flg);
			        this.getFxdrel().setIssueno( chngNb);
			        this.getFxdrel().setFxdinr( this.getFxd().getInr());
			        Platform.mdbUpdate(this.getFxdrel());
			      }
			    }
			  }
			  return "XXX";
			}
			else if(type.equals("376"))
			{
			  log.debug("{}","开始处理376");
			  String typ = String.valueOf(map.get("LiPrtry"));
			  String inbic = String.valueOf(map.get("InId"));
			  String outbic = String.valueOf(map.get("OutId"));
			  Platform.mdbRead(this.getInmpi(),new Argument<String>("othref",String.valueOf(map.get("MsgId"))));
			  if("SGND".equals(typ))
			  {
			    this.getMar().setInbic( inbic);
			    this.getMar().setOutbic( outbic);
			    this.getMar().setSta( "待处理");
			    this.getMar().setTyp( "签约");
			    this.getMar().setNo( String.valueOf(map.get("PrtcNm")));
			    this.getMar().setDir( "<");
			    this.getMar().setOutmpiinr( this.getInmpi().getInr());
			    Platform.sdbInsert(this.getMar());
			  }
			  if("CANC".equals(typ))
			  {
			    Platform.mdbRead(this.getMar(),new Argument<String>("inbic",inbic),new Argument<String>("outbic",outbic));
			    this.getMar().setSta( "待处理");
			    this.getMar().setTyp( "解约");
			    this.getMar().setDir( "<");
			    this.getMar().setOutmpiinr( this.getInmpi().getInr());
			    this.getMar().setInmpiinr( "");
			    Platform.mdbUpdate(this.getMar());
			  }
			  return "OOO";
			}
			else if(type.equals("377"))
			{
			  log.debug("{}","开始处理377");
			  Platform.mdbRead(this.getInmpi(),new Argument<String>("othref",String.valueOf(map.get("MsgId"))),new Argument<String>("subtyp","377"));
			  Platform.mdbRead(this.getOutmpi(),new Argument<String>("ownref",String.valueOf(map.get("MsgId1"))),new Argument<String>("subtyp","376"));
			  Platform.mdbRead(this.getMar(),new Argument<String>("outmpiinr",this.getOutmpi().getInr()));
			  String flg = String.valueOf(map.get("Accptd"));
			  log.debug("{}","flg的值"+flg);
			  if(("签约".equals(this.getMar().getTyp())&&"true".equals(flg)) || ("解约".equals(this.getMar().getTyp())&&"false".equals(flg)))
			  {
			    log.debug("{}","开始签约");
			    this.getMar().setTyp( "签约");
			    this.getMar().setInmpiinr( this.getInmpi().getInr());
			    this.getMar().setSta( "已处理");
			    Platform.mdbUpdate(this.getMar());
			  }
			  //如果应答状态为拒绝，376来报为签约；应答状态为同意，376来报为解约，删除该笔互助关系
			  if(("签约".equals(this.getMar().getTyp())&&"false".equals(flg)) || ("解约".equals(this.getMar().getTyp())&&"true".equals(flg)))
			  {
			    log.debug("{}","开始解约");
			    Platform.mdbDelete(this.getMar());
			  }
			  this.getOutmpi().setOthref( this.getInmpi().getOthref());
			  Platform.mdbUpdate(this.getOutmpi());
			  return "OOO";
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0065.script
        */
        public String do_rtnControl990Message(String type)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  *990通信级确认报文
			  */
			Map<String,Object> map = (Map<String,Object>)ctx.restoreData("cipsmap");
			String orgnum = (String)map.get("MsgId");
			String subtyp = "";
			if(!MdaUtils.isEmpty(map.get("MT")))
			{
			  subtyp = (String)map.get("MT");
			  subtyp = subtyp.substring(5,8);
			}
			log.debug("{}","CIPS-990原业务参考号:"+orgnum+",原报文类型:"+subtyp);
			String addinf = null;
			if(!MdaUtils.isEmpty(map.get("MsgPrcCd")))
			{
			  addinf = map.get("MsgPrcCd").toString();//业务处理码+处理信息
			}
			MdaUtils.clear(this.getMpi());
			MdaUtils.clear(this.getMps());
			//根据原发报报文20域，报文类型来查找原关联报文,更新原记录回执状态
			Argument argument = new Argument("ownref",orgnum).and("dir","<");
			argument = argument.and("msgtyp","xml");
			argument = argument.and("subtyp",subtyp);
			ctx.getErrorCode();
			Platform.mdbRead(this.getMpi(),argument,new Argument("gendat",DESC));
			Platform.mdbRead(this.getMps(),new Argument("inr",this.getMpi().getInr()));
			if(ctx.getErrorCode()==NO_ERROR)
			{
			  Date processDate = new Date();
			  this.getMps().setLstdattim( processDate);
			  this.getMps().setRspdattim( processDate);
			  MdaUtils.clear(this.getMpe());
			  //生产为两个前置机取报文。可能会出现PMTS自动返回的通信级确认报文990，在发报回执报文（比如601）后面，导致数据库状态更新出错的问题。
			  //解决方法：判断mps字段rspsta是否为"W",若是则更新状态为"P"
			  if(this.getMps().getRspsta().equals("W"))
			  {
			    if("PM1I0000".equals(addinf))
			    {
			      this.getMps().setRspsta( "P");
			      this.getMpe().setTxt( "已成功发至PMTS,处理信息:"+addinf);
			    }
			    else
			    {
			      this.getMps().setRspsta( "P");
			      this.getMpe().setTxt( "发送PMTS异常,异常信息:"+addinf);
			    }
			    Platform.mdbUpdate(this.getMps());
			  }
			  else
			  {
			    this.getMpe().setTxt( "发报回执状态不为待核销状态，不更新发送到PMTS成功状态\"P\"");
			  }
			  this.getMpe().setMpsinr( this.getMps().getInr());
			  this.getMpe().setChncod( "CPS");
			  this.getMpe().setNxtchncod( "");
			  this.getMpe().setSmhinr( this.getMps().getInr());
			  this.getMpe().setDattim( processDate);
			  this.getMpe().setPrvsta( "D");
			  this.getMpe().setSta( "F");
			  Platform.sdbInsert(this.getMpe());
			}
			return "OOO";
		}
        /**
        *   source:dtrmod.@0066.script
        */
        public void saveCipsPending(Map map)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			log.debug("{}","601 存储排队信息 ");
			MdaUtils.clear(this.getPng());
			log.debug("{}","message: mpsinr = " +this.getMps().getInr() );
			Platform.mdbRead(this.getPng(),new Argument("mpsinr",this.getMps().getInr()),new Argument("etyref",this.getMpi().getOwnref()));
			int err =ctx.getErrorCode() ;
			log.debug("{}","error =" + err) ;
			if( MdaUtils.isEmpty(this.getPng().getInr()))
			{
			  this.getPng().setCur( this.getMpi().getCur());
			  this.getPng().setAmt( this.getMpi().getAmt());
			  this.getPng().setMsgtyp( this.getMpi().getSubtyp());
			  this.getPng().setSta( "2" );
			  this.getPng().setEtyref( this.getMpi().getOwnref());
			  this.getPng().setCredat( this.getMps().getSnddattim());
			  this.getPng().setMpsinr( this.getMps().getInr());
			  Platform.sdbInsert(this.getPng());
			  log.debug("{}"," png.inr = " + this.getPng().getInr());
			}
		}
        /**
        *   source:dtrmod.@0067.script
        */
        public boolean do_swiftToCips(String sndbic, String cur)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			///判断是否需要swift转换至cips。
			///sndbix: 需要为邮储的间参行
			///cur: 币种为人民币
			log.debug("{}","swiftToCips:" + this.getSmpmod().getMps().getInr() + "," + sndbic + "," + cur);
			boolean flg = false;
			String fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			fileName = MdaUtils.catPath(fileName,"rcvsndmsg.properties");
			String bic = MdaUtils.getPropertyValue(fileName,"INDIR_BIC");
			String dat = MdaUtils.format(MdaUtils.today(),"yyyyMMdd");
			String valdat = "20"+ MdaUtils.format(this.getSmpmod().getMpi().getValdat(),"yyMMdd");
			if("CNY".equals(cur) && bic.equals(sndbic) && dat.equals(valdat))
			{
			  log.debug("{}","符合币种、发报行、起息日校验规则，需转换成CIPS报文.");
			  flg = true;
			}
			return flg;
		}
        /**
        *   source:dtrmod.@0068.script
        */
        public boolean do_CipsToSwift(String rcvindbic)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			///判断是否需要swift转换至cips。
			///sndbix: 需要为邮储的间参行
			///cur: 币种为人民币
			log.debug("{}","CipsToSwift:" + this.getSmpmod().getMps().getInr() + "," + rcvindbic);
			boolean flg = false;
			String fileName = MdaUtils.catPath(ctx.getEnvConfig().getRootPath(),"cfg");
			fileName = MdaUtils.catPath(fileName,"rcvsndmsg.properties");
			String bic = MdaUtils.getPropertyValue(fileName,"INDIR_BIC");
			if( bic.equals(rcvindbic))
			{
			  log.debug("{}","符合收报间参报行校验，需转换成CIPS报文.");
			  flg = true;
			}
			return flg;
		}
        /**
        *   source:dtrmod.@0069.script
        */
        public int distributeMessageAutomaticWithResult(String db,String dir)
		{
			//取得上下文
			IContext ctx = MdaEnv.getContext();
			ctx.setErrorCode(NO_ERROR);
			/*
			  * 报文自动清分处理
			  * 1, 先读取指定报文类型（例如：sf2）所有清分规则；
			  * 2, 逐条进行报文渠道字符串（chnstr）正则表达式匹配检查 （例如：SWT或GJSSWT）;
			  * 3, 渠道字符串匹配则进行报文类型字符串（typstr）正则表达式匹配检查（例如：103）；
			  * 4, 渠道和报文类型匹配则再进行域字符串（tagstr）函数检查（例如：$ref(#20)）；
			  */
			/// 获取并锁定一条需要自动清分记录（MPS，将会自动读取相关MPE、SMH、CHN信息）
			// if($smpmod.fetchAndLockMessage(db,"XXX","A"))
			
			//修改函数返回, -1:没有更多数据需要处理,0:处理失败,1:处理成功
			if(this.getSmpmod().fetchAndLockMessage(db,"XXX","A",dir))
			{
			  /// 获取报文类型
			  String messageType = this.getSmpmod().getSmh().getDocfxt();
			  /// 开始本次处理事务
			  Platform.mdbBegin();
			  /// 获取或新创建报文信息(如果失败则设置为需要手工清分)
			  if(!this.getSmpmod().getOrCreateMessageInformation(messageType))
			  {
			    /// 累加错误信息
			    this.getSmpmod().getSmh().setXxxcnt( this.getSmpmod().getSmh().getXxxcnt()+ 1);
			    Platform.mdbUpdate(this.getSmpmod().getSmh());
			    /// 如果错误次数少于3次则认为“等待同步文件”，否则置错误不再处理
			    if(this.getSmpmod().getSmh().getXxxcnt()>3)
			      this.getSmpmod().updatekWithUnlock("XXX",null,null,"E","无法读取或创建报文信息！"); // 状态为E则为错误状态
			    else
			      this.getSmpmod().updatekWithUnlock("XXX",null,null,"A","等待集群主机同步文件..."); // 状态为A则继续进行清分
			    Platform.mdbCommit();
			    return 0;
			  }
			  else
			  {
			    if("E".equals(this.getSmpmod().getMps().getSta()))
			    {
			      this.getSmpmod().updatekWithUnlock("XXX",null,null,"E","GISP异常报文,不做后续处理"); // 状态为E则为错误状态
			      Platform.mdbCommit();
			      return 0;
			    }
			  }
			  if(this.getSmpmod().checkNeedValidate())	//检查是否需要人工检查再放行
			  {
			    log.debug("{}","验证需要复查，不再进行余下处理");
			    Platform.mdbCommit();
			    return 0;
			  }
			  /// 生成渠道字符串
			  String channelStr = this.getSmpmod().getMps().getSrcchncod();
			  if(!MdaUtils.isEmpty(this.getSmpmod().getMps().getTgtchncod()))
			    channelStr += this.getSmpmod().getMps().getTgtchncod();
			  else
			    channelStr += "ALL"; // 注：所有渠道
			  /// 生成报文类型字符串
			  String typeStr = this.getSmpmod().getMpi().getSubtyp();
			  if(typeStr==null)
			    typeStr = "";
			  /// 读取当前报文的所有规则并按level进行排序
			  /// (FIXME) 需要加入生效时间判断
			  if(!MdaUtils.isEmpty(this.getSmpmod().getNxtsmh().getDocfxt()))
			    messageType = this.getSmpmod().getNxtsmh().getDocfxt();
			  Platform.esdbReadset("eibs",this.getDtrlst(),0,new Argument("msgtyp",messageType),new Argument("lvl",ASC),new Argument("chnstr",ASC));
			  log.info("{}","size:"+this.getDtrlst().fullSize());
			  String stepTraceStr = "";
			  log.debug("{}","channelStr,typeStr:\t"+channelStr+"\t"+typeStr);
			  /// 逐条清分规则进行处理
			  for(com.ceb.gjjs.mda.bo.Dtr dtr : this.getDtrlst())
			  {
			    log.debug("{}","chnstr,typestr,tagstr:\t"+dtr.getChnstr()+"\t"+dtr.getTypstr()+"\t"+dtr.getTagstr());
			    /// 检查渠道字符串与当前规则是否匹配
			    if(checkMatches(channelStr,dtr.getChnstr()))
			    {
			      log.debug("{}","channelStr.matched.");
			      /// 检查报文类型字符串与当前规则是否匹配
			      if(checkMatches(typeStr,dtr.getTypstr()))
			      {
			        log.debug("{}","typeStr.matched.");
			        /// 执行报文域的匹配检查
			        if(checkTagMatches(dtr.getTagstr()))
			        {
			          log.debug("{}","tagStr.matched.");
			          /// 记录该规则已匹配执行
			          stepTraceStr += "\r\n" + dtr.getRulnam();
			          /*String beginDB = (String)Platform.getStoredData("BeginDB."+Platform.getModuleRoot()+Platform.addThreadIdIfIsBackground());
			            if(beginDB == null)
			            {
			            Platform.mdbBegin();
			            }*/
			          /// 执行报文规则检查脚本（直接返回步骤，值以逗号隔开为先后关系，分隔符|隔开为并列关系即抄送）
			          String steps = getChannelStepValue(dtr.getSmpstp());
			          if(!MdaUtils.isEmpty(steps))
			          {

			            log.debug("{}","steps:"+steps);
			            /// 记录并处理mps状态信息
			            this.getSmpmod().getMps().setStp( steps);
			            /// 将应执行步骤、已匹配规则信息进行具体步骤执行
			            processMessageBySteps(steps, stepTraceStr);

			            //20181226 针对收报的103|202COV|192新增加reptrksta的值，后续自动回复199报文
			            if(">".equals(this.getSmpmod().getMps().getDir()) && MdaUtils.isEmpty(this.getSmpmod().getMps().getReptrksta()) && "GPI".equals(this.getSmpmod().getMpi().getGpi())
			              && ("103|202COV|202|192".contains(this.getSmpmod().getMpi().getSubtyp())))
			            {
			              this.getSmpmod().getMps().setReptrksta("W");
			            }

			            /// 下一渠道和目标渠道均不为空且不为自动清分处理渠道则表达清分已经成功！
			            if(!"XXX".equals(this.getSmpmod().getMps().getNxtchncod())&&!MdaUtils.isEmpty(this.getSmpmod().getMps().getNxtchncod())
			              &&!"XXX".equals(this.getSmpmod().getMps().getTgtchncod())&&!MdaUtils.isEmpty(this.getSmpmod().getMps().getTgtchncod()))
			            {

			              //记录黑名单状态
			              if("BLK".equals(this.getSmpmod().getMps().getNxtchncod()))
			                this.getSmpmod().getMps().setIsblk( "X");
			              // if(("GHD|GJS|ZQS".indexOf($smpmod\\mps\\tgtchncod.getValue())>=0)&&(!$smpmod\\mpi\\subtyp.getValue().matches("[0-9]9[0-9]")))
			
			              if(("GHD|ZQS".indexOf(this.getSmpmod().getMps().getTgtchncod())>=0)
			                &&(("103".equals(this.getSmpmod().getMpi().getSubtyp()))
			              &&("sf2".equals(this.getSmpmod().getMpi().getMsgtyp()))
			              ||("100|101|102|103|104".contains(this.getSmpmod().getMpi().getSubtyp()))
			              &&("txt".equals(this.getSmpmod().getMpi().getMsgtyp()))))
			              //20200430修改，国际结算1、2字头报文也需等待950-暂不上
			              /* if (("GHD|GJS|ZQS".indexOf($smpmod\\mps\\tgtchncod.getValue()) >= 0) && (
			              ("103|202|202COV".contains($smpmod\\mpi\\subtyp.getValue())) &&
			              ("sf2".equals($smpmod\\mpi\\msgtyp.getValue())) || (
			              ("100|101|102|103|104|200|201|202|204".contains($smpmod\\mpi\\subtyp.getValue())) &&
			              ("txt".equals($smpmod\\mpi\\msgtyp.getValue())))))*/
			            {
			              MdaUtils.clear(this.getSmpmod().getMpe());
			              this.getSmpmod().getMpe().setMpsinr(this.getSmpmod().getMps().getInr());
			              this.getSmpmod().getMpe().setChncod(this.getSmpmod().getMps().getChncod());
			              this.getSmpmod().getMpe().setNxtchncod(this.getSmpmod().getMps().getNxtchncod());
			              this.getSmpmod().getMpe().setSmhinr(this.getSmpmod().getMps().getSmhinr());
			              this.getSmpmod().getMpe().setNxtsmhinr(this.getSmpmod().getMps().getSmhinr());
			              this.getSmpmod().getMpe().setDattim(new Date());
			              this.getSmpmod().getMpe().setUsr(MdaEnv.getLoginUser());
			              this.getSmpmod().getMpe().setFrmnam(ctx.getTransName());
			              this.getSmpmod().getMpe().setPrvsta(this.getSmpmod().getMps().getSta());
			              this.getSmpmod().getMpe().setSta("L");
			              this.getSmpmod().getMpe().setTxt("等待关联勾销");
			              this.getSmpmod().getMpe().setRspsta(this.getSmpmod().getMps().getNxtsta());
			              this.getSmpmod().getMpe().setPrvrspsta(this.getSmpmod().getMps().getSta());
			              Platform.sdbInsert(this.getSmpmod().getMpe());
			              this.getSmpmod().getMps().setSta("L");
			            }

			            Platform.mdbUpdate(this.getSmpmod().getMps());
			            Platform.mdbCommit();
			            if(ctx.getErrorCode()!=NO_ERROR)
			            {
			              log.info("{}","commit error");
			              //Platform.mdbRollback();
			              return 0;
			            }
			            log.debug("{}","xxxtsk isblk :"+this.getSmpmod().getMps().getIsblk());
			            //20190416添加代码，如是192s报文，但下一渠道是黑名单的，需向业务发送短信提醒
			            /* if("192".equals($smpmod\\mpi\\subtyp.getValue()) && "sf2".equals($smpmod\\mpi\\msgtyp.getValue()) && "GPI".equals($smpmod\\mpi\\gpi.getValue())
			              && (("C".equals($smpmod\\mps\\isblk.getValue()) || "BLK".equals($smpmod\\mps\\nxtchncod.getValue()))))
			              {
			              log.info("192s清分至黑名单...");
			              boolean flg = $txtm.snd192sMessage($smpmod\\mpi\\othref.getValue(),$smpmod\\mps\\rcvdattim.getValue());
			              log.info("flg:"+flg);
			              }*/

			            if("xml".equals(this.getSmpmod().getMpi().getMsgtyp()) && "111|112|113".contains(this.getSmpmod().getMpi().getSubtyp()))
			            {
			              this.getSwemod().createOrUpdateSedEntryForCips(this.getSmpmod().getMpi().getSubtyp(),this.getSmpmod().getMps(),this.getSmpmod().getMpi());
			            }
			            return 1;
			          }
			        }
			      } // 报文域匹配处理结束
			    } // 报文类型字符串匹配结束
			  } // 渠道字符串匹配结束
			} // 逐条循环清分规则结束
			this.getSmpmod().updatekWithUnlock("XXX",null,null,"X","无已定义规则可进行自动清分！");
			Platform.mdbCommit();

			if("xml".equals(this.getSmpmod().getMpi().getMsgtyp()) && "111|112|113".contains(this.getSmpmod().getMpi().getSubtyp()))
			{
			  this.getSwemod().createOrUpdateSedEntryForCips(this.getSmpmod().getMpi().getSubtyp(),this.getSmpmod().getMps(),this.getSmpmod().getMpi());
			}

			//20181219添加代码，如是192s报文，但下一渠道是黑名单或人工清分的，需向业务发送短信提醒
			/*if("192".equals($smpmod\\mpi\\subtyp.getValue()) && "sf2".equals($smpmod\\mpi\\msgtyp.getValue()) && "GPI".equals($smpmod\\mpi\\gpi.getValue())
			  && ( (("X".equals($smpmod\\mps\\sta.getValue()) && ("XXX".equals($smpmod\\mps\\nxtchncod.getValue()) || Platform.isEmpty($smpmod\\mps\\nxtchncod.getValue()))))))
			  {
			  log.info("192s无已定义的清分规则...");
			  boolean flg = $txtm.snd192sMessage($smpmod\\mpi\\othref.getValue(),$smpmod\\mps\\rcvdattim.getValue());
			  log.info("flg:"+flg);
			  }*/
			return 1;
			}
			else
			{
			return -1;
			}
		}













































}